/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* DAG Instruction Selector for the WebAssembly target                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

// *** NOTE: This file is #included into the middle of the target
// *** instruction selector class.  These functions are really methods.

// If GET_DAGISEL_DECL is #defined with any value, only function
// declarations will be included when this file is included.
// If GET_DAGISEL_BODY is #defined, its value should be the name of
// the instruction selector class. Function bodies will be emitted
// and each function's name will be qualified with the name of the
// class.
//
// When neither of the GET_DAGISEL* macros is defined, the functions
// are emitted inline.

#if defined(GET_DAGISEL_DECL) && defined(GET_DAGISEL_BODY)
#error GET_DAGISEL_DECL and GET_DAGISEL_BODY cannot be both defined, undef both for inline definitions
#endif

#ifdef GET_DAGISEL_BODY
#define LOCAL_DAGISEL_STRINGIZE(X) LOCAL_DAGISEL_STRINGIZE_(X)
#define LOCAL_DAGISEL_STRINGIZE_(X) #X
static_assert(sizeof(LOCAL_DAGISEL_STRINGIZE(GET_DAGISEL_BODY)) > 1,
   "GET_DAGISEL_BODY is empty: it should be defined with the class name");
#undef LOCAL_DAGISEL_STRINGIZE_
#undef LOCAL_DAGISEL_STRINGIZE
#endif

#if !defined(GET_DAGISEL_DECL) && !defined(GET_DAGISEL_BODY)
#define DAGISEL_INLINE 1
#else
#define DAGISEL_INLINE 0
#endif

#if !DAGISEL_INLINE
#define DAGISEL_CLASS_COLONCOLON GET_DAGISEL_BODY ::
#else
#define DAGISEL_CLASS_COLONCOLON
#endif

#ifdef GET_DAGISEL_DECL
void SelectCode(SDNode *N);
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
void DAGISEL_CLASS_COLONCOLON SelectCode(SDNode *N)
{
  // Some target values are emitted as 2 bytes, TARGET_VAL handles
  // this.
  #define TARGET_VAL(X) X & 255, unsigned(X) >> 8
  static const unsigned char MatcherTable[] = {
/*     0*/ OPC_SwitchOpcode /*116 cases */, 62|128,10/*1342*/, TARGET_VAL(ISD::ZERO_EXTEND),// ->1347
/*     5*/  OPC_Scope, 50|128,10/*1330*/, /*->1338*/ // 2 children in Scope
/*     8*/   OPC_MoveChild0,
/*     9*/   OPC_SwitchOpcode /*9 cases */, 8|128,1/*136*/, TARGET_VAL(ISD::AssertZext),// ->150
/*    14*/    OPC_MoveChild0,
/*    15*/    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*    18*/    OPC_RecordMemRef,
/*    19*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*    20*/    OPC_CheckFoldableChainNode,
/*    21*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*    22*/    OPC_Scope, 62, /*->86*/ // 2 children in Scope
/*    24*/     OPC_CheckChild1TypeI32,
/*    25*/     OPC_MoveChild2,
/*    26*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    29*/     OPC_RecordChild0, // #2 = $exp
/*    30*/     OPC_MoveSibling3,
/*    31*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    34*/     OPC_RecordChild0, // #3 = $new
/*    35*/     OPC_MoveParent,
/*    36*/     OPC_Scope, 23, /*->61*/ // 2 children in Scope
/*    38*/      OPC_CheckPredicate, 0, // Predicate_atomic_cmp_swap_8
/*    40*/      OPC_MoveParent,
/*    41*/      OPC_MoveParent,
/*    42*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    44*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*    47*/      OPC_EmitMergeInputChains1_0,
/*    48*/      OPC_EmitInteger32, 0, 
/*    50*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*    61*/     /*Scope*/ 23, /*->85*/
/*    62*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_16
/*    64*/      OPC_MoveParent,
/*    65*/      OPC_MoveParent,
/*    66*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    68*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*    71*/      OPC_EmitMergeInputChains1_0,
/*    72*/      OPC_EmitInteger32, 0, 
/*    74*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*    85*/     0, /*End of Scope*/
/*    86*/    /*Scope*/ 62, /*->149*/
/*    87*/     OPC_CheckChild1TypeI64,
/*    88*/     OPC_MoveChild2,
/*    89*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    92*/     OPC_RecordChild0, // #2 = $exp
/*    93*/     OPC_MoveSibling3,
/*    94*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    97*/     OPC_RecordChild0, // #3 = $new
/*    98*/     OPC_MoveParent,
/*    99*/     OPC_Scope, 23, /*->124*/ // 2 children in Scope
/*   101*/      OPC_CheckPredicate, 0, // Predicate_atomic_cmp_swap_8
/*   103*/      OPC_MoveParent,
/*   104*/      OPC_MoveParent,
/*   105*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   107*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   110*/      OPC_EmitMergeInputChains1_0,
/*   111*/      OPC_EmitInteger32, 0, 
/*   113*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   124*/     /*Scope*/ 23, /*->148*/
/*   125*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_16
/*   127*/      OPC_MoveParent,
/*   128*/      OPC_MoveParent,
/*   129*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   131*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   134*/      OPC_EmitMergeInputChains1_0,
/*   135*/      OPC_EmitInteger32, 0, 
/*   137*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   148*/     0, /*End of Scope*/
/*   149*/    0, /*End of Scope*/
/*   150*/   /*SwitchOpcode*/ 75, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->228
/*   153*/    OPC_RecordMemRef,
/*   154*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*   155*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   156*/    OPC_Scope, 34, /*->192*/ // 2 children in Scope
/*   158*/     OPC_CheckChild1TypeI32,
/*   159*/     OPC_MoveChild2,
/*   160*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   163*/     OPC_RecordChild0, // #2 = $exp
/*   164*/     OPC_MoveSibling3,
/*   165*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   168*/     OPC_RecordChild0, // #3 = $new
/*   169*/     OPC_MoveParent,
/*   170*/     OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_32
/*   172*/     OPC_MoveParent,
/*   173*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   175*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*   178*/     OPC_EmitMergeInputChains1_0,
/*   179*/     OPC_EmitInteger32, 0, 
/*   181*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 22
               // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   192*/    /*Scope*/ 34, /*->227*/
/*   193*/     OPC_CheckChild1TypeI64,
/*   194*/     OPC_MoveChild2,
/*   195*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   198*/     OPC_RecordChild0, // #2 = $exp
/*   199*/     OPC_MoveSibling3,
/*   200*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   203*/     OPC_RecordChild0, // #3 = $new
/*   204*/     OPC_MoveParent,
/*   205*/     OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_32
/*   207*/     OPC_MoveParent,
/*   208*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   210*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   213*/     OPC_EmitMergeInputChains1_0,
/*   214*/     OPC_EmitInteger32, 0, 
/*   216*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 22
               // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   227*/    0, /*End of Scope*/
/*   228*/   /*SwitchOpcode*/ 29|128,1/*157*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->389
/*   232*/    OPC_RecordMemRef,
/*   233*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*   234*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   235*/    OPC_Scope, 75, /*->312*/ // 2 children in Scope
/*   237*/     OPC_CheckChild1TypeI32,
/*   238*/     OPC_MoveChild2,
/*   239*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   242*/     OPC_RecordChild0, // #2 = $val
/*   243*/     OPC_MoveParent,
/*   244*/     OPC_Scope, 21, /*->267*/ // 3 children in Scope
/*   246*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_add_8
/*   248*/      OPC_MoveParent,
/*   249*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   251*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   254*/      OPC_EmitMergeInputChains1_0,
/*   255*/      OPC_EmitInteger32, 0, 
/*   257*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   267*/     /*Scope*/ 21, /*->289*/
/*   268*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_16
/*   270*/      OPC_MoveParent,
/*   271*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   273*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   276*/      OPC_EmitMergeInputChains1_0,
/*   277*/      OPC_EmitInteger32, 0, 
/*   279*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   289*/     /*Scope*/ 21, /*->311*/
/*   290*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_32
/*   292*/      OPC_MoveParent,
/*   293*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   295*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   298*/      OPC_EmitMergeInputChains1_0,
/*   299*/      OPC_EmitInteger32, 0, 
/*   301*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   311*/     0, /*End of Scope*/
/*   312*/    /*Scope*/ 75, /*->388*/
/*   313*/     OPC_CheckChild1TypeI64,
/*   314*/     OPC_MoveChild2,
/*   315*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   318*/     OPC_RecordChild0, // #2 = $val
/*   319*/     OPC_MoveParent,
/*   320*/     OPC_Scope, 21, /*->343*/ // 3 children in Scope
/*   322*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_add_8
/*   324*/      OPC_MoveParent,
/*   325*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   327*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   330*/      OPC_EmitMergeInputChains1_0,
/*   331*/      OPC_EmitInteger32, 0, 
/*   333*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   343*/     /*Scope*/ 21, /*->365*/
/*   344*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_16
/*   346*/      OPC_MoveParent,
/*   347*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   349*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   352*/      OPC_EmitMergeInputChains1_0,
/*   353*/      OPC_EmitInteger32, 0, 
/*   355*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   365*/     /*Scope*/ 21, /*->387*/
/*   366*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_32
/*   368*/      OPC_MoveParent,
/*   369*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   371*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   374*/      OPC_EmitMergeInputChains1_0,
/*   375*/      OPC_EmitInteger32, 0, 
/*   377*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   387*/     0, /*End of Scope*/
/*   388*/    0, /*End of Scope*/
/*   389*/   /*SwitchOpcode*/ 29|128,1/*157*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->550
/*   393*/    OPC_RecordMemRef,
/*   394*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*   395*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   396*/    OPC_Scope, 75, /*->473*/ // 2 children in Scope
/*   398*/     OPC_CheckChild1TypeI32,
/*   399*/     OPC_MoveChild2,
/*   400*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   403*/     OPC_RecordChild0, // #2 = $val
/*   404*/     OPC_MoveParent,
/*   405*/     OPC_Scope, 21, /*->428*/ // 3 children in Scope
/*   407*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_sub_8
/*   409*/      OPC_MoveParent,
/*   410*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   412*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   415*/      OPC_EmitMergeInputChains1_0,
/*   416*/      OPC_EmitInteger32, 0, 
/*   418*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   428*/     /*Scope*/ 21, /*->450*/
/*   429*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_16
/*   431*/      OPC_MoveParent,
/*   432*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   434*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   437*/      OPC_EmitMergeInputChains1_0,
/*   438*/      OPC_EmitInteger32, 0, 
/*   440*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   450*/     /*Scope*/ 21, /*->472*/
/*   451*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_32
/*   453*/      OPC_MoveParent,
/*   454*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   456*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   459*/      OPC_EmitMergeInputChains1_0,
/*   460*/      OPC_EmitInteger32, 0, 
/*   462*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   472*/     0, /*End of Scope*/
/*   473*/    /*Scope*/ 75, /*->549*/
/*   474*/     OPC_CheckChild1TypeI64,
/*   475*/     OPC_MoveChild2,
/*   476*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   479*/     OPC_RecordChild0, // #2 = $val
/*   480*/     OPC_MoveParent,
/*   481*/     OPC_Scope, 21, /*->504*/ // 3 children in Scope
/*   483*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_sub_8
/*   485*/      OPC_MoveParent,
/*   486*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   488*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   491*/      OPC_EmitMergeInputChains1_0,
/*   492*/      OPC_EmitInteger32, 0, 
/*   494*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   504*/     /*Scope*/ 21, /*->526*/
/*   505*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_16
/*   507*/      OPC_MoveParent,
/*   508*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   510*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   513*/      OPC_EmitMergeInputChains1_0,
/*   514*/      OPC_EmitInteger32, 0, 
/*   516*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   526*/     /*Scope*/ 21, /*->548*/
/*   527*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_32
/*   529*/      OPC_MoveParent,
/*   530*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   532*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   535*/      OPC_EmitMergeInputChains1_0,
/*   536*/      OPC_EmitInteger32, 0, 
/*   538*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   548*/     0, /*End of Scope*/
/*   549*/    0, /*End of Scope*/
/*   550*/   /*SwitchOpcode*/ 29|128,1/*157*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->711
/*   554*/    OPC_RecordMemRef,
/*   555*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*   556*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   557*/    OPC_Scope, 75, /*->634*/ // 2 children in Scope
/*   559*/     OPC_CheckChild1TypeI32,
/*   560*/     OPC_MoveChild2,
/*   561*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   564*/     OPC_RecordChild0, // #2 = $val
/*   565*/     OPC_MoveParent,
/*   566*/     OPC_Scope, 21, /*->589*/ // 3 children in Scope
/*   568*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_and_8
/*   570*/      OPC_MoveParent,
/*   571*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   573*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   576*/      OPC_EmitMergeInputChains1_0,
/*   577*/      OPC_EmitInteger32, 0, 
/*   579*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   589*/     /*Scope*/ 21, /*->611*/
/*   590*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_16
/*   592*/      OPC_MoveParent,
/*   593*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   595*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   598*/      OPC_EmitMergeInputChains1_0,
/*   599*/      OPC_EmitInteger32, 0, 
/*   601*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   611*/     /*Scope*/ 21, /*->633*/
/*   612*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_32
/*   614*/      OPC_MoveParent,
/*   615*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   617*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   620*/      OPC_EmitMergeInputChains1_0,
/*   621*/      OPC_EmitInteger32, 0, 
/*   623*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   633*/     0, /*End of Scope*/
/*   634*/    /*Scope*/ 75, /*->710*/
/*   635*/     OPC_CheckChild1TypeI64,
/*   636*/     OPC_MoveChild2,
/*   637*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   640*/     OPC_RecordChild0, // #2 = $val
/*   641*/     OPC_MoveParent,
/*   642*/     OPC_Scope, 21, /*->665*/ // 3 children in Scope
/*   644*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_and_8
/*   646*/      OPC_MoveParent,
/*   647*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   649*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   652*/      OPC_EmitMergeInputChains1_0,
/*   653*/      OPC_EmitInteger32, 0, 
/*   655*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   665*/     /*Scope*/ 21, /*->687*/
/*   666*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_16
/*   668*/      OPC_MoveParent,
/*   669*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   671*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   674*/      OPC_EmitMergeInputChains1_0,
/*   675*/      OPC_EmitInteger32, 0, 
/*   677*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   687*/     /*Scope*/ 21, /*->709*/
/*   688*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_32
/*   690*/      OPC_MoveParent,
/*   691*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   693*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   696*/      OPC_EmitMergeInputChains1_0,
/*   697*/      OPC_EmitInteger32, 0, 
/*   699*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   709*/     0, /*End of Scope*/
/*   710*/    0, /*End of Scope*/
/*   711*/   /*SwitchOpcode*/ 29|128,1/*157*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->872
/*   715*/    OPC_RecordMemRef,
/*   716*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*   717*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   718*/    OPC_Scope, 75, /*->795*/ // 2 children in Scope
/*   720*/     OPC_CheckChild1TypeI32,
/*   721*/     OPC_MoveChild2,
/*   722*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   725*/     OPC_RecordChild0, // #2 = $val
/*   726*/     OPC_MoveParent,
/*   727*/     OPC_Scope, 21, /*->750*/ // 3 children in Scope
/*   729*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_or_8
/*   731*/      OPC_MoveParent,
/*   732*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   734*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   737*/      OPC_EmitMergeInputChains1_0,
/*   738*/      OPC_EmitInteger32, 0, 
/*   740*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   750*/     /*Scope*/ 21, /*->772*/
/*   751*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_16
/*   753*/      OPC_MoveParent,
/*   754*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   756*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   759*/      OPC_EmitMergeInputChains1_0,
/*   760*/      OPC_EmitInteger32, 0, 
/*   762*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   772*/     /*Scope*/ 21, /*->794*/
/*   773*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_32
/*   775*/      OPC_MoveParent,
/*   776*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   778*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   781*/      OPC_EmitMergeInputChains1_0,
/*   782*/      OPC_EmitInteger32, 0, 
/*   784*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   794*/     0, /*End of Scope*/
/*   795*/    /*Scope*/ 75, /*->871*/
/*   796*/     OPC_CheckChild1TypeI64,
/*   797*/     OPC_MoveChild2,
/*   798*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   801*/     OPC_RecordChild0, // #2 = $val
/*   802*/     OPC_MoveParent,
/*   803*/     OPC_Scope, 21, /*->826*/ // 3 children in Scope
/*   805*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_or_8
/*   807*/      OPC_MoveParent,
/*   808*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   810*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   813*/      OPC_EmitMergeInputChains1_0,
/*   814*/      OPC_EmitInteger32, 0, 
/*   816*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   826*/     /*Scope*/ 21, /*->848*/
/*   827*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_16
/*   829*/      OPC_MoveParent,
/*   830*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   832*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   835*/      OPC_EmitMergeInputChains1_0,
/*   836*/      OPC_EmitInteger32, 0, 
/*   838*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   848*/     /*Scope*/ 21, /*->870*/
/*   849*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_32
/*   851*/      OPC_MoveParent,
/*   852*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   854*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   857*/      OPC_EmitMergeInputChains1_0,
/*   858*/      OPC_EmitInteger32, 0, 
/*   860*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   870*/     0, /*End of Scope*/
/*   871*/    0, /*End of Scope*/
/*   872*/   /*SwitchOpcode*/ 29|128,1/*157*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->1033
/*   876*/    OPC_RecordMemRef,
/*   877*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*   878*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   879*/    OPC_Scope, 75, /*->956*/ // 2 children in Scope
/*   881*/     OPC_CheckChild1TypeI32,
/*   882*/     OPC_MoveChild2,
/*   883*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   886*/     OPC_RecordChild0, // #2 = $val
/*   887*/     OPC_MoveParent,
/*   888*/     OPC_Scope, 21, /*->911*/ // 3 children in Scope
/*   890*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_xor_8
/*   892*/      OPC_MoveParent,
/*   893*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   895*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   898*/      OPC_EmitMergeInputChains1_0,
/*   899*/      OPC_EmitInteger32, 0, 
/*   901*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   911*/     /*Scope*/ 21, /*->933*/
/*   912*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_16
/*   914*/      OPC_MoveParent,
/*   915*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   917*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   920*/      OPC_EmitMergeInputChains1_0,
/*   921*/      OPC_EmitInteger32, 0, 
/*   923*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   933*/     /*Scope*/ 21, /*->955*/
/*   934*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_32
/*   936*/      OPC_MoveParent,
/*   937*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   939*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   942*/      OPC_EmitMergeInputChains1_0,
/*   943*/      OPC_EmitInteger32, 0, 
/*   945*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   955*/     0, /*End of Scope*/
/*   956*/    /*Scope*/ 75, /*->1032*/
/*   957*/     OPC_CheckChild1TypeI64,
/*   958*/     OPC_MoveChild2,
/*   959*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   962*/     OPC_RecordChild0, // #2 = $val
/*   963*/     OPC_MoveParent,
/*   964*/     OPC_Scope, 21, /*->987*/ // 3 children in Scope
/*   966*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_xor_8
/*   968*/      OPC_MoveParent,
/*   969*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   971*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   974*/      OPC_EmitMergeInputChains1_0,
/*   975*/      OPC_EmitInteger32, 0, 
/*   977*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   987*/     /*Scope*/ 21, /*->1009*/
/*   988*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_16
/*   990*/      OPC_MoveParent,
/*   991*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   993*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   996*/      OPC_EmitMergeInputChains1_0,
/*   997*/      OPC_EmitInteger32, 0, 
/*   999*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1009*/     /*Scope*/ 21, /*->1031*/
/*  1010*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_32
/*  1012*/      OPC_MoveParent,
/*  1013*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1015*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1018*/      OPC_EmitMergeInputChains1_0,
/*  1019*/      OPC_EmitInteger32, 0, 
/*  1021*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1031*/     0, /*End of Scope*/
/*  1032*/    0, /*End of Scope*/
/*  1033*/   /*SwitchOpcode*/ 29|128,1/*157*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->1194
/*  1037*/    OPC_RecordMemRef,
/*  1038*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  1039*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1040*/    OPC_Scope, 75, /*->1117*/ // 2 children in Scope
/*  1042*/     OPC_CheckChild1TypeI32,
/*  1043*/     OPC_MoveChild2,
/*  1044*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1047*/     OPC_RecordChild0, // #2 = $val
/*  1048*/     OPC_MoveParent,
/*  1049*/     OPC_Scope, 21, /*->1072*/ // 3 children in Scope
/*  1051*/      OPC_CheckPredicate, 0, // Predicate_atomic_swap_8
/*  1053*/      OPC_MoveParent,
/*  1054*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1056*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1059*/      OPC_EmitMergeInputChains1_0,
/*  1060*/      OPC_EmitInteger32, 0, 
/*  1062*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1072*/     /*Scope*/ 21, /*->1094*/
/*  1073*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_16
/*  1075*/      OPC_MoveParent,
/*  1076*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1078*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1081*/      OPC_EmitMergeInputChains1_0,
/*  1082*/      OPC_EmitInteger32, 0, 
/*  1084*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1094*/     /*Scope*/ 21, /*->1116*/
/*  1095*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_32
/*  1097*/      OPC_MoveParent,
/*  1098*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1100*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1103*/      OPC_EmitMergeInputChains1_0,
/*  1104*/      OPC_EmitInteger32, 0, 
/*  1106*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1116*/     0, /*End of Scope*/
/*  1117*/    /*Scope*/ 75, /*->1193*/
/*  1118*/     OPC_CheckChild1TypeI64,
/*  1119*/     OPC_MoveChild2,
/*  1120*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1123*/     OPC_RecordChild0, // #2 = $val
/*  1124*/     OPC_MoveParent,
/*  1125*/     OPC_Scope, 21, /*->1148*/ // 3 children in Scope
/*  1127*/      OPC_CheckPredicate, 0, // Predicate_atomic_swap_8
/*  1129*/      OPC_MoveParent,
/*  1130*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1132*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1135*/      OPC_EmitMergeInputChains1_0,
/*  1136*/      OPC_EmitInteger32, 0, 
/*  1138*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1148*/     /*Scope*/ 21, /*->1170*/
/*  1149*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_16
/*  1151*/      OPC_MoveParent,
/*  1152*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1154*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1157*/      OPC_EmitMergeInputChains1_0,
/*  1158*/      OPC_EmitInteger32, 0, 
/*  1160*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1170*/     /*Scope*/ 21, /*->1192*/
/*  1171*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_32
/*  1173*/      OPC_MoveParent,
/*  1174*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1176*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1179*/      OPC_EmitMergeInputChains1_0,
/*  1180*/      OPC_EmitInteger32, 0, 
/*  1182*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1192*/     0, /*End of Scope*/
/*  1193*/    0, /*End of Scope*/
/*  1194*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD),// ->1337
/*  1198*/    OPC_RecordMemRef,
/*  1199*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  1200*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1201*/    OPC_Scope, 66, /*->1269*/ // 2 children in Scope
/*  1203*/     OPC_CheckChild1TypeI32,
/*  1204*/     OPC_Scope, 20, /*->1226*/ // 3 children in Scope
/*  1206*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_8
/*  1208*/      OPC_MoveParent,
/*  1209*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  1211*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1214*/      OPC_EmitMergeInputChains1_0,
/*  1215*/      OPC_EmitInteger32, 0, 
/*  1217*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1226*/     /*Scope*/ 20, /*->1247*/
/*  1227*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_16
/*  1229*/      OPC_MoveParent,
/*  1230*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  1232*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1235*/      OPC_EmitMergeInputChains1_0,
/*  1236*/      OPC_EmitInteger32, 0, 
/*  1238*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1247*/     /*Scope*/ 20, /*->1268*/
/*  1248*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_32
/*  1250*/      OPC_MoveParent,
/*  1251*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  1253*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1256*/      OPC_EmitMergeInputChains1_0,
/*  1257*/      OPC_EmitInteger32, 0, 
/*  1259*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_32>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1268*/     0, /*End of Scope*/
/*  1269*/    /*Scope*/ 66, /*->1336*/
/*  1270*/     OPC_CheckChild1TypeI64,
/*  1271*/     OPC_Scope, 20, /*->1293*/ // 3 children in Scope
/*  1273*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_8
/*  1275*/      OPC_MoveParent,
/*  1276*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  1278*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1281*/      OPC_EmitMergeInputChains1_0,
/*  1282*/      OPC_EmitInteger32, 0, 
/*  1284*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1293*/     /*Scope*/ 20, /*->1314*/
/*  1294*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_16
/*  1296*/      OPC_MoveParent,
/*  1297*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  1299*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1302*/      OPC_EmitMergeInputChains1_0,
/*  1303*/      OPC_EmitInteger32, 0, 
/*  1305*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1314*/     /*Scope*/ 20, /*->1335*/
/*  1315*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_32
/*  1317*/      OPC_MoveParent,
/*  1318*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  1320*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1323*/      OPC_EmitMergeInputChains1_0,
/*  1324*/      OPC_EmitInteger32, 0, 
/*  1326*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_32>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1335*/     0, /*End of Scope*/
/*  1336*/    0, /*End of Scope*/
/*  1337*/   0, // EndSwitchOpcode
/*  1338*/  /*Scope*/ 7, /*->1346*/
/*  1339*/   OPC_RecordChild0, // #0 = $src
/*  1340*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (zext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/*  1346*/  0, /*End of Scope*/
/*  1347*/ /*SwitchOpcode*/ 55|128,7/*951*/, TARGET_VAL(ISD::ANY_EXTEND),// ->2302
/*  1351*/  OPC_Scope, 43|128,7/*939*/, /*->2293*/ // 2 children in Scope
/*  1354*/   OPC_MoveChild0,
/*  1355*/   OPC_SwitchOpcode /*8 cases */, 8|128,1/*136*/, TARGET_VAL(ISD::AssertZext),// ->1496
/*  1360*/    OPC_MoveChild0,
/*  1361*/    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*  1364*/    OPC_RecordMemRef,
/*  1365*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  1366*/    OPC_CheckFoldableChainNode,
/*  1367*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1368*/    OPC_Scope, 62, /*->1432*/ // 2 children in Scope
/*  1370*/     OPC_CheckChild1TypeI32,
/*  1371*/     OPC_MoveChild2,
/*  1372*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1375*/     OPC_RecordChild0, // #2 = $exp
/*  1376*/     OPC_MoveSibling3,
/*  1377*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1380*/     OPC_RecordChild0, // #3 = $new
/*  1381*/     OPC_MoveParent,
/*  1382*/     OPC_Scope, 23, /*->1407*/ // 2 children in Scope
/*  1384*/      OPC_CheckPredicate, 0, // Predicate_atomic_cmp_swap_8
/*  1386*/      OPC_MoveParent,
/*  1387*/      OPC_MoveParent,
/*  1388*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1390*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  1393*/      OPC_EmitMergeInputChains1_0,
/*  1394*/      OPC_EmitInteger32, 0, 
/*  1396*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1407*/     /*Scope*/ 23, /*->1431*/
/*  1408*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_16
/*  1410*/      OPC_MoveParent,
/*  1411*/      OPC_MoveParent,
/*  1412*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1414*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  1417*/      OPC_EmitMergeInputChains1_0,
/*  1418*/      OPC_EmitInteger32, 0, 
/*  1420*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1431*/     0, /*End of Scope*/
/*  1432*/    /*Scope*/ 62, /*->1495*/
/*  1433*/     OPC_CheckChild1TypeI64,
/*  1434*/     OPC_MoveChild2,
/*  1435*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1438*/     OPC_RecordChild0, // #2 = $exp
/*  1439*/     OPC_MoveSibling3,
/*  1440*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1443*/     OPC_RecordChild0, // #3 = $new
/*  1444*/     OPC_MoveParent,
/*  1445*/     OPC_Scope, 23, /*->1470*/ // 2 children in Scope
/*  1447*/      OPC_CheckPredicate, 0, // Predicate_atomic_cmp_swap_8
/*  1449*/      OPC_MoveParent,
/*  1450*/      OPC_MoveParent,
/*  1451*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1453*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  1456*/      OPC_EmitMergeInputChains1_0,
/*  1457*/      OPC_EmitInteger32, 0, 
/*  1459*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1470*/     /*Scope*/ 23, /*->1494*/
/*  1471*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_16
/*  1473*/      OPC_MoveParent,
/*  1474*/      OPC_MoveParent,
/*  1475*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1477*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  1480*/      OPC_EmitMergeInputChains1_0,
/*  1481*/      OPC_EmitInteger32, 0, 
/*  1483*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1494*/     0, /*End of Scope*/
/*  1495*/    0, /*End of Scope*/
/*  1496*/   /*SwitchOpcode*/ 113, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->1612
/*  1499*/    OPC_RecordMemRef,
/*  1500*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  1501*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1502*/    OPC_Scope, 53, /*->1557*/ // 2 children in Scope
/*  1504*/     OPC_CheckChild1TypeI32,
/*  1505*/     OPC_MoveChild2,
/*  1506*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1509*/     OPC_RecordChild0, // #2 = $val
/*  1510*/     OPC_MoveParent,
/*  1511*/     OPC_Scope, 21, /*->1534*/ // 2 children in Scope
/*  1513*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_add_8
/*  1515*/      OPC_MoveParent,
/*  1516*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1518*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1521*/      OPC_EmitMergeInputChains1_0,
/*  1522*/      OPC_EmitInteger32, 0, 
/*  1524*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1534*/     /*Scope*/ 21, /*->1556*/
/*  1535*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_16
/*  1537*/      OPC_MoveParent,
/*  1538*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1540*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1543*/      OPC_EmitMergeInputChains1_0,
/*  1544*/      OPC_EmitInteger32, 0, 
/*  1546*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1556*/     0, /*End of Scope*/
/*  1557*/    /*Scope*/ 53, /*->1611*/
/*  1558*/     OPC_CheckChild1TypeI64,
/*  1559*/     OPC_MoveChild2,
/*  1560*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1563*/     OPC_RecordChild0, // #2 = $val
/*  1564*/     OPC_MoveParent,
/*  1565*/     OPC_Scope, 21, /*->1588*/ // 2 children in Scope
/*  1567*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_add_8
/*  1569*/      OPC_MoveParent,
/*  1570*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1572*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1575*/      OPC_EmitMergeInputChains1_0,
/*  1576*/      OPC_EmitInteger32, 0, 
/*  1578*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1588*/     /*Scope*/ 21, /*->1610*/
/*  1589*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_16
/*  1591*/      OPC_MoveParent,
/*  1592*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1594*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1597*/      OPC_EmitMergeInputChains1_0,
/*  1598*/      OPC_EmitInteger32, 0, 
/*  1600*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1610*/     0, /*End of Scope*/
/*  1611*/    0, /*End of Scope*/
/*  1612*/   /*SwitchOpcode*/ 113, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->1728
/*  1615*/    OPC_RecordMemRef,
/*  1616*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  1617*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1618*/    OPC_Scope, 53, /*->1673*/ // 2 children in Scope
/*  1620*/     OPC_CheckChild1TypeI32,
/*  1621*/     OPC_MoveChild2,
/*  1622*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1625*/     OPC_RecordChild0, // #2 = $val
/*  1626*/     OPC_MoveParent,
/*  1627*/     OPC_Scope, 21, /*->1650*/ // 2 children in Scope
/*  1629*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_sub_8
/*  1631*/      OPC_MoveParent,
/*  1632*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1634*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1637*/      OPC_EmitMergeInputChains1_0,
/*  1638*/      OPC_EmitInteger32, 0, 
/*  1640*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1650*/     /*Scope*/ 21, /*->1672*/
/*  1651*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_16
/*  1653*/      OPC_MoveParent,
/*  1654*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1656*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1659*/      OPC_EmitMergeInputChains1_0,
/*  1660*/      OPC_EmitInteger32, 0, 
/*  1662*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1672*/     0, /*End of Scope*/
/*  1673*/    /*Scope*/ 53, /*->1727*/
/*  1674*/     OPC_CheckChild1TypeI64,
/*  1675*/     OPC_MoveChild2,
/*  1676*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1679*/     OPC_RecordChild0, // #2 = $val
/*  1680*/     OPC_MoveParent,
/*  1681*/     OPC_Scope, 21, /*->1704*/ // 2 children in Scope
/*  1683*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_sub_8
/*  1685*/      OPC_MoveParent,
/*  1686*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1688*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1691*/      OPC_EmitMergeInputChains1_0,
/*  1692*/      OPC_EmitInteger32, 0, 
/*  1694*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1704*/     /*Scope*/ 21, /*->1726*/
/*  1705*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_16
/*  1707*/      OPC_MoveParent,
/*  1708*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1710*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1713*/      OPC_EmitMergeInputChains1_0,
/*  1714*/      OPC_EmitInteger32, 0, 
/*  1716*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1726*/     0, /*End of Scope*/
/*  1727*/    0, /*End of Scope*/
/*  1728*/   /*SwitchOpcode*/ 113, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->1844
/*  1731*/    OPC_RecordMemRef,
/*  1732*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  1733*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1734*/    OPC_Scope, 53, /*->1789*/ // 2 children in Scope
/*  1736*/     OPC_CheckChild1TypeI32,
/*  1737*/     OPC_MoveChild2,
/*  1738*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1741*/     OPC_RecordChild0, // #2 = $val
/*  1742*/     OPC_MoveParent,
/*  1743*/     OPC_Scope, 21, /*->1766*/ // 2 children in Scope
/*  1745*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_and_8
/*  1747*/      OPC_MoveParent,
/*  1748*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1750*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1753*/      OPC_EmitMergeInputChains1_0,
/*  1754*/      OPC_EmitInteger32, 0, 
/*  1756*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1766*/     /*Scope*/ 21, /*->1788*/
/*  1767*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_16
/*  1769*/      OPC_MoveParent,
/*  1770*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1772*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1775*/      OPC_EmitMergeInputChains1_0,
/*  1776*/      OPC_EmitInteger32, 0, 
/*  1778*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1788*/     0, /*End of Scope*/
/*  1789*/    /*Scope*/ 53, /*->1843*/
/*  1790*/     OPC_CheckChild1TypeI64,
/*  1791*/     OPC_MoveChild2,
/*  1792*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1795*/     OPC_RecordChild0, // #2 = $val
/*  1796*/     OPC_MoveParent,
/*  1797*/     OPC_Scope, 21, /*->1820*/ // 2 children in Scope
/*  1799*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_and_8
/*  1801*/      OPC_MoveParent,
/*  1802*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1804*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1807*/      OPC_EmitMergeInputChains1_0,
/*  1808*/      OPC_EmitInteger32, 0, 
/*  1810*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1820*/     /*Scope*/ 21, /*->1842*/
/*  1821*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_16
/*  1823*/      OPC_MoveParent,
/*  1824*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1826*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1829*/      OPC_EmitMergeInputChains1_0,
/*  1830*/      OPC_EmitInteger32, 0, 
/*  1832*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1842*/     0, /*End of Scope*/
/*  1843*/    0, /*End of Scope*/
/*  1844*/   /*SwitchOpcode*/ 113, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->1960
/*  1847*/    OPC_RecordMemRef,
/*  1848*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  1849*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1850*/    OPC_Scope, 53, /*->1905*/ // 2 children in Scope
/*  1852*/     OPC_CheckChild1TypeI32,
/*  1853*/     OPC_MoveChild2,
/*  1854*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1857*/     OPC_RecordChild0, // #2 = $val
/*  1858*/     OPC_MoveParent,
/*  1859*/     OPC_Scope, 21, /*->1882*/ // 2 children in Scope
/*  1861*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_or_8
/*  1863*/      OPC_MoveParent,
/*  1864*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1866*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1869*/      OPC_EmitMergeInputChains1_0,
/*  1870*/      OPC_EmitInteger32, 0, 
/*  1872*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1882*/     /*Scope*/ 21, /*->1904*/
/*  1883*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_16
/*  1885*/      OPC_MoveParent,
/*  1886*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1888*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1891*/      OPC_EmitMergeInputChains1_0,
/*  1892*/      OPC_EmitInteger32, 0, 
/*  1894*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1904*/     0, /*End of Scope*/
/*  1905*/    /*Scope*/ 53, /*->1959*/
/*  1906*/     OPC_CheckChild1TypeI64,
/*  1907*/     OPC_MoveChild2,
/*  1908*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1911*/     OPC_RecordChild0, // #2 = $val
/*  1912*/     OPC_MoveParent,
/*  1913*/     OPC_Scope, 21, /*->1936*/ // 2 children in Scope
/*  1915*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_or_8
/*  1917*/      OPC_MoveParent,
/*  1918*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1920*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1923*/      OPC_EmitMergeInputChains1_0,
/*  1924*/      OPC_EmitInteger32, 0, 
/*  1926*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1936*/     /*Scope*/ 21, /*->1958*/
/*  1937*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_16
/*  1939*/      OPC_MoveParent,
/*  1940*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1942*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1945*/      OPC_EmitMergeInputChains1_0,
/*  1946*/      OPC_EmitInteger32, 0, 
/*  1948*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1958*/     0, /*End of Scope*/
/*  1959*/    0, /*End of Scope*/
/*  1960*/   /*SwitchOpcode*/ 113, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->2076
/*  1963*/    OPC_RecordMemRef,
/*  1964*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  1965*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1966*/    OPC_Scope, 53, /*->2021*/ // 2 children in Scope
/*  1968*/     OPC_CheckChild1TypeI32,
/*  1969*/     OPC_MoveChild2,
/*  1970*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1973*/     OPC_RecordChild0, // #2 = $val
/*  1974*/     OPC_MoveParent,
/*  1975*/     OPC_Scope, 21, /*->1998*/ // 2 children in Scope
/*  1977*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_xor_8
/*  1979*/      OPC_MoveParent,
/*  1980*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1982*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1985*/      OPC_EmitMergeInputChains1_0,
/*  1986*/      OPC_EmitInteger32, 0, 
/*  1988*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1998*/     /*Scope*/ 21, /*->2020*/
/*  1999*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_16
/*  2001*/      OPC_MoveParent,
/*  2002*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2004*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  2007*/      OPC_EmitMergeInputChains1_0,
/*  2008*/      OPC_EmitInteger32, 0, 
/*  2010*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  2020*/     0, /*End of Scope*/
/*  2021*/    /*Scope*/ 53, /*->2075*/
/*  2022*/     OPC_CheckChild1TypeI64,
/*  2023*/     OPC_MoveChild2,
/*  2024*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2027*/     OPC_RecordChild0, // #2 = $val
/*  2028*/     OPC_MoveParent,
/*  2029*/     OPC_Scope, 21, /*->2052*/ // 2 children in Scope
/*  2031*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_xor_8
/*  2033*/      OPC_MoveParent,
/*  2034*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2036*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  2039*/      OPC_EmitMergeInputChains1_0,
/*  2040*/      OPC_EmitInteger32, 0, 
/*  2042*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  2052*/     /*Scope*/ 21, /*->2074*/
/*  2053*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_16
/*  2055*/      OPC_MoveParent,
/*  2056*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2058*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  2061*/      OPC_EmitMergeInputChains1_0,
/*  2062*/      OPC_EmitInteger32, 0, 
/*  2064*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  2074*/     0, /*End of Scope*/
/*  2075*/    0, /*End of Scope*/
/*  2076*/   /*SwitchOpcode*/ 113, TARGET_VAL(ISD::ATOMIC_SWAP),// ->2192
/*  2079*/    OPC_RecordMemRef,
/*  2080*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  2081*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  2082*/    OPC_Scope, 53, /*->2137*/ // 2 children in Scope
/*  2084*/     OPC_CheckChild1TypeI32,
/*  2085*/     OPC_MoveChild2,
/*  2086*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2089*/     OPC_RecordChild0, // #2 = $val
/*  2090*/     OPC_MoveParent,
/*  2091*/     OPC_Scope, 21, /*->2114*/ // 2 children in Scope
/*  2093*/      OPC_CheckPredicate, 0, // Predicate_atomic_swap_8
/*  2095*/      OPC_MoveParent,
/*  2096*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2098*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  2101*/      OPC_EmitMergeInputChains1_0,
/*  2102*/      OPC_EmitInteger32, 0, 
/*  2104*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  2114*/     /*Scope*/ 21, /*->2136*/
/*  2115*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_16
/*  2117*/      OPC_MoveParent,
/*  2118*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2120*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  2123*/      OPC_EmitMergeInputChains1_0,
/*  2124*/      OPC_EmitInteger32, 0, 
/*  2126*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  2136*/     0, /*End of Scope*/
/*  2137*/    /*Scope*/ 53, /*->2191*/
/*  2138*/     OPC_CheckChild1TypeI64,
/*  2139*/     OPC_MoveChild2,
/*  2140*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2143*/     OPC_RecordChild0, // #2 = $val
/*  2144*/     OPC_MoveParent,
/*  2145*/     OPC_Scope, 21, /*->2168*/ // 2 children in Scope
/*  2147*/      OPC_CheckPredicate, 0, // Predicate_atomic_swap_8
/*  2149*/      OPC_MoveParent,
/*  2150*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2152*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  2155*/      OPC_EmitMergeInputChains1_0,
/*  2156*/      OPC_EmitInteger32, 0, 
/*  2158*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  2168*/     /*Scope*/ 21, /*->2190*/
/*  2169*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_16
/*  2171*/      OPC_MoveParent,
/*  2172*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2174*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  2177*/      OPC_EmitMergeInputChains1_0,
/*  2178*/      OPC_EmitInteger32, 0, 
/*  2180*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  2190*/     0, /*End of Scope*/
/*  2191*/    0, /*End of Scope*/
/*  2192*/   /*SwitchOpcode*/ 97, TARGET_VAL(ISD::ATOMIC_LOAD),// ->2292
/*  2195*/    OPC_RecordMemRef,
/*  2196*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  2197*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  2198*/    OPC_Scope, 45, /*->2245*/ // 2 children in Scope
/*  2200*/     OPC_CheckChild1TypeI32,
/*  2201*/     OPC_Scope, 20, /*->2223*/ // 2 children in Scope
/*  2203*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_8
/*  2205*/      OPC_MoveParent,
/*  2206*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2208*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  2211*/      OPC_EmitMergeInputChains1_0,
/*  2212*/      OPC_EmitInteger32, 0, 
/*  2214*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  2223*/     /*Scope*/ 20, /*->2244*/
/*  2224*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_16
/*  2226*/      OPC_MoveParent,
/*  2227*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2229*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  2232*/      OPC_EmitMergeInputChains1_0,
/*  2233*/      OPC_EmitInteger32, 0, 
/*  2235*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  2244*/     0, /*End of Scope*/
/*  2245*/    /*Scope*/ 45, /*->2291*/
/*  2246*/     OPC_CheckChild1TypeI64,
/*  2247*/     OPC_Scope, 20, /*->2269*/ // 2 children in Scope
/*  2249*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_8
/*  2251*/      OPC_MoveParent,
/*  2252*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2254*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  2257*/      OPC_EmitMergeInputChains1_0,
/*  2258*/      OPC_EmitInteger32, 0, 
/*  2260*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  2269*/     /*Scope*/ 20, /*->2290*/
/*  2270*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_16
/*  2272*/      OPC_MoveParent,
/*  2273*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2275*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  2278*/      OPC_EmitMergeInputChains1_0,
/*  2279*/      OPC_EmitInteger32, 0, 
/*  2281*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  2290*/     0, /*End of Scope*/
/*  2291*/    0, /*End of Scope*/
/*  2292*/   0, // EndSwitchOpcode
/*  2293*/  /*Scope*/ 7, /*->2301*/
/*  2294*/   OPC_RecordChild0, // #0 = $src
/*  2295*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (anyext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/*  2301*/  0, /*End of Scope*/
/*  2302*/ /*SwitchOpcode*/ 22|128,8/*1046*/, TARGET_VAL(ISD::STORE),// ->3352
/*  2306*/  OPC_RecordMemRef,
/*  2307*/  OPC_RecordNode, // #0 = 'st' chained node
/*  2308*/  OPC_Scope, 27|128,2/*283*/, /*->2594*/ // 2 children in Scope
/*  2311*/   OPC_MoveChild1,
/*  2312*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  2315*/   OPC_RecordChild0, // #1 = $vec
/*  2316*/   OPC_Scope, 70, /*->2388*/ // 4 children in Scope
/*  2318*/    OPC_CheckChild0Type, MVT::v16i8,
/*  2320*/    OPC_RecordChild1, // #2 = $idx
/*  2321*/    OPC_MoveChild1,
/*  2322*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2325*/    OPC_CheckPredicate, 3, // Predicate_LaneIdx16
/*  2327*/    OPC_CheckTypeI32,
/*  2328*/    OPC_MoveParent,
/*  2329*/    OPC_CheckTypeI32,
/*  2330*/    OPC_MoveParent,
/*  2331*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2332*/    OPC_Scope, 26, /*->2360*/ // 2 children in Scope
/*  2334*/     OPC_CheckChild2TypeI32,
/*  2335*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2337*/     OPC_CheckPredicate, 5, // Predicate_truncstore
/*  2339*/     OPC_CheckPredicate, 6, // Predicate_truncstorei8
/*  2341*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2343*/     OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2346*/     OPC_EmitMergeInputChains1_0,
/*  2347*/     OPC_EmitInteger32, 0, 
/*  2349*/     OPC_EmitConvertToTarget2,
/*  2350*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 21
               // Dst: (STORE_LANE_I8x16_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v16i8] }:$vec)
/*  2360*/    /*Scope*/ 26, /*->2387*/
/*  2361*/     OPC_CheckChild2TypeI64,
/*  2362*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2364*/     OPC_CheckPredicate, 5, // Predicate_truncstore
/*  2366*/     OPC_CheckPredicate, 6, // Predicate_truncstorei8
/*  2368*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2370*/     OPC_CheckComplexPat, /*CP*/1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2373*/     OPC_EmitMergeInputChains1_0,
/*  2374*/     OPC_EmitInteger32, 0, 
/*  2376*/     OPC_EmitConvertToTarget2,
/*  2377*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 21
               // Dst: (STORE_LANE_I8x16_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v16i8] }:$vec)
/*  2387*/    0, /*End of Scope*/
/*  2388*/   /*Scope*/ 70, /*->2459*/
/*  2389*/    OPC_CheckChild0Type, MVT::v8i16,
/*  2391*/    OPC_RecordChild1, // #2 = $idx
/*  2392*/    OPC_MoveChild1,
/*  2393*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2396*/    OPC_CheckPredicate, 7, // Predicate_LaneIdx8
/*  2398*/    OPC_CheckTypeI32,
/*  2399*/    OPC_MoveParent,
/*  2400*/    OPC_CheckTypeI32,
/*  2401*/    OPC_MoveParent,
/*  2402*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2403*/    OPC_Scope, 26, /*->2431*/ // 2 children in Scope
/*  2405*/     OPC_CheckChild2TypeI32,
/*  2406*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2408*/     OPC_CheckPredicate, 5, // Predicate_truncstore
/*  2410*/     OPC_CheckPredicate, 8, // Predicate_truncstorei16
/*  2412*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2414*/     OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2417*/     OPC_EmitMergeInputChains1_0,
/*  2418*/     OPC_EmitInteger32, 0, 
/*  2420*/     OPC_EmitConvertToTarget2,
/*  2421*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 21
               // Dst: (STORE_LANE_I16x8_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v8i16] }:$vec)
/*  2431*/    /*Scope*/ 26, /*->2458*/
/*  2432*/     OPC_CheckChild2TypeI64,
/*  2433*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2435*/     OPC_CheckPredicate, 5, // Predicate_truncstore
/*  2437*/     OPC_CheckPredicate, 8, // Predicate_truncstorei16
/*  2439*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2441*/     OPC_CheckComplexPat, /*CP*/1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2444*/     OPC_EmitMergeInputChains1_0,
/*  2445*/     OPC_EmitInteger32, 0, 
/*  2447*/     OPC_EmitConvertToTarget2,
/*  2448*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 21
               // Dst: (STORE_LANE_I16x8_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v8i16] }:$vec)
/*  2458*/    0, /*End of Scope*/
/*  2459*/   /*Scope*/ 66, /*->2526*/
/*  2460*/    OPC_CheckChild0Type, MVT::v4i32,
/*  2462*/    OPC_RecordChild1, // #2 = $idx
/*  2463*/    OPC_MoveChild1,
/*  2464*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2467*/    OPC_CheckPredicate, 9, // Predicate_LaneIdx4
/*  2469*/    OPC_CheckTypeI32,
/*  2470*/    OPC_MoveParent,
/*  2471*/    OPC_CheckTypeI32,
/*  2472*/    OPC_MoveParent,
/*  2473*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2474*/    OPC_Scope, 24, /*->2500*/ // 2 children in Scope
/*  2476*/     OPC_CheckChild2TypeI32,
/*  2477*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2479*/     OPC_CheckPredicate, 10, // Predicate_store
/*  2481*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2483*/     OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2486*/     OPC_EmitMergeInputChains1_0,
/*  2487*/     OPC_EmitInteger32, 0, 
/*  2489*/     OPC_EmitConvertToTarget2,
/*  2490*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I32x4_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/*  2500*/    /*Scope*/ 24, /*->2525*/
/*  2501*/     OPC_CheckChild2TypeI64,
/*  2502*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2504*/     OPC_CheckPredicate, 10, // Predicate_store
/*  2506*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2508*/     OPC_CheckComplexPat, /*CP*/1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2511*/     OPC_EmitMergeInputChains1_0,
/*  2512*/     OPC_EmitInteger32, 0, 
/*  2514*/     OPC_EmitConvertToTarget2,
/*  2515*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I32x4_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/*  2525*/    0, /*End of Scope*/
/*  2526*/   /*Scope*/ 66, /*->2593*/
/*  2527*/    OPC_CheckChild0Type, MVT::v2i64,
/*  2529*/    OPC_RecordChild1, // #2 = $idx
/*  2530*/    OPC_MoveChild1,
/*  2531*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2534*/    OPC_CheckPredicate, 11, // Predicate_LaneIdx2
/*  2536*/    OPC_CheckTypeI32,
/*  2537*/    OPC_MoveParent,
/*  2538*/    OPC_CheckTypeI64,
/*  2539*/    OPC_MoveParent,
/*  2540*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2541*/    OPC_Scope, 24, /*->2567*/ // 2 children in Scope
/*  2543*/     OPC_CheckChild2TypeI32,
/*  2544*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2546*/     OPC_CheckPredicate, 10, // Predicate_store
/*  2548*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2550*/     OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2553*/     OPC_EmitMergeInputChains1_0,
/*  2554*/     OPC_EmitInteger32, 0, 
/*  2556*/     OPC_EmitConvertToTarget2,
/*  2557*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I64x2_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/*  2567*/    /*Scope*/ 24, /*->2592*/
/*  2568*/     OPC_CheckChild2TypeI64,
/*  2569*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2571*/     OPC_CheckPredicate, 10, // Predicate_store
/*  2573*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2575*/     OPC_CheckComplexPat, /*CP*/1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2578*/     OPC_EmitMergeInputChains1_0,
/*  2579*/     OPC_EmitInteger32, 0, 
/*  2581*/     OPC_EmitConvertToTarget2,
/*  2582*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I64x2_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/*  2592*/    0, /*End of Scope*/
/*  2593*/   0, /*End of Scope*/
/*  2594*/  /*Scope*/ 115|128,5/*755*/, /*->3351*/
/*  2596*/   OPC_RecordChild1, // #1 = $val
/*  2597*/   OPC_Scope, 18|128,1/*146*/, /*->2746*/ // 10 children in Scope
/*  2600*/    OPC_CheckChild1TypeI32,
/*  2601*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2602*/    OPC_Scope, 70, /*->2674*/ // 2 children in Scope
/*  2604*/     OPC_CheckChild2TypeI32,
/*  2605*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2607*/     OPC_Scope, 19, /*->2628*/ // 2 children in Scope
/*  2609*/      OPC_CheckPredicate, 10, // Predicate_store
/*  2611*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2613*/      OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2616*/      OPC_EmitMergeInputChains1_0,
/*  2617*/      OPC_EmitInteger32, 0, 
/*  2619*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2628*/     /*Scope*/ 44, /*->2673*/
/*  2629*/      OPC_CheckPredicate, 5, // Predicate_truncstore
/*  2631*/      OPC_Scope, 19, /*->2652*/ // 2 children in Scope
/*  2633*/       OPC_CheckPredicate, 6, // Predicate_truncstorei8
/*  2635*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2637*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2640*/       OPC_EmitMergeInputChains1_0,
/*  2641*/       OPC_EmitInteger32, 0, 
/*  2643*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2652*/      /*Scope*/ 19, /*->2672*/
/*  2653*/       OPC_CheckPredicate, 8, // Predicate_truncstorei16
/*  2655*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2657*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2660*/       OPC_EmitMergeInputChains1_0,
/*  2661*/       OPC_EmitInteger32, 0, 
/*  2663*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2672*/      0, /*End of Scope*/
/*  2673*/     0, /*End of Scope*/
/*  2674*/    /*Scope*/ 70, /*->2745*/
/*  2675*/     OPC_CheckChild2TypeI64,
/*  2676*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2678*/     OPC_Scope, 19, /*->2699*/ // 2 children in Scope
/*  2680*/      OPC_CheckPredicate, 10, // Predicate_store
/*  2682*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2684*/      OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2687*/      OPC_EmitMergeInputChains1_0,
/*  2688*/      OPC_EmitInteger32, 0, 
/*  2690*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2699*/     /*Scope*/ 44, /*->2744*/
/*  2700*/      OPC_CheckPredicate, 5, // Predicate_truncstore
/*  2702*/      OPC_Scope, 19, /*->2723*/ // 2 children in Scope
/*  2704*/       OPC_CheckPredicate, 6, // Predicate_truncstorei8
/*  2706*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2708*/       OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2711*/       OPC_EmitMergeInputChains1_0,
/*  2712*/       OPC_EmitInteger32, 0, 
/*  2714*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2723*/      /*Scope*/ 19, /*->2743*/
/*  2724*/       OPC_CheckPredicate, 8, // Predicate_truncstorei16
/*  2726*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2728*/       OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2731*/       OPC_EmitMergeInputChains1_0,
/*  2732*/       OPC_EmitInteger32, 0, 
/*  2734*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2743*/      0, /*End of Scope*/
/*  2744*/     0, /*End of Scope*/
/*  2745*/    0, /*End of Scope*/
/*  2746*/   /*Scope*/ 58|128,1/*186*/, /*->2934*/
/*  2748*/    OPC_CheckChild1TypeI64,
/*  2749*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2750*/    OPC_Scope, 90, /*->2842*/ // 2 children in Scope
/*  2752*/     OPC_CheckChild2TypeI32,
/*  2753*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2755*/     OPC_Scope, 19, /*->2776*/ // 2 children in Scope
/*  2757*/      OPC_CheckPredicate, 10, // Predicate_store
/*  2759*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2761*/      OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2764*/      OPC_EmitMergeInputChains1_0,
/*  2765*/      OPC_EmitInteger32, 0, 
/*  2767*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2776*/     /*Scope*/ 64, /*->2841*/
/*  2777*/      OPC_CheckPredicate, 5, // Predicate_truncstore
/*  2779*/      OPC_Scope, 19, /*->2800*/ // 3 children in Scope
/*  2781*/       OPC_CheckPredicate, 6, // Predicate_truncstorei8
/*  2783*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2785*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2788*/       OPC_EmitMergeInputChains1_0,
/*  2789*/       OPC_EmitInteger32, 0, 
/*  2791*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2800*/      /*Scope*/ 19, /*->2820*/
/*  2801*/       OPC_CheckPredicate, 8, // Predicate_truncstorei16
/*  2803*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2805*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2808*/       OPC_EmitMergeInputChains1_0,
/*  2809*/       OPC_EmitInteger32, 0, 
/*  2811*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2820*/      /*Scope*/ 19, /*->2840*/
/*  2821*/       OPC_CheckPredicate, 12, // Predicate_truncstorei32
/*  2823*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2825*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2828*/       OPC_EmitMergeInputChains1_0,
/*  2829*/       OPC_EmitInteger32, 0, 
/*  2831*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                 // Dst: (STORE32_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2840*/      0, /*End of Scope*/
/*  2841*/     0, /*End of Scope*/
/*  2842*/    /*Scope*/ 90, /*->2933*/
/*  2843*/     OPC_CheckChild2TypeI64,
/*  2844*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2846*/     OPC_Scope, 19, /*->2867*/ // 2 children in Scope
/*  2848*/      OPC_CheckPredicate, 10, // Predicate_store
/*  2850*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2852*/      OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2855*/      OPC_EmitMergeInputChains1_0,
/*  2856*/      OPC_EmitInteger32, 0, 
/*  2858*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2867*/     /*Scope*/ 64, /*->2932*/
/*  2868*/      OPC_CheckPredicate, 5, // Predicate_truncstore
/*  2870*/      OPC_Scope, 19, /*->2891*/ // 3 children in Scope
/*  2872*/       OPC_CheckPredicate, 6, // Predicate_truncstorei8
/*  2874*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2876*/       OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2879*/       OPC_EmitMergeInputChains1_0,
/*  2880*/       OPC_EmitInteger32, 0, 
/*  2882*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2891*/      /*Scope*/ 19, /*->2911*/
/*  2892*/       OPC_CheckPredicate, 8, // Predicate_truncstorei16
/*  2894*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2896*/       OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2899*/       OPC_EmitMergeInputChains1_0,
/*  2900*/       OPC_EmitInteger32, 0, 
/*  2902*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2911*/      /*Scope*/ 19, /*->2931*/
/*  2912*/       OPC_CheckPredicate, 12, // Predicate_truncstorei32
/*  2914*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2916*/       OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2919*/       OPC_EmitMergeInputChains1_0,
/*  2920*/       OPC_EmitInteger32, 0, 
/*  2922*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                 // Dst: (STORE32_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2931*/      0, /*End of Scope*/
/*  2932*/     0, /*End of Scope*/
/*  2933*/    0, /*End of Scope*/
/*  2934*/   /*Scope*/ 51, /*->2986*/
/*  2935*/    OPC_CheckChild1Type, MVT::f32,
/*  2937*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2938*/    OPC_Scope, 22, /*->2962*/ // 2 children in Scope
/*  2940*/     OPC_CheckChild2TypeI32,
/*  2941*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2943*/     OPC_CheckPredicate, 10, // Predicate_store
/*  2945*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2947*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2950*/     OPC_EmitMergeInputChains1_0,
/*  2951*/     OPC_EmitInteger32, 0, 
/*  2953*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f32:{ *:[f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/*  2962*/    /*Scope*/ 22, /*->2985*/
/*  2963*/     OPC_CheckChild2TypeI64,
/*  2964*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2966*/     OPC_CheckPredicate, 10, // Predicate_store
/*  2968*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2970*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2973*/     OPC_EmitMergeInputChains1_0,
/*  2974*/     OPC_EmitInteger32, 0, 
/*  2976*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f32:{ *:[f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f32:{ *:[f32] }:$val)
/*  2985*/    0, /*End of Scope*/
/*  2986*/   /*Scope*/ 51, /*->3038*/
/*  2987*/    OPC_CheckChild1Type, MVT::f64,
/*  2989*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2990*/    OPC_Scope, 22, /*->3014*/ // 2 children in Scope
/*  2992*/     OPC_CheckChild2TypeI32,
/*  2993*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2995*/     OPC_CheckPredicate, 10, // Predicate_store
/*  2997*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2999*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3002*/     OPC_EmitMergeInputChains1_0,
/*  3003*/     OPC_EmitInteger32, 0, 
/*  3005*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f64:{ *:[f64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f64:{ *:[f64] }:$val)
/*  3014*/    /*Scope*/ 22, /*->3037*/
/*  3015*/     OPC_CheckChild2TypeI64,
/*  3016*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3018*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3020*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3022*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3025*/     OPC_EmitMergeInputChains1_0,
/*  3026*/     OPC_EmitInteger32, 0, 
/*  3028*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f64:{ *:[f64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f64:{ *:[f64] }:$val)
/*  3037*/    0, /*End of Scope*/
/*  3038*/   /*Scope*/ 51, /*->3090*/
/*  3039*/    OPC_CheckChild1Type, MVT::v16i8,
/*  3041*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3042*/    OPC_Scope, 22, /*->3066*/ // 2 children in Scope
/*  3044*/     OPC_CheckChild2TypeI32,
/*  3045*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3047*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3049*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  3051*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3054*/     OPC_EmitMergeInputChains1_0,
/*  3055*/     OPC_EmitInteger32, 0, 
/*  3057*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v16i8:{ *:[v16i8] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v16i8:{ *:[v16i8] }:$val)
/*  3066*/    /*Scope*/ 22, /*->3089*/
/*  3067*/     OPC_CheckChild2TypeI64,
/*  3068*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3070*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3072*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3074*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3077*/     OPC_EmitMergeInputChains1_0,
/*  3078*/     OPC_EmitInteger32, 0, 
/*  3080*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v16i8:{ *:[v16i8] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v16i8:{ *:[v16i8] }:$val)
/*  3089*/    0, /*End of Scope*/
/*  3090*/   /*Scope*/ 51, /*->3142*/
/*  3091*/    OPC_CheckChild1Type, MVT::v8i16,
/*  3093*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3094*/    OPC_Scope, 22, /*->3118*/ // 2 children in Scope
/*  3096*/     OPC_CheckChild2TypeI32,
/*  3097*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3099*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3101*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  3103*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3106*/     OPC_EmitMergeInputChains1_0,
/*  3107*/     OPC_EmitInteger32, 0, 
/*  3109*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8i16:{ *:[v8i16] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v8i16:{ *:[v8i16] }:$val)
/*  3118*/    /*Scope*/ 22, /*->3141*/
/*  3119*/     OPC_CheckChild2TypeI64,
/*  3120*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3122*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3124*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3126*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3129*/     OPC_EmitMergeInputChains1_0,
/*  3130*/     OPC_EmitInteger32, 0, 
/*  3132*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8i16:{ *:[v8i16] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v8i16:{ *:[v8i16] }:$val)
/*  3141*/    0, /*End of Scope*/
/*  3142*/   /*Scope*/ 51, /*->3194*/
/*  3143*/    OPC_CheckChild1Type, MVT::v4i32,
/*  3145*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3146*/    OPC_Scope, 22, /*->3170*/ // 2 children in Scope
/*  3148*/     OPC_CheckChild2TypeI32,
/*  3149*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3151*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3153*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  3155*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3158*/     OPC_EmitMergeInputChains1_0,
/*  3159*/     OPC_EmitInteger32, 0, 
/*  3161*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4i32:{ *:[v4i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v4i32:{ *:[v4i32] }:$val)
/*  3170*/    /*Scope*/ 22, /*->3193*/
/*  3171*/     OPC_CheckChild2TypeI64,
/*  3172*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3174*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3176*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3178*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3181*/     OPC_EmitMergeInputChains1_0,
/*  3182*/     OPC_EmitInteger32, 0, 
/*  3184*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4i32:{ *:[v4i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v4i32:{ *:[v4i32] }:$val)
/*  3193*/    0, /*End of Scope*/
/*  3194*/   /*Scope*/ 51, /*->3246*/
/*  3195*/    OPC_CheckChild1Type, MVT::v2i64,
/*  3197*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3198*/    OPC_Scope, 22, /*->3222*/ // 2 children in Scope
/*  3200*/     OPC_CheckChild2TypeI32,
/*  3201*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3203*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3205*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  3207*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3210*/     OPC_EmitMergeInputChains1_0,
/*  3211*/     OPC_EmitInteger32, 0, 
/*  3213*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2i64:{ *:[v2i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v2i64:{ *:[v2i64] }:$val)
/*  3222*/    /*Scope*/ 22, /*->3245*/
/*  3223*/     OPC_CheckChild2TypeI64,
/*  3224*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3226*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3228*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3230*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3233*/     OPC_EmitMergeInputChains1_0,
/*  3234*/     OPC_EmitInteger32, 0, 
/*  3236*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2i64:{ *:[v2i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v2i64:{ *:[v2i64] }:$val)
/*  3245*/    0, /*End of Scope*/
/*  3246*/   /*Scope*/ 51, /*->3298*/
/*  3247*/    OPC_CheckChild1Type, MVT::v4f32,
/*  3249*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3250*/    OPC_Scope, 22, /*->3274*/ // 2 children in Scope
/*  3252*/     OPC_CheckChild2TypeI32,
/*  3253*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3255*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3257*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  3259*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3262*/     OPC_EmitMergeInputChains1_0,
/*  3263*/     OPC_EmitInteger32, 0, 
/*  3265*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4f32:{ *:[v4f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v4f32:{ *:[v4f32] }:$val)
/*  3274*/    /*Scope*/ 22, /*->3297*/
/*  3275*/     OPC_CheckChild2TypeI64,
/*  3276*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3278*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3280*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3282*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3285*/     OPC_EmitMergeInputChains1_0,
/*  3286*/     OPC_EmitInteger32, 0, 
/*  3288*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4f32:{ *:[v4f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v4f32:{ *:[v4f32] }:$val)
/*  3297*/    0, /*End of Scope*/
/*  3298*/   /*Scope*/ 51, /*->3350*/
/*  3299*/    OPC_CheckChild1Type, MVT::v2f64,
/*  3301*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3302*/    OPC_Scope, 22, /*->3326*/ // 2 children in Scope
/*  3304*/     OPC_CheckChild2TypeI32,
/*  3305*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3307*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3309*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  3311*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3314*/     OPC_EmitMergeInputChains1_0,
/*  3315*/     OPC_EmitInteger32, 0, 
/*  3317*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2f64:{ *:[v2f64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v2f64:{ *:[v2f64] }:$val)
/*  3326*/    /*Scope*/ 22, /*->3349*/
/*  3327*/     OPC_CheckChild2TypeI64,
/*  3328*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3330*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3332*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3334*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3337*/     OPC_EmitMergeInputChains1_0,
/*  3338*/     OPC_EmitInteger32, 0, 
/*  3340*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2f64:{ *:[v2f64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v2f64:{ *:[v2f64] }:$val)
/*  3349*/    0, /*End of Scope*/
/*  3350*/   0, /*End of Scope*/
/*  3351*/  0, /*End of Scope*/
/*  3352*/ /*SwitchOpcode*/ 47|128,1/*175*/, TARGET_VAL(ISD::INTRINSIC_VOID),// ->3531
/*  3356*/  OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  3357*/  OPC_Scope, 40, /*->3399*/ // 6 children in Scope
/*  3359*/   OPC_CheckChild1Integer, 108|128,59|128,1/*24044*/, 
/*  3363*/   OPC_MoveChild2,
/*  3364*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3367*/   OPC_RecordChild0, // #1 = $table1
/*  3368*/   OPC_MoveChild0,
/*  3369*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3372*/   OPC_MoveParent,
/*  3373*/   OPC_MoveSibling3,
/*  3374*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3377*/   OPC_RecordChild0, // #2 = $table2
/*  3378*/   OPC_MoveChild0,
/*  3379*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3382*/   OPC_MoveParent,
/*  3383*/   OPC_MoveParent,
/*  3384*/   OPC_RecordChild4, // #3 = $d
/*  3385*/   OPC_RecordChild5, // #4 = $s
/*  3386*/   OPC_RecordChild6, // #5 = $n
/*  3387*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  3389*/   OPC_EmitMergeInputChains1_0,
/*  3390*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_COPY),
                 5/*#Ops*/, 1, 2, 3, 4, 5, 
             // Src: (intrinsic_void 12022:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table1), (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table2), I32:{ *:[i32] }:$d, I32:{ *:[i32] }:$s, I32:{ *:[i32] }:$n) - Complexity = 20
             // Dst: (TABLE_COPY (tglobaladdr:{ *:[i32] }):$table1, (tglobaladdr:{ *:[i32] }):$table2, I32:{ *:[i32] }:$d, I32:{ *:[i32] }:$s, I32:{ *:[i32] }:$n)
/*  3399*/  /*Scope*/ 27, /*->3427*/
/*  3400*/   OPC_CheckChild1Integer, 124|128,59|128,1/*24060*/, 
/*  3404*/   OPC_MoveChild2,
/*  3405*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3408*/   OPC_RecordChild0, // #1 = $table
/*  3409*/   OPC_MoveChild0,
/*  3410*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3413*/   OPC_MoveParent,
/*  3414*/   OPC_MoveParent,
/*  3415*/   OPC_RecordChild3, // #2 = $i
/*  3416*/   OPC_RecordChild4, // #3 = $val
/*  3417*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  3419*/   OPC_EmitMergeInputChains1_0,
/*  3420*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF),
                 3/*#Ops*/, 1, 2, 3, 
             // Src: (intrinsic_void 12030:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val) - Complexity = 14
             // Dst: (TABLE_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val)
/*  3427*/  /*Scope*/ 29, /*->3457*/
/*  3428*/   OPC_CheckChild1Integer, 112|128,59|128,1/*24048*/, 
/*  3432*/   OPC_MoveChild2,
/*  3433*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3436*/   OPC_RecordChild0, // #1 = $table
/*  3437*/   OPC_MoveChild0,
/*  3438*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3441*/   OPC_MoveParent,
/*  3442*/   OPC_MoveParent,
/*  3443*/   OPC_RecordChild3, // #2 = $i
/*  3444*/   OPC_RecordChild4, // #3 = $val
/*  3445*/   OPC_RecordChild5, // #4 = $n
/*  3446*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  3448*/   OPC_EmitMergeInputChains1_0,
/*  3449*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_FUNCREF),
                 4/*#Ops*/, 1, 2, 3, 4, 
             // Src: (intrinsic_void 12024:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
             // Dst: (TABLE_FILL_FUNCREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n)
/*  3457*/  /*Scope*/ 27, /*->3485*/
/*  3458*/   OPC_CheckChild1Integer, 122|128,59|128,1/*24058*/, 
/*  3462*/   OPC_MoveChild2,
/*  3463*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3466*/   OPC_RecordChild0, // #1 = $table
/*  3467*/   OPC_MoveChild0,
/*  3468*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3471*/   OPC_MoveParent,
/*  3472*/   OPC_MoveParent,
/*  3473*/   OPC_RecordChild3, // #2 = $i
/*  3474*/   OPC_RecordChild4, // #3 = $val
/*  3475*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  3477*/   OPC_EmitMergeInputChains1_0,
/*  3478*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF),
                 3/*#Ops*/, 1, 2, 3, 
             // Src: (intrinsic_void 12029:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val) - Complexity = 14
             // Dst: (TABLE_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val)
/*  3485*/  /*Scope*/ 29, /*->3515*/
/*  3486*/   OPC_CheckChild1Integer, 110|128,59|128,1/*24046*/, 
/*  3490*/   OPC_MoveChild2,
/*  3491*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3494*/   OPC_RecordChild0, // #1 = $table
/*  3495*/   OPC_MoveChild0,
/*  3496*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3499*/   OPC_MoveParent,
/*  3500*/   OPC_MoveParent,
/*  3501*/   OPC_RecordChild3, // #2 = $i
/*  3502*/   OPC_RecordChild4, // #3 = $val
/*  3503*/   OPC_RecordChild5, // #4 = $n
/*  3504*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  3506*/   OPC_EmitMergeInputChains1_0,
/*  3507*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_EXTERNREF),
                 4/*#Ops*/, 1, 2, 3, 4, 
             // Src: (intrinsic_void 12023:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
             // Dst: (TABLE_FILL_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n)
/*  3515*/  /*Scope*/ 14, /*->3530*/
/*  3516*/   OPC_CheckChild1Integer, 98|128,59|128,1/*24034*/, 
/*  3520*/   OPC_CheckPatternPredicate, 5, // (Subtarget->hasExceptionHandling())
/*  3522*/   OPC_EmitMergeInputChains1_0,
/*  3523*/   OPC_EmitInteger32, 0, 
/*  3525*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::RETHROW),
                 1/*#Ops*/, 1, 
             // Src: (intrinsic_void 12017:{ *:[iPTR] }) - Complexity = 8
             // Dst: (RETHROW 0:{ *:[i32] })
/*  3530*/  0, /*End of Scope*/
/*  3531*/ /*SwitchOpcode*/ 123|128,2/*379*/, TARGET_VAL(ISD::INTRINSIC_W_CHAIN),// ->3914
/*  3535*/  OPC_Scope, 34|128,1/*162*/, /*->3700*/ // 2 children in Scope
/*  3538*/   OPC_RecordMemRef,
/*  3539*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3540*/   OPC_Scope, 49, /*->3591*/ // 3 children in Scope
/*  3542*/    OPC_CheckChild1Integer, 42|128,59|128,1/*23978*/, 
/*  3546*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3547*/    OPC_Scope, 20, /*->3569*/ // 2 children in Scope
/*  3549*/     OPC_CheckChild2TypeI32,
/*  3550*/     OPC_RecordChild3, // #2 = $count
/*  3551*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3553*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  3556*/     OPC_EmitMergeInputChains1_0,
/*  3557*/     OPC_EmitInteger32, 0, 
/*  3559*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 11989:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), I32:{ *:[i32] }:$count) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_NOTIFY_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$count)
/*  3569*/    /*Scope*/ 20, /*->3590*/
/*  3570*/     OPC_CheckChild2TypeI64,
/*  3571*/     OPC_RecordChild3, // #2 = $count
/*  3572*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3574*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  3577*/     OPC_EmitMergeInputChains1_0,
/*  3578*/     OPC_EmitInteger32, 0, 
/*  3580*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 11989:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), I32:{ *:[i32] }:$count) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_NOTIFY_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$count)
/*  3590*/    0, /*End of Scope*/
/*  3591*/   /*Scope*/ 53, /*->3645*/
/*  3592*/    OPC_CheckChild1Integer, 44|128,59|128,1/*23980*/, 
/*  3596*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3597*/    OPC_Scope, 22, /*->3621*/ // 2 children in Scope
/*  3599*/     OPC_CheckChild2TypeI32,
/*  3600*/     OPC_RecordChild3, // #2 = $exp
/*  3601*/     OPC_RecordChild4, // #3 = $timeout
/*  3602*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3604*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  3607*/     OPC_EmitMergeInputChains1_0,
/*  3608*/     OPC_EmitInteger32, 0, 
/*  3610*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 11990:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3621*/    /*Scope*/ 22, /*->3644*/
/*  3622*/     OPC_CheckChild2TypeI64,
/*  3623*/     OPC_RecordChild3, // #2 = $exp
/*  3624*/     OPC_RecordChild4, // #3 = $timeout
/*  3625*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3627*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  3630*/     OPC_EmitMergeInputChains1_0,
/*  3631*/     OPC_EmitInteger32, 0, 
/*  3633*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 11990:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3644*/    0, /*End of Scope*/
/*  3645*/   /*Scope*/ 53, /*->3699*/
/*  3646*/    OPC_CheckChild1Integer, 46|128,59|128,1/*23982*/, 
/*  3650*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3651*/    OPC_Scope, 22, /*->3675*/ // 2 children in Scope
/*  3653*/     OPC_CheckChild2TypeI32,
/*  3654*/     OPC_RecordChild3, // #2 = $exp
/*  3655*/     OPC_RecordChild4, // #3 = $timeout
/*  3656*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3658*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  3661*/     OPC_EmitMergeInputChains1_0,
/*  3662*/     OPC_EmitInteger32, 0, 
/*  3664*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 11991:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT64_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3675*/    /*Scope*/ 22, /*->3698*/
/*  3676*/     OPC_CheckChild2TypeI64,
/*  3677*/     OPC_RecordChild3, // #2 = $exp
/*  3678*/     OPC_RecordChild4, // #3 = $timeout
/*  3679*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3681*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  3684*/     OPC_EmitMergeInputChains1_0,
/*  3685*/     OPC_EmitInteger32, 0, 
/*  3687*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 11991:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT64_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3698*/    0, /*End of Scope*/
/*  3699*/   0, /*End of Scope*/
/*  3700*/  /*Scope*/ 83|128,1/*211*/, /*->3913*/
/*  3702*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3703*/   OPC_Scope, 26, /*->3731*/ // 7 children in Scope
/*  3705*/    OPC_CheckChild1Integer, 116|128,59|128,1/*24052*/, 
/*  3709*/    OPC_MoveChild2,
/*  3710*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3713*/    OPC_RecordChild0, // #1 = $table
/*  3714*/    OPC_MoveChild0,
/*  3715*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3718*/    OPC_MoveParent,
/*  3719*/    OPC_MoveParent,
/*  3720*/    OPC_RecordChild3, // #2 = $i
/*  3721*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  3723*/    OPC_EmitMergeInputChains1_0,
/*  3724*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_FUNCREF),
                  MVT::funcref, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[funcref] } 12026:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3731*/   /*Scope*/ 28, /*->3760*/
/*  3732*/    OPC_CheckChild1Integer, 120|128,59|128,1/*24056*/, 
/*  3736*/    OPC_MoveChild2,
/*  3737*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3740*/    OPC_RecordChild0, // #1 = $table
/*  3741*/    OPC_MoveChild0,
/*  3742*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3745*/    OPC_MoveParent,
/*  3746*/    OPC_MoveParent,
/*  3747*/    OPC_RecordChild3, // #2 = $val
/*  3748*/    OPC_RecordChild4, // #3 = $n
/*  3749*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  3751*/    OPC_EmitMergeInputChains1_0,
/*  3752*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_FUNCREF),
                  MVT::i32, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12028:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_FUNCREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n)
/*  3760*/   /*Scope*/ 26, /*->3787*/
/*  3761*/    OPC_CheckChild1Integer, 114|128,59|128,1/*24050*/, 
/*  3765*/    OPC_MoveChild2,
/*  3766*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3769*/    OPC_RecordChild0, // #1 = $table
/*  3770*/    OPC_MoveChild0,
/*  3771*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3774*/    OPC_MoveParent,
/*  3775*/    OPC_MoveParent,
/*  3776*/    OPC_RecordChild3, // #2 = $i
/*  3777*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  3779*/    OPC_EmitMergeInputChains1_0,
/*  3780*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_EXTERNREF),
                  MVT::externref, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[externref] } 12025:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3787*/   /*Scope*/ 28, /*->3816*/
/*  3788*/    OPC_CheckChild1Integer, 118|128,59|128,1/*24054*/, 
/*  3792*/    OPC_MoveChild2,
/*  3793*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3796*/    OPC_RecordChild0, // #1 = $table
/*  3797*/    OPC_MoveChild0,
/*  3798*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3801*/    OPC_MoveParent,
/*  3802*/    OPC_MoveParent,
/*  3803*/    OPC_RecordChild3, // #2 = $val
/*  3804*/    OPC_RecordChild4, // #3 = $n
/*  3805*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  3807*/    OPC_EmitMergeInputChains1_0,
/*  3808*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_EXTERNREF),
                  MVT::i32, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12027:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_EXTERNREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n)
/*  3816*/   /*Scope*/ 24, /*->3841*/
/*  3817*/    OPC_CheckChild1Integer, 126|128,59|128,1/*24062*/, 
/*  3821*/    OPC_MoveChild2,
/*  3822*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3825*/    OPC_RecordChild0, // #1 = $table
/*  3826*/    OPC_MoveChild0,
/*  3827*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3830*/    OPC_MoveParent,
/*  3831*/    OPC_MoveParent,
/*  3832*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  3834*/    OPC_EmitMergeInputChains1_0,
/*  3835*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_SIZE),
                  MVT::i32, 1/*#Ops*/, 1, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12031:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table)) - Complexity = 14
              // Dst: (TABLE_SIZE:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table)
/*  3841*/   /*Scope*/ 32, /*->3874*/
/*  3842*/    OPC_CheckChild1Integer, 50|128,59|128,1/*23986*/, 
/*  3846*/    OPC_RecordChild2, // #1 = $flags
/*  3847*/    OPC_MoveChild2,
/*  3848*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3851*/    OPC_MoveParent,
/*  3852*/    OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->3863
/*  3855*/     OPC_EmitMergeInputChains1_0,
/*  3856*/     OPC_EmitConvertToTarget1,
/*  3857*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_7219MEMORY_SIZE_A32),
                   MVT::i32, 1/*#Ops*/, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 11993:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
               // Dst: (anonymous_7219MEMORY_SIZE_A32:{ *:[i32] } (imm:{ *:[i32] }):$flags)
/*  3863*/    /*SwitchType*/ 8, MVT::i64,// ->3873
/*  3865*/     OPC_EmitMergeInputChains1_0,
/*  3866*/     OPC_EmitConvertToTarget1,
/*  3867*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_7220MEMORY_SIZE_A64),
                   MVT::i64, 1/*#Ops*/, 2, 
               // Src: (intrinsic_w_chain:{ *:[i64] } 11993:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
               // Dst: (anonymous_7220MEMORY_SIZE_A64:{ *:[i64] } (imm:{ *:[i32] }):$flags)
/*  3873*/    0, // EndSwitchType
/*  3874*/   /*Scope*/ 37, /*->3912*/
/*  3875*/    OPC_CheckChild1Integer, 48|128,59|128,1/*23984*/, 
/*  3879*/    OPC_RecordChild2, // #1 = $flags
/*  3880*/    OPC_MoveChild2,
/*  3881*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3884*/    OPC_MoveParent,
/*  3885*/    OPC_RecordChild3, // #2 = $delta
/*  3886*/    OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->3899
/*  3889*/     OPC_CheckChild3TypeI32,
/*  3890*/     OPC_EmitMergeInputChains1_0,
/*  3891*/     OPC_EmitConvertToTarget1,
/*  3892*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_7219MEMORY_GROW_A32),
                   MVT::i32, 2/*#Ops*/, 3, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 11992:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta) - Complexity = 11
               // Dst: (anonymous_7219MEMORY_GROW_A32:{ *:[i32] } (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta)
/*  3899*/    /*SwitchType*/ 10, MVT::i64,// ->3911
/*  3901*/     OPC_CheckChild3TypeI64,
/*  3902*/     OPC_EmitMergeInputChains1_0,
/*  3903*/     OPC_EmitConvertToTarget1,
/*  3904*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_7220MEMORY_GROW_A64),
                   MVT::i64, 2/*#Ops*/, 3, 2, 
               // Src: (intrinsic_w_chain:{ *:[i64] } 11992:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I64:{ *:[i64] }:$delta) - Complexity = 11
               // Dst: (anonymous_7220MEMORY_GROW_A64:{ *:[i64] } (imm:{ *:[i32] }):$flags, I64:{ *:[i64] }:$delta)
/*  3911*/    0, // EndSwitchType
/*  3912*/   0, /*End of Scope*/
/*  3913*/  0, /*End of Scope*/
/*  3914*/ /*SwitchOpcode*/ 73|128,2/*329*/, TARGET_VAL(ISD::ATOMIC_STORE),// ->4247
/*  3918*/  OPC_RecordMemRef,
/*  3919*/  OPC_RecordNode, // #0 = 'atomic_store' chained node
/*  3920*/  OPC_Scope, 9|128,1/*137*/, /*->4060*/ // 2 children in Scope
/*  3923*/   OPC_MoveChild1,
/*  3924*/   OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3927*/   OPC_RecordChild0, // #1 = $val
/*  3928*/   OPC_MoveParent,
/*  3929*/   OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3930*/   OPC_Scope, 63, /*->3995*/ // 2 children in Scope
/*  3932*/    OPC_CheckChild2TypeI32,
/*  3933*/    OPC_Scope, 19, /*->3954*/ // 3 children in Scope
/*  3935*/     OPC_CheckPredicate, 0, // Predicate_atomic_store_8
/*  3937*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3939*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3942*/     OPC_EmitMergeInputChains1_0,
/*  3943*/     OPC_EmitInteger32, 0, 
/*  3945*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 16
               // Dst: (ATOMIC_STORE8_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3954*/    /*Scope*/ 19, /*->3974*/
/*  3955*/     OPC_CheckPredicate, 1, // Predicate_atomic_store_16
/*  3957*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3959*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3962*/     OPC_EmitMergeInputChains1_0,
/*  3963*/     OPC_EmitInteger32, 0, 
/*  3965*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 16
               // Dst: (ATOMIC_STORE16_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3974*/    /*Scope*/ 19, /*->3994*/
/*  3975*/     OPC_CheckPredicate, 2, // Predicate_atomic_store_32
/*  3977*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3979*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3982*/     OPC_EmitMergeInputChains1_0,
/*  3983*/     OPC_EmitInteger32, 0, 
/*  3985*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 16
               // Dst: (ATOMIC_STORE32_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3994*/    0, /*End of Scope*/
/*  3995*/   /*Scope*/ 63, /*->4059*/
/*  3996*/    OPC_CheckChild2TypeI64,
/*  3997*/    OPC_Scope, 19, /*->4018*/ // 3 children in Scope
/*  3999*/     OPC_CheckPredicate, 0, // Predicate_atomic_store_8
/*  4001*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4003*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  4006*/     OPC_EmitMergeInputChains1_0,
/*  4007*/     OPC_EmitInteger32, 0, 
/*  4009*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 16
               // Dst: (ATOMIC_STORE8_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  4018*/    /*Scope*/ 19, /*->4038*/
/*  4019*/     OPC_CheckPredicate, 1, // Predicate_atomic_store_16
/*  4021*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4023*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  4026*/     OPC_EmitMergeInputChains1_0,
/*  4027*/     OPC_EmitInteger32, 0, 
/*  4029*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 16
               // Dst: (ATOMIC_STORE16_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  4038*/    /*Scope*/ 19, /*->4058*/
/*  4039*/     OPC_CheckPredicate, 2, // Predicate_atomic_store_32
/*  4041*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4043*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  4046*/     OPC_EmitMergeInputChains1_0,
/*  4047*/     OPC_EmitInteger32, 0, 
/*  4049*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 16
               // Dst: (ATOMIC_STORE32_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  4058*/    0, /*End of Scope*/
/*  4059*/   0, /*End of Scope*/
/*  4060*/  /*Scope*/ 56|128,1/*184*/, /*->4246*/
/*  4062*/   OPC_RecordChild1, // #1 = $val
/*  4063*/   OPC_Scope, 4|128,1/*132*/, /*->4198*/ // 2 children in Scope
/*  4066*/    OPC_CheckChild1TypeI32,
/*  4067*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  4068*/    OPC_Scope, 63, /*->4133*/ // 2 children in Scope
/*  4070*/     OPC_CheckChild2TypeI32,
/*  4071*/     OPC_Scope, 19, /*->4092*/ // 3 children in Scope
/*  4073*/      OPC_CheckPredicate, 2, // Predicate_atomic_store_32
/*  4075*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4077*/      OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  4080*/      OPC_EmitMergeInputChains1_0,
/*  4081*/      OPC_EmitInteger32, 0, 
/*  4083*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 13
                // Dst: (ATOMIC_STORE_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  4092*/     /*Scope*/ 19, /*->4112*/
/*  4093*/      OPC_CheckPredicate, 0, // Predicate_atomic_store_8
/*  4095*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4097*/      OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  4100*/      OPC_EmitMergeInputChains1_0,
/*  4101*/      OPC_EmitInteger32, 0, 
/*  4103*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 13
                // Dst: (ATOMIC_STORE8_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  4112*/     /*Scope*/ 19, /*->4132*/
/*  4113*/      OPC_CheckPredicate, 1, // Predicate_atomic_store_16
/*  4115*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4117*/      OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  4120*/      OPC_EmitMergeInputChains1_0,
/*  4121*/      OPC_EmitInteger32, 0, 
/*  4123*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 13
                // Dst: (ATOMIC_STORE16_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  4132*/     0, /*End of Scope*/
/*  4133*/    /*Scope*/ 63, /*->4197*/
/*  4134*/     OPC_CheckChild2TypeI64,
/*  4135*/     OPC_Scope, 19, /*->4156*/ // 3 children in Scope
/*  4137*/      OPC_CheckPredicate, 2, // Predicate_atomic_store_32
/*  4139*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4141*/      OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  4144*/      OPC_EmitMergeInputChains1_0,
/*  4145*/      OPC_EmitInteger32, 0, 
/*  4147*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 13
                // Dst: (ATOMIC_STORE_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  4156*/     /*Scope*/ 19, /*->4176*/
/*  4157*/      OPC_CheckPredicate, 0, // Predicate_atomic_store_8
/*  4159*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4161*/      OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  4164*/      OPC_EmitMergeInputChains1_0,
/*  4165*/      OPC_EmitInteger32, 0, 
/*  4167*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 13
                // Dst: (ATOMIC_STORE8_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  4176*/     /*Scope*/ 19, /*->4196*/
/*  4177*/      OPC_CheckPredicate, 1, // Predicate_atomic_store_16
/*  4179*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4181*/      OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  4184*/      OPC_EmitMergeInputChains1_0,
/*  4185*/      OPC_EmitInteger32, 0, 
/*  4187*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 13
                // Dst: (ATOMIC_STORE16_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  4196*/     0, /*End of Scope*/
/*  4197*/    0, /*End of Scope*/
/*  4198*/   /*Scope*/ 46, /*->4245*/
/*  4199*/    OPC_CheckChild1TypeI64,
/*  4200*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  4201*/    OPC_Scope, 20, /*->4223*/ // 2 children in Scope
/*  4203*/     OPC_CheckChild2TypeI32,
/*  4204*/     OPC_CheckPredicate, 13, // Predicate_atomic_store_64
/*  4206*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4208*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  4211*/     OPC_EmitMergeInputChains1_0,
/*  4212*/     OPC_EmitInteger32, 0, 
/*  4214*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_64>> - Complexity = 13
               // Dst: (ATOMIC_STORE_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  4223*/    /*Scope*/ 20, /*->4244*/
/*  4224*/     OPC_CheckChild2TypeI64,
/*  4225*/     OPC_CheckPredicate, 13, // Predicate_atomic_store_64
/*  4227*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4229*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  4232*/     OPC_EmitMergeInputChains1_0,
/*  4233*/     OPC_EmitInteger32, 0, 
/*  4235*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_64>> - Complexity = 13
               // Dst: (ATOMIC_STORE_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  4244*/    0, /*End of Scope*/
/*  4245*/   0, /*End of Scope*/
/*  4246*/  0, /*End of Scope*/
/*  4247*/ /*SwitchOpcode*/ 90|128,2/*346*/, TARGET_VAL(ISD::AND),// ->4597
/*  4251*/  OPC_Scope, 118, /*->4371*/ // 6 children in Scope
/*  4253*/   OPC_MoveChild0,
/*  4254*/   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
/*  4257*/   OPC_Scope, 55, /*->4314*/ // 2 children in Scope
/*  4259*/    OPC_CheckChild0Integer, 18|128,59|128,1/*23954*/, 
/*  4263*/    OPC_RecordChild1, // #0 = $x
/*  4264*/    OPC_Scope, 11, /*->4277*/ // 4 children in Scope
/*  4266*/     OPC_CheckChild1Type, MVT::v16i8,
/*  4268*/     OPC_MoveParent,
/*  4269*/     OPC_CheckChild1Integer, 2, 
/*  4271*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11977:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4277*/    /*Scope*/ 11, /*->4289*/
/*  4278*/     OPC_CheckChild1Type, MVT::v8i16,
/*  4280*/     OPC_MoveParent,
/*  4281*/     OPC_CheckChild1Integer, 2, 
/*  4283*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11977:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4289*/    /*Scope*/ 11, /*->4301*/
/*  4290*/     OPC_CheckChild1Type, MVT::v4i32,
/*  4292*/     OPC_MoveParent,
/*  4293*/     OPC_CheckChild1Integer, 2, 
/*  4295*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11977:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4301*/    /*Scope*/ 11, /*->4313*/
/*  4302*/     OPC_CheckChild1Type, MVT::v2i64,
/*  4304*/     OPC_MoveParent,
/*  4305*/     OPC_CheckChild1Integer, 2, 
/*  4307*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11977:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4313*/    0, /*End of Scope*/
/*  4314*/   /*Scope*/ 55, /*->4370*/
/*  4315*/    OPC_CheckChild0Integer, 16|128,59|128,1/*23952*/, 
/*  4319*/    OPC_RecordChild1, // #0 = $x
/*  4320*/    OPC_Scope, 11, /*->4333*/ // 4 children in Scope
/*  4322*/     OPC_CheckChild1Type, MVT::v16i8,
/*  4324*/     OPC_MoveParent,
/*  4325*/     OPC_CheckChild1Integer, 2, 
/*  4327*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11976:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4333*/    /*Scope*/ 11, /*->4345*/
/*  4334*/     OPC_CheckChild1Type, MVT::v8i16,
/*  4336*/     OPC_MoveParent,
/*  4337*/     OPC_CheckChild1Integer, 2, 
/*  4339*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11976:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4345*/    /*Scope*/ 11, /*->4357*/
/*  4346*/     OPC_CheckChild1Type, MVT::v4i32,
/*  4348*/     OPC_MoveParent,
/*  4349*/     OPC_CheckChild1Integer, 2, 
/*  4351*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11976:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4357*/    /*Scope*/ 11, /*->4369*/
/*  4358*/     OPC_CheckChild1Type, MVT::v2i64,
/*  4360*/     OPC_MoveParent,
/*  4361*/     OPC_CheckChild1Integer, 2, 
/*  4363*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11976:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4369*/    0, /*End of Scope*/
/*  4370*/   0, /*End of Scope*/
/*  4371*/  /*Scope*/ 29, /*->4401*/
/*  4372*/   OPC_CheckAndImm, 127|128,1/*255*/, 
/*  4375*/   OPC_MoveChild0,
/*  4376*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  4379*/   OPC_RecordChild0, // #0 = $vec
/*  4380*/   OPC_CheckChild0Type, MVT::v16i8,
/*  4382*/   OPC_RecordChild1, // #1 = $idx
/*  4383*/   OPC_MoveChild1,
/*  4384*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4387*/   OPC_CheckPredicate, 3, // Predicate_LaneIdx16
/*  4389*/   OPC_CheckTypeI32,
/*  4390*/   OPC_MoveParent,
/*  4391*/   OPC_MoveParent,
/*  4392*/   OPC_CheckTypeI32,
/*  4393*/   OPC_EmitConvertToTarget1,
/*  4394*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u),
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), 255:{ *:[i32] }) - Complexity = 15
             // Dst: (EXTRACT_LANE_I8x16_u:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/*  4401*/  /*Scope*/ 30, /*->4432*/
/*  4402*/   OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  4406*/   OPC_MoveChild0,
/*  4407*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  4410*/   OPC_RecordChild0, // #0 = $vec
/*  4411*/   OPC_CheckChild0Type, MVT::v8i16,
/*  4413*/   OPC_RecordChild1, // #1 = $idx
/*  4414*/   OPC_MoveChild1,
/*  4415*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4418*/   OPC_CheckPredicate, 7, // Predicate_LaneIdx8
/*  4420*/   OPC_CheckTypeI32,
/*  4421*/   OPC_MoveParent,
/*  4422*/   OPC_MoveParent,
/*  4423*/   OPC_CheckTypeI32,
/*  4424*/   OPC_EmitConvertToTarget1,
/*  4425*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u),
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), 65535:{ *:[i32] }) - Complexity = 15
             // Dst: (EXTRACT_LANE_I16x8_u:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/*  4432*/  /*Scope*/ 73, /*->4506*/
/*  4433*/   OPC_RecordChild0, // #0 = $lhs
/*  4434*/   OPC_Scope, 21, /*->4457*/ // 2 children in Scope
/*  4436*/    OPC_RecordChild1, // #1 = $rhs
/*  4437*/    OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->4447
/*  4440*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND_I32),
                   MVT::i32, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
               // Dst: (AND_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4447*/    /*SwitchType*/ 7, MVT::i64,// ->4456
/*  4449*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND_I64),
                   MVT::i64, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
               // Dst: (AND_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4456*/    0, // EndSwitchType
/*  4457*/   /*Scope*/ 47, /*->4505*/
/*  4458*/    OPC_MoveChild1,
/*  4459*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*  4462*/    OPC_RecordChild0, // #1 = $rhs
/*  4463*/    OPC_MoveChild1,
/*  4464*/    OPC_CheckImmAllOnesV,
/*  4465*/    OPC_MoveParent,
/*  4466*/    OPC_MoveParent,
/*  4467*/    OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->4477
/*  4470*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$rhs, immAllOnesV:{ *:[v16i8] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4477*/    /*SwitchType*/ 7, MVT::v8i16,// ->4486
/*  4479*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$rhs, immAllOnesV:{ *:[v8i16] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4486*/    /*SwitchType*/ 7, MVT::v4i32,// ->4495
/*  4488*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$rhs, immAllOnesV:{ *:[v4i32] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4495*/    /*SwitchType*/ 7, MVT::v2i64,// ->4504
/*  4497*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$rhs, immAllOnesV:{ *:[v2i64] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4504*/    0, // EndSwitchType
/*  4505*/   0, /*End of Scope*/
/*  4506*/  /*Scope*/ 48, /*->4555*/
/*  4507*/   OPC_MoveChild0,
/*  4508*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*  4511*/   OPC_RecordChild0, // #0 = $rhs
/*  4512*/   OPC_MoveChild1,
/*  4513*/   OPC_CheckImmAllOnesV,
/*  4514*/   OPC_MoveParent,
/*  4515*/   OPC_MoveParent,
/*  4516*/   OPC_RecordChild1, // #1 = $lhs
/*  4517*/   OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->4527
/*  4520*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  MVT::v16i8, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$rhs, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4527*/   /*SwitchType*/ 7, MVT::v8i16,// ->4536
/*  4529*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  MVT::v8i16, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$rhs, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4536*/   /*SwitchType*/ 7, MVT::v4i32,// ->4545
/*  4538*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  MVT::v4i32, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$rhs, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4545*/   /*SwitchType*/ 7, MVT::v2i64,// ->4554
/*  4547*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  MVT::v2i64, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$rhs, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4554*/   0, // EndSwitchType
/*  4555*/  /*Scope*/ 40, /*->4596*/
/*  4556*/   OPC_RecordChild0, // #0 = $lhs
/*  4557*/   OPC_RecordChild1, // #1 = $rhs
/*  4558*/   OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->4568
/*  4561*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4568*/   /*SwitchType*/ 7, MVT::v8i16,// ->4577
/*  4570*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4577*/   /*SwitchType*/ 7, MVT::v4i32,// ->4586
/*  4579*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4586*/   /*SwitchType*/ 7, MVT::v2i64,// ->4595
/*  4588*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4595*/   0, // EndSwitchType
/*  4596*/  0, /*End of Scope*/
/*  4597*/ /*SwitchOpcode*/ 96|128,11/*1504*/, TARGET_VAL(ISD::SETCC),// ->6105
/*  4601*/  OPC_Scope, 126|128,1/*254*/, /*->4858*/ // 2 children in Scope
/*  4604*/   OPC_MoveChild0,
/*  4605*/   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
/*  4608*/   OPC_Scope, 123, /*->4733*/ // 2 children in Scope
/*  4610*/    OPC_CheckChild0Integer, 18|128,59|128,1/*23954*/, 
/*  4614*/    OPC_RecordChild1, // #0 = $x
/*  4615*/    OPC_Scope, 28, /*->4645*/ // 4 children in Scope
/*  4617*/     OPC_CheckChild1Type, MVT::v16i8,
/*  4619*/     OPC_MoveParent,
/*  4620*/     OPC_CheckTypeI32,
/*  4621*/     OPC_Scope, 10, /*->4633*/ // 2 children in Scope
/*  4623*/      OPC_CheckChild1Integer, 0, 
/*  4625*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4627*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11977:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4633*/     /*Scope*/ 10, /*->4644*/
/*  4634*/      OPC_CheckChild1Integer, 2, 
/*  4636*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4638*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11977:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4644*/     0, /*End of Scope*/
/*  4645*/    /*Scope*/ 28, /*->4674*/
/*  4646*/     OPC_CheckChild1Type, MVT::v8i16,
/*  4648*/     OPC_MoveParent,
/*  4649*/     OPC_CheckTypeI32,
/*  4650*/     OPC_Scope, 10, /*->4662*/ // 2 children in Scope
/*  4652*/      OPC_CheckChild1Integer, 0, 
/*  4654*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4656*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11977:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4662*/     /*Scope*/ 10, /*->4673*/
/*  4663*/      OPC_CheckChild1Integer, 2, 
/*  4665*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4667*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11977:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4673*/     0, /*End of Scope*/
/*  4674*/    /*Scope*/ 28, /*->4703*/
/*  4675*/     OPC_CheckChild1Type, MVT::v4i32,
/*  4677*/     OPC_MoveParent,
/*  4678*/     OPC_CheckTypeI32,
/*  4679*/     OPC_Scope, 10, /*->4691*/ // 2 children in Scope
/*  4681*/      OPC_CheckChild1Integer, 0, 
/*  4683*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4685*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11977:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4691*/     /*Scope*/ 10, /*->4702*/
/*  4692*/      OPC_CheckChild1Integer, 2, 
/*  4694*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4696*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11977:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4702*/     0, /*End of Scope*/
/*  4703*/    /*Scope*/ 28, /*->4732*/
/*  4704*/     OPC_CheckChild1Type, MVT::v2i64,
/*  4706*/     OPC_MoveParent,
/*  4707*/     OPC_CheckTypeI32,
/*  4708*/     OPC_Scope, 10, /*->4720*/ // 2 children in Scope
/*  4710*/      OPC_CheckChild1Integer, 0, 
/*  4712*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4714*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11977:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4720*/     /*Scope*/ 10, /*->4731*/
/*  4721*/      OPC_CheckChild1Integer, 2, 
/*  4723*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4725*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11977:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4731*/     0, /*End of Scope*/
/*  4732*/    0, /*End of Scope*/
/*  4733*/   /*Scope*/ 123, /*->4857*/
/*  4734*/    OPC_CheckChild0Integer, 16|128,59|128,1/*23952*/, 
/*  4738*/    OPC_RecordChild1, // #0 = $x
/*  4739*/    OPC_Scope, 28, /*->4769*/ // 4 children in Scope
/*  4741*/     OPC_CheckChild1Type, MVT::v16i8,
/*  4743*/     OPC_MoveParent,
/*  4744*/     OPC_CheckTypeI32,
/*  4745*/     OPC_Scope, 10, /*->4757*/ // 2 children in Scope
/*  4747*/      OPC_CheckChild1Integer, 0, 
/*  4749*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4751*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11976:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4757*/     /*Scope*/ 10, /*->4768*/
/*  4758*/      OPC_CheckChild1Integer, 2, 
/*  4760*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4762*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11976:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4768*/     0, /*End of Scope*/
/*  4769*/    /*Scope*/ 28, /*->4798*/
/*  4770*/     OPC_CheckChild1Type, MVT::v8i16,
/*  4772*/     OPC_MoveParent,
/*  4773*/     OPC_CheckTypeI32,
/*  4774*/     OPC_Scope, 10, /*->4786*/ // 2 children in Scope
/*  4776*/      OPC_CheckChild1Integer, 0, 
/*  4778*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4780*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11976:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4786*/     /*Scope*/ 10, /*->4797*/
/*  4787*/      OPC_CheckChild1Integer, 2, 
/*  4789*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4791*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11976:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4797*/     0, /*End of Scope*/
/*  4798*/    /*Scope*/ 28, /*->4827*/
/*  4799*/     OPC_CheckChild1Type, MVT::v4i32,
/*  4801*/     OPC_MoveParent,
/*  4802*/     OPC_CheckTypeI32,
/*  4803*/     OPC_Scope, 10, /*->4815*/ // 2 children in Scope
/*  4805*/      OPC_CheckChild1Integer, 0, 
/*  4807*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4809*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11976:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4815*/     /*Scope*/ 10, /*->4826*/
/*  4816*/      OPC_CheckChild1Integer, 2, 
/*  4818*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4820*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11976:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4826*/     0, /*End of Scope*/
/*  4827*/    /*Scope*/ 28, /*->4856*/
/*  4828*/     OPC_CheckChild1Type, MVT::v2i64,
/*  4830*/     OPC_MoveParent,
/*  4831*/     OPC_CheckTypeI32,
/*  4832*/     OPC_Scope, 10, /*->4844*/ // 2 children in Scope
/*  4834*/      OPC_CheckChild1Integer, 0, 
/*  4836*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4838*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11976:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4844*/     /*Scope*/ 10, /*->4855*/
/*  4845*/      OPC_CheckChild1Integer, 2, 
/*  4847*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4849*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 11976:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4855*/     0, /*End of Scope*/
/*  4856*/    0, /*End of Scope*/
/*  4857*/   0, /*End of Scope*/
/*  4858*/  /*Scope*/ 92|128,9/*1244*/, /*->6104*/
/*  4860*/   OPC_RecordChild0, // #0 = $src
/*  4861*/   OPC_SwitchType /*5 cases */, 108|128,3/*492*/, MVT::i32,// ->5357
/*  4865*/    OPC_Scope, 118, /*->4985*/ // 4 children in Scope
/*  4867*/     OPC_CheckChild0TypeI32,
/*  4868*/     OPC_Scope, 10, /*->4880*/ // 2 children in Scope
/*  4870*/      OPC_CheckChild1Integer, 0, 
/*  4872*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4874*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQZ_I32),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$src, 0:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 8
                // Dst: (EQZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/*  4880*/     /*Scope*/ 103, /*->4984*/
/*  4881*/      OPC_RecordChild1, // #1 = $rhs
/*  4882*/      OPC_Scope, 9, /*->4893*/ // 10 children in Scope
/*  4884*/       OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4886*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                 // Dst: (EQ_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4893*/      /*Scope*/ 9, /*->4903*/
/*  4894*/       OPC_CheckChild2CondCode, ISD::SETNE,
/*  4896*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                 // Dst: (NE_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4903*/      /*Scope*/ 9, /*->4913*/
/*  4904*/       OPC_CheckChild2CondCode, ISD::SETLT,
/*  4906*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4913*/      /*Scope*/ 9, /*->4923*/
/*  4914*/       OPC_CheckChild2CondCode, ISD::SETULT,
/*  4916*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4923*/      /*Scope*/ 9, /*->4933*/
/*  4924*/       OPC_CheckChild2CondCode, ISD::SETGT,
/*  4926*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4933*/      /*Scope*/ 9, /*->4943*/
/*  4934*/       OPC_CheckChild2CondCode, ISD::SETUGT,
/*  4936*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4943*/      /*Scope*/ 9, /*->4953*/
/*  4944*/       OPC_CheckChild2CondCode, ISD::SETLE,
/*  4946*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4953*/      /*Scope*/ 9, /*->4963*/
/*  4954*/       OPC_CheckChild2CondCode, ISD::SETULE,
/*  4956*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4963*/      /*Scope*/ 9, /*->4973*/
/*  4964*/       OPC_CheckChild2CondCode, ISD::SETGE,
/*  4966*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4973*/      /*Scope*/ 9, /*->4983*/
/*  4974*/       OPC_CheckChild2CondCode, ISD::SETUGE,
/*  4976*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I32),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4983*/      0, /*End of Scope*/
/*  4984*/     0, /*End of Scope*/
/*  4985*/    /*Scope*/ 118, /*->5104*/
/*  4986*/     OPC_CheckChild0TypeI64,
/*  4987*/     OPC_Scope, 10, /*->4999*/ // 2 children in Scope
/*  4989*/      OPC_CheckChild1Integer, 0, 
/*  4991*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4993*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQZ_I64),
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$src, 0:{ *:[i64] }, SETEQ:{ *:[Other] }) - Complexity = 8
                // Dst: (EQZ_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/*  4999*/     /*Scope*/ 103, /*->5103*/
/*  5000*/      OPC_RecordChild1, // #1 = $rhs
/*  5001*/      OPC_Scope, 9, /*->5012*/ // 10 children in Scope
/*  5003*/       OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5005*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                 // Dst: (EQ_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5012*/      /*Scope*/ 9, /*->5022*/
/*  5013*/       OPC_CheckChild2CondCode, ISD::SETNE,
/*  5015*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                 // Dst: (NE_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5022*/      /*Scope*/ 9, /*->5032*/
/*  5023*/       OPC_CheckChild2CondCode, ISD::SETLT,
/*  5025*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5032*/      /*Scope*/ 9, /*->5042*/
/*  5033*/       OPC_CheckChild2CondCode, ISD::SETULT,
/*  5035*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5042*/      /*Scope*/ 9, /*->5052*/
/*  5043*/       OPC_CheckChild2CondCode, ISD::SETGT,
/*  5045*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5052*/      /*Scope*/ 9, /*->5062*/
/*  5053*/       OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5055*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5062*/      /*Scope*/ 9, /*->5072*/
/*  5063*/       OPC_CheckChild2CondCode, ISD::SETLE,
/*  5065*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5072*/      /*Scope*/ 9, /*->5082*/
/*  5073*/       OPC_CheckChild2CondCode, ISD::SETULE,
/*  5075*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5082*/      /*Scope*/ 9, /*->5092*/
/*  5083*/       OPC_CheckChild2CondCode, ISD::SETGE,
/*  5085*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5092*/      /*Scope*/ 9, /*->5102*/
/*  5093*/       OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5095*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I64),
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5102*/      0, /*End of Scope*/
/*  5103*/     0, /*End of Scope*/
/*  5104*/    /*Scope*/ 125, /*->5230*/
/*  5105*/     OPC_CheckChild0Type, MVT::f32,
/*  5107*/     OPC_RecordChild1, // #1 = $rhs
/*  5108*/     OPC_Scope, 9, /*->5119*/ // 12 children in Scope
/*  5110*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5112*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  5119*/     /*Scope*/ 9, /*->5129*/
/*  5120*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5122*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  5129*/     /*Scope*/ 9, /*->5139*/
/*  5130*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5132*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  5139*/     /*Scope*/ 9, /*->5149*/
/*  5140*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5142*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  5149*/     /*Scope*/ 9, /*->5159*/
/*  5150*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5152*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  5159*/     /*Scope*/ 9, /*->5169*/
/*  5160*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5162*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  5169*/     /*Scope*/ 9, /*->5179*/
/*  5170*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5172*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5179*/     /*Scope*/ 9, /*->5189*/
/*  5180*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5182*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5189*/     /*Scope*/ 9, /*->5199*/
/*  5190*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5192*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5199*/     /*Scope*/ 9, /*->5209*/
/*  5200*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5202*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5209*/     /*Scope*/ 9, /*->5219*/
/*  5210*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5212*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5219*/     /*Scope*/ 9, /*->5229*/
/*  5220*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5222*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5229*/     0, /*End of Scope*/
/*  5230*/    /*Scope*/ 125, /*->5356*/
/*  5231*/     OPC_CheckChild0Type, MVT::f64,
/*  5233*/     OPC_RecordChild1, // #1 = $rhs
/*  5234*/     OPC_Scope, 9, /*->5245*/ // 12 children in Scope
/*  5236*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5238*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5245*/     /*Scope*/ 9, /*->5255*/
/*  5246*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5248*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5255*/     /*Scope*/ 9, /*->5265*/
/*  5256*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5258*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5265*/     /*Scope*/ 9, /*->5275*/
/*  5266*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5268*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5275*/     /*Scope*/ 9, /*->5285*/
/*  5276*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5278*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5285*/     /*Scope*/ 9, /*->5295*/
/*  5286*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5288*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5295*/     /*Scope*/ 9, /*->5305*/
/*  5296*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5298*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5305*/     /*Scope*/ 9, /*->5315*/
/*  5306*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5308*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5315*/     /*Scope*/ 9, /*->5325*/
/*  5316*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5318*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5325*/     /*Scope*/ 9, /*->5335*/
/*  5326*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5328*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5335*/     /*Scope*/ 9, /*->5345*/
/*  5336*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5338*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5345*/     /*Scope*/ 9, /*->5355*/
/*  5346*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5348*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64),
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5355*/     0, /*End of Scope*/
/*  5356*/    0, /*End of Scope*/
/*  5357*/   /*SwitchType*/ 125, MVT::v16i8,// ->5484
/*  5359*/    OPC_CheckChild0Type, MVT::v16i8,
/*  5361*/    OPC_RecordChild1, // #1 = $rhs
/*  5362*/    OPC_Scope, 11, /*->5375*/ // 10 children in Scope
/*  5364*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5366*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5368*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
               // Dst: (EQ_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5375*/    /*Scope*/ 11, /*->5387*/
/*  5376*/     OPC_CheckChild2CondCode, ISD::SETNE,
/*  5378*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5380*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
               // Dst: (NE_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5387*/    /*Scope*/ 11, /*->5399*/
/*  5388*/     OPC_CheckChild2CondCode, ISD::SETLT,
/*  5390*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5392*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5399*/    /*Scope*/ 11, /*->5411*/
/*  5400*/     OPC_CheckChild2CondCode, ISD::SETULT,
/*  5402*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5404*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5411*/    /*Scope*/ 11, /*->5423*/
/*  5412*/     OPC_CheckChild2CondCode, ISD::SETGT,
/*  5414*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5416*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5423*/    /*Scope*/ 11, /*->5435*/
/*  5424*/     OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5426*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5428*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5435*/    /*Scope*/ 11, /*->5447*/
/*  5436*/     OPC_CheckChild2CondCode, ISD::SETLE,
/*  5438*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5440*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5447*/    /*Scope*/ 11, /*->5459*/
/*  5448*/     OPC_CheckChild2CondCode, ISD::SETULE,
/*  5450*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5452*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5459*/    /*Scope*/ 11, /*->5471*/
/*  5460*/     OPC_CheckChild2CondCode, ISD::SETGE,
/*  5462*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5464*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5471*/    /*Scope*/ 11, /*->5483*/
/*  5472*/     OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5474*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5476*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5483*/    0, /*End of Scope*/
/*  5484*/   /*SwitchType*/ 125, MVT::v8i16,// ->5611
/*  5486*/    OPC_CheckChild0Type, MVT::v8i16,
/*  5488*/    OPC_RecordChild1, // #1 = $rhs
/*  5489*/    OPC_Scope, 11, /*->5502*/ // 10 children in Scope
/*  5491*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5493*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5495*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
               // Dst: (EQ_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5502*/    /*Scope*/ 11, /*->5514*/
/*  5503*/     OPC_CheckChild2CondCode, ISD::SETNE,
/*  5505*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5507*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
               // Dst: (NE_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5514*/    /*Scope*/ 11, /*->5526*/
/*  5515*/     OPC_CheckChild2CondCode, ISD::SETLT,
/*  5517*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5519*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5526*/    /*Scope*/ 11, /*->5538*/
/*  5527*/     OPC_CheckChild2CondCode, ISD::SETULT,
/*  5529*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5531*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5538*/    /*Scope*/ 11, /*->5550*/
/*  5539*/     OPC_CheckChild2CondCode, ISD::SETGT,
/*  5541*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5543*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5550*/    /*Scope*/ 11, /*->5562*/
/*  5551*/     OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5553*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5555*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5562*/    /*Scope*/ 11, /*->5574*/
/*  5563*/     OPC_CheckChild2CondCode, ISD::SETLE,
/*  5565*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5567*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5574*/    /*Scope*/ 11, /*->5586*/
/*  5575*/     OPC_CheckChild2CondCode, ISD::SETULE,
/*  5577*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5579*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5586*/    /*Scope*/ 11, /*->5598*/
/*  5587*/     OPC_CheckChild2CondCode, ISD::SETGE,
/*  5589*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5591*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5598*/    /*Scope*/ 11, /*->5610*/
/*  5599*/     OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5601*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5603*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5610*/    0, /*End of Scope*/
/*  5611*/   /*SwitchType*/ 11|128,2/*267*/, MVT::v4i32,// ->5881
/*  5614*/    OPC_Scope, 125, /*->5741*/ // 2 children in Scope
/*  5616*/     OPC_CheckChild0Type, MVT::v4i32,
/*  5618*/     OPC_RecordChild1, // #1 = $rhs
/*  5619*/     OPC_Scope, 11, /*->5632*/ // 10 children in Scope
/*  5621*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5623*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5625*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5632*/     /*Scope*/ 11, /*->5644*/
/*  5633*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5635*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5637*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5644*/     /*Scope*/ 11, /*->5656*/
/*  5645*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5647*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5649*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5656*/     /*Scope*/ 11, /*->5668*/
/*  5657*/      OPC_CheckChild2CondCode, ISD::SETULT,
/*  5659*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5661*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5668*/     /*Scope*/ 11, /*->5680*/
/*  5669*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5671*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5673*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5680*/     /*Scope*/ 11, /*->5692*/
/*  5681*/      OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5683*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5685*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5692*/     /*Scope*/ 11, /*->5704*/
/*  5693*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5695*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5697*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5704*/     /*Scope*/ 11, /*->5716*/
/*  5705*/      OPC_CheckChild2CondCode, ISD::SETULE,
/*  5707*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5709*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5716*/     /*Scope*/ 11, /*->5728*/
/*  5717*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5719*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5721*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5728*/     /*Scope*/ 11, /*->5740*/
/*  5729*/      OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5731*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5733*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5740*/     0, /*End of Scope*/
/*  5741*/    /*Scope*/ 9|128,1/*137*/, /*->5880*/
/*  5743*/     OPC_CheckChild0Type, MVT::v4f32,
/*  5745*/     OPC_RecordChild1, // #1 = $rhs
/*  5746*/     OPC_Scope, 11, /*->5759*/ // 12 children in Scope
/*  5748*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5750*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5752*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5759*/     /*Scope*/ 11, /*->5771*/
/*  5760*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5762*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5764*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5771*/     /*Scope*/ 11, /*->5783*/
/*  5772*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5774*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5776*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5783*/     /*Scope*/ 11, /*->5795*/
/*  5784*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5786*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5788*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5795*/     /*Scope*/ 11, /*->5807*/
/*  5796*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5798*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5800*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5807*/     /*Scope*/ 11, /*->5819*/
/*  5808*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5810*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5812*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5819*/     /*Scope*/ 9, /*->5829*/
/*  5820*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5822*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5829*/     /*Scope*/ 9, /*->5839*/
/*  5830*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5832*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5839*/     /*Scope*/ 9, /*->5849*/
/*  5840*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5842*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5849*/     /*Scope*/ 9, /*->5859*/
/*  5850*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5852*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5859*/     /*Scope*/ 9, /*->5869*/
/*  5860*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5862*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5869*/     /*Scope*/ 9, /*->5879*/
/*  5870*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5872*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32x4),
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5879*/     0, /*End of Scope*/
/*  5880*/    0, /*End of Scope*/
/*  5881*/   /*SwitchType*/ 91|128,1/*219*/, MVT::v2i64,// ->6103
/*  5884*/    OPC_Scope, 77, /*->5963*/ // 2 children in Scope
/*  5886*/     OPC_CheckChild0Type, MVT::v2i64,
/*  5888*/     OPC_RecordChild1, // #1 = $rhs
/*  5889*/     OPC_Scope, 11, /*->5902*/ // 6 children in Scope
/*  5891*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5893*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5895*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5902*/     /*Scope*/ 11, /*->5914*/
/*  5903*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5905*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5907*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5914*/     /*Scope*/ 11, /*->5926*/
/*  5915*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5917*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5919*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5926*/     /*Scope*/ 11, /*->5938*/
/*  5927*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5929*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5931*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5938*/     /*Scope*/ 11, /*->5950*/
/*  5939*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5941*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5943*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5950*/     /*Scope*/ 11, /*->5962*/
/*  5951*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5953*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5955*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5962*/     0, /*End of Scope*/
/*  5963*/    /*Scope*/ 9|128,1/*137*/, /*->6102*/
/*  5965*/     OPC_CheckChild0Type, MVT::v2f64,
/*  5967*/     OPC_RecordChild1, // #1 = $rhs
/*  5968*/     OPC_Scope, 11, /*->5981*/ // 12 children in Scope
/*  5970*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5972*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5974*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5981*/     /*Scope*/ 11, /*->5993*/
/*  5982*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5984*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5986*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5993*/     /*Scope*/ 11, /*->6005*/
/*  5994*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5996*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5998*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  6005*/     /*Scope*/ 11, /*->6017*/
/*  6006*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  6008*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6010*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  6017*/     /*Scope*/ 11, /*->6029*/
/*  6018*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  6020*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6022*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  6029*/     /*Scope*/ 11, /*->6041*/
/*  6030*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  6032*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6034*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  6041*/     /*Scope*/ 9, /*->6051*/
/*  6042*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  6044*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  6051*/     /*Scope*/ 9, /*->6061*/
/*  6052*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  6054*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  6061*/     /*Scope*/ 9, /*->6071*/
/*  6062*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  6064*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  6071*/     /*Scope*/ 9, /*->6081*/
/*  6072*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  6074*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  6081*/     /*Scope*/ 9, /*->6091*/
/*  6082*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  6084*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  6091*/     /*Scope*/ 9, /*->6101*/
/*  6092*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  6094*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64x2),
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  6101*/     0, /*End of Scope*/
/*  6102*/    0, /*End of Scope*/
/*  6103*/   0, // EndSwitchType
/*  6104*/  0, /*End of Scope*/
/*  6105*/ /*SwitchOpcode*/ 63|128,12/*1599*/, TARGET_VAL(ISD::LOAD),// ->7708
/*  6109*/  OPC_RecordMemRef,
/*  6110*/  OPC_RecordNode, // #0 = 'ld' chained node
/*  6111*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  6112*/  OPC_Scope, 27|128,6/*795*/, /*->6910*/ // 2 children in Scope
/*  6115*/   OPC_CheckChild1TypeI32,
/*  6116*/   OPC_CheckPredicate, 14, // Predicate_unindexedload
/*  6118*/   OPC_Scope, 42, /*->6162*/ // 16 children in Scope
/*  6120*/    OPC_CheckPredicate, 15, // Predicate_load
/*  6122*/    OPC_SwitchType /*2 cases */, 17, MVT::i32,// ->6142
/*  6125*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6127*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6130*/     OPC_EmitMergeInputChains1_0,
/*  6131*/     OPC_EmitInteger32, 0, 
/*  6133*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6142*/    /*SwitchType*/ 17, MVT::i64,// ->6161
/*  6144*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6146*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6149*/     OPC_EmitMergeInputChains1_0,
/*  6150*/     OPC_EmitInteger32, 0, 
/*  6152*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6161*/    0, // EndSwitchType
/*  6162*/   /*Scope*/ 112, /*->6275*/
/*  6163*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  6165*/    OPC_SwitchType /*2 cases */, 42, MVT::i32,// ->6210
/*  6168*/     OPC_Scope, 19, /*->6189*/ // 2 children in Scope
/*  6170*/      OPC_CheckPredicate, 0, // Predicate_sextloadi8
/*  6172*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6174*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6177*/      OPC_EmitMergeInputChains1_0,
/*  6178*/      OPC_EmitInteger32, 0, 
/*  6180*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6189*/     /*Scope*/ 19, /*->6209*/
/*  6190*/      OPC_CheckPredicate, 1, // Predicate_sextloadi16
/*  6192*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6194*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6197*/      OPC_EmitMergeInputChains1_0,
/*  6198*/      OPC_EmitInteger32, 0, 
/*  6200*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6209*/     0, /*End of Scope*/
/*  6210*/    /*SwitchType*/ 62, MVT::i64,// ->6274
/*  6212*/     OPC_Scope, 19, /*->6233*/ // 3 children in Scope
/*  6214*/      OPC_CheckPredicate, 0, // Predicate_sextloadi8
/*  6216*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6218*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6221*/      OPC_EmitMergeInputChains1_0,
/*  6222*/      OPC_EmitInteger32, 0, 
/*  6224*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6233*/     /*Scope*/ 19, /*->6253*/
/*  6234*/      OPC_CheckPredicate, 1, // Predicate_sextloadi16
/*  6236*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6238*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6241*/      OPC_EmitMergeInputChains1_0,
/*  6242*/      OPC_EmitInteger32, 0, 
/*  6244*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6253*/     /*Scope*/ 19, /*->6273*/
/*  6254*/      OPC_CheckPredicate, 2, // Predicate_sextloadi32
/*  6256*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6258*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6261*/      OPC_EmitMergeInputChains1_0,
/*  6262*/      OPC_EmitInteger32, 0, 
/*  6264*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                // Dst: (LOAD32_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6273*/     0, /*End of Scope*/
/*  6274*/    0, // EndSwitchType
/*  6275*/   /*Scope*/ 112, /*->6388*/
/*  6276*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  6278*/    OPC_SwitchType /*2 cases */, 42, MVT::i32,// ->6323
/*  6281*/     OPC_Scope, 19, /*->6302*/ // 2 children in Scope
/*  6283*/      OPC_CheckPredicate, 0, // Predicate_zextloadi8
/*  6285*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6287*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6290*/      OPC_EmitMergeInputChains1_0,
/*  6291*/      OPC_EmitInteger32, 0, 
/*  6293*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6302*/     /*Scope*/ 19, /*->6322*/
/*  6303*/      OPC_CheckPredicate, 1, // Predicate_zextloadi16
/*  6305*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6307*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6310*/      OPC_EmitMergeInputChains1_0,
/*  6311*/      OPC_EmitInteger32, 0, 
/*  6313*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6322*/     0, /*End of Scope*/
/*  6323*/    /*SwitchType*/ 62, MVT::i64,// ->6387
/*  6325*/     OPC_Scope, 19, /*->6346*/ // 3 children in Scope
/*  6327*/      OPC_CheckPredicate, 0, // Predicate_zextloadi8
/*  6329*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6331*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6334*/      OPC_EmitMergeInputChains1_0,
/*  6335*/      OPC_EmitInteger32, 0, 
/*  6337*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6346*/     /*Scope*/ 19, /*->6366*/
/*  6347*/      OPC_CheckPredicate, 1, // Predicate_zextloadi16
/*  6349*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6351*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6354*/      OPC_EmitMergeInputChains1_0,
/*  6355*/      OPC_EmitInteger32, 0, 
/*  6357*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6366*/     /*Scope*/ 19, /*->6386*/
/*  6367*/      OPC_CheckPredicate, 2, // Predicate_zextloadi32
/*  6369*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6371*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6374*/      OPC_EmitMergeInputChains1_0,
/*  6375*/      OPC_EmitInteger32, 0, 
/*  6377*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6386*/     0, /*End of Scope*/
/*  6387*/    0, // EndSwitchType
/*  6388*/   /*Scope*/ 112, /*->6501*/
/*  6389*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  6391*/    OPC_SwitchType /*2 cases */, 42, MVT::i32,// ->6436
/*  6394*/     OPC_Scope, 19, /*->6415*/ // 2 children in Scope
/*  6396*/      OPC_CheckPredicate, 0, // Predicate_extloadi8
/*  6398*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6400*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6403*/      OPC_EmitMergeInputChains1_0,
/*  6404*/      OPC_EmitInteger32, 0, 
/*  6406*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6415*/     /*Scope*/ 19, /*->6435*/
/*  6416*/      OPC_CheckPredicate, 1, // Predicate_extloadi16
/*  6418*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6420*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6423*/      OPC_EmitMergeInputChains1_0,
/*  6424*/      OPC_EmitInteger32, 0, 
/*  6426*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6435*/     0, /*End of Scope*/
/*  6436*/    /*SwitchType*/ 62, MVT::i64,// ->6500
/*  6438*/     OPC_Scope, 19, /*->6459*/ // 3 children in Scope
/*  6440*/      OPC_CheckPredicate, 0, // Predicate_extloadi8
/*  6442*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6444*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6447*/      OPC_EmitMergeInputChains1_0,
/*  6448*/      OPC_EmitInteger32, 0, 
/*  6450*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6459*/     /*Scope*/ 19, /*->6479*/
/*  6460*/      OPC_CheckPredicate, 1, // Predicate_extloadi16
/*  6462*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6464*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6467*/      OPC_EmitMergeInputChains1_0,
/*  6468*/      OPC_EmitInteger32, 0, 
/*  6470*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6479*/     /*Scope*/ 19, /*->6499*/
/*  6480*/      OPC_CheckPredicate, 2, // Predicate_extloadi32
/*  6482*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6484*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6487*/      OPC_EmitMergeInputChains1_0,
/*  6488*/      OPC_EmitInteger32, 0, 
/*  6490*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6499*/     0, /*End of Scope*/
/*  6500*/    0, // EndSwitchType
/*  6501*/   /*Scope*/ 118, /*->6620*/
/*  6502*/    OPC_CheckPredicate, 15, // Predicate_load
/*  6504*/    OPC_SwitchType /*6 cases */, 17, MVT::f32,// ->6524
/*  6507*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6509*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6512*/     OPC_EmitMergeInputChains1_0,
/*  6513*/     OPC_EmitInteger32, 0, 
/*  6515*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F32_A32:{ *:[f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6524*/    /*SwitchType*/ 17, MVT::f64,// ->6543
/*  6526*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6528*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6531*/     OPC_EmitMergeInputChains1_0,
/*  6532*/     OPC_EmitInteger32, 0, 
/*  6534*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F64_A32:{ *:[f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6543*/    /*SwitchType*/ 17, MVT::v16i8,// ->6562
/*  6545*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6547*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6550*/     OPC_EmitMergeInputChains1_0,
/*  6551*/     OPC_EmitInteger32, 0, 
/*  6553*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v16i8] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v16i8] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6562*/    /*SwitchType*/ 17, MVT::v8i16,// ->6581
/*  6564*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6566*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6569*/     OPC_EmitMergeInputChains1_0,
/*  6570*/     OPC_EmitInteger32, 0, 
/*  6572*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6581*/    /*SwitchType*/ 17, MVT::v4i32,// ->6600
/*  6583*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6585*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6588*/     OPC_EmitMergeInputChains1_0,
/*  6589*/     OPC_EmitInteger32, 0, 
/*  6591*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6600*/    /*SwitchType*/ 17, MVT::v2i64,// ->6619
/*  6602*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6604*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6607*/     OPC_EmitMergeInputChains1_0,
/*  6608*/     OPC_EmitInteger32, 0, 
/*  6610*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6619*/    0, // EndSwitchType
/*  6620*/   /*Scope*/ 23, /*->6644*/
/*  6621*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  6623*/    OPC_CheckPredicate, 19, // Predicate_sextloadvi8
/*  6625*/    OPC_CheckType, MVT::v8i16,
/*  6627*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6629*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6632*/    OPC_EmitMergeInputChains1_0,
/*  6633*/    OPC_EmitInteger32, 0, 
/*  6635*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6644*/   /*Scope*/ 23, /*->6668*/
/*  6645*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  6647*/    OPC_CheckPredicate, 19, // Predicate_zextloadvi8
/*  6649*/    OPC_CheckType, MVT::v8i16,
/*  6651*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6653*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6656*/    OPC_EmitMergeInputChains1_0,
/*  6657*/    OPC_EmitInteger32, 0, 
/*  6659*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6668*/   /*Scope*/ 23, /*->6692*/
/*  6669*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  6671*/    OPC_CheckPredicate, 19, // Predicate_extloadvi8
/*  6673*/    OPC_CheckType, MVT::v8i16,
/*  6675*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6677*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6680*/    OPC_EmitMergeInputChains1_0,
/*  6681*/    OPC_EmitInteger32, 0, 
/*  6683*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6692*/   /*Scope*/ 23, /*->6716*/
/*  6693*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  6695*/    OPC_CheckPredicate, 20, // Predicate_sextloadvi16
/*  6697*/    OPC_CheckType, MVT::v4i32,
/*  6699*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6701*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6704*/    OPC_EmitMergeInputChains1_0,
/*  6705*/    OPC_EmitInteger32, 0, 
/*  6707*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6716*/   /*Scope*/ 23, /*->6740*/
/*  6717*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  6719*/    OPC_CheckPredicate, 20, // Predicate_zextloadvi16
/*  6721*/    OPC_CheckType, MVT::v4i32,
/*  6723*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6725*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6728*/    OPC_EmitMergeInputChains1_0,
/*  6729*/    OPC_EmitInteger32, 0, 
/*  6731*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6740*/   /*Scope*/ 23, /*->6764*/
/*  6741*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  6743*/    OPC_CheckPredicate, 20, // Predicate_extloadvi16
/*  6745*/    OPC_CheckType, MVT::v4i32,
/*  6747*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6749*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6752*/    OPC_EmitMergeInputChains1_0,
/*  6753*/    OPC_EmitInteger32, 0, 
/*  6755*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6764*/   /*Scope*/ 23, /*->6788*/
/*  6765*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  6767*/    OPC_CheckPredicate, 21, // Predicate_sextloadvi32
/*  6769*/    OPC_CheckType, MVT::v2i64,
/*  6771*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6773*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6776*/    OPC_EmitMergeInputChains1_0,
/*  6777*/    OPC_EmitInteger32, 0, 
/*  6779*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6788*/   /*Scope*/ 23, /*->6812*/
/*  6789*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  6791*/    OPC_CheckPredicate, 21, // Predicate_zextloadvi32
/*  6793*/    OPC_CheckType, MVT::v2i64,
/*  6795*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6797*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6800*/    OPC_EmitMergeInputChains1_0,
/*  6801*/    OPC_EmitInteger32, 0, 
/*  6803*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6812*/   /*Scope*/ 23, /*->6836*/
/*  6813*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  6815*/    OPC_CheckPredicate, 21, // Predicate_extloadvi32
/*  6817*/    OPC_CheckType, MVT::v2i64,
/*  6819*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6821*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6824*/    OPC_EmitMergeInputChains1_0,
/*  6825*/    OPC_EmitInteger32, 0, 
/*  6827*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6836*/   /*Scope*/ 42, /*->6879*/
/*  6837*/    OPC_CheckPredicate, 15, // Predicate_load
/*  6839*/    OPC_SwitchType /*2 cases */, 17, MVT::v4f32,// ->6859
/*  6842*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6844*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6847*/     OPC_EmitMergeInputChains1_0,
/*  6848*/     OPC_EmitInteger32, 0, 
/*  6850*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6859*/    /*SwitchType*/ 17, MVT::v2f64,// ->6878
/*  6861*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6863*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6866*/     OPC_EmitMergeInputChains1_0,
/*  6867*/     OPC_EmitInteger32, 0, 
/*  6869*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6878*/    0, // EndSwitchType
/*  6879*/   /*Scope*/ 29, /*->6909*/
/*  6880*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  6882*/    OPC_CheckType, MVT::v2f64,
/*  6884*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6886*/    OPC_EmitMergeInputChains1_0,
/*  6887*/    OPC_EmitInteger32, 0, 
/*  6889*/    OPC_EmitInteger32, 0, 
/*  6891*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v16i8, 3/*#Ops*/, 2, 3, 1,  // Results = #4
/*  6900*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                  MVT::v2f64, 1/*#Ops*/, 4,  // Results = #5
/*  6906*/    OPC_CompleteMatch, 1, 5, 
               // Src: (ld:{ *:[v2f64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>> - Complexity = 4
               // Dst: (promote_low_F64x2:{ *:[v2f64] } (LOAD_ZERO_I64x2_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr))
/*  6909*/   0, /*End of Scope*/
/*  6910*/  /*Scope*/ 27|128,6/*795*/, /*->7707*/
/*  6912*/   OPC_CheckChild1TypeI64,
/*  6913*/   OPC_CheckPredicate, 14, // Predicate_unindexedload
/*  6915*/   OPC_Scope, 42, /*->6959*/ // 16 children in Scope
/*  6917*/    OPC_CheckPredicate, 15, // Predicate_load
/*  6919*/    OPC_SwitchType /*2 cases */, 17, MVT::i32,// ->6939
/*  6922*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  6924*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6927*/     OPC_EmitMergeInputChains1_0,
/*  6928*/     OPC_EmitInteger32, 0, 
/*  6930*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6939*/    /*SwitchType*/ 17, MVT::i64,// ->6958
/*  6941*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  6943*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6946*/     OPC_EmitMergeInputChains1_0,
/*  6947*/     OPC_EmitInteger32, 0, 
/*  6949*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6958*/    0, // EndSwitchType
/*  6959*/   /*Scope*/ 112, /*->7072*/
/*  6960*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  6962*/    OPC_SwitchType /*2 cases */, 42, MVT::i32,// ->7007
/*  6965*/     OPC_Scope, 19, /*->6986*/ // 2 children in Scope
/*  6967*/      OPC_CheckPredicate, 0, // Predicate_sextloadi8
/*  6969*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  6971*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6974*/      OPC_EmitMergeInputChains1_0,
/*  6975*/      OPC_EmitInteger32, 0, 
/*  6977*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6986*/     /*Scope*/ 19, /*->7006*/
/*  6987*/      OPC_CheckPredicate, 1, // Predicate_sextloadi16
/*  6989*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  6991*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6994*/      OPC_EmitMergeInputChains1_0,
/*  6995*/      OPC_EmitInteger32, 0, 
/*  6997*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7006*/     0, /*End of Scope*/
/*  7007*/    /*SwitchType*/ 62, MVT::i64,// ->7071
/*  7009*/     OPC_Scope, 19, /*->7030*/ // 3 children in Scope
/*  7011*/      OPC_CheckPredicate, 0, // Predicate_sextloadi8
/*  7013*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7015*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7018*/      OPC_EmitMergeInputChains1_0,
/*  7019*/      OPC_EmitInteger32, 0, 
/*  7021*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7030*/     /*Scope*/ 19, /*->7050*/
/*  7031*/      OPC_CheckPredicate, 1, // Predicate_sextloadi16
/*  7033*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7035*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7038*/      OPC_EmitMergeInputChains1_0,
/*  7039*/      OPC_EmitInteger32, 0, 
/*  7041*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7050*/     /*Scope*/ 19, /*->7070*/
/*  7051*/      OPC_CheckPredicate, 2, // Predicate_sextloadi32
/*  7053*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7055*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7058*/      OPC_EmitMergeInputChains1_0,
/*  7059*/      OPC_EmitInteger32, 0, 
/*  7061*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                // Dst: (LOAD32_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7070*/     0, /*End of Scope*/
/*  7071*/    0, // EndSwitchType
/*  7072*/   /*Scope*/ 112, /*->7185*/
/*  7073*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  7075*/    OPC_SwitchType /*2 cases */, 42, MVT::i32,// ->7120
/*  7078*/     OPC_Scope, 19, /*->7099*/ // 2 children in Scope
/*  7080*/      OPC_CheckPredicate, 0, // Predicate_zextloadi8
/*  7082*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7084*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7087*/      OPC_EmitMergeInputChains1_0,
/*  7088*/      OPC_EmitInteger32, 0, 
/*  7090*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7099*/     /*Scope*/ 19, /*->7119*/
/*  7100*/      OPC_CheckPredicate, 1, // Predicate_zextloadi16
/*  7102*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7104*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7107*/      OPC_EmitMergeInputChains1_0,
/*  7108*/      OPC_EmitInteger32, 0, 
/*  7110*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7119*/     0, /*End of Scope*/
/*  7120*/    /*SwitchType*/ 62, MVT::i64,// ->7184
/*  7122*/     OPC_Scope, 19, /*->7143*/ // 3 children in Scope
/*  7124*/      OPC_CheckPredicate, 0, // Predicate_zextloadi8
/*  7126*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7128*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7131*/      OPC_EmitMergeInputChains1_0,
/*  7132*/      OPC_EmitInteger32, 0, 
/*  7134*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7143*/     /*Scope*/ 19, /*->7163*/
/*  7144*/      OPC_CheckPredicate, 1, // Predicate_zextloadi16
/*  7146*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7148*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7151*/      OPC_EmitMergeInputChains1_0,
/*  7152*/      OPC_EmitInteger32, 0, 
/*  7154*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7163*/     /*Scope*/ 19, /*->7183*/
/*  7164*/      OPC_CheckPredicate, 2, // Predicate_zextloadi32
/*  7166*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7168*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7171*/      OPC_EmitMergeInputChains1_0,
/*  7172*/      OPC_EmitInteger32, 0, 
/*  7174*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7183*/     0, /*End of Scope*/
/*  7184*/    0, // EndSwitchType
/*  7185*/   /*Scope*/ 112, /*->7298*/
/*  7186*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  7188*/    OPC_SwitchType /*2 cases */, 42, MVT::i32,// ->7233
/*  7191*/     OPC_Scope, 19, /*->7212*/ // 2 children in Scope
/*  7193*/      OPC_CheckPredicate, 0, // Predicate_extloadi8
/*  7195*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7197*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7200*/      OPC_EmitMergeInputChains1_0,
/*  7201*/      OPC_EmitInteger32, 0, 
/*  7203*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7212*/     /*Scope*/ 19, /*->7232*/
/*  7213*/      OPC_CheckPredicate, 1, // Predicate_extloadi16
/*  7215*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7217*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7220*/      OPC_EmitMergeInputChains1_0,
/*  7221*/      OPC_EmitInteger32, 0, 
/*  7223*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7232*/     0, /*End of Scope*/
/*  7233*/    /*SwitchType*/ 62, MVT::i64,// ->7297
/*  7235*/     OPC_Scope, 19, /*->7256*/ // 3 children in Scope
/*  7237*/      OPC_CheckPredicate, 0, // Predicate_extloadi8
/*  7239*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7241*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7244*/      OPC_EmitMergeInputChains1_0,
/*  7245*/      OPC_EmitInteger32, 0, 
/*  7247*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7256*/     /*Scope*/ 19, /*->7276*/
/*  7257*/      OPC_CheckPredicate, 1, // Predicate_extloadi16
/*  7259*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7261*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7264*/      OPC_EmitMergeInputChains1_0,
/*  7265*/      OPC_EmitInteger32, 0, 
/*  7267*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7276*/     /*Scope*/ 19, /*->7296*/
/*  7277*/      OPC_CheckPredicate, 2, // Predicate_extloadi32
/*  7279*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7281*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7284*/      OPC_EmitMergeInputChains1_0,
/*  7285*/      OPC_EmitInteger32, 0, 
/*  7287*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7296*/     0, /*End of Scope*/
/*  7297*/    0, // EndSwitchType
/*  7298*/   /*Scope*/ 118, /*->7417*/
/*  7299*/    OPC_CheckPredicate, 15, // Predicate_load
/*  7301*/    OPC_SwitchType /*6 cases */, 17, MVT::f32,// ->7321
/*  7304*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7306*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7309*/     OPC_EmitMergeInputChains1_0,
/*  7310*/     OPC_EmitInteger32, 0, 
/*  7312*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F32_A64:{ *:[f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7321*/    /*SwitchType*/ 17, MVT::f64,// ->7340
/*  7323*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7325*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7328*/     OPC_EmitMergeInputChains1_0,
/*  7329*/     OPC_EmitInteger32, 0, 
/*  7331*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F64_A64:{ *:[f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7340*/    /*SwitchType*/ 17, MVT::v16i8,// ->7359
/*  7342*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7344*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7347*/     OPC_EmitMergeInputChains1_0,
/*  7348*/     OPC_EmitInteger32, 0, 
/*  7350*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v16i8] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v16i8] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7359*/    /*SwitchType*/ 17, MVT::v8i16,// ->7378
/*  7361*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7363*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7366*/     OPC_EmitMergeInputChains1_0,
/*  7367*/     OPC_EmitInteger32, 0, 
/*  7369*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7378*/    /*SwitchType*/ 17, MVT::v4i32,// ->7397
/*  7380*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7382*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7385*/     OPC_EmitMergeInputChains1_0,
/*  7386*/     OPC_EmitInteger32, 0, 
/*  7388*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7397*/    /*SwitchType*/ 17, MVT::v2i64,// ->7416
/*  7399*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7401*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7404*/     OPC_EmitMergeInputChains1_0,
/*  7405*/     OPC_EmitInteger32, 0, 
/*  7407*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7416*/    0, // EndSwitchType
/*  7417*/   /*Scope*/ 23, /*->7441*/
/*  7418*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  7420*/    OPC_CheckPredicate, 19, // Predicate_sextloadvi8
/*  7422*/    OPC_CheckType, MVT::v8i16,
/*  7424*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7426*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7429*/    OPC_EmitMergeInputChains1_0,
/*  7430*/    OPC_EmitInteger32, 0, 
/*  7432*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7441*/   /*Scope*/ 23, /*->7465*/
/*  7442*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  7444*/    OPC_CheckPredicate, 19, // Predicate_zextloadvi8
/*  7446*/    OPC_CheckType, MVT::v8i16,
/*  7448*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7450*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7453*/    OPC_EmitMergeInputChains1_0,
/*  7454*/    OPC_EmitInteger32, 0, 
/*  7456*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7465*/   /*Scope*/ 23, /*->7489*/
/*  7466*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  7468*/    OPC_CheckPredicate, 19, // Predicate_extloadvi8
/*  7470*/    OPC_CheckType, MVT::v8i16,
/*  7472*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7474*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7477*/    OPC_EmitMergeInputChains1_0,
/*  7478*/    OPC_EmitInteger32, 0, 
/*  7480*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7489*/   /*Scope*/ 23, /*->7513*/
/*  7490*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  7492*/    OPC_CheckPredicate, 20, // Predicate_sextloadvi16
/*  7494*/    OPC_CheckType, MVT::v4i32,
/*  7496*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7498*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7501*/    OPC_EmitMergeInputChains1_0,
/*  7502*/    OPC_EmitInteger32, 0, 
/*  7504*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7513*/   /*Scope*/ 23, /*->7537*/
/*  7514*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  7516*/    OPC_CheckPredicate, 20, // Predicate_zextloadvi16
/*  7518*/    OPC_CheckType, MVT::v4i32,
/*  7520*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7522*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7525*/    OPC_EmitMergeInputChains1_0,
/*  7526*/    OPC_EmitInteger32, 0, 
/*  7528*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7537*/   /*Scope*/ 23, /*->7561*/
/*  7538*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  7540*/    OPC_CheckPredicate, 20, // Predicate_extloadvi16
/*  7542*/    OPC_CheckType, MVT::v4i32,
/*  7544*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7546*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7549*/    OPC_EmitMergeInputChains1_0,
/*  7550*/    OPC_EmitInteger32, 0, 
/*  7552*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7561*/   /*Scope*/ 23, /*->7585*/
/*  7562*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  7564*/    OPC_CheckPredicate, 21, // Predicate_sextloadvi32
/*  7566*/    OPC_CheckType, MVT::v2i64,
/*  7568*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7570*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7573*/    OPC_EmitMergeInputChains1_0,
/*  7574*/    OPC_EmitInteger32, 0, 
/*  7576*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7585*/   /*Scope*/ 23, /*->7609*/
/*  7586*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  7588*/    OPC_CheckPredicate, 21, // Predicate_zextloadvi32
/*  7590*/    OPC_CheckType, MVT::v2i64,
/*  7592*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7594*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7597*/    OPC_EmitMergeInputChains1_0,
/*  7598*/    OPC_EmitInteger32, 0, 
/*  7600*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7609*/   /*Scope*/ 23, /*->7633*/
/*  7610*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  7612*/    OPC_CheckPredicate, 21, // Predicate_extloadvi32
/*  7614*/    OPC_CheckType, MVT::v2i64,
/*  7616*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7618*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7621*/    OPC_EmitMergeInputChains1_0,
/*  7622*/    OPC_EmitInteger32, 0, 
/*  7624*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7633*/   /*Scope*/ 42, /*->7676*/
/*  7634*/    OPC_CheckPredicate, 15, // Predicate_load
/*  7636*/    OPC_SwitchType /*2 cases */, 17, MVT::v4f32,// ->7656
/*  7639*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7641*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7644*/     OPC_EmitMergeInputChains1_0,
/*  7645*/     OPC_EmitInteger32, 0, 
/*  7647*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7656*/    /*SwitchType*/ 17, MVT::v2f64,// ->7675
/*  7658*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7660*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7663*/     OPC_EmitMergeInputChains1_0,
/*  7664*/     OPC_EmitInteger32, 0, 
/*  7666*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7675*/    0, // EndSwitchType
/*  7676*/   /*Scope*/ 29, /*->7706*/
/*  7677*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  7679*/    OPC_CheckType, MVT::v2f64,
/*  7681*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7683*/    OPC_EmitMergeInputChains1_0,
/*  7684*/    OPC_EmitInteger32, 0, 
/*  7686*/    OPC_EmitInteger64, 0, 
/*  7688*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v16i8, 3/*#Ops*/, 2, 3, 1,  // Results = #4
/*  7697*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                  MVT::v2f64, 1/*#Ops*/, 4,  // Results = #5
/*  7703*/    OPC_CompleteMatch, 1, 5, 
               // Src: (ld:{ *:[v2f64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>> - Complexity = 4
               // Dst: (promote_low_F64x2:{ *:[v2f64] } (LOAD_ZERO_I64x2_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr))
/*  7706*/   0, /*End of Scope*/
/*  7707*/  0, /*End of Scope*/
/*  7708*/ /*SwitchOpcode*/ 55|128,1/*183*/, TARGET_VAL(ISD::ATOMIC_LOAD),// ->7895
/*  7712*/  OPC_RecordMemRef,
/*  7713*/  OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  7714*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7715*/  OPC_Scope, 88, /*->7805*/ // 2 children in Scope
/*  7717*/   OPC_CheckChild1TypeI32,
/*  7718*/   OPC_SwitchType /*2 cases */, 62, MVT::i32,// ->7783
/*  7721*/    OPC_Scope, 19, /*->7742*/ // 3 children in Scope
/*  7723*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_32
/*  7725*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7727*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7730*/     OPC_EmitMergeInputChains1_0,
/*  7731*/     OPC_EmitInteger32, 0, 
/*  7733*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_32>> - Complexity = 13
               // Dst: (ATOMIC_LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7742*/    /*Scope*/ 19, /*->7762*/
/*  7743*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_8
/*  7745*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7747*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7750*/     OPC_EmitMergeInputChains1_0,
/*  7751*/     OPC_EmitInteger32, 0, 
/*  7753*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>> - Complexity = 13
               // Dst: (ATOMIC_LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7762*/    /*Scope*/ 19, /*->7782*/
/*  7763*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_16
/*  7765*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7767*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7770*/     OPC_EmitMergeInputChains1_0,
/*  7771*/     OPC_EmitInteger32, 0, 
/*  7773*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>> - Complexity = 13
               // Dst: (ATOMIC_LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7782*/    0, /*End of Scope*/
/*  7783*/   /*SwitchType*/ 19, MVT::i64,// ->7804
/*  7785*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_64
/*  7787*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7789*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7792*/    OPC_EmitMergeInputChains1_0,
/*  7793*/    OPC_EmitInteger32, 0, 
/*  7795*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (atomic_load:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7804*/   0, // EndSwitchType
/*  7805*/  /*Scope*/ 88, /*->7894*/
/*  7806*/   OPC_CheckChild1TypeI64,
/*  7807*/   OPC_SwitchType /*2 cases */, 62, MVT::i32,// ->7872
/*  7810*/    OPC_Scope, 19, /*->7831*/ // 3 children in Scope
/*  7812*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_32
/*  7814*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7816*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7819*/     OPC_EmitMergeInputChains1_0,
/*  7820*/     OPC_EmitInteger32, 0, 
/*  7822*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_32>> - Complexity = 13
               // Dst: (ATOMIC_LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7831*/    /*Scope*/ 19, /*->7851*/
/*  7832*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_8
/*  7834*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7836*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7839*/     OPC_EmitMergeInputChains1_0,
/*  7840*/     OPC_EmitInteger32, 0, 
/*  7842*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>> - Complexity = 13
               // Dst: (ATOMIC_LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7851*/    /*Scope*/ 19, /*->7871*/
/*  7852*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_16
/*  7854*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7856*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7859*/     OPC_EmitMergeInputChains1_0,
/*  7860*/     OPC_EmitInteger32, 0, 
/*  7862*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>> - Complexity = 13
               // Dst: (ATOMIC_LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7871*/    0, /*End of Scope*/
/*  7872*/   /*SwitchType*/ 19, MVT::i64,// ->7893
/*  7874*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_64
/*  7876*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7878*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7881*/    OPC_EmitMergeInputChains1_0,
/*  7882*/    OPC_EmitInteger32, 0, 
/*  7884*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (atomic_load:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7893*/   0, // EndSwitchType
/*  7894*/  0, /*End of Scope*/
/*  7895*/ /*SwitchOpcode*/ 23|128,2/*279*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->8178
/*  7899*/  OPC_RecordMemRef,
/*  7900*/  OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  7901*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7902*/  OPC_Scope, 7|128,1/*135*/, /*->8040*/ // 2 children in Scope
/*  7905*/   OPC_CheckChild1TypeI32,
/*  7906*/   OPC_RecordChild2, // #2 = $val
/*  7907*/   OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->8017
/*  7910*/    OPC_Scope, 20, /*->7932*/ // 5 children in Scope
/*  7912*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_add_32
/*  7914*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7916*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7919*/     OPC_EmitMergeInputChains1_0,
/*  7920*/     OPC_EmitInteger32, 0, 
/*  7922*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7932*/    /*Scope*/ 20, /*->7953*/
/*  7933*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_add_8
/*  7935*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7937*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7940*/     OPC_EmitMergeInputChains1_0,
/*  7941*/     OPC_EmitInteger32, 0, 
/*  7943*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7953*/    /*Scope*/ 20, /*->7974*/
/*  7954*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_add_16
/*  7956*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7958*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7961*/     OPC_EmitMergeInputChains1_0,
/*  7962*/     OPC_EmitInteger32, 0, 
/*  7964*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7974*/    /*Scope*/ 20, /*->7995*/
/*  7975*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_add_8
/*  7977*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7979*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7982*/     OPC_EmitMergeInputChains1_0,
/*  7983*/     OPC_EmitInteger32, 0, 
/*  7985*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7995*/    /*Scope*/ 20, /*->8016*/
/*  7996*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_add_16
/*  7998*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8000*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8003*/     OPC_EmitMergeInputChains1_0,
/*  8004*/     OPC_EmitInteger32, 0, 
/*  8006*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8016*/    0, /*End of Scope*/
/*  8017*/   /*SwitchType*/ 20, MVT::i64,// ->8039
/*  8019*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_add_64
/*  8021*/    OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8023*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8026*/    OPC_EmitMergeInputChains1_0,
/*  8027*/    OPC_EmitInteger32, 0, 
/*  8029*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_add:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8039*/   0, // EndSwitchType
/*  8040*/  /*Scope*/ 7|128,1/*135*/, /*->8177*/
/*  8042*/   OPC_CheckChild1TypeI64,
/*  8043*/   OPC_RecordChild2, // #2 = $val
/*  8044*/   OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->8154
/*  8047*/    OPC_Scope, 20, /*->8069*/ // 5 children in Scope
/*  8049*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_add_32
/*  8051*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8053*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8056*/     OPC_EmitMergeInputChains1_0,
/*  8057*/     OPC_EmitInteger32, 0, 
/*  8059*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8069*/    /*Scope*/ 20, /*->8090*/
/*  8070*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_add_8
/*  8072*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8074*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8077*/     OPC_EmitMergeInputChains1_0,
/*  8078*/     OPC_EmitInteger32, 0, 
/*  8080*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8090*/    /*Scope*/ 20, /*->8111*/
/*  8091*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_add_16
/*  8093*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8095*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8098*/     OPC_EmitMergeInputChains1_0,
/*  8099*/     OPC_EmitInteger32, 0, 
/*  8101*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8111*/    /*Scope*/ 20, /*->8132*/
/*  8112*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_add_8
/*  8114*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8116*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8119*/     OPC_EmitMergeInputChains1_0,
/*  8120*/     OPC_EmitInteger32, 0, 
/*  8122*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8132*/    /*Scope*/ 20, /*->8153*/
/*  8133*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_add_16
/*  8135*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8137*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8140*/     OPC_EmitMergeInputChains1_0,
/*  8141*/     OPC_EmitInteger32, 0, 
/*  8143*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8153*/    0, /*End of Scope*/
/*  8154*/   /*SwitchType*/ 20, MVT::i64,// ->8176
/*  8156*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_add_64
/*  8158*/    OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8160*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8163*/    OPC_EmitMergeInputChains1_0,
/*  8164*/    OPC_EmitInteger32, 0, 
/*  8166*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_add:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8176*/   0, // EndSwitchType
/*  8177*/  0, /*End of Scope*/
/*  8178*/ /*SwitchOpcode*/ 23|128,2/*279*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->8461
/*  8182*/  OPC_RecordMemRef,
/*  8183*/  OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  8184*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8185*/  OPC_Scope, 7|128,1/*135*/, /*->8323*/ // 2 children in Scope
/*  8188*/   OPC_CheckChild1TypeI32,
/*  8189*/   OPC_RecordChild2, // #2 = $val
/*  8190*/   OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->8300
/*  8193*/    OPC_Scope, 20, /*->8215*/ // 5 children in Scope
/*  8195*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_32
/*  8197*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8199*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8202*/     OPC_EmitMergeInputChains1_0,
/*  8203*/     OPC_EmitInteger32, 0, 
/*  8205*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8215*/    /*Scope*/ 20, /*->8236*/
/*  8216*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_sub_8
/*  8218*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8220*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8223*/     OPC_EmitMergeInputChains1_0,
/*  8224*/     OPC_EmitInteger32, 0, 
/*  8226*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8236*/    /*Scope*/ 20, /*->8257*/
/*  8237*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_16
/*  8239*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8241*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8244*/     OPC_EmitMergeInputChains1_0,
/*  8245*/     OPC_EmitInteger32, 0, 
/*  8247*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8257*/    /*Scope*/ 20, /*->8278*/
/*  8258*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_sub_8
/*  8260*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8262*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8265*/     OPC_EmitMergeInputChains1_0,
/*  8266*/     OPC_EmitInteger32, 0, 
/*  8268*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8278*/    /*Scope*/ 20, /*->8299*/
/*  8279*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_16
/*  8281*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8283*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8286*/     OPC_EmitMergeInputChains1_0,
/*  8287*/     OPC_EmitInteger32, 0, 
/*  8289*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8299*/    0, /*End of Scope*/
/*  8300*/   /*SwitchType*/ 20, MVT::i64,// ->8322
/*  8302*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_sub_64
/*  8304*/    OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8306*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8309*/    OPC_EmitMergeInputChains1_0,
/*  8310*/    OPC_EmitInteger32, 0, 
/*  8312*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_sub:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8322*/   0, // EndSwitchType
/*  8323*/  /*Scope*/ 7|128,1/*135*/, /*->8460*/
/*  8325*/   OPC_CheckChild1TypeI64,
/*  8326*/   OPC_RecordChild2, // #2 = $val
/*  8327*/   OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->8437
/*  8330*/    OPC_Scope, 20, /*->8352*/ // 5 children in Scope
/*  8332*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_32
/*  8334*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8336*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8339*/     OPC_EmitMergeInputChains1_0,
/*  8340*/     OPC_EmitInteger32, 0, 
/*  8342*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8352*/    /*Scope*/ 20, /*->8373*/
/*  8353*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_sub_8
/*  8355*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8357*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8360*/     OPC_EmitMergeInputChains1_0,
/*  8361*/     OPC_EmitInteger32, 0, 
/*  8363*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8373*/    /*Scope*/ 20, /*->8394*/
/*  8374*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_16
/*  8376*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8378*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8381*/     OPC_EmitMergeInputChains1_0,
/*  8382*/     OPC_EmitInteger32, 0, 
/*  8384*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8394*/    /*Scope*/ 20, /*->8415*/
/*  8395*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_sub_8
/*  8397*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8399*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8402*/     OPC_EmitMergeInputChains1_0,
/*  8403*/     OPC_EmitInteger32, 0, 
/*  8405*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8415*/    /*Scope*/ 20, /*->8436*/
/*  8416*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_16
/*  8418*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8420*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8423*/     OPC_EmitMergeInputChains1_0,
/*  8424*/     OPC_EmitInteger32, 0, 
/*  8426*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8436*/    0, /*End of Scope*/
/*  8437*/   /*SwitchType*/ 20, MVT::i64,// ->8459
/*  8439*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_sub_64
/*  8441*/    OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8443*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8446*/    OPC_EmitMergeInputChains1_0,
/*  8447*/    OPC_EmitInteger32, 0, 
/*  8449*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_sub:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8459*/   0, // EndSwitchType
/*  8460*/  0, /*End of Scope*/
/*  8461*/ /*SwitchOpcode*/ 23|128,2/*279*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->8744
/*  8465*/  OPC_RecordMemRef,
/*  8466*/  OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  8467*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8468*/  OPC_Scope, 7|128,1/*135*/, /*->8606*/ // 2 children in Scope
/*  8471*/   OPC_CheckChild1TypeI32,
/*  8472*/   OPC_RecordChild2, // #2 = $val
/*  8473*/   OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->8583
/*  8476*/    OPC_Scope, 20, /*->8498*/ // 5 children in Scope
/*  8478*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_and_32
/*  8480*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8482*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8485*/     OPC_EmitMergeInputChains1_0,
/*  8486*/     OPC_EmitInteger32, 0, 
/*  8488*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8498*/    /*Scope*/ 20, /*->8519*/
/*  8499*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_and_8
/*  8501*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8503*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8506*/     OPC_EmitMergeInputChains1_0,
/*  8507*/     OPC_EmitInteger32, 0, 
/*  8509*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8519*/    /*Scope*/ 20, /*->8540*/
/*  8520*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_and_16
/*  8522*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8524*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8527*/     OPC_EmitMergeInputChains1_0,
/*  8528*/     OPC_EmitInteger32, 0, 
/*  8530*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8540*/    /*Scope*/ 20, /*->8561*/
/*  8541*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_and_8
/*  8543*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8545*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8548*/     OPC_EmitMergeInputChains1_0,
/*  8549*/     OPC_EmitInteger32, 0, 
/*  8551*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8561*/    /*Scope*/ 20, /*->8582*/
/*  8562*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_and_16
/*  8564*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8566*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8569*/     OPC_EmitMergeInputChains1_0,
/*  8570*/     OPC_EmitInteger32, 0, 
/*  8572*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8582*/    0, /*End of Scope*/
/*  8583*/   /*SwitchType*/ 20, MVT::i64,// ->8605
/*  8585*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_and_64
/*  8587*/    OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8589*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8592*/    OPC_EmitMergeInputChains1_0,
/*  8593*/    OPC_EmitInteger32, 0, 
/*  8595*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_and:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8605*/   0, // EndSwitchType
/*  8606*/  /*Scope*/ 7|128,1/*135*/, /*->8743*/
/*  8608*/   OPC_CheckChild1TypeI64,
/*  8609*/   OPC_RecordChild2, // #2 = $val
/*  8610*/   OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->8720
/*  8613*/    OPC_Scope, 20, /*->8635*/ // 5 children in Scope
/*  8615*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_and_32
/*  8617*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8619*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8622*/     OPC_EmitMergeInputChains1_0,
/*  8623*/     OPC_EmitInteger32, 0, 
/*  8625*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8635*/    /*Scope*/ 20, /*->8656*/
/*  8636*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_and_8
/*  8638*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8640*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8643*/     OPC_EmitMergeInputChains1_0,
/*  8644*/     OPC_EmitInteger32, 0, 
/*  8646*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8656*/    /*Scope*/ 20, /*->8677*/
/*  8657*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_and_16
/*  8659*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8661*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8664*/     OPC_EmitMergeInputChains1_0,
/*  8665*/     OPC_EmitInteger32, 0, 
/*  8667*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8677*/    /*Scope*/ 20, /*->8698*/
/*  8678*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_and_8
/*  8680*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8682*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8685*/     OPC_EmitMergeInputChains1_0,
/*  8686*/     OPC_EmitInteger32, 0, 
/*  8688*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8698*/    /*Scope*/ 20, /*->8719*/
/*  8699*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_and_16
/*  8701*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8703*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8706*/     OPC_EmitMergeInputChains1_0,
/*  8707*/     OPC_EmitInteger32, 0, 
/*  8709*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8719*/    0, /*End of Scope*/
/*  8720*/   /*SwitchType*/ 20, MVT::i64,// ->8742
/*  8722*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_and_64
/*  8724*/    OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8726*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8729*/    OPC_EmitMergeInputChains1_0,
/*  8730*/    OPC_EmitInteger32, 0, 
/*  8732*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_and:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8742*/   0, // EndSwitchType
/*  8743*/  0, /*End of Scope*/
/*  8744*/ /*SwitchOpcode*/ 23|128,2/*279*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->9027
/*  8748*/  OPC_RecordMemRef,
/*  8749*/  OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  8750*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8751*/  OPC_Scope, 7|128,1/*135*/, /*->8889*/ // 2 children in Scope
/*  8754*/   OPC_CheckChild1TypeI32,
/*  8755*/   OPC_RecordChild2, // #2 = $val
/*  8756*/   OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->8866
/*  8759*/    OPC_Scope, 20, /*->8781*/ // 5 children in Scope
/*  8761*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_or_32
/*  8763*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8765*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8768*/     OPC_EmitMergeInputChains1_0,
/*  8769*/     OPC_EmitInteger32, 0, 
/*  8771*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8781*/    /*Scope*/ 20, /*->8802*/
/*  8782*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_or_8
/*  8784*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8786*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8789*/     OPC_EmitMergeInputChains1_0,
/*  8790*/     OPC_EmitInteger32, 0, 
/*  8792*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8802*/    /*Scope*/ 20, /*->8823*/
/*  8803*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_or_16
/*  8805*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8807*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8810*/     OPC_EmitMergeInputChains1_0,
/*  8811*/     OPC_EmitInteger32, 0, 
/*  8813*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8823*/    /*Scope*/ 20, /*->8844*/
/*  8824*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_or_8
/*  8826*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8828*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8831*/     OPC_EmitMergeInputChains1_0,
/*  8832*/     OPC_EmitInteger32, 0, 
/*  8834*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8844*/    /*Scope*/ 20, /*->8865*/
/*  8845*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_or_16
/*  8847*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8849*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8852*/     OPC_EmitMergeInputChains1_0,
/*  8853*/     OPC_EmitInteger32, 0, 
/*  8855*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8865*/    0, /*End of Scope*/
/*  8866*/   /*SwitchType*/ 20, MVT::i64,// ->8888
/*  8868*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_or_64
/*  8870*/    OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8872*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8875*/    OPC_EmitMergeInputChains1_0,
/*  8876*/    OPC_EmitInteger32, 0, 
/*  8878*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_or:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8888*/   0, // EndSwitchType
/*  8889*/  /*Scope*/ 7|128,1/*135*/, /*->9026*/
/*  8891*/   OPC_CheckChild1TypeI64,
/*  8892*/   OPC_RecordChild2, // #2 = $val
/*  8893*/   OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->9003
/*  8896*/    OPC_Scope, 20, /*->8918*/ // 5 children in Scope
/*  8898*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_or_32
/*  8900*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8902*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8905*/     OPC_EmitMergeInputChains1_0,
/*  8906*/     OPC_EmitInteger32, 0, 
/*  8908*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8918*/    /*Scope*/ 20, /*->8939*/
/*  8919*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_or_8
/*  8921*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8923*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8926*/     OPC_EmitMergeInputChains1_0,
/*  8927*/     OPC_EmitInteger32, 0, 
/*  8929*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8939*/    /*Scope*/ 20, /*->8960*/
/*  8940*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_or_16
/*  8942*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8944*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8947*/     OPC_EmitMergeInputChains1_0,
/*  8948*/     OPC_EmitInteger32, 0, 
/*  8950*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8960*/    /*Scope*/ 20, /*->8981*/
/*  8961*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_or_8
/*  8963*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8965*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8968*/     OPC_EmitMergeInputChains1_0,
/*  8969*/     OPC_EmitInteger32, 0, 
/*  8971*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8981*/    /*Scope*/ 20, /*->9002*/
/*  8982*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_or_16
/*  8984*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8986*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8989*/     OPC_EmitMergeInputChains1_0,
/*  8990*/     OPC_EmitInteger32, 0, 
/*  8992*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9002*/    0, /*End of Scope*/
/*  9003*/   /*SwitchType*/ 20, MVT::i64,// ->9025
/*  9005*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_or_64
/*  9007*/    OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9009*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9012*/    OPC_EmitMergeInputChains1_0,
/*  9013*/    OPC_EmitInteger32, 0, 
/*  9015*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_or:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  9025*/   0, // EndSwitchType
/*  9026*/  0, /*End of Scope*/
/*  9027*/ /*SwitchOpcode*/ 23|128,2/*279*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->9310
/*  9031*/  OPC_RecordMemRef,
/*  9032*/  OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  9033*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  9034*/  OPC_Scope, 7|128,1/*135*/, /*->9172*/ // 2 children in Scope
/*  9037*/   OPC_CheckChild1TypeI32,
/*  9038*/   OPC_RecordChild2, // #2 = $val
/*  9039*/   OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->9149
/*  9042*/    OPC_Scope, 20, /*->9064*/ // 5 children in Scope
/*  9044*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_32
/*  9046*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9048*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9051*/     OPC_EmitMergeInputChains1_0,
/*  9052*/     OPC_EmitInteger32, 0, 
/*  9054*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9064*/    /*Scope*/ 20, /*->9085*/
/*  9065*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_xor_8
/*  9067*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9069*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9072*/     OPC_EmitMergeInputChains1_0,
/*  9073*/     OPC_EmitInteger32, 0, 
/*  9075*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9085*/    /*Scope*/ 20, /*->9106*/
/*  9086*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_16
/*  9088*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9090*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9093*/     OPC_EmitMergeInputChains1_0,
/*  9094*/     OPC_EmitInteger32, 0, 
/*  9096*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9106*/    /*Scope*/ 20, /*->9127*/
/*  9107*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_xor_8
/*  9109*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9111*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9114*/     OPC_EmitMergeInputChains1_0,
/*  9115*/     OPC_EmitInteger32, 0, 
/*  9117*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9127*/    /*Scope*/ 20, /*->9148*/
/*  9128*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_16
/*  9130*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9132*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9135*/     OPC_EmitMergeInputChains1_0,
/*  9136*/     OPC_EmitInteger32, 0, 
/*  9138*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9148*/    0, /*End of Scope*/
/*  9149*/   /*SwitchType*/ 20, MVT::i64,// ->9171
/*  9151*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_xor_64
/*  9153*/    OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9155*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9158*/    OPC_EmitMergeInputChains1_0,
/*  9159*/    OPC_EmitInteger32, 0, 
/*  9161*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_xor:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  9171*/   0, // EndSwitchType
/*  9172*/  /*Scope*/ 7|128,1/*135*/, /*->9309*/
/*  9174*/   OPC_CheckChild1TypeI64,
/*  9175*/   OPC_RecordChild2, // #2 = $val
/*  9176*/   OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->9286
/*  9179*/    OPC_Scope, 20, /*->9201*/ // 5 children in Scope
/*  9181*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_32
/*  9183*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9185*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9188*/     OPC_EmitMergeInputChains1_0,
/*  9189*/     OPC_EmitInteger32, 0, 
/*  9191*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9201*/    /*Scope*/ 20, /*->9222*/
/*  9202*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_xor_8
/*  9204*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9206*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9209*/     OPC_EmitMergeInputChains1_0,
/*  9210*/     OPC_EmitInteger32, 0, 
/*  9212*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9222*/    /*Scope*/ 20, /*->9243*/
/*  9223*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_16
/*  9225*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9227*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9230*/     OPC_EmitMergeInputChains1_0,
/*  9231*/     OPC_EmitInteger32, 0, 
/*  9233*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9243*/    /*Scope*/ 20, /*->9264*/
/*  9244*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_xor_8
/*  9246*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9248*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9251*/     OPC_EmitMergeInputChains1_0,
/*  9252*/     OPC_EmitInteger32, 0, 
/*  9254*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9264*/    /*Scope*/ 20, /*->9285*/
/*  9265*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_16
/*  9267*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9269*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9272*/     OPC_EmitMergeInputChains1_0,
/*  9273*/     OPC_EmitInteger32, 0, 
/*  9275*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9285*/    0, /*End of Scope*/
/*  9286*/   /*SwitchType*/ 20, MVT::i64,// ->9308
/*  9288*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_xor_64
/*  9290*/    OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9292*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9295*/    OPC_EmitMergeInputChains1_0,
/*  9296*/    OPC_EmitInteger32, 0, 
/*  9298*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_xor:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  9308*/   0, // EndSwitchType
/*  9309*/  0, /*End of Scope*/
/*  9310*/ /*SwitchOpcode*/ 23|128,2/*279*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->9593
/*  9314*/  OPC_RecordMemRef,
/*  9315*/  OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  9316*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  9317*/  OPC_Scope, 7|128,1/*135*/, /*->9455*/ // 2 children in Scope
/*  9320*/   OPC_CheckChild1TypeI32,
/*  9321*/   OPC_RecordChild2, // #2 = $val
/*  9322*/   OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->9432
/*  9325*/    OPC_Scope, 20, /*->9347*/ // 5 children in Scope
/*  9327*/     OPC_CheckPredicate, 2, // Predicate_atomic_swap_32
/*  9329*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9331*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9334*/     OPC_EmitMergeInputChains1_0,
/*  9335*/     OPC_EmitInteger32, 0, 
/*  9337*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9347*/    /*Scope*/ 20, /*->9368*/
/*  9348*/     OPC_CheckPredicate, 0, // Predicate_atomic_swap_8
/*  9350*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9352*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9355*/     OPC_EmitMergeInputChains1_0,
/*  9356*/     OPC_EmitInteger32, 0, 
/*  9358*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9368*/    /*Scope*/ 20, /*->9389*/
/*  9369*/     OPC_CheckPredicate, 1, // Predicate_atomic_swap_16
/*  9371*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9373*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9376*/     OPC_EmitMergeInputChains1_0,
/*  9377*/     OPC_EmitInteger32, 0, 
/*  9379*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9389*/    /*Scope*/ 20, /*->9410*/
/*  9390*/     OPC_CheckPredicate, 0, // Predicate_atomic_swap_8
/*  9392*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9394*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9397*/     OPC_EmitMergeInputChains1_0,
/*  9398*/     OPC_EmitInteger32, 0, 
/*  9400*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9410*/    /*Scope*/ 20, /*->9431*/
/*  9411*/     OPC_CheckPredicate, 1, // Predicate_atomic_swap_16
/*  9413*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9415*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9418*/     OPC_EmitMergeInputChains1_0,
/*  9419*/     OPC_EmitInteger32, 0, 
/*  9421*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9431*/    0, /*End of Scope*/
/*  9432*/   /*SwitchType*/ 20, MVT::i64,// ->9454
/*  9434*/    OPC_CheckPredicate, 13, // Predicate_atomic_swap_64
/*  9436*/    OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9438*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9441*/    OPC_EmitMergeInputChains1_0,
/*  9442*/    OPC_EmitInteger32, 0, 
/*  9444*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_swap:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  9454*/   0, // EndSwitchType
/*  9455*/  /*Scope*/ 7|128,1/*135*/, /*->9592*/
/*  9457*/   OPC_CheckChild1TypeI64,
/*  9458*/   OPC_RecordChild2, // #2 = $val
/*  9459*/   OPC_SwitchType /*2 cases */, 107, MVT::i32,// ->9569
/*  9462*/    OPC_Scope, 20, /*->9484*/ // 5 children in Scope
/*  9464*/     OPC_CheckPredicate, 2, // Predicate_atomic_swap_32
/*  9466*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9468*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9471*/     OPC_EmitMergeInputChains1_0,
/*  9472*/     OPC_EmitInteger32, 0, 
/*  9474*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9484*/    /*Scope*/ 20, /*->9505*/
/*  9485*/     OPC_CheckPredicate, 0, // Predicate_atomic_swap_8
/*  9487*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9489*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9492*/     OPC_EmitMergeInputChains1_0,
/*  9493*/     OPC_EmitInteger32, 0, 
/*  9495*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9505*/    /*Scope*/ 20, /*->9526*/
/*  9506*/     OPC_CheckPredicate, 1, // Predicate_atomic_swap_16
/*  9508*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9510*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9513*/     OPC_EmitMergeInputChains1_0,
/*  9514*/     OPC_EmitInteger32, 0, 
/*  9516*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9526*/    /*Scope*/ 20, /*->9547*/
/*  9527*/     OPC_CheckPredicate, 0, // Predicate_atomic_swap_8
/*  9529*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9531*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9534*/     OPC_EmitMergeInputChains1_0,
/*  9535*/     OPC_EmitInteger32, 0, 
/*  9537*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9547*/    /*Scope*/ 20, /*->9568*/
/*  9548*/     OPC_CheckPredicate, 1, // Predicate_atomic_swap_16
/*  9550*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9552*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9555*/     OPC_EmitMergeInputChains1_0,
/*  9556*/     OPC_EmitInteger32, 0, 
/*  9558*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9568*/    0, /*End of Scope*/
/*  9569*/   /*SwitchType*/ 20, MVT::i64,// ->9591
/*  9571*/    OPC_CheckPredicate, 13, // Predicate_atomic_swap_64
/*  9573*/    OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9575*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9578*/    OPC_EmitMergeInputChains1_0,
/*  9579*/    OPC_EmitInteger32, 0, 
/*  9581*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_swap:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  9591*/   0, // EndSwitchType
/*  9592*/  0, /*End of Scope*/
/*  9593*/ /*SwitchOpcode*/ 37|128,2/*293*/, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->9890
/*  9597*/  OPC_RecordMemRef,
/*  9598*/  OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  9599*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  9600*/  OPC_Scope, 14|128,1/*142*/, /*->9745*/ // 2 children in Scope
/*  9603*/   OPC_CheckChild1TypeI32,
/*  9604*/   OPC_RecordChild2, // #2 = $exp
/*  9605*/   OPC_RecordChild3, // #3 = $new
/*  9606*/   OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->9721
/*  9609*/    OPC_Scope, 21, /*->9632*/ // 5 children in Scope
/*  9611*/     OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_32
/*  9613*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9615*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9618*/     OPC_EmitMergeInputChains1_0,
/*  9619*/     OPC_EmitInteger32, 0, 
/*  9621*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9632*/    /*Scope*/ 21, /*->9654*/
/*  9633*/     OPC_CheckPredicate, 0, // Predicate_atomic_cmp_swap_8
/*  9635*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9637*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9640*/     OPC_EmitMergeInputChains1_0,
/*  9641*/     OPC_EmitInteger32, 0, 
/*  9643*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9654*/    /*Scope*/ 21, /*->9676*/
/*  9655*/     OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_16
/*  9657*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9659*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9662*/     OPC_EmitMergeInputChains1_0,
/*  9663*/     OPC_EmitInteger32, 0, 
/*  9665*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9676*/    /*Scope*/ 21, /*->9698*/
/*  9677*/     OPC_CheckPredicate, 0, // Predicate_atomic_cmp_swap_8
/*  9679*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9681*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9684*/     OPC_EmitMergeInputChains1_0,
/*  9685*/     OPC_EmitInteger32, 0, 
/*  9687*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9698*/    /*Scope*/ 21, /*->9720*/
/*  9699*/     OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_16
/*  9701*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9703*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9706*/     OPC_EmitMergeInputChains1_0,
/*  9707*/     OPC_EmitInteger32, 0, 
/*  9709*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9720*/    0, /*End of Scope*/
/*  9721*/   /*SwitchType*/ 21, MVT::i64,// ->9744
/*  9723*/    OPC_CheckPredicate, 13, // Predicate_atomic_cmp_swap_64
/*  9725*/    OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9727*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9730*/    OPC_EmitMergeInputChains1_0,
/*  9731*/    OPC_EmitInteger32, 0, 
/*  9733*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
              // Src: (atomic_cmp_swap:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  9744*/   0, // EndSwitchType
/*  9745*/  /*Scope*/ 14|128,1/*142*/, /*->9889*/
/*  9747*/   OPC_CheckChild1TypeI64,
/*  9748*/   OPC_RecordChild2, // #2 = $exp
/*  9749*/   OPC_RecordChild3, // #3 = $new
/*  9750*/   OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->9865
/*  9753*/    OPC_Scope, 21, /*->9776*/ // 5 children in Scope
/*  9755*/     OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_32
/*  9757*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9759*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9762*/     OPC_EmitMergeInputChains1_0,
/*  9763*/     OPC_EmitInteger32, 0, 
/*  9765*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9776*/    /*Scope*/ 21, /*->9798*/
/*  9777*/     OPC_CheckPredicate, 0, // Predicate_atomic_cmp_swap_8
/*  9779*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9781*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9784*/     OPC_EmitMergeInputChains1_0,
/*  9785*/     OPC_EmitInteger32, 0, 
/*  9787*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9798*/    /*Scope*/ 21, /*->9820*/
/*  9799*/     OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_16
/*  9801*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9803*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9806*/     OPC_EmitMergeInputChains1_0,
/*  9807*/     OPC_EmitInteger32, 0, 
/*  9809*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9820*/    /*Scope*/ 21, /*->9842*/
/*  9821*/     OPC_CheckPredicate, 0, // Predicate_atomic_cmp_swap_8
/*  9823*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9825*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9828*/     OPC_EmitMergeInputChains1_0,
/*  9829*/     OPC_EmitInteger32, 0, 
/*  9831*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9842*/    /*Scope*/ 21, /*->9864*/
/*  9843*/     OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_16
/*  9845*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9847*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9850*/     OPC_EmitMergeInputChains1_0,
/*  9851*/     OPC_EmitInteger32, 0, 
/*  9853*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9864*/    0, /*End of Scope*/
/*  9865*/   /*SwitchType*/ 21, MVT::i64,// ->9888
/*  9867*/    OPC_CheckPredicate, 13, // Predicate_atomic_cmp_swap_64
/*  9869*/    OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9871*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9874*/    OPC_EmitMergeInputChains1_0,
/*  9875*/    OPC_EmitInteger32, 0, 
/*  9877*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
              // Src: (atomic_cmp_swap:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  9888*/   0, // EndSwitchType
/*  9889*/  0, /*End of Scope*/
/*  9890*/ /*SwitchOpcode*/ 89, TARGET_VAL(ISD::BRCOND),// ->9982
/*  9893*/  OPC_RecordNode, // #0 = 'brcond' chained node
/*  9894*/  OPC_Scope, 69, /*->9965*/ // 2 children in Scope
/*  9896*/   OPC_MoveChild1,
/*  9897*/   OPC_SwitchOpcode /*2 cases */, 21, TARGET_VAL(ISD::XOR),// ->9922
/*  9901*/    OPC_RecordChild0, // #1 = $cond
/*  9902*/    OPC_MoveChild0,
/*  9903*/    OPC_CheckPredicate, 22, // Predicate_bool_node
/*  9905*/    OPC_MoveParent,
/*  9906*/    OPC_CheckChild1Integer, 2, 
/*  9908*/    OPC_CheckTypeI32,
/*  9909*/    OPC_MoveSibling2,
/*  9910*/    OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9913*/    OPC_RecordNode, // #2 = $dst
/*  9914*/    OPC_MoveParent,
/*  9915*/    OPC_EmitMergeInputChains1_0,
/*  9916*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_UNLESS),
                  2/*#Ops*/, 2, 1, 
              // Src: (brcond (xor:{ *:[i32] } I32:{ *:[i32] }<<P:Predicate_bool_node>>:$cond, 1:{ *:[i32] }), (bb:{ *:[Other] }):$dst) - Complexity = 12
              // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9922*/   /*SwitchOpcode*/ 39, TARGET_VAL(ISD::SETCC),// ->9964
/*  9925*/    OPC_RecordChild0, // #1 = $cond
/*  9926*/    OPC_CheckChild0TypeI32,
/*  9927*/    OPC_CheckChild1Integer, 0, 
/*  9929*/    OPC_CheckTypeI32,
/*  9930*/    OPC_Scope, 15, /*->9947*/ // 2 children in Scope
/*  9932*/     OPC_CheckChild2CondCode, ISD::SETNE,
/*  9934*/     OPC_MoveSibling2,
/*  9935*/     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9938*/     OPC_RecordNode, // #2 = $dst
/*  9939*/     OPC_MoveParent,
/*  9940*/     OPC_EmitMergeInputChains1_0,
/*  9941*/     OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_IF),
                   2/*#Ops*/, 2, 1, 
               // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
               // Dst: (BR_IF bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9947*/    /*Scope*/ 15, /*->9963*/
/*  9948*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9950*/     OPC_MoveSibling2,
/*  9951*/     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9954*/     OPC_RecordNode, // #2 = $dst
/*  9955*/     OPC_MoveParent,
/*  9956*/     OPC_EmitMergeInputChains1_0,
/*  9957*/     OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_UNLESS),
                   2/*#Ops*/, 2, 1, 
               // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
               // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9963*/    0, /*End of Scope*/
/*  9964*/   0, // EndSwitchOpcode
/*  9965*/  /*Scope*/ 15, /*->9981*/
/*  9966*/   OPC_RecordChild1, // #1 = $cond
/*  9967*/   OPC_CheckChild1TypeI32,
/*  9968*/   OPC_RecordChild2, // #2 = $dst
/*  9969*/   OPC_MoveChild2,
/*  9970*/   OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9973*/   OPC_MoveParent,
/*  9974*/   OPC_EmitMergeInputChains1_0,
/*  9975*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_IF),
                 2/*#Ops*/, 2, 1, 
             // Src: (brcond I32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst) - Complexity = 3
             // Dst: (BR_IF (bb:{ *:[Other] }):$dst, I32:{ *:[i32] }:$cond)
/*  9981*/  0, /*End of Scope*/
/*  9982*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SHL),// ->10044
/*  9985*/  OPC_RecordChild0, // #0 = $lhs
/*  9986*/  OPC_Scope, 31, /*->10019*/ // 2 children in Scope
/*  9988*/   OPC_MoveChild1,
/*  9989*/   OPC_SwitchType /*2 cases */, 12, MVT::i32,// ->10004
/*  9992*/    OPC_CheckAndImm, 31, 
/*  9994*/    OPC_RecordChild0, // #1 = $rhs
/*  9995*/    OPC_MoveParent,
/*  9996*/    OPC_CheckTypeI32,
/*  9997*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10004*/   /*SwitchType*/ 12, MVT::i64,// ->10018
/* 10006*/    OPC_CheckAndImm, 63, 
/* 10008*/    OPC_RecordChild0, // #1 = $rhs
/* 10009*/    OPC_MoveParent,
/* 10010*/    OPC_CheckTypeI64,
/* 10011*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10018*/   0, // EndSwitchType
/* 10019*/  /*Scope*/ 23, /*->10043*/
/* 10020*/   OPC_RecordChild1, // #1 = $rhs
/* 10021*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->10032
/* 10024*/    OPC_CheckChild1TypeI32,
/* 10025*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10032*/   /*SwitchType*/ 8, MVT::i64,// ->10042
/* 10034*/    OPC_CheckChild1TypeI64,
/* 10035*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10042*/   0, // EndSwitchType
/* 10043*/  0, /*End of Scope*/
/* 10044*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SRA),// ->10106
/* 10047*/  OPC_RecordChild0, // #0 = $lhs
/* 10048*/  OPC_Scope, 31, /*->10081*/ // 2 children in Scope
/* 10050*/   OPC_MoveChild1,
/* 10051*/   OPC_SwitchType /*2 cases */, 12, MVT::i32,// ->10066
/* 10054*/    OPC_CheckAndImm, 31, 
/* 10056*/    OPC_RecordChild0, // #1 = $rhs
/* 10057*/    OPC_MoveParent,
/* 10058*/    OPC_CheckTypeI32,
/* 10059*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10066*/   /*SwitchType*/ 12, MVT::i64,// ->10080
/* 10068*/    OPC_CheckAndImm, 63, 
/* 10070*/    OPC_RecordChild0, // #1 = $rhs
/* 10071*/    OPC_MoveParent,
/* 10072*/    OPC_CheckTypeI64,
/* 10073*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10080*/   0, // EndSwitchType
/* 10081*/  /*Scope*/ 23, /*->10105*/
/* 10082*/   OPC_RecordChild1, // #1 = $rhs
/* 10083*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->10094
/* 10086*/    OPC_CheckChild1TypeI32,
/* 10087*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10094*/   /*SwitchType*/ 8, MVT::i64,// ->10104
/* 10096*/    OPC_CheckChild1TypeI64,
/* 10097*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10104*/   0, // EndSwitchType
/* 10105*/  0, /*End of Scope*/
/* 10106*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SRL),// ->10168
/* 10109*/  OPC_RecordChild0, // #0 = $lhs
/* 10110*/  OPC_Scope, 31, /*->10143*/ // 2 children in Scope
/* 10112*/   OPC_MoveChild1,
/* 10113*/   OPC_SwitchType /*2 cases */, 12, MVT::i32,// ->10128
/* 10116*/    OPC_CheckAndImm, 31, 
/* 10118*/    OPC_RecordChild0, // #1 = $rhs
/* 10119*/    OPC_MoveParent,
/* 10120*/    OPC_CheckTypeI32,
/* 10121*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10128*/   /*SwitchType*/ 12, MVT::i64,// ->10142
/* 10130*/    OPC_CheckAndImm, 63, 
/* 10132*/    OPC_RecordChild0, // #1 = $rhs
/* 10133*/    OPC_MoveParent,
/* 10134*/    OPC_CheckTypeI64,
/* 10135*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10142*/   0, // EndSwitchType
/* 10143*/  /*Scope*/ 23, /*->10167*/
/* 10144*/   OPC_RecordChild1, // #1 = $rhs
/* 10145*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->10156
/* 10148*/    OPC_CheckChild1TypeI32,
/* 10149*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10156*/   /*SwitchType*/ 8, MVT::i64,// ->10166
/* 10158*/    OPC_CheckChild1TypeI64,
/* 10159*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10166*/   0, // EndSwitchType
/* 10167*/  0, /*End of Scope*/
/* 10168*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::ROTL),// ->10230
/* 10171*/  OPC_RecordChild0, // #0 = $lhs
/* 10172*/  OPC_Scope, 31, /*->10205*/ // 2 children in Scope
/* 10174*/   OPC_MoveChild1,
/* 10175*/   OPC_SwitchType /*2 cases */, 12, MVT::i32,// ->10190
/* 10178*/    OPC_CheckAndImm, 31, 
/* 10180*/    OPC_RecordChild0, // #1 = $rhs
/* 10181*/    OPC_MoveParent,
/* 10182*/    OPC_CheckTypeI32,
/* 10183*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10190*/   /*SwitchType*/ 12, MVT::i64,// ->10204
/* 10192*/    OPC_CheckAndImm, 63, 
/* 10194*/    OPC_RecordChild0, // #1 = $rhs
/* 10195*/    OPC_MoveParent,
/* 10196*/    OPC_CheckTypeI64,
/* 10197*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10204*/   0, // EndSwitchType
/* 10205*/  /*Scope*/ 23, /*->10229*/
/* 10206*/   OPC_RecordChild1, // #1 = $rhs
/* 10207*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->10218
/* 10210*/    OPC_CheckChild1TypeI32,
/* 10211*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10218*/   /*SwitchType*/ 8, MVT::i64,// ->10228
/* 10220*/    OPC_CheckChild1TypeI64,
/* 10221*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10228*/   0, // EndSwitchType
/* 10229*/  0, /*End of Scope*/
/* 10230*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::ROTR),// ->10292
/* 10233*/  OPC_RecordChild0, // #0 = $lhs
/* 10234*/  OPC_Scope, 31, /*->10267*/ // 2 children in Scope
/* 10236*/   OPC_MoveChild1,
/* 10237*/   OPC_SwitchType /*2 cases */, 12, MVT::i32,// ->10252
/* 10240*/    OPC_CheckAndImm, 31, 
/* 10242*/    OPC_RecordChild0, // #1 = $rhs
/* 10243*/    OPC_MoveParent,
/* 10244*/    OPC_CheckTypeI32,
/* 10245*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10252*/   /*SwitchType*/ 12, MVT::i64,// ->10266
/* 10254*/    OPC_CheckAndImm, 63, 
/* 10256*/    OPC_RecordChild0, // #1 = $rhs
/* 10257*/    OPC_MoveParent,
/* 10258*/    OPC_CheckTypeI64,
/* 10259*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10266*/   0, // EndSwitchType
/* 10267*/  /*Scope*/ 23, /*->10291*/
/* 10268*/   OPC_RecordChild1, // #1 = $rhs
/* 10269*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->10280
/* 10272*/    OPC_CheckChild1TypeI32,
/* 10273*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10280*/   /*SwitchType*/ 8, MVT::i64,// ->10290
/* 10282*/    OPC_CheckChild1TypeI64,
/* 10283*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10290*/   0, // EndSwitchType
/* 10291*/  0, /*End of Scope*/
/* 10292*/ /*SwitchOpcode*/ 122|128,3/*506*/, TARGET_VAL(ISD::SELECT),// ->10802
/* 10296*/  OPC_Scope, 107, /*->10405*/ // 8 children in Scope
/* 10298*/   OPC_MoveChild0,
/* 10299*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 10302*/   OPC_RecordChild0, // #0 = $cond
/* 10303*/   OPC_CheckChild0TypeI32,
/* 10304*/   OPC_CheckChild1Integer, 0, 
/* 10306*/   OPC_CheckTypeI32,
/* 10307*/   OPC_Scope, 47, /*->10356*/ // 2 children in Scope
/* 10309*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 10311*/    OPC_MoveParent,
/* 10312*/    OPC_RecordChild1, // #1 = $lhs
/* 10313*/    OPC_RecordChild2, // #2 = $rhs
/* 10314*/    OPC_SwitchType /*4 cases */, 8, MVT::i32,// ->10325
/* 10317*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                   MVT::i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10325*/    /*SwitchType*/ 8, MVT::i64,// ->10335
/* 10327*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                   MVT::i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10335*/    /*SwitchType*/ 8, MVT::funcref,// ->10345
/* 10337*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                   MVT::funcref, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[funcref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10345*/    /*SwitchType*/ 8, MVT::externref,// ->10355
/* 10347*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                   MVT::externref, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[externref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10355*/    0, // EndSwitchType
/* 10356*/   /*Scope*/ 47, /*->10404*/
/* 10357*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 10359*/    OPC_MoveParent,
/* 10360*/    OPC_RecordChild1, // #1 = $lhs
/* 10361*/    OPC_RecordChild2, // #2 = $rhs
/* 10362*/    OPC_SwitchType /*4 cases */, 8, MVT::i32,// ->10373
/* 10365*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                   MVT::i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$cond)
/* 10373*/    /*SwitchType*/ 8, MVT::i64,// ->10383
/* 10375*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                   MVT::i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$rhs, I64:{ *:[i64] }:$lhs, I32:{ *:[i32] }:$cond)
/* 10383*/    /*SwitchType*/ 8, MVT::funcref,// ->10393
/* 10385*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                   MVT::funcref, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[funcref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$rhs, FUNCREF:{ *:[funcref] }:$lhs, I32:{ *:[i32] }:$cond)
/* 10393*/    /*SwitchType*/ 8, MVT::externref,// ->10403
/* 10395*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                   MVT::externref, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[externref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$rhs, EXTERNREF:{ *:[externref] }:$lhs, I32:{ *:[i32] }:$cond)
/* 10403*/    0, // EndSwitchType
/* 10404*/   0, /*End of Scope*/
/* 10405*/  /*Scope*/ 50, /*->10456*/
/* 10406*/   OPC_RecordChild0, // #0 = $cond
/* 10407*/   OPC_CheckChild0TypeI32,
/* 10408*/   OPC_RecordChild1, // #1 = $lhs
/* 10409*/   OPC_RecordChild2, // #2 = $rhs
/* 10410*/   OPC_SwitchType /*4 cases */, 8, MVT::i32,// ->10421
/* 10413*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                  MVT::i32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[i32] } I32:{ *:[i32] }:$cond, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10421*/   /*SwitchType*/ 8, MVT::i64,// ->10431
/* 10423*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                  MVT::i64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[i64] } I32:{ *:[i32] }:$cond, I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10431*/   /*SwitchType*/ 10, MVT::funcref,// ->10443
/* 10433*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 10435*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                  MVT::funcref, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[funcref] } I32:{ *:[i32] }:$cond, FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10443*/   /*SwitchType*/ 10, MVT::externref,// ->10455
/* 10445*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 10447*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                  MVT::externref, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[externref] } I32:{ *:[i32] }:$cond, EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10455*/   0, // EndSwitchType
/* 10456*/  /*Scope*/ 67, /*->10524*/
/* 10457*/   OPC_MoveChild0,
/* 10458*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 10461*/   OPC_RecordChild0, // #0 = $cond
/* 10462*/   OPC_CheckChild0TypeI32,
/* 10463*/   OPC_CheckChild1Integer, 0, 
/* 10465*/   OPC_CheckTypeI32,
/* 10466*/   OPC_Scope, 27, /*->10495*/ // 2 children in Scope
/* 10468*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 10470*/    OPC_MoveParent,
/* 10471*/    OPC_RecordChild1, // #1 = $lhs
/* 10472*/    OPC_RecordChild2, // #2 = $rhs
/* 10473*/    OPC_SwitchType /*2 cases */, 8, MVT::f32,// ->10484
/* 10476*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                   MVT::f32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10484*/    /*SwitchType*/ 8, MVT::f64,// ->10494
/* 10486*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                   MVT::f64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10494*/    0, // EndSwitchType
/* 10495*/   /*Scope*/ 27, /*->10523*/
/* 10496*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 10498*/    OPC_MoveParent,
/* 10499*/    OPC_RecordChild1, // #1 = $lhs
/* 10500*/    OPC_RecordChild2, // #2 = $rhs
/* 10501*/    OPC_SwitchType /*2 cases */, 8, MVT::f32,// ->10512
/* 10504*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                   MVT::f32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$rhs, F32:{ *:[f32] }:$lhs, I32:{ *:[i32] }:$cond)
/* 10512*/    /*SwitchType*/ 8, MVT::f64,// ->10522
/* 10514*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                   MVT::f64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$rhs, F64:{ *:[f64] }:$lhs, I32:{ *:[i32] }:$cond)
/* 10522*/    0, // EndSwitchType
/* 10523*/   0, /*End of Scope*/
/* 10524*/  /*Scope*/ 26, /*->10551*/
/* 10525*/   OPC_RecordChild0, // #0 = $cond
/* 10526*/   OPC_CheckChild0TypeI32,
/* 10527*/   OPC_RecordChild1, // #1 = $lhs
/* 10528*/   OPC_RecordChild2, // #2 = $rhs
/* 10529*/   OPC_SwitchType /*2 cases */, 8, MVT::f32,// ->10540
/* 10532*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                  MVT::f32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[f32] } I32:{ *:[i32] }:$cond, F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10540*/   /*SwitchType*/ 8, MVT::f64,// ->10550
/* 10542*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                  MVT::f64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[f64] } I32:{ *:[i32] }:$cond, F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10550*/   0, // EndSwitchType
/* 10551*/  /*Scope*/ 107, /*->10659*/
/* 10552*/   OPC_MoveChild0,
/* 10553*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 10556*/   OPC_RecordChild0, // #0 = $cond
/* 10557*/   OPC_CheckChild0TypeI32,
/* 10558*/   OPC_CheckChild1Integer, 0, 
/* 10560*/   OPC_CheckTypeI32,
/* 10561*/   OPC_Scope, 47, /*->10610*/ // 2 children in Scope
/* 10563*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 10565*/    OPC_MoveParent,
/* 10566*/    OPC_RecordChild1, // #1 = $lhs
/* 10567*/    OPC_RecordChild2, // #2 = $rhs
/* 10568*/    OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->10579
/* 10571*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v16i8] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10579*/    /*SwitchType*/ 8, MVT::v8i16,// ->10589
/* 10581*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v8i16] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10589*/    /*SwitchType*/ 8, MVT::v4i32,// ->10599
/* 10591*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v4i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10599*/    /*SwitchType*/ 8, MVT::v2i64,// ->10609
/* 10601*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v2i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10609*/    0, // EndSwitchType
/* 10610*/   /*Scope*/ 47, /*->10658*/
/* 10611*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 10613*/    OPC_MoveParent,
/* 10614*/    OPC_RecordChild1, // #1 = $lhs
/* 10615*/    OPC_RecordChild2, // #2 = $rhs
/* 10616*/    OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->10627
/* 10619*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v16i8] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$rhs, ?:{ *:[v16i8] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10627*/    /*SwitchType*/ 8, MVT::v8i16,// ->10637
/* 10629*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v8i16] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$rhs, ?:{ *:[v8i16] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10637*/    /*SwitchType*/ 8, MVT::v4i32,// ->10647
/* 10639*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v4i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$rhs, ?:{ *:[v4i32] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10647*/    /*SwitchType*/ 8, MVT::v2i64,// ->10657
/* 10649*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v2i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$rhs, ?:{ *:[v2i64] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10657*/    0, // EndSwitchType
/* 10658*/   0, /*End of Scope*/
/* 10659*/  /*Scope*/ 46, /*->10706*/
/* 10660*/   OPC_RecordChild0, // #0 = $cond
/* 10661*/   OPC_CheckChild0TypeI32,
/* 10662*/   OPC_RecordChild1, // #1 = $lhs
/* 10663*/   OPC_RecordChild2, // #2 = $rhs
/* 10664*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->10675
/* 10667*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v16i8] } I32:{ *:[i32] }:$cond, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10675*/   /*SwitchType*/ 8, MVT::v8i16,// ->10685
/* 10677*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v8i16] } I32:{ *:[i32] }:$cond, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10685*/   /*SwitchType*/ 8, MVT::v4i32,// ->10695
/* 10687*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v4i32] } I32:{ *:[i32] }:$cond, V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10695*/   /*SwitchType*/ 8, MVT::v2i64,// ->10705
/* 10697*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v2i64] } I32:{ *:[i32] }:$cond, V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10705*/   0, // EndSwitchType
/* 10706*/  /*Scope*/ 67, /*->10774*/
/* 10707*/   OPC_MoveChild0,
/* 10708*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 10711*/   OPC_RecordChild0, // #0 = $cond
/* 10712*/   OPC_CheckChild0TypeI32,
/* 10713*/   OPC_CheckChild1Integer, 0, 
/* 10715*/   OPC_CheckTypeI32,
/* 10716*/   OPC_Scope, 27, /*->10745*/ // 2 children in Scope
/* 10718*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 10720*/    OPC_MoveParent,
/* 10721*/    OPC_RecordChild1, // #1 = $lhs
/* 10722*/    OPC_RecordChild2, // #2 = $rhs
/* 10723*/    OPC_SwitchType /*2 cases */, 8, MVT::v4f32,// ->10734
/* 10726*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v4f32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v4f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10734*/    /*SwitchType*/ 8, MVT::v2f64,// ->10744
/* 10736*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v2f64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v2f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10744*/    0, // EndSwitchType
/* 10745*/   /*Scope*/ 27, /*->10773*/
/* 10746*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 10748*/    OPC_MoveParent,
/* 10749*/    OPC_RecordChild1, // #1 = $lhs
/* 10750*/    OPC_RecordChild2, // #2 = $rhs
/* 10751*/    OPC_SwitchType /*2 cases */, 8, MVT::v4f32,// ->10762
/* 10754*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v4f32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v4f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$rhs, ?:{ *:[v4f32] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10762*/    /*SwitchType*/ 8, MVT::v2f64,// ->10772
/* 10764*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   MVT::v2f64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v2f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$rhs, ?:{ *:[v2f64] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10772*/    0, // EndSwitchType
/* 10773*/   0, /*End of Scope*/
/* 10774*/  /*Scope*/ 26, /*->10801*/
/* 10775*/   OPC_RecordChild0, // #0 = $cond
/* 10776*/   OPC_CheckChild0TypeI32,
/* 10777*/   OPC_RecordChild1, // #1 = $lhs
/* 10778*/   OPC_RecordChild2, // #2 = $rhs
/* 10779*/   OPC_SwitchType /*2 cases */, 8, MVT::v4f32,// ->10790
/* 10782*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v4f32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v4f32] } I32:{ *:[i32] }:$cond, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10790*/   /*SwitchType*/ 8, MVT::v2f64,// ->10800
/* 10792*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  MVT::v2f64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v2f64] } I32:{ *:[i32] }:$cond, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10800*/   0, // EndSwitchType
/* 10801*/  0, /*End of Scope*/
/* 10802*/ /*SwitchOpcode*/ 1|128,1/*129*/, TARGET_VAL(ISD::SIGN_EXTEND_INREG),// ->10935
/* 10806*/  OPC_Scope, 57, /*->10865*/ // 2 children in Scope
/* 10808*/   OPC_MoveChild0,
/* 10809*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/* 10812*/   OPC_RecordChild0, // #0 = $vec
/* 10813*/   OPC_Scope, 24, /*->10839*/ // 2 children in Scope
/* 10815*/    OPC_CheckChild0Type, MVT::v16i8,
/* 10817*/    OPC_RecordChild1, // #1 = $idx
/* 10818*/    OPC_MoveChild1,
/* 10819*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10822*/    OPC_CheckPredicate, 3, // Predicate_LaneIdx16
/* 10824*/    OPC_CheckTypeI32,
/* 10825*/    OPC_MoveParent,
/* 10826*/    OPC_MoveSibling1,
/* 10827*/    OPC_CheckValueType, MVT::i8,
/* 10829*/    OPC_MoveParent,
/* 10830*/    OPC_CheckTypeI32,
/* 10831*/    OPC_EmitConvertToTarget1,
/* 10832*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_s),
                  MVT::i32, 2/*#Ops*/, 0, 2, 
              // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), i8:{ *:[Other] }) - Complexity = 10
              // Dst: (EXTRACT_LANE_I8x16_s:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 10839*/   /*Scope*/ 24, /*->10864*/
/* 10840*/    OPC_CheckChild0Type, MVT::v8i16,
/* 10842*/    OPC_RecordChild1, // #1 = $idx
/* 10843*/    OPC_MoveChild1,
/* 10844*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10847*/    OPC_CheckPredicate, 7, // Predicate_LaneIdx8
/* 10849*/    OPC_CheckTypeI32,
/* 10850*/    OPC_MoveParent,
/* 10851*/    OPC_MoveSibling1,
/* 10852*/    OPC_CheckValueType, MVT::i16,
/* 10854*/    OPC_MoveParent,
/* 10855*/    OPC_CheckTypeI32,
/* 10856*/    OPC_EmitConvertToTarget1,
/* 10857*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_s),
                  MVT::i32, 2/*#Ops*/, 0, 2, 
              // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), i16:{ *:[Other] }) - Complexity = 10
              // Dst: (EXTRACT_LANE_I16x8_s:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 10864*/   0, /*End of Scope*/
/* 10865*/  /*Scope*/ 68, /*->10934*/
/* 10866*/   OPC_RecordChild0, // #0 = $src
/* 10867*/   OPC_MoveChild1,
/* 10868*/   OPC_Scope, 25, /*->10895*/ // 3 children in Scope
/* 10870*/    OPC_CheckValueType, MVT::i8,
/* 10872*/    OPC_MoveParent,
/* 10873*/    OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->10884
/* 10876*/     OPC_CheckPatternPredicate, 7, // (Subtarget->hasSignExt())
/* 10878*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_EXTEND8_S_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i8:{ *:[Other] }) - Complexity = 3
               // Dst: (I32_EXTEND8_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 10884*/    /*SwitchType*/ 8, MVT::i64,// ->10894
/* 10886*/     OPC_CheckPatternPredicate, 7, // (Subtarget->hasSignExt())
/* 10888*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND8_S_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i8:{ *:[Other] }) - Complexity = 3
               // Dst: (I64_EXTEND8_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10894*/    0, // EndSwitchType
/* 10895*/   /*Scope*/ 25, /*->10921*/
/* 10896*/    OPC_CheckValueType, MVT::i16,
/* 10898*/    OPC_MoveParent,
/* 10899*/    OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->10910
/* 10902*/     OPC_CheckPatternPredicate, 7, // (Subtarget->hasSignExt())
/* 10904*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_EXTEND16_S_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i16:{ *:[Other] }) - Complexity = 3
               // Dst: (I32_EXTEND16_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 10910*/    /*SwitchType*/ 8, MVT::i64,// ->10920
/* 10912*/     OPC_CheckPatternPredicate, 7, // (Subtarget->hasSignExt())
/* 10914*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND16_S_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i16:{ *:[Other] }) - Complexity = 3
               // Dst: (I64_EXTEND16_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10920*/    0, // EndSwitchType
/* 10921*/   /*Scope*/ 11, /*->10933*/
/* 10922*/    OPC_CheckValueType, MVT::i32,
/* 10924*/    OPC_MoveParent,
/* 10925*/    OPC_CheckPatternPredicate, 7, // (Subtarget->hasSignExt())
/* 10927*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND32_S_I64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_EXTEND32_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10933*/   0, /*End of Scope*/
/* 10934*/  0, /*End of Scope*/
/* 10935*/ /*SwitchOpcode*/ 23|128,1/*151*/, TARGET_VAL(WebAssemblyISD::GLOBAL_GET),// ->11090
/* 10939*/  OPC_RecordMemRef,
/* 10940*/  OPC_RecordNode, // #0 = 'WebAssemblyglobal_get' chained node
/* 10941*/  OPC_MoveChild1,
/* 10942*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10945*/  OPC_RecordChild0, // #1 = $addr
/* 10946*/  OPC_MoveChild0,
/* 10947*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10950*/  OPC_MoveParent,
/* 10951*/  OPC_MoveParent,
/* 10952*/  OPC_SwitchType /*12 cases */, 8, MVT::i32,// ->10963
/* 10955*/   OPC_EmitMergeInputChains1_0,
/* 10956*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[i32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10963*/  /*SwitchType*/ 8, MVT::i64,// ->10973
/* 10965*/   OPC_EmitMergeInputChains1_0,
/* 10966*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[i64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 10973*/  /*SwitchType*/ 10, MVT::funcref,// ->10985
/* 10975*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 10977*/   OPC_EmitMergeInputChains1_0,
/* 10978*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::funcref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[funcref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10985*/  /*SwitchType*/ 10, MVT::externref,// ->10997
/* 10987*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 10989*/   OPC_EmitMergeInputChains1_0,
/* 10990*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::externref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[externref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10997*/  /*SwitchType*/ 8, MVT::f32,// ->11007
/* 10999*/   OPC_EmitMergeInputChains1_0,
/* 11000*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[f32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_F32:{ *:[f32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11007*/  /*SwitchType*/ 8, MVT::f64,// ->11017
/* 11009*/   OPC_EmitMergeInputChains1_0,
/* 11010*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[f64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_F64:{ *:[f64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11017*/  /*SwitchType*/ 10, MVT::v2i64,// ->11029
/* 11019*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11021*/   OPC_EmitMergeInputChains1_0,
/* 11022*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v2i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v2i64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v2i64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11029*/  /*SwitchType*/ 10, MVT::v4i32,// ->11041
/* 11031*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11033*/   OPC_EmitMergeInputChains1_0,
/* 11034*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v4i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v4i32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v4i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11041*/  /*SwitchType*/ 10, MVT::v16i8,// ->11053
/* 11043*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11045*/   OPC_EmitMergeInputChains1_0,
/* 11046*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v16i8, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v16i8] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v16i8] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11053*/  /*SwitchType*/ 10, MVT::v8i16,// ->11065
/* 11055*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11057*/   OPC_EmitMergeInputChains1_0,
/* 11058*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v8i16, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v8i16] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v8i16] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11065*/  /*SwitchType*/ 10, MVT::v4f32,// ->11077
/* 11067*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11069*/   OPC_EmitMergeInputChains1_0,
/* 11070*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v4f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v4f32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v4f32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11077*/  /*SwitchType*/ 10, MVT::v2f64,// ->11089
/* 11079*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11081*/   OPC_EmitMergeInputChains1_0,
/* 11082*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v2f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v2f64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v2f64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11089*/  0, // EndSwitchType
/* 11090*/ /*SwitchOpcode*/ 27|128,2/*283*/, TARGET_VAL(WebAssemblyISD::GLOBAL_SET),// ->11377
/* 11094*/  OPC_RecordMemRef,
/* 11095*/  OPC_RecordNode, // #0 = 'WebAssemblyglobal_set' chained node
/* 11096*/  OPC_RecordChild1, // #1 = $src
/* 11097*/  OPC_Scope, 20, /*->11119*/ // 12 children in Scope
/* 11099*/   OPC_CheckChild1TypeI32,
/* 11100*/   OPC_MoveChild2,
/* 11101*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11104*/   OPC_RecordChild0, // #2 = $addr
/* 11105*/   OPC_MoveChild0,
/* 11106*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11109*/   OPC_MoveParent,
/* 11110*/   OPC_MoveParent,
/* 11111*/   OPC_EmitMergeInputChains1_0,
/* 11112*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set i32:{ *:[i32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_I32 (tglobaladdr:{ *:[i32] }):$addr, i32:{ *:[i32] }:$src)
/* 11119*/  /*Scope*/ 20, /*->11140*/
/* 11120*/   OPC_CheckChild1TypeI64,
/* 11121*/   OPC_MoveChild2,
/* 11122*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11125*/   OPC_RecordChild0, // #2 = $addr
/* 11126*/   OPC_MoveChild0,
/* 11127*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11130*/   OPC_MoveParent,
/* 11131*/   OPC_MoveParent,
/* 11132*/   OPC_EmitMergeInputChains1_0,
/* 11133*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set i64:{ *:[i64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_I64 (tglobaladdr:{ *:[i64] }):$addr, i64:{ *:[i64] }:$src)
/* 11140*/  /*Scope*/ 21, /*->11162*/
/* 11141*/   OPC_CheckChild1Type, MVT::f32,
/* 11143*/   OPC_MoveChild2,
/* 11144*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11147*/   OPC_RecordChild0, // #2 = $addr
/* 11148*/   OPC_MoveChild0,
/* 11149*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11152*/   OPC_MoveParent,
/* 11153*/   OPC_MoveParent,
/* 11154*/   OPC_EmitMergeInputChains1_0,
/* 11155*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set f32:{ *:[f32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_F32 (tglobaladdr:{ *:[i32] }):$addr, f32:{ *:[f32] }:$src)
/* 11162*/  /*Scope*/ 21, /*->11184*/
/* 11163*/   OPC_CheckChild1Type, MVT::f64,
/* 11165*/   OPC_MoveChild2,
/* 11166*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11169*/   OPC_RecordChild0, // #2 = $addr
/* 11170*/   OPC_MoveChild0,
/* 11171*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11174*/   OPC_MoveParent,
/* 11175*/   OPC_MoveParent,
/* 11176*/   OPC_EmitMergeInputChains1_0,
/* 11177*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set f64:{ *:[f64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_F64 (tglobaladdr:{ *:[i32] }):$addr, f64:{ *:[f64] }:$src)
/* 11184*/  /*Scope*/ 23, /*->11208*/
/* 11185*/   OPC_CheckChild1Type, MVT::v4f32,
/* 11187*/   OPC_MoveChild2,
/* 11188*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11191*/   OPC_RecordChild0, // #2 = $addr
/* 11192*/   OPC_MoveChild0,
/* 11193*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11196*/   OPC_MoveParent,
/* 11197*/   OPC_MoveParent,
/* 11198*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11200*/   OPC_EmitMergeInputChains1_0,
/* 11201*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v4f32:{ *:[v4f32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v4f32:{ *:[v4f32] }:$src)
/* 11208*/  /*Scope*/ 23, /*->11232*/
/* 11209*/   OPC_CheckChild1Type, MVT::v2f64,
/* 11211*/   OPC_MoveChild2,
/* 11212*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11215*/   OPC_RecordChild0, // #2 = $addr
/* 11216*/   OPC_MoveChild0,
/* 11217*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11220*/   OPC_MoveParent,
/* 11221*/   OPC_MoveParent,
/* 11222*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11224*/   OPC_EmitMergeInputChains1_0,
/* 11225*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v2f64:{ *:[v2f64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v2f64:{ *:[v2f64] }:$src)
/* 11232*/  /*Scope*/ 23, /*->11256*/
/* 11233*/   OPC_CheckChild1Type, MVT::v2i64,
/* 11235*/   OPC_MoveChild2,
/* 11236*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11239*/   OPC_RecordChild0, // #2 = $addr
/* 11240*/   OPC_MoveChild0,
/* 11241*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11244*/   OPC_MoveParent,
/* 11245*/   OPC_MoveParent,
/* 11246*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11248*/   OPC_EmitMergeInputChains1_0,
/* 11249*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v2i64:{ *:[v2i64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v2i64:{ *:[v2i64] }:$src)
/* 11256*/  /*Scope*/ 23, /*->11280*/
/* 11257*/   OPC_CheckChild1Type, MVT::v4i32,
/* 11259*/   OPC_MoveChild2,
/* 11260*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11263*/   OPC_RecordChild0, // #2 = $addr
/* 11264*/   OPC_MoveChild0,
/* 11265*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11268*/   OPC_MoveParent,
/* 11269*/   OPC_MoveParent,
/* 11270*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11272*/   OPC_EmitMergeInputChains1_0,
/* 11273*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v4i32:{ *:[v4i32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v4i32:{ *:[v4i32] }:$src)
/* 11280*/  /*Scope*/ 23, /*->11304*/
/* 11281*/   OPC_CheckChild1Type, MVT::v16i8,
/* 11283*/   OPC_MoveChild2,
/* 11284*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11287*/   OPC_RecordChild0, // #2 = $addr
/* 11288*/   OPC_MoveChild0,
/* 11289*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11292*/   OPC_MoveParent,
/* 11293*/   OPC_MoveParent,
/* 11294*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11296*/   OPC_EmitMergeInputChains1_0,
/* 11297*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v16i8:{ *:[v16i8] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v16i8:{ *:[v16i8] }:$src)
/* 11304*/  /*Scope*/ 23, /*->11328*/
/* 11305*/   OPC_CheckChild1Type, MVT::v8i16,
/* 11307*/   OPC_MoveChild2,
/* 11308*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11311*/   OPC_RecordChild0, // #2 = $addr
/* 11312*/   OPC_MoveChild0,
/* 11313*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11316*/   OPC_MoveParent,
/* 11317*/   OPC_MoveParent,
/* 11318*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11320*/   OPC_EmitMergeInputChains1_0,
/* 11321*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v8i16:{ *:[v8i16] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v8i16:{ *:[v8i16] }:$src)
/* 11328*/  /*Scope*/ 23, /*->11352*/
/* 11329*/   OPC_CheckChild1Type, MVT::funcref,
/* 11331*/   OPC_MoveChild2,
/* 11332*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11335*/   OPC_RecordChild0, // #2 = $addr
/* 11336*/   OPC_MoveChild0,
/* 11337*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11340*/   OPC_MoveParent,
/* 11341*/   OPC_MoveParent,
/* 11342*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 11344*/   OPC_EmitMergeInputChains1_0,
/* 11345*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set funcref:{ *:[funcref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$addr, funcref:{ *:[funcref] }:$src)
/* 11352*/  /*Scope*/ 23, /*->11376*/
/* 11353*/   OPC_CheckChild1Type, MVT::externref,
/* 11355*/   OPC_MoveChild2,
/* 11356*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11359*/   OPC_RecordChild0, // #2 = $addr
/* 11360*/   OPC_MoveChild0,
/* 11361*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11364*/   OPC_MoveParent,
/* 11365*/   OPC_MoveParent,
/* 11366*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 11368*/   OPC_EmitMergeInputChains1_0,
/* 11369*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set externref:{ *:[externref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$addr, externref:{ *:[externref] }:$src)
/* 11376*/  0, /*End of Scope*/
/* 11377*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CALLSEQ_START),// ->11401
/* 11380*/  OPC_RecordNode, // #0 = 'WebAssemblycallseq_start' chained node
/* 11381*/  OPC_RecordChild1, // #1 = $amt
/* 11382*/  OPC_MoveChild1,
/* 11383*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 11386*/  OPC_MoveSibling2,
/* 11387*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 11390*/  OPC_RecordNode, // #2 = $amt2
/* 11391*/  OPC_MoveParent,
/* 11392*/  OPC_EmitMergeInputChains1_0,
/* 11393*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKDOWN), 0|OPFL_Chain|OPFL_GlueOutput,
                MVT::i32, 2/*#Ops*/, 1, 2, 
            // Src: (WebAssemblycallseq_start (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKDOWN:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 11401*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::CALLSEQ_END),// ->11426
/* 11404*/  OPC_RecordNode, // #0 = 'WebAssemblycallseq_end' chained node
/* 11405*/  OPC_CaptureGlueInput,
/* 11406*/  OPC_RecordChild1, // #1 = $amt
/* 11407*/  OPC_MoveChild1,
/* 11408*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 11411*/  OPC_MoveSibling2,
/* 11412*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 11415*/  OPC_RecordNode, // #2 = $amt2
/* 11416*/  OPC_MoveParent,
/* 11417*/  OPC_EmitMergeInputChains1_0,
/* 11418*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKUP), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput,
                MVT::i32, 2/*#Ops*/, 1, 2, 
            // Src: (WebAssemblycallseq_end (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKUP:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 11426*/ /*SwitchOpcode*/ 57, TARGET_VAL(WebAssemblyISD::MEMORY_COPY),// ->11486
/* 11429*/  OPC_RecordNode, // #0 = 'wasm_memcpy' chained node
/* 11430*/  OPC_RecordChild1, // #1 = $src_idx
/* 11431*/  OPC_MoveChild1,
/* 11432*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11435*/  OPC_CheckTypeI32,
/* 11436*/  OPC_MoveSibling2,
/* 11437*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11440*/  OPC_RecordNode, // #2 = $dst_idx
/* 11441*/  OPC_CheckTypeI32,
/* 11442*/  OPC_MoveParent,
/* 11443*/  OPC_RecordChild3, // #3 = $dst
/* 11444*/  OPC_Scope, 19, /*->11465*/ // 2 children in Scope
/* 11446*/   OPC_CheckChild3TypeI32,
/* 11447*/   OPC_RecordChild4, // #4 = $src
/* 11448*/   OPC_CheckChild4TypeI32,
/* 11449*/   OPC_RecordChild5, // #5 = $len
/* 11450*/   OPC_CheckChild5TypeI32,
/* 11451*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasBulkMemory())
/* 11453*/   OPC_EmitMergeInputChains1_0,
/* 11454*/   OPC_EmitConvertToTarget1,
/* 11455*/   OPC_EmitConvertToTarget2,
/* 11456*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_7901MEMORY_COPY_A32),
                 5/*#Ops*/, 6, 7, 3, 4, 5, 
             // Src: (wasm_memcpy (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$src, I32:{ *:[i32] }:$len) - Complexity = 9
             // Dst: (anonymous_7901MEMORY_COPY_A32 (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$src, I32:{ *:[i32] }:$len)
/* 11465*/  /*Scope*/ 19, /*->11485*/
/* 11466*/   OPC_CheckChild3TypeI64,
/* 11467*/   OPC_RecordChild4, // #4 = $src
/* 11468*/   OPC_CheckChild4TypeI64,
/* 11469*/   OPC_RecordChild5, // #5 = $len
/* 11470*/   OPC_CheckChild5TypeI64,
/* 11471*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasBulkMemory())
/* 11473*/   OPC_EmitMergeInputChains1_0,
/* 11474*/   OPC_EmitConvertToTarget1,
/* 11475*/   OPC_EmitConvertToTarget2,
/* 11476*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_7902MEMORY_COPY_A64),
                 5/*#Ops*/, 6, 7, 3, 4, 5, 
             // Src: (wasm_memcpy (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I64:{ *:[i64] }:$dst, I64:{ *:[i64] }:$src, I64:{ *:[i64] }:$len) - Complexity = 9
             // Dst: (anonymous_7902MEMORY_COPY_A64 (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I64:{ *:[i64] }:$dst, I64:{ *:[i64] }:$src, I64:{ *:[i64] }:$len)
/* 11485*/  0, /*End of Scope*/
/* 11486*/ /*SwitchOpcode*/ 43, TARGET_VAL(WebAssemblyISD::TABLE_GET),// ->11532
/* 11489*/  OPC_RecordMemRef,
/* 11490*/  OPC_RecordNode, // #0 = 'WebAssemblyTableGet' chained node
/* 11491*/  OPC_MoveChild1,
/* 11492*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11495*/  OPC_RecordChild0, // #1 = $table
/* 11496*/  OPC_MoveChild0,
/* 11497*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11500*/  OPC_MoveParent,
/* 11501*/  OPC_MoveParent,
/* 11502*/  OPC_RecordChild2, // #2 = $idx
/* 11503*/  OPC_CheckChild2TypeI32,
/* 11504*/  OPC_SwitchType /*2 cases */, 11, MVT::funcref,// ->11518
/* 11507*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 11509*/   OPC_EmitMergeInputChains1_0,
/* 11510*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::funcref, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[funcref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 11518*/  /*SwitchType*/ 11, MVT::externref,// ->11531
/* 11520*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 11522*/   OPC_EmitMergeInputChains1_0,
/* 11523*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::externref, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[externref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 11531*/  0, // EndSwitchType
/* 11532*/ /*SwitchOpcode*/ 72, TARGET_VAL(WebAssemblyISD::TABLE_SET),// ->11607
/* 11535*/  OPC_RecordMemRef,
/* 11536*/  OPC_RecordNode, // #0 = 'WebAssemblyTableSet' chained node
/* 11537*/  OPC_Scope, 44, /*->11583*/ // 2 children in Scope
/* 11539*/   OPC_MoveChild1,
/* 11540*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11543*/   OPC_RecordChild0, // #1 = $table
/* 11544*/   OPC_MoveChild0,
/* 11545*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11548*/   OPC_MoveParent,
/* 11549*/   OPC_MoveParent,
/* 11550*/   OPC_RecordChild2, // #2 = $idx
/* 11551*/   OPC_CheckChild2TypeI32,
/* 11552*/   OPC_RecordChild3, // #3 = $src
/* 11553*/   OPC_Scope, 13, /*->11568*/ // 2 children in Scope
/* 11555*/    OPC_CheckChild3Type, MVT::funcref,
/* 11557*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 11559*/    OPC_EmitMergeInputChains1_0,
/* 11560*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$src)
/* 11568*/   /*Scope*/ 13, /*->11582*/
/* 11569*/    OPC_CheckChild3Type, MVT::externref,
/* 11571*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 11573*/    OPC_EmitMergeInputChains1_0,
/* 11574*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, externref:{ *:[externref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, externref:{ *:[externref] }:$src)
/* 11582*/   0, /*End of Scope*/
/* 11583*/  /*Scope*/ 22, /*->11606*/
/* 11584*/   OPC_RecordChild1, // #1 = $table
/* 11585*/   OPC_MoveChild1,
/* 11586*/   OPC_CheckOpcode, TARGET_VAL(ISD::MCSymbol),
/* 11589*/   OPC_MoveParent,
/* 11590*/   OPC_RecordChild2, // #2 = $idx
/* 11591*/   OPC_CheckChild2TypeI32,
/* 11592*/   OPC_RecordChild3, // #3 = $r
/* 11593*/   OPC_CheckChild3Type, MVT::funcref,
/* 11595*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 11597*/   OPC_EmitMergeInputChains1_0,
/* 11598*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 3/*#Ops*/, 1, 2, 3, 
             // Src: (WebAssemblyTableSet (mcsym:{ *:[iPTR] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$r) - Complexity = 6
             // Dst: (TABLE_SET_FUNCREF (mcsym:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$r)
/* 11606*/  0, /*End of Scope*/
/* 11607*/ /*SwitchOpcode*/ 52|128,9/*1204*/, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),// ->12815
/* 11611*/  OPC_Scope, 49, /*->11662*/ // 36 children in Scope
/* 11613*/   OPC_CheckChild0Integer, 12|128,60|128,1/*24076*/, 
/* 11617*/   OPC_RecordChild1, // #0 = $src
/* 11618*/   OPC_Scope, 20, /*->11640*/ // 2 children in Scope
/* 11620*/    OPC_CheckChild1Type, MVT::f32,
/* 11622*/    OPC_SwitchType /*2 cases */, 6, MVT::i32,// ->11631
/* 11625*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12038:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_S_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 11631*/    /*SwitchType*/ 6, MVT::i64,// ->11639
/* 11633*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12038:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_S_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 11639*/    0, // EndSwitchType
/* 11640*/   /*Scope*/ 20, /*->11661*/
/* 11641*/    OPC_CheckChild1Type, MVT::f64,
/* 11643*/    OPC_SwitchType /*2 cases */, 6, MVT::i32,// ->11652
/* 11646*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12038:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_S_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 11652*/    /*SwitchType*/ 6, MVT::i64,// ->11660
/* 11654*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12038:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_S_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 11660*/    0, // EndSwitchType
/* 11661*/   0, /*End of Scope*/
/* 11662*/  /*Scope*/ 49, /*->11712*/
/* 11663*/   OPC_CheckChild0Integer, 14|128,60|128,1/*24078*/, 
/* 11667*/   OPC_RecordChild1, // #0 = $src
/* 11668*/   OPC_Scope, 20, /*->11690*/ // 2 children in Scope
/* 11670*/    OPC_CheckChild1Type, MVT::f32,
/* 11672*/    OPC_SwitchType /*2 cases */, 6, MVT::i32,// ->11681
/* 11675*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12039:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_U_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 11681*/    /*SwitchType*/ 6, MVT::i64,// ->11689
/* 11683*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12039:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_U_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 11689*/    0, // EndSwitchType
/* 11690*/   /*Scope*/ 20, /*->11711*/
/* 11691*/    OPC_CheckChild1Type, MVT::f64,
/* 11693*/    OPC_SwitchType /*2 cases */, 6, MVT::i32,// ->11702
/* 11696*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12039:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_U_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 11702*/    /*SwitchType*/ 6, MVT::i64,// ->11710
/* 11704*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12039:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_U_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 11710*/    0, // EndSwitchType
/* 11711*/   0, /*End of Scope*/
/* 11712*/  /*Scope*/ 43, /*->11756*/
/* 11713*/   OPC_CheckChild0Integer, 18|128,59|128,1/*23954*/, 
/* 11717*/   OPC_RecordChild1, // #0 = $vec
/* 11718*/   OPC_Scope, 8, /*->11728*/ // 4 children in Scope
/* 11720*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11722*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 11977:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11728*/   /*Scope*/ 8, /*->11737*/
/* 11729*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11731*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 11977:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11737*/   /*Scope*/ 8, /*->11746*/
/* 11738*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11740*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 11977:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11746*/   /*Scope*/ 8, /*->11755*/
/* 11747*/    OPC_CheckChild1Type, MVT::v2i64,
/* 11749*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 11977:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11755*/   0, /*End of Scope*/
/* 11756*/  /*Scope*/ 51, /*->11808*/
/* 11757*/   OPC_CheckChild0Integer, 16|128,59|128,1/*23952*/, 
/* 11761*/   OPC_RecordChild1, // #0 = $vec
/* 11762*/   OPC_Scope, 10, /*->11774*/ // 4 children in Scope
/* 11764*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11766*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11768*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 11976:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I8x16:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11774*/   /*Scope*/ 10, /*->11785*/
/* 11775*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11777*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11779*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 11976:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I16x8:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11785*/   /*Scope*/ 10, /*->11796*/
/* 11786*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11788*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11790*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 11976:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I32x4:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11796*/   /*Scope*/ 10, /*->11807*/
/* 11797*/    OPC_CheckChild1Type, MVT::v2i64,
/* 11799*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11801*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 11976:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I64x2:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11807*/   0, /*End of Scope*/
/* 11808*/  /*Scope*/ 51, /*->11860*/
/* 11809*/   OPC_CheckChild0Integer, 22|128,59|128,1/*23958*/, 
/* 11813*/   OPC_RecordChild1, // #0 = $vec
/* 11814*/   OPC_Scope, 10, /*->11826*/ // 4 children in Scope
/* 11816*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11818*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11820*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I8x16),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 11979:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I8x16:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11826*/   /*Scope*/ 10, /*->11837*/
/* 11827*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11829*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11831*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I16x8),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 11979:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I16x8:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11837*/   /*Scope*/ 10, /*->11848*/
/* 11838*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11840*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11842*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I32x4),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 11979:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I32x4:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11848*/   /*Scope*/ 10, /*->11859*/
/* 11849*/    OPC_CheckChild1Type, MVT::v2i64,
/* 11851*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11853*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I64x2),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 11979:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I64x2:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11859*/   0, /*End of Scope*/
/* 11860*/  /*Scope*/ 11, /*->11872*/
/* 11861*/   OPC_CheckChild0Integer, 68|128,59|128,1/*24004*/, 
/* 11865*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 11867*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_FUNCREF),
                 MVT::funcref, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[funcref] } 12002:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_FUNCREF:{ *:[funcref] })
/* 11872*/  /*Scope*/ 13, /*->11886*/
/* 11873*/   OPC_CheckChild0Integer, 64|128,59|128,1/*24000*/, 
/* 11877*/   OPC_RecordChild1, // #0 = $ref
/* 11878*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 11880*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_FUNCREF),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 12000:{ *:[iPTR] }, FUNCREF:{ *:[funcref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_FUNCREF:{ *:[i32] } FUNCREF:{ *:[funcref] }:$ref)
/* 11886*/  /*Scope*/ 11, /*->11898*/
/* 11887*/   OPC_CheckChild0Integer, 66|128,59|128,1/*24002*/, 
/* 11891*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 11893*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_EXTERNREF),
                 MVT::externref, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[externref] } 12001:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_EXTERNREF:{ *:[externref] })
/* 11898*/  /*Scope*/ 13, /*->11912*/
/* 11899*/   OPC_CheckChild0Integer, 62|128,59|128,1/*23998*/, 
/* 11903*/   OPC_RecordChild1, // #0 = $ref
/* 11904*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 11906*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_EXTERNREF),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 11999:{ *:[iPTR] }, EXTERNREF:{ *:[externref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_EXTERNREF:{ *:[i32] } EXTERNREF:{ *:[externref] }:$ref)
/* 11912*/  /*Scope*/ 13, /*->11926*/
/* 11913*/   OPC_CheckChild0Integer, 106|128,59|128,1/*24042*/, 
/* 11917*/   OPC_RecordChild1, // #0 = $src
/* 11918*/   OPC_RecordChild2, // #1 = $mask
/* 11919*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SWIZZLE),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12021:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 8
             // Dst: (SWIZZLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$src, ?:{ *:[v16i8] }:$mask)
/* 11926*/  /*Scope*/ 115, /*->12042*/
/* 11927*/   OPC_CheckChild0Integer, 24|128,59|128,1/*23960*/, 
/* 11931*/   OPC_RecordChild1, // #0 = $v1
/* 11932*/   OPC_SwitchType /*6 cases */, 16, MVT::v16i8,// ->11951
/* 11935*/    OPC_CheckChild1Type, MVT::v16i8,
/* 11937*/    OPC_RecordChild2, // #1 = $v2
/* 11938*/    OPC_CheckChild2Type, MVT::v16i8,
/* 11940*/    OPC_RecordChild3, // #2 = $c
/* 11941*/    OPC_CheckChild3Type, MVT::v16i8,
/* 11943*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 11980:{ *:[iPTR] }, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 11951*/   /*SwitchType*/ 16, MVT::v8i16,// ->11969
/* 11953*/    OPC_CheckChild1Type, MVT::v8i16,
/* 11955*/    OPC_RecordChild2, // #1 = $v2
/* 11956*/    OPC_CheckChild2Type, MVT::v8i16,
/* 11958*/    OPC_RecordChild3, // #2 = $c
/* 11959*/    OPC_CheckChild3Type, MVT::v8i16,
/* 11961*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 11980:{ *:[iPTR] }, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 11969*/   /*SwitchType*/ 16, MVT::v4i32,// ->11987
/* 11971*/    OPC_CheckChild1Type, MVT::v4i32,
/* 11973*/    OPC_RecordChild2, // #1 = $v2
/* 11974*/    OPC_CheckChild2Type, MVT::v4i32,
/* 11976*/    OPC_RecordChild3, // #2 = $c
/* 11977*/    OPC_CheckChild3Type, MVT::v4i32,
/* 11979*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 11980:{ *:[iPTR] }, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 11987*/   /*SwitchType*/ 16, MVT::v2i64,// ->12005
/* 11989*/    OPC_CheckChild1Type, MVT::v2i64,
/* 11991*/    OPC_RecordChild2, // #1 = $v2
/* 11992*/    OPC_CheckChild2Type, MVT::v2i64,
/* 11994*/    OPC_RecordChild3, // #2 = $c
/* 11995*/    OPC_CheckChild3Type, MVT::v2i64,
/* 11997*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2i64] } 11980:{ *:[iPTR] }, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 12005*/   /*SwitchType*/ 16, MVT::v4f32,// ->12023
/* 12007*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12009*/    OPC_RecordChild2, // #1 = $v2
/* 12010*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12012*/    OPC_RecordChild3, // #2 = $c
/* 12013*/    OPC_CheckChild3Type, MVT::v4f32,
/* 12015*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 11980:{ *:[iPTR] }, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v4f32] } ?:{ *:[v4f32] }:$v1, ?:{ *:[v4f32] }:$v2, ?:{ *:[v4f32] }:$c)
/* 12023*/   /*SwitchType*/ 16, MVT::v2f64,// ->12041
/* 12025*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12027*/    OPC_RecordChild2, // #1 = $v2
/* 12028*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12030*/    OPC_RecordChild3, // #2 = $c
/* 12031*/    OPC_CheckChild3Type, MVT::v2f64,
/* 12033*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2f64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 11980:{ *:[iPTR] }, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v2f64] } ?:{ *:[v2f64] }:$v1, ?:{ *:[v2f64] }:$v2, ?:{ *:[v2f64] }:$c)
/* 12041*/   0, // EndSwitchType
/* 12042*/  /*Scope*/ 39, /*->12082*/
/* 12043*/   OPC_CheckChild0Integer, 102|128,59|128,1/*24038*/, 
/* 12047*/   OPC_RecordChild1, // #0 = $lhs
/* 12048*/   OPC_SwitchType /*2 cases */, 14, MVT::v16i8,// ->12065
/* 12051*/    OPC_CheckChild1Type, MVT::v16i8,
/* 12053*/    OPC_RecordChild2, // #1 = $rhs
/* 12054*/    OPC_CheckChild2Type, MVT::v16i8,
/* 12056*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12058*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_S_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12019:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 12065*/   /*SwitchType*/ 14, MVT::v8i16,// ->12081
/* 12067*/    OPC_CheckChild1Type, MVT::v8i16,
/* 12069*/    OPC_RecordChild2, // #1 = $rhs
/* 12070*/    OPC_CheckChild2Type, MVT::v8i16,
/* 12072*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12074*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_S_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12019:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 12081*/   0, // EndSwitchType
/* 12082*/  /*Scope*/ 39, /*->12122*/
/* 12083*/   OPC_CheckChild0Integer, 104|128,59|128,1/*24040*/, 
/* 12087*/   OPC_RecordChild1, // #0 = $lhs
/* 12088*/   OPC_SwitchType /*2 cases */, 14, MVT::v16i8,// ->12105
/* 12091*/    OPC_CheckChild1Type, MVT::v16i8,
/* 12093*/    OPC_RecordChild2, // #1 = $rhs
/* 12094*/    OPC_CheckChild2Type, MVT::v16i8,
/* 12096*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12098*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_U_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12020:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 12105*/   /*SwitchType*/ 14, MVT::v8i16,// ->12121
/* 12107*/    OPC_CheckChild1Type, MVT::v8i16,
/* 12109*/    OPC_RecordChild2, // #1 = $rhs
/* 12110*/    OPC_CheckChild2Type, MVT::v8i16,
/* 12112*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12114*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_U_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12020:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 12121*/   0, // EndSwitchType
/* 12122*/  /*Scope*/ 39, /*->12162*/
/* 12123*/   OPC_CheckChild0Integer, 20|128,59|128,1/*23956*/, 
/* 12127*/   OPC_RecordChild1, // #0 = $lhs
/* 12128*/   OPC_SwitchType /*2 cases */, 14, MVT::v16i8,// ->12145
/* 12131*/    OPC_CheckChild1Type, MVT::v16i8,
/* 12133*/    OPC_RecordChild2, // #1 = $rhs
/* 12134*/    OPC_CheckChild2Type, MVT::v16i8,
/* 12136*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12138*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 11978:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (AVGR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 12145*/   /*SwitchType*/ 14, MVT::v8i16,// ->12161
/* 12147*/    OPC_CheckChild1Type, MVT::v8i16,
/* 12149*/    OPC_RecordChild2, // #1 = $rhs
/* 12150*/    OPC_CheckChild2Type, MVT::v8i16,
/* 12152*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12154*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 11978:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (AVGR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 12161*/   0, // EndSwitchType
/* 12162*/  /*Scope*/ 15, /*->12178*/
/* 12163*/   OPC_CheckChild0Integer, 28|128,59|128,1/*23964*/, 
/* 12167*/   OPC_RecordChild1, // #0 = $lhs
/* 12168*/   OPC_RecordChild2, // #1 = $rhs
/* 12169*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12171*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DOT),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 11982:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (DOT:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 12178*/  /*Scope*/ 39, /*->12218*/
/* 12179*/   OPC_CheckChild0Integer, 52|128,59|128,1/*23988*/, 
/* 12183*/   OPC_RecordChild1, // #0 = $low
/* 12184*/   OPC_SwitchType /*2 cases */, 14, MVT::v16i8,// ->12201
/* 12187*/    OPC_CheckChild1Type, MVT::v8i16,
/* 12189*/    OPC_RecordChild2, // #1 = $high
/* 12190*/    OPC_CheckChild2Type, MVT::v8i16,
/* 12192*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12194*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_S_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 11994:{ *:[iPTR] }, V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high) - Complexity = 8
              // Dst: (NARROW_S_I8x16:{ *:[v16i8] } V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high)
/* 12201*/   /*SwitchType*/ 14, MVT::v8i16,// ->12217
/* 12203*/    OPC_CheckChild1Type, MVT::v4i32,
/* 12205*/    OPC_RecordChild2, // #1 = $high
/* 12206*/    OPC_CheckChild2Type, MVT::v4i32,
/* 12208*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12210*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_S_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 11994:{ *:[iPTR] }, V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high) - Complexity = 8
              // Dst: (NARROW_S_I16x8:{ *:[v8i16] } V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high)
/* 12217*/   0, // EndSwitchType
/* 12218*/  /*Scope*/ 39, /*->12258*/
/* 12219*/   OPC_CheckChild0Integer, 54|128,59|128,1/*23990*/, 
/* 12223*/   OPC_RecordChild1, // #0 = $low
/* 12224*/   OPC_SwitchType /*2 cases */, 14, MVT::v16i8,// ->12241
/* 12227*/    OPC_CheckChild1Type, MVT::v8i16,
/* 12229*/    OPC_RecordChild2, // #1 = $high
/* 12230*/    OPC_CheckChild2Type, MVT::v8i16,
/* 12232*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12234*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 11995:{ *:[iPTR] }, V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high) - Complexity = 8
              // Dst: (NARROW_U_I8x16:{ *:[v16i8] } V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high)
/* 12241*/   /*SwitchType*/ 14, MVT::v8i16,// ->12257
/* 12243*/    OPC_CheckChild1Type, MVT::v4i32,
/* 12245*/    OPC_RecordChild2, // #1 = $high
/* 12246*/    OPC_CheckChild2Type, MVT::v4i32,
/* 12248*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12250*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 11995:{ *:[iPTR] }, V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high) - Complexity = 8
              // Dst: (NARROW_U_I16x8:{ *:[v8i16] } V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high)
/* 12257*/   0, // EndSwitchType
/* 12258*/  /*Scope*/ 31, /*->12290*/
/* 12259*/   OPC_CheckChild0Integer, 30|128,59|128,1/*23966*/, 
/* 12263*/   OPC_RecordChild1, // #0 = $vec
/* 12264*/   OPC_SwitchType /*2 cases */, 10, MVT::v8i16,// ->12277
/* 12267*/    OPC_CheckChild1Type, MVT::v16i8,
/* 12269*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12271*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I16x8),
                  MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 11983:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_signed_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 12277*/   /*SwitchType*/ 10, MVT::v4i32,// ->12289
/* 12279*/    OPC_CheckChild1Type, MVT::v8i16,
/* 12281*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12283*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I32x4),
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 11983:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_signed_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 12289*/   0, // EndSwitchType
/* 12290*/  /*Scope*/ 31, /*->12322*/
/* 12291*/   OPC_CheckChild0Integer, 32|128,59|128,1/*23968*/, 
/* 12295*/   OPC_RecordChild1, // #0 = $vec
/* 12296*/   OPC_SwitchType /*2 cases */, 10, MVT::v8i16,// ->12309
/* 12299*/    OPC_CheckChild1Type, MVT::v16i8,
/* 12301*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12303*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I16x8),
                  MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 11984:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_unsigned_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 12309*/   /*SwitchType*/ 10, MVT::v4i32,// ->12321
/* 12311*/    OPC_CheckChild1Type, MVT::v8i16,
/* 12313*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12315*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I32x4),
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 11984:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_unsigned_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 12321*/   0, // EndSwitchType
/* 12322*/  /*Scope*/ 15, /*->12338*/
/* 12323*/   OPC_CheckChild0Integer, 60|128,59|128,1/*23996*/, 
/* 12327*/   OPC_RecordChild1, // #0 = $lhs
/* 12328*/   OPC_RecordChild2, // #1 = $rhs
/* 12329*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12331*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::Q15MULR_SAT_S_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 11998:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (Q15MULR_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 12338*/  /*Scope*/ 15, /*->12354*/
/* 12339*/   OPC_CheckChild0Integer, 88|128,59|128,1/*24024*/, 
/* 12343*/   OPC_RecordChild1, // #0 = $src
/* 12344*/   OPC_RecordChild2, // #1 = $mask
/* 12345*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 12347*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_SWIZZLE),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12012:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 8
             // Dst: (RELAXED_SWIZZLE:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask)
/* 12354*/  /*Scope*/ 13, /*->12368*/
/* 12355*/   OPC_CheckChild0Integer, 90|128,59|128,1/*24026*/, 
/* 12359*/   OPC_RecordChild1, // #0 = $vec
/* 12360*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 12362*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_signed_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12013:{ *:[iPTR] }, V128:{ *:[v4f32] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_signed_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 12368*/  /*Scope*/ 13, /*->12382*/
/* 12369*/   OPC_CheckChild0Integer, 94|128,59|128,1/*24030*/, 
/* 12373*/   OPC_RecordChild1, // #0 = $vec
/* 12374*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 12376*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_unsigned_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12015:{ *:[iPTR] }, V128:{ *:[v4f32] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_unsigned_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 12382*/  /*Scope*/ 13, /*->12396*/
/* 12383*/   OPC_CheckChild0Integer, 92|128,59|128,1/*24028*/, 
/* 12387*/   OPC_RecordChild1, // #0 = $vec
/* 12388*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 12390*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_signed_zero_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12014:{ *:[iPTR] }, V128:{ *:[v2f64] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_signed_zero_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 12396*/  /*Scope*/ 13, /*->12410*/
/* 12397*/   OPC_CheckChild0Integer, 96|128,59|128,1/*24032*/, 
/* 12401*/   OPC_RecordChild1, // #0 = $vec
/* 12402*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 12404*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_unsigned_zero_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12016:{ *:[iPTR] }, V128:{ *:[v2f64] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_unsigned_zero_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 12410*/  /*Scope*/ 87, /*->12498*/
/* 12411*/   OPC_CheckChild0Integer, 76|128,59|128,1/*24012*/, 
/* 12415*/   OPC_RecordChild1, // #0 = $a
/* 12416*/   OPC_SwitchType /*4 cases */, 18, MVT::v16i8,// ->12437
/* 12419*/    OPC_CheckChild1Type, MVT::v16i8,
/* 12421*/    OPC_RecordChild2, // #1 = $b
/* 12422*/    OPC_CheckChild2Type, MVT::v16i8,
/* 12424*/    OPC_RecordChild3, // #2 = $c
/* 12425*/    OPC_CheckChild3Type, MVT::v16i8,
/* 12427*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 12429*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I8x16),
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12006:{ *:[iPTR] }, V128:{ *:[v16i8] }:$a, V128:{ *:[v16i8] }:$b, V128:{ *:[v16i8] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$a, V128:{ *:[v16i8] }:$b, V128:{ *:[v16i8] }:$c)
/* 12437*/   /*SwitchType*/ 18, MVT::v8i16,// ->12457
/* 12439*/    OPC_CheckChild1Type, MVT::v8i16,
/* 12441*/    OPC_RecordChild2, // #1 = $b
/* 12442*/    OPC_CheckChild2Type, MVT::v8i16,
/* 12444*/    OPC_RecordChild3, // #2 = $c
/* 12445*/    OPC_CheckChild3Type, MVT::v8i16,
/* 12447*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 12449*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I16x8),
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12006:{ *:[iPTR] }, V128:{ *:[v8i16] }:$a, V128:{ *:[v8i16] }:$b, V128:{ *:[v8i16] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$a, V128:{ *:[v8i16] }:$b, V128:{ *:[v8i16] }:$c)
/* 12457*/   /*SwitchType*/ 18, MVT::v4i32,// ->12477
/* 12459*/    OPC_CheckChild1Type, MVT::v4i32,
/* 12461*/    OPC_RecordChild2, // #1 = $b
/* 12462*/    OPC_CheckChild2Type, MVT::v4i32,
/* 12464*/    OPC_RecordChild3, // #2 = $c
/* 12465*/    OPC_CheckChild3Type, MVT::v4i32,
/* 12467*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 12469*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I32x4),
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12006:{ *:[iPTR] }, V128:{ *:[v4i32] }:$a, V128:{ *:[v4i32] }:$b, V128:{ *:[v4i32] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$a, V128:{ *:[v4i32] }:$b, V128:{ *:[v4i32] }:$c)
/* 12477*/   /*SwitchType*/ 18, MVT::v2i64,// ->12497
/* 12479*/    OPC_CheckChild1Type, MVT::v2i64,
/* 12481*/    OPC_RecordChild2, // #1 = $b
/* 12482*/    OPC_CheckChild2Type, MVT::v2i64,
/* 12484*/    OPC_RecordChild3, // #2 = $c
/* 12485*/    OPC_CheckChild3Type, MVT::v2i64,
/* 12487*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 12489*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I64x2),
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2i64] } 12006:{ *:[iPTR] }, V128:{ *:[v2i64] }:$a, V128:{ *:[v2i64] }:$b, V128:{ *:[v2i64] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$a, V128:{ *:[v2i64] }:$b, V128:{ *:[v2i64] }:$c)
/* 12497*/   0, // EndSwitchType
/* 12498*/  /*Scope*/ 15, /*->12514*/
/* 12499*/   OPC_CheckChild0Integer, 86|128,59|128,1/*24022*/, 
/* 12503*/   OPC_RecordChild1, // #0 = $lhs
/* 12504*/   OPC_RecordChild2, // #1 = $rhs
/* 12505*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 12507*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_Q15MULR_S_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12011:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (RELAXED_Q15MULR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 12514*/  /*Scope*/ 15, /*->12530*/
/* 12515*/   OPC_CheckChild0Integer, 74|128,59|128,1/*24010*/, 
/* 12519*/   OPC_RecordChild1, // #0 = $lhs
/* 12520*/   OPC_RecordChild2, // #1 = $rhs
/* 12521*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 12523*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12005:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
             // Dst: (RELAXED_DOT:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 12530*/  /*Scope*/ 17, /*->12548*/
/* 12531*/   OPC_CheckChild0Integer, 72|128,59|128,1/*24008*/, 
/* 12535*/   OPC_RecordChild1, // #0 = $lhs
/* 12536*/   OPC_RecordChild2, // #1 = $rhs
/* 12537*/   OPC_RecordChild3, // #2 = $acc
/* 12538*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 12540*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT_ADD),
                 MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12004:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, V128:{ *:[v4i32] }:$acc) - Complexity = 8
             // Dst: (RELAXED_DOT_ADD:{ *:[v4i32] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, V128:{ *:[v4i32] }:$acc)
/* 12548*/  /*Scope*/ 35, /*->12584*/
/* 12549*/   OPC_CheckChild0Integer, 58|128,59|128,1/*23994*/, 
/* 12553*/   OPC_RecordChild1, // #0 = $lhs
/* 12554*/   OPC_SwitchType /*2 cases */, 12, MVT::v4f32,// ->12569
/* 12557*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12559*/    OPC_RecordChild2, // #1 = $rhs
/* 12560*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12562*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 11997:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12569*/   /*SwitchType*/ 12, MVT::v2f64,// ->12583
/* 12571*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12573*/    OPC_RecordChild2, // #1 = $rhs
/* 12574*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12576*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 11997:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12583*/   0, // EndSwitchType
/* 12584*/  /*Scope*/ 35, /*->12620*/
/* 12585*/   OPC_CheckChild0Integer, 56|128,59|128,1/*23992*/, 
/* 12589*/   OPC_RecordChild1, // #0 = $lhs
/* 12590*/   OPC_SwitchType /*2 cases */, 12, MVT::v4f32,// ->12605
/* 12593*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12595*/    OPC_RecordChild2, // #1 = $rhs
/* 12596*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12598*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 11996:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12605*/   /*SwitchType*/ 12, MVT::v2f64,// ->12619
/* 12607*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12609*/    OPC_RecordChild2, // #1 = $rhs
/* 12610*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12612*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 11996:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12619*/   0, // EndSwitchType
/* 12620*/  /*Scope*/ 47, /*->12668*/
/* 12621*/   OPC_CheckChild0Integer, 78|128,59|128,1/*24014*/, 
/* 12625*/   OPC_RecordChild1, // #0 = $a
/* 12626*/   OPC_SwitchType /*2 cases */, 18, MVT::v4f32,// ->12647
/* 12629*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12631*/    OPC_RecordChild2, // #1 = $b
/* 12632*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12634*/    OPC_RecordChild3, // #2 = $c
/* 12635*/    OPC_CheckChild3Type, MVT::v4f32,
/* 12637*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 12639*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F32x4),
                  MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12007:{ *:[iPTR] }, V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (MADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c)
/* 12647*/   /*SwitchType*/ 18, MVT::v2f64,// ->12667
/* 12649*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12651*/    OPC_RecordChild2, // #1 = $b
/* 12652*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12654*/    OPC_RecordChild3, // #2 = $c
/* 12655*/    OPC_CheckChild3Type, MVT::v2f64,
/* 12657*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 12659*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F64x2),
                  MVT::v2f64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12007:{ *:[iPTR] }, V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (MADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c)
/* 12667*/   0, // EndSwitchType
/* 12668*/  /*Scope*/ 47, /*->12716*/
/* 12669*/   OPC_CheckChild0Integer, 84|128,59|128,1/*24020*/, 
/* 12673*/   OPC_RecordChild1, // #0 = $a
/* 12674*/   OPC_SwitchType /*2 cases */, 18, MVT::v4f32,// ->12695
/* 12677*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12679*/    OPC_RecordChild2, // #1 = $b
/* 12680*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12682*/    OPC_RecordChild3, // #2 = $c
/* 12683*/    OPC_CheckChild3Type, MVT::v4f32,
/* 12685*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 12687*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F32x4),
                  MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12010:{ *:[iPTR] }, V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (NMADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c)
/* 12695*/   /*SwitchType*/ 18, MVT::v2f64,// ->12715
/* 12697*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12699*/    OPC_RecordChild2, // #1 = $b
/* 12700*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12702*/    OPC_RecordChild3, // #2 = $c
/* 12703*/    OPC_CheckChild3Type, MVT::v2f64,
/* 12705*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 12707*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F64x2),
                  MVT::v2f64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12010:{ *:[iPTR] }, V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (NMADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c)
/* 12715*/   0, // EndSwitchType
/* 12716*/  /*Scope*/ 39, /*->12756*/
/* 12717*/   OPC_CheckChild0Integer, 82|128,59|128,1/*24018*/, 
/* 12721*/   OPC_RecordChild1, // #0 = $lhs
/* 12722*/   OPC_SwitchType /*2 cases */, 14, MVT::v4f32,// ->12739
/* 12725*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12727*/    OPC_RecordChild2, // #1 = $rhs
/* 12728*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12730*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 12732*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMIN_F32x4),
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12009:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12739*/   /*SwitchType*/ 14, MVT::v2f64,// ->12755
/* 12741*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12743*/    OPC_RecordChild2, // #1 = $rhs
/* 12744*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12746*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 12748*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMIN_F64x2),
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12009:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12755*/   0, // EndSwitchType
/* 12756*/  /*Scope*/ 39, /*->12796*/
/* 12757*/   OPC_CheckChild0Integer, 80|128,59|128,1/*24016*/, 
/* 12761*/   OPC_RecordChild1, // #0 = $lhs
/* 12762*/   OPC_SwitchType /*2 cases */, 14, MVT::v4f32,// ->12779
/* 12765*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12767*/    OPC_RecordChild2, // #1 = $rhs
/* 12768*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12770*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 12772*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMAX_F32x4),
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12008:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12779*/   /*SwitchType*/ 14, MVT::v2f64,// ->12795
/* 12781*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12783*/    OPC_RecordChild2, // #1 = $rhs
/* 12784*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12786*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 12788*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMAX_F64x2),
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12008:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12795*/   0, // EndSwitchType
/* 12796*/  /*Scope*/ 17, /*->12814*/
/* 12797*/   OPC_CheckChild0Integer, 70|128,59|128,1/*24006*/, 
/* 12801*/   OPC_RecordChild1, // #0 = $lhs
/* 12802*/   OPC_RecordChild2, // #1 = $rhs
/* 12803*/   OPC_RecordChild3, // #2 = $acc
/* 12804*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 12806*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT_BFLOAT),
                 MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12003:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, V128:{ *:[v4f32] }:$acc) - Complexity = 8
             // Dst: (RELAXED_DOT_BFLOAT:{ *:[v4f32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, V128:{ *:[v4f32] }:$acc)
/* 12814*/  0, /*End of Scope*/
/* 12815*/ /*SwitchOpcode*/ 3|128,1/*131*/, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),// ->12950
/* 12819*/  OPC_RecordChild0, // #0 = $vec
/* 12820*/  OPC_Scope, 20, /*->12842*/ // 6 children in Scope
/* 12822*/   OPC_CheckChild0Type, MVT::v16i8,
/* 12824*/   OPC_RecordChild1, // #1 = $idx
/* 12825*/   OPC_MoveChild1,
/* 12826*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12829*/   OPC_CheckPredicate, 3, // Predicate_LaneIdx16
/* 12831*/   OPC_CheckTypeI32,
/* 12832*/   OPC_MoveParent,
/* 12833*/   OPC_CheckTypeI32,
/* 12834*/   OPC_EmitConvertToTarget1,
/* 12835*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u),
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I8x16_u:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12842*/  /*Scope*/ 20, /*->12863*/
/* 12843*/   OPC_CheckChild0Type, MVT::v8i16,
/* 12845*/   OPC_RecordChild1, // #1 = $idx
/* 12846*/   OPC_MoveChild1,
/* 12847*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12850*/   OPC_CheckPredicate, 7, // Predicate_LaneIdx8
/* 12852*/   OPC_CheckTypeI32,
/* 12853*/   OPC_MoveParent,
/* 12854*/   OPC_CheckTypeI32,
/* 12855*/   OPC_EmitConvertToTarget1,
/* 12856*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u),
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I16x8_u:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12863*/  /*Scope*/ 20, /*->12884*/
/* 12864*/   OPC_CheckChild0Type, MVT::v4i32,
/* 12866*/   OPC_RecordChild1, // #1 = $idx
/* 12867*/   OPC_MoveChild1,
/* 12868*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12871*/   OPC_CheckPredicate, 9, // Predicate_LaneIdx4
/* 12873*/   OPC_CheckTypeI32,
/* 12874*/   OPC_MoveParent,
/* 12875*/   OPC_CheckTypeI32,
/* 12876*/   OPC_EmitConvertToTarget1,
/* 12877*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I32x4),
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12884*/  /*Scope*/ 20, /*->12905*/
/* 12885*/   OPC_CheckChild0Type, MVT::v2i64,
/* 12887*/   OPC_RecordChild1, // #1 = $idx
/* 12888*/   OPC_MoveChild1,
/* 12889*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12892*/   OPC_CheckPredicate, 11, // Predicate_LaneIdx2
/* 12894*/   OPC_CheckTypeI32,
/* 12895*/   OPC_MoveParent,
/* 12896*/   OPC_CheckTypeI64,
/* 12897*/   OPC_EmitConvertToTarget1,
/* 12898*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2),
                 MVT::i64, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I64x2:{ *:[i64] } ?:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12905*/  /*Scope*/ 21, /*->12927*/
/* 12906*/   OPC_CheckChild0Type, MVT::v4f32,
/* 12908*/   OPC_RecordChild1, // #1 = $idx
/* 12909*/   OPC_MoveChild1,
/* 12910*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12913*/   OPC_CheckPredicate, 9, // Predicate_LaneIdx4
/* 12915*/   OPC_CheckTypeI32,
/* 12916*/   OPC_MoveParent,
/* 12917*/   OPC_CheckType, MVT::f32,
/* 12919*/   OPC_EmitConvertToTarget1,
/* 12920*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F32x4),
                 MVT::f32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_F32x4:{ *:[f32] } ?:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12927*/  /*Scope*/ 21, /*->12949*/
/* 12928*/   OPC_CheckChild0Type, MVT::v2f64,
/* 12930*/   OPC_RecordChild1, // #1 = $idx
/* 12931*/   OPC_MoveChild1,
/* 12932*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12935*/   OPC_CheckPredicate, 11, // Predicate_LaneIdx2
/* 12937*/   OPC_CheckTypeI32,
/* 12938*/   OPC_MoveParent,
/* 12939*/   OPC_CheckType, MVT::f64,
/* 12941*/   OPC_EmitConvertToTarget1,
/* 12942*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F64x2),
                 MVT::f64, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_F64x2:{ *:[f64] } ?:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12949*/  0, /*End of Scope*/
/* 12950*/ /*SwitchOpcode*/ 104, TARGET_VAL(WebAssemblyISD::ARGUMENT),// ->13057
/* 12953*/  OPC_RecordChild0, // #0 = $argno
/* 12954*/  OPC_MoveChild0,
/* 12955*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12958*/  OPC_MoveParent,
/* 12959*/  OPC_SwitchType /*12 cases */, 6, MVT::i32,// ->12968
/* 12962*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_i32),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_i32:{ *:[i32] } (timm:{ *:[i32] }):$argno)
/* 12968*/  /*SwitchType*/ 6, MVT::i64,// ->12976
/* 12970*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_i64),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_i64:{ *:[i64] } (timm:{ *:[i32] }):$argno)
/* 12976*/  /*SwitchType*/ 6, MVT::funcref,// ->12984
/* 12978*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_funcref),
                 MVT::funcref, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[funcref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_funcref:{ *:[funcref] } (timm:{ *:[i32] }):$argno)
/* 12984*/  /*SwitchType*/ 6, MVT::externref,// ->12992
/* 12986*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_externref),
                 MVT::externref, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[externref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_externref:{ *:[externref] } (timm:{ *:[i32] }):$argno)
/* 12992*/  /*SwitchType*/ 6, MVT::f32,// ->13000
/* 12994*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_f32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_f32:{ *:[f32] } (timm:{ *:[i32] }):$argno)
/* 13000*/  /*SwitchType*/ 6, MVT::f64,// ->13008
/* 13002*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_f64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_f64:{ *:[f64] } (timm:{ *:[i32] }):$argno)
/* 13008*/  /*SwitchType*/ 6, MVT::v16i8,// ->13016
/* 13010*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v16i8),
                 MVT::v16i8, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v16i8] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v16i8:{ *:[v16i8] } (timm:{ *:[i32] }):$argno)
/* 13016*/  /*SwitchType*/ 6, MVT::v8i16,// ->13024
/* 13018*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v8i16),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v8i16] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v8i16:{ *:[v8i16] } (timm:{ *:[i32] }):$argno)
/* 13024*/  /*SwitchType*/ 6, MVT::v4i32,// ->13032
/* 13026*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v4i32),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v4i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v4i32:{ *:[v4i32] } (timm:{ *:[i32] }):$argno)
/* 13032*/  /*SwitchType*/ 6, MVT::v2i64,// ->13040
/* 13034*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v2i64),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v2i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v2i64:{ *:[v2i64] } (timm:{ *:[i32] }):$argno)
/* 13040*/  /*SwitchType*/ 6, MVT::v4f32,// ->13048
/* 13042*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v4f32),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v4f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v4f32:{ *:[v4f32] } (timm:{ *:[i32] }):$argno)
/* 13048*/  /*SwitchType*/ 6, MVT::v2f64,// ->13056
/* 13050*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v2f64),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v2f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v2f64:{ *:[v2f64] } (timm:{ *:[i32] }):$argno)
/* 13056*/  0, // EndSwitchType
/* 13057*/ /*SwitchOpcode*/ 5|128,1/*133*/, TARGET_VAL(WebAssemblyISD::LOCAL_GET),// ->13194
/* 13061*/  OPC_RecordNode, // #0 = 'WebAssemblylocal_get' chained node
/* 13062*/  OPC_RecordChild1, // #1 = $local
/* 13063*/  OPC_MoveChild1,
/* 13064*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 13067*/  OPC_MoveParent,
/* 13068*/  OPC_SwitchType /*12 cases */, 7, MVT::i32,// ->13078
/* 13071*/   OPC_EmitMergeInputChains1_0,
/* 13072*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_I32),
                 MVT::i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[i32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_I32:{ *:[i32] } (timm:{ *:[i32] }):$local)
/* 13078*/  /*SwitchType*/ 7, MVT::i64,// ->13087
/* 13080*/   OPC_EmitMergeInputChains1_0,
/* 13081*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_I64),
                 MVT::i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[i64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_I64:{ *:[i64] } (timm:{ *:[i32] }):$local)
/* 13087*/  /*SwitchType*/ 9, MVT::funcref,// ->13098
/* 13089*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 13091*/   OPC_EmitMergeInputChains1_0,
/* 13092*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_FUNCREF),
                 MVT::funcref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[funcref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_FUNCREF:{ *:[funcref] } (timm:{ *:[i32] }):$local)
/* 13098*/  /*SwitchType*/ 9, MVT::externref,// ->13109
/* 13100*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 13102*/   OPC_EmitMergeInputChains1_0,
/* 13103*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_EXTERNREF),
                 MVT::externref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[externref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_EXTERNREF:{ *:[externref] } (timm:{ *:[i32] }):$local)
/* 13109*/  /*SwitchType*/ 7, MVT::f32,// ->13118
/* 13111*/   OPC_EmitMergeInputChains1_0,
/* 13112*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_F32),
                 MVT::f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[f32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_F32:{ *:[f32] } (timm:{ *:[i32] }):$local)
/* 13118*/  /*SwitchType*/ 7, MVT::f64,// ->13127
/* 13120*/   OPC_EmitMergeInputChains1_0,
/* 13121*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_F64),
                 MVT::f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[f64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_F64:{ *:[f64] } (timm:{ *:[i32] }):$local)
/* 13127*/  /*SwitchType*/ 9, MVT::v2i64,// ->13138
/* 13129*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13131*/   OPC_EmitMergeInputChains1_0,
/* 13132*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v2i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v2i64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v2i64] } (timm:{ *:[i32] }):$local)
/* 13138*/  /*SwitchType*/ 9, MVT::v4i32,// ->13149
/* 13140*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13142*/   OPC_EmitMergeInputChains1_0,
/* 13143*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v4i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v4i32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v4i32] } (timm:{ *:[i32] }):$local)
/* 13149*/  /*SwitchType*/ 9, MVT::v16i8,// ->13160
/* 13151*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13153*/   OPC_EmitMergeInputChains1_0,
/* 13154*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v16i8, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v16i8] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v16i8] } (timm:{ *:[i32] }):$local)
/* 13160*/  /*SwitchType*/ 9, MVT::v8i16,// ->13171
/* 13162*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13164*/   OPC_EmitMergeInputChains1_0,
/* 13165*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v8i16, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v8i16] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v8i16] } (timm:{ *:[i32] }):$local)
/* 13171*/  /*SwitchType*/ 9, MVT::v4f32,// ->13182
/* 13173*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13175*/   OPC_EmitMergeInputChains1_0,
/* 13176*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v4f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v4f32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v4f32] } (timm:{ *:[i32] }):$local)
/* 13182*/  /*SwitchType*/ 9, MVT::v2f64,// ->13193
/* 13184*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13186*/   OPC_EmitMergeInputChains1_0,
/* 13187*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 MVT::v2f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v2f64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v2f64] } (timm:{ *:[i32] }):$local)
/* 13193*/  0, // EndSwitchType
/* 13194*/ /*SwitchOpcode*/ 16|128,1/*144*/, TARGET_VAL(WebAssemblyISD::LOCAL_SET),// ->13342
/* 13198*/  OPC_RecordNode, // #0 = 'WebAssemblylocal_set' chained node
/* 13199*/  OPC_RecordChild1, // #1 = $local
/* 13200*/  OPC_MoveChild1,
/* 13201*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 13204*/  OPC_MoveParent,
/* 13205*/  OPC_RecordChild2, // #2 = $src
/* 13206*/  OPC_Scope, 8, /*->13216*/ // 12 children in Scope
/* 13208*/   OPC_CheckChild2TypeI32,
/* 13209*/   OPC_EmitMergeInputChains1_0,
/* 13210*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_I32),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, i32:{ *:[i32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_I32 (timm:{ *:[i32] }):$local, i32:{ *:[i32] }:$src)
/* 13216*/  /*Scope*/ 8, /*->13225*/
/* 13217*/   OPC_CheckChild2TypeI64,
/* 13218*/   OPC_EmitMergeInputChains1_0,
/* 13219*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_I64),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, i64:{ *:[i64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_I64 (timm:{ *:[i32] }):$local, i64:{ *:[i64] }:$src)
/* 13225*/  /*Scope*/ 9, /*->13235*/
/* 13226*/   OPC_CheckChild2Type, MVT::f32,
/* 13228*/   OPC_EmitMergeInputChains1_0,
/* 13229*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_F32),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, f32:{ *:[f32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_F32 (timm:{ *:[i32] }):$local, f32:{ *:[f32] }:$src)
/* 13235*/  /*Scope*/ 9, /*->13245*/
/* 13236*/   OPC_CheckChild2Type, MVT::f64,
/* 13238*/   OPC_EmitMergeInputChains1_0,
/* 13239*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_F64),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, f64:{ *:[f64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_F64 (timm:{ *:[i32] }):$local, f64:{ *:[f64] }:$src)
/* 13245*/  /*Scope*/ 11, /*->13257*/
/* 13246*/   OPC_CheckChild2Type, MVT::v4f32,
/* 13248*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13250*/   OPC_EmitMergeInputChains1_0,
/* 13251*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v4f32:{ *:[v4f32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v4f32:{ *:[v4f32] }:$src)
/* 13257*/  /*Scope*/ 11, /*->13269*/
/* 13258*/   OPC_CheckChild2Type, MVT::v2f64,
/* 13260*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13262*/   OPC_EmitMergeInputChains1_0,
/* 13263*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v2f64:{ *:[v2f64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v2f64:{ *:[v2f64] }:$src)
/* 13269*/  /*Scope*/ 11, /*->13281*/
/* 13270*/   OPC_CheckChild2Type, MVT::v2i64,
/* 13272*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13274*/   OPC_EmitMergeInputChains1_0,
/* 13275*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v2i64:{ *:[v2i64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v2i64:{ *:[v2i64] }:$src)
/* 13281*/  /*Scope*/ 11, /*->13293*/
/* 13282*/   OPC_CheckChild2Type, MVT::v4i32,
/* 13284*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13286*/   OPC_EmitMergeInputChains1_0,
/* 13287*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v4i32:{ *:[v4i32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v4i32:{ *:[v4i32] }:$src)
/* 13293*/  /*Scope*/ 11, /*->13305*/
/* 13294*/   OPC_CheckChild2Type, MVT::v16i8,
/* 13296*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13298*/   OPC_EmitMergeInputChains1_0,
/* 13299*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v16i8:{ *:[v16i8] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v16i8:{ *:[v16i8] }:$src)
/* 13305*/  /*Scope*/ 11, /*->13317*/
/* 13306*/   OPC_CheckChild2Type, MVT::v8i16,
/* 13308*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13310*/   OPC_EmitMergeInputChains1_0,
/* 13311*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v8i16:{ *:[v8i16] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v8i16:{ *:[v8i16] }:$src)
/* 13317*/  /*Scope*/ 11, /*->13329*/
/* 13318*/   OPC_CheckChild2Type, MVT::funcref,
/* 13320*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 13322*/   OPC_EmitMergeInputChains1_0,
/* 13323*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_FUNCREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, funcref:{ *:[funcref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_FUNCREF (timm:{ *:[i32] }):$local, funcref:{ *:[funcref] }:$src)
/* 13329*/  /*Scope*/ 11, /*->13341*/
/* 13330*/   OPC_CheckChild2Type, MVT::externref,
/* 13332*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 13334*/   OPC_EmitMergeInputChains1_0,
/* 13335*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_EXTERNREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, externref:{ *:[externref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_EXTERNREF (timm:{ *:[i32] }):$local, externref:{ *:[externref] }:$src)
/* 13341*/  0, /*End of Scope*/
/* 13342*/ /*SwitchOpcode*/ 2|128,1/*130*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->13476
/* 13346*/  OPC_RecordChild0, // #0 = $addr
/* 13347*/  OPC_MoveChild0,
/* 13348*/  OPC_SwitchOpcode /*3 cases */, 47, TARGET_VAL(ISD::TargetGlobalAddress),// ->13399
/* 13352*/   OPC_MoveParent,
/* 13353*/   OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->13376
/* 13356*/    OPC_Scope, 8, /*->13366*/ // 2 children in Scope
/* 13358*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13360*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 13366*/    /*Scope*/ 8, /*->13375*/
/* 13367*/     OPC_CheckPatternPredicate, 11, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13369*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 13375*/    0, /*End of Scope*/
/* 13376*/   /*SwitchType*/ 20, MVT::i64,// ->13398
/* 13378*/    OPC_Scope, 8, /*->13388*/ // 2 children in Scope
/* 13380*/     OPC_CheckPatternPredicate, 12, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13382*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (CONST_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 13388*/    /*Scope*/ 8, /*->13397*/
/* 13389*/     OPC_CheckPatternPredicate, 13, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13391*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 13397*/    0, /*End of Scope*/
/* 13398*/   0, // EndSwitchType
/* 13399*/  /*SwitchOpcode*/ 23, TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->13425
/* 13402*/   OPC_MoveParent,
/* 13403*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->13414
/* 13406*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 13408*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr)
/* 13414*/   /*SwitchType*/ 8, MVT::i64,// ->13424
/* 13416*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 13418*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr)
/* 13424*/   0, // EndSwitchType
/* 13425*/  /*SwitchOpcode*/ 47, TARGET_VAL(ISD::TargetExternalSymbol),// ->13475
/* 13428*/   OPC_MoveParent,
/* 13429*/   OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->13452
/* 13432*/    OPC_Scope, 8, /*->13442*/ // 2 children in Scope
/* 13434*/     OPC_CheckPatternPredicate, 11, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13436*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 13442*/    /*Scope*/ 8, /*->13451*/
/* 13443*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13445*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (CONST_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 13451*/    0, /*End of Scope*/
/* 13452*/   /*SwitchType*/ 20, MVT::i64,// ->13474
/* 13454*/    OPC_Scope, 8, /*->13464*/ // 2 children in Scope
/* 13456*/     OPC_CheckPatternPredicate, 13, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13458*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 13464*/    /*Scope*/ 8, /*->13473*/
/* 13465*/     OPC_CheckPatternPredicate, 12, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13467*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (CONST_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 13473*/    0, /*End of Scope*/
/* 13474*/   0, // EndSwitchType
/* 13475*/  0, // EndSwitchOpcode
/* 13476*/ /*SwitchOpcode*/ 82, TARGET_VAL(WebAssemblyISD::WrapperREL),// ->13561
/* 13479*/  OPC_RecordChild0, // #0 = $addr
/* 13480*/  OPC_MoveChild0,
/* 13481*/  OPC_SwitchOpcode /*3 cases */, 23, TARGET_VAL(ISD::TargetGlobalAddress),// ->13508
/* 13485*/   OPC_MoveParent,
/* 13486*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->13497
/* 13489*/    OPC_CheckPatternPredicate, 11, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13491*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 13497*/   /*SwitchType*/ 8, MVT::i64,// ->13507
/* 13499*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13501*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 13507*/   0, // EndSwitchType
/* 13508*/  /*SwitchOpcode*/ 23, TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->13534
/* 13511*/   OPC_MoveParent,
/* 13512*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->13523
/* 13515*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 13517*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr)
/* 13523*/   /*SwitchType*/ 8, MVT::i64,// ->13533
/* 13525*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 13527*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr)
/* 13533*/   0, // EndSwitchType
/* 13534*/  /*SwitchOpcode*/ 23, TARGET_VAL(ISD::TargetExternalSymbol),// ->13560
/* 13537*/   OPC_MoveParent,
/* 13538*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->13549
/* 13541*/    OPC_CheckPatternPredicate, 11, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13543*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 13549*/   /*SwitchType*/ 8, MVT::i64,// ->13559
/* 13551*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13553*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 13559*/   0, // EndSwitchType
/* 13560*/  0, // EndSwitchOpcode
/* 13561*/ /*SwitchOpcode*/ 47, TARGET_VAL(WebAssemblyISD::MEMORY_FILL),// ->13611
/* 13564*/  OPC_RecordNode, // #0 = 'wasm_memset' chained node
/* 13565*/  OPC_RecordChild1, // #1 = $idx
/* 13566*/  OPC_MoveChild1,
/* 13567*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 13570*/  OPC_CheckTypeI32,
/* 13571*/  OPC_MoveParent,
/* 13572*/  OPC_RecordChild2, // #2 = $dst
/* 13573*/  OPC_Scope, 17, /*->13592*/ // 2 children in Scope
/* 13575*/   OPC_CheckChild2TypeI32,
/* 13576*/   OPC_RecordChild3, // #3 = $value
/* 13577*/   OPC_CheckChild3TypeI32,
/* 13578*/   OPC_RecordChild4, // #4 = $size
/* 13579*/   OPC_CheckChild4TypeI32,
/* 13580*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasBulkMemory())
/* 13582*/   OPC_EmitMergeInputChains1_0,
/* 13583*/   OPC_EmitConvertToTarget1,
/* 13584*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_7901MEMORY_FILL_A32),
                 4/*#Ops*/, 5, 2, 3, 4, 
             // Src: (wasm_memset (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$value, I32:{ *:[i32] }:$size) - Complexity = 6
             // Dst: (anonymous_7901MEMORY_FILL_A32 (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$value, I32:{ *:[i32] }:$size)
/* 13592*/  /*Scope*/ 17, /*->13610*/
/* 13593*/   OPC_CheckChild2TypeI64,
/* 13594*/   OPC_RecordChild3, // #3 = $value
/* 13595*/   OPC_CheckChild3TypeI32,
/* 13596*/   OPC_RecordChild4, // #4 = $size
/* 13597*/   OPC_CheckChild4TypeI64,
/* 13598*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasBulkMemory())
/* 13600*/   OPC_EmitMergeInputChains1_0,
/* 13601*/   OPC_EmitConvertToTarget1,
/* 13602*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_7902MEMORY_FILL_A64),
                 4/*#Ops*/, 5, 2, 3, 4, 
             // Src: (wasm_memset (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$dst, I32:{ *:[i32] }:$value, I64:{ *:[i64] }:$size) - Complexity = 6
             // Dst: (anonymous_7902MEMORY_FILL_A64 (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$dst, I32:{ *:[i32] }:$value, I64:{ *:[i64] }:$size)
/* 13610*/  0, /*End of Scope*/
/* 13611*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::Constant),// ->13635
/* 13614*/  OPC_RecordNode, // #0 = $imm
/* 13615*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13625
/* 13618*/   OPC_EmitConvertToTarget0,
/* 13619*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                 MVT::i32, 1/*#Ops*/, 1, 
             // Src: (imm:{ *:[i32] }):$imm - Complexity = 3
             // Dst: (CONST_I32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
/* 13625*/  /*SwitchType*/ 7, MVT::i64,// ->13634
/* 13627*/   OPC_EmitConvertToTarget0,
/* 13628*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                 MVT::i64, 1/*#Ops*/, 1, 
             // Src: (imm:{ *:[i64] }):$imm - Complexity = 3
             // Dst: (CONST_I64:{ *:[i64] } (imm:{ *:[i64] }):$imm)
/* 13634*/  0, // EndSwitchType
/* 13635*/ /*SwitchOpcode*/ 13, TARGET_VAL(ISD::BR),// ->13651
/* 13638*/  OPC_RecordNode, // #0 = 'br' chained node
/* 13639*/  OPC_RecordChild1, // #1 = $dst
/* 13640*/  OPC_MoveChild1,
/* 13641*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13644*/  OPC_MoveParent,
/* 13645*/  OPC_EmitMergeInputChains1_0,
/* 13646*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR),
                1/*#Ops*/, 1, 
            // Src: (br (bb:{ *:[Other] }):$dst) - Complexity = 3
            // Dst: (BR (bb:{ *:[Other] }):$dst)
/* 13651*/ /*SwitchOpcode*/ 22, TARGET_VAL(WebAssemblyISD::BR_TABLE),// ->13676
/* 13654*/  OPC_RecordNode, // #0 = 'WebAssemblybr_table' chained node
/* 13655*/  OPC_RecordChild1, // #1 = $index
/* 13656*/  OPC_Scope, 8, /*->13666*/ // 2 children in Scope
/* 13658*/   OPC_CheckChild1TypeI32,
/* 13659*/   OPC_EmitMergeInputChains1_0,
/* 13660*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I32), 0|OPFL_Chain|OPFL_Variadic1,
                 1/*#Ops*/, 1, 
             // Src: (WebAssemblybr_table I32:{ *:[i32] }:$index) - Complexity = 3
             // Dst: (BR_TABLE_I32 I32:{ *:[i32] }:$index)
/* 13666*/  /*Scope*/ 8, /*->13675*/
/* 13667*/   OPC_CheckChild1TypeI64,
/* 13668*/   OPC_EmitMergeInputChains1_0,
/* 13669*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I64), 0|OPFL_Chain|OPFL_Variadic1,
                 1/*#Ops*/, 1, 
             // Src: (WebAssemblybr_table I64:{ *:[i64] }:$index) - Complexity = 3
             // Dst: (BR_TABLE_I64 I64:{ *:[i64] }:$index)
/* 13675*/  0, /*End of Scope*/
/* 13676*/ /*SwitchOpcode*/ 7, TARGET_VAL(WebAssemblyISD::RETURN),// ->13686
/* 13679*/  OPC_RecordNode, // #0 = 'WebAssemblyreturn' chained node
/* 13680*/  OPC_EmitMergeInputChains1_0,
/* 13681*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETURN), 0|OPFL_Chain|OPFL_Variadic0,
                0/*#Ops*/, 
            // Src: (WebAssemblyreturn) - Complexity = 3
            // Dst: (RETURN)
/* 13686*/ /*SwitchOpcode*/ 6, TARGET_VAL(ISD::TRAP),// ->13695
/* 13689*/  OPC_RecordNode, // #0 = 'trap' chained node
/* 13690*/  OPC_EmitMergeInputChains1_0,
/* 13691*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::UNREACHABLE),
                0/*#Ops*/, 
            // Src: (trap) - Complexity = 3
            // Dst: (UNREACHABLE)
/* 13695*/ /*SwitchOpcode*/ 6, TARGET_VAL(ISD::DEBUGTRAP),// ->13704
/* 13698*/  OPC_RecordNode, // #0 = 'debugtrap' chained node
/* 13699*/  OPC_EmitMergeInputChains1_0,
/* 13700*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::DEBUG_UNREACHABLE),
                0/*#Ops*/, 
            // Src: (debugtrap) - Complexity = 3
            // Dst: (DEBUG_UNREACHABLE)
/* 13704*/ /*SwitchOpcode*/ 8, TARGET_VAL(ISD::CLEANUPRET),// ->13715
/* 13707*/  OPC_RecordNode, // #0 = 'cleanupret' chained node
/* 13708*/  OPC_CheckPatternPredicate, 5, // (Subtarget->hasExceptionHandling())
/* 13710*/  OPC_EmitMergeInputChains1_0,
/* 13711*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::CLEANUPRET),
                0/*#Ops*/, 
            // Src: (cleanupret) - Complexity = 3
            // Dst: (CLEANUPRET)
/* 13715*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CATCHRET),// ->13739
/* 13718*/  OPC_RecordNode, // #0 = 'catchret' chained node
/* 13719*/  OPC_RecordChild1, // #1 = $dst
/* 13720*/  OPC_MoveChild1,
/* 13721*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13724*/  OPC_MoveSibling2,
/* 13725*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13728*/  OPC_RecordNode, // #2 = $from
/* 13729*/  OPC_MoveParent,
/* 13730*/  OPC_CheckPatternPredicate, 5, // (Subtarget->hasExceptionHandling())
/* 13732*/  OPC_EmitMergeInputChains1_0,
/* 13733*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::CATCHRET),
                2/*#Ops*/, 1, 2, 
            // Src: (catchret (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from) - Complexity = 3
            // Dst: (CATCHRET (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from)
/* 13739*/ /*SwitchOpcode*/ 66, TARGET_VAL(ISD::ADD),// ->13808
/* 13742*/  OPC_RecordChild0, // #0 = $lhs
/* 13743*/  OPC_RecordChild1, // #1 = $rhs
/* 13744*/  OPC_SwitchType /*6 cases */, 7, MVT::i32,// ->13754
/* 13747*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I32),
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (ADD_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13754*/  /*SwitchType*/ 7, MVT::i64,// ->13763
/* 13756*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I64),
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (ADD_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13763*/  /*SwitchType*/ 9, MVT::v16i8,// ->13774
/* 13765*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13767*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13774*/  /*SwitchType*/ 9, MVT::v8i16,// ->13785
/* 13776*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13778*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13785*/  /*SwitchType*/ 9, MVT::v4i32,// ->13796
/* 13787*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13789*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I32x4),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (ADD_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13796*/  /*SwitchType*/ 9, MVT::v2i64,// ->13807
/* 13798*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13800*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I64x2),
                 MVT::v2i64, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
             // Dst: (ADD_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 13807*/  0, // EndSwitchType
/* 13808*/ /*SwitchOpcode*/ 121, TARGET_VAL(ISD::SUB),// ->13932
/* 13811*/  OPC_Scope, 22, /*->13835*/ // 3 children in Scope
/* 13813*/   OPC_RecordChild0, // #0 = $lhs
/* 13814*/   OPC_RecordChild1, // #1 = $rhs
/* 13815*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13825
/* 13818*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SUB_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13825*/   /*SwitchType*/ 7, MVT::i64,// ->13834
/* 13827*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SUB_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13834*/   0, // EndSwitchType
/* 13835*/  /*Scope*/ 46, /*->13882*/
/* 13836*/   OPC_MoveChild0,
/* 13837*/   OPC_CheckImmAllZerosV,
/* 13838*/   OPC_MoveParent,
/* 13839*/   OPC_RecordChild1, // #0 = $v
/* 13840*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->13851
/* 13843*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13845*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I8x16),
                  MVT::v16i8, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$v) - Complexity = 7
              // Dst: (NEG_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 13851*/   /*SwitchType*/ 8, MVT::v8i16,// ->13861
/* 13853*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13855*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I16x8),
                  MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$v) - Complexity = 7
              // Dst: (NEG_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$v)
/* 13861*/   /*SwitchType*/ 8, MVT::v4i32,// ->13871
/* 13863*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13865*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I32x4),
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$v) - Complexity = 7
              // Dst: (NEG_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$v)
/* 13871*/   /*SwitchType*/ 8, MVT::v2i64,// ->13881
/* 13873*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13875*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I64x2),
                  MVT::v2i64, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$v) - Complexity = 7
              // Dst: (NEG_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$v)
/* 13881*/   0, // EndSwitchType
/* 13882*/  /*Scope*/ 48, /*->13931*/
/* 13883*/   OPC_RecordChild0, // #0 = $lhs
/* 13884*/   OPC_RecordChild1, // #1 = $rhs
/* 13885*/   OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->13897
/* 13888*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13890*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (SUB_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13897*/   /*SwitchType*/ 9, MVT::v8i16,// ->13908
/* 13899*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13901*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (SUB_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13908*/   /*SwitchType*/ 9, MVT::v4i32,// ->13919
/* 13910*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13912*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (SUB_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13919*/   /*SwitchType*/ 9, MVT::v2i64,// ->13930
/* 13921*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13923*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (SUB_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 13930*/   0, // EndSwitchType
/* 13931*/  0, /*End of Scope*/
/* 13932*/ /*SwitchOpcode*/ 100|128,2/*356*/, TARGET_VAL(ISD::MUL),// ->14292
/* 13936*/  OPC_Scope, 22, /*->13960*/ // 3 children in Scope
/* 13938*/   OPC_RecordChild0, // #0 = $lhs
/* 13939*/   OPC_RecordChild1, // #1 = $rhs
/* 13940*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->13950
/* 13943*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (MUL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13950*/   /*SwitchType*/ 7, MVT::i64,// ->13959
/* 13952*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (MUL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13959*/   0, // EndSwitchType
/* 13960*/  /*Scope*/ 35|128,2/*291*/, /*->14253*/
/* 13962*/   OPC_MoveChild0,
/* 13963*/   OPC_SwitchOpcode /*4 cases */, 69, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),// ->14036
/* 13967*/    OPC_RecordChild0, // #0 = $lhs
/* 13968*/    OPC_Scope, 21, /*->13991*/ // 3 children in Scope
/* 13970*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13972*/     OPC_MoveSibling1,
/* 13973*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 13976*/     OPC_RecordChild0, // #1 = $rhs
/* 13977*/     OPC_CheckChild0Type, MVT::v16i8,
/* 13979*/     OPC_MoveParent,
/* 13980*/     OPC_CheckType, MVT::v8i16,
/* 13982*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13984*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13991*/    /*Scope*/ 21, /*->14013*/
/* 13992*/     OPC_CheckChild0Type, MVT::v8i16,
/* 13994*/     OPC_MoveSibling1,
/* 13995*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 13998*/     OPC_RecordChild0, // #1 = $rhs
/* 13999*/     OPC_CheckChild0Type, MVT::v8i16,
/* 14001*/     OPC_MoveParent,
/* 14002*/     OPC_CheckType, MVT::v4i32,
/* 14004*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14006*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 14013*/    /*Scope*/ 21, /*->14035*/
/* 14014*/     OPC_CheckChild0Type, MVT::v4i32,
/* 14016*/     OPC_MoveSibling1,
/* 14017*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 14020*/     OPC_RecordChild0, // #1 = $rhs
/* 14021*/     OPC_CheckChild0Type, MVT::v4i32,
/* 14023*/     OPC_MoveParent,
/* 14024*/     OPC_CheckType, MVT::v2i64,
/* 14026*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14028*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 14035*/    0, /*End of Scope*/
/* 14036*/   /*SwitchOpcode*/ 69, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),// ->14108
/* 14039*/    OPC_RecordChild0, // #0 = $lhs
/* 14040*/    OPC_Scope, 21, /*->14063*/ // 3 children in Scope
/* 14042*/     OPC_CheckChild0Type, MVT::v16i8,
/* 14044*/     OPC_MoveSibling1,
/* 14045*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 14048*/     OPC_RecordChild0, // #1 = $rhs
/* 14049*/     OPC_CheckChild0Type, MVT::v16i8,
/* 14051*/     OPC_MoveParent,
/* 14052*/     OPC_CheckType, MVT::v8i16,
/* 14054*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14056*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 14063*/    /*Scope*/ 21, /*->14085*/
/* 14064*/     OPC_CheckChild0Type, MVT::v8i16,
/* 14066*/     OPC_MoveSibling1,
/* 14067*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 14070*/     OPC_RecordChild0, // #1 = $rhs
/* 14071*/     OPC_CheckChild0Type, MVT::v8i16,
/* 14073*/     OPC_MoveParent,
/* 14074*/     OPC_CheckType, MVT::v4i32,
/* 14076*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14078*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 14085*/    /*Scope*/ 21, /*->14107*/
/* 14086*/     OPC_CheckChild0Type, MVT::v4i32,
/* 14088*/     OPC_MoveSibling1,
/* 14089*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 14092*/     OPC_RecordChild0, // #1 = $rhs
/* 14093*/     OPC_CheckChild0Type, MVT::v4i32,
/* 14095*/     OPC_MoveParent,
/* 14096*/     OPC_CheckType, MVT::v2i64,
/* 14098*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14100*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 14107*/    0, /*End of Scope*/
/* 14108*/   /*SwitchOpcode*/ 69, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),// ->14180
/* 14111*/    OPC_RecordChild0, // #0 = $lhs
/* 14112*/    OPC_Scope, 21, /*->14135*/ // 3 children in Scope
/* 14114*/     OPC_CheckChild0Type, MVT::v16i8,
/* 14116*/     OPC_MoveSibling1,
/* 14117*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 14120*/     OPC_RecordChild0, // #1 = $rhs
/* 14121*/     OPC_CheckChild0Type, MVT::v16i8,
/* 14123*/     OPC_MoveParent,
/* 14124*/     OPC_CheckType, MVT::v8i16,
/* 14126*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14128*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 14135*/    /*Scope*/ 21, /*->14157*/
/* 14136*/     OPC_CheckChild0Type, MVT::v8i16,
/* 14138*/     OPC_MoveSibling1,
/* 14139*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 14142*/     OPC_RecordChild0, // #1 = $rhs
/* 14143*/     OPC_CheckChild0Type, MVT::v8i16,
/* 14145*/     OPC_MoveParent,
/* 14146*/     OPC_CheckType, MVT::v4i32,
/* 14148*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14150*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 14157*/    /*Scope*/ 21, /*->14179*/
/* 14158*/     OPC_CheckChild0Type, MVT::v4i32,
/* 14160*/     OPC_MoveSibling1,
/* 14161*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 14164*/     OPC_RecordChild0, // #1 = $rhs
/* 14165*/     OPC_CheckChild0Type, MVT::v4i32,
/* 14167*/     OPC_MoveParent,
/* 14168*/     OPC_CheckType, MVT::v2i64,
/* 14170*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14172*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 14179*/    0, /*End of Scope*/
/* 14180*/   /*SwitchOpcode*/ 69, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),// ->14252
/* 14183*/    OPC_RecordChild0, // #0 = $lhs
/* 14184*/    OPC_Scope, 21, /*->14207*/ // 3 children in Scope
/* 14186*/     OPC_CheckChild0Type, MVT::v16i8,
/* 14188*/     OPC_MoveSibling1,
/* 14189*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 14192*/     OPC_RecordChild0, // #1 = $rhs
/* 14193*/     OPC_CheckChild0Type, MVT::v16i8,
/* 14195*/     OPC_MoveParent,
/* 14196*/     OPC_CheckType, MVT::v8i16,
/* 14198*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14200*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 14207*/    /*Scope*/ 21, /*->14229*/
/* 14208*/     OPC_CheckChild0Type, MVT::v8i16,
/* 14210*/     OPC_MoveSibling1,
/* 14211*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 14214*/     OPC_RecordChild0, // #1 = $rhs
/* 14215*/     OPC_CheckChild0Type, MVT::v8i16,
/* 14217*/     OPC_MoveParent,
/* 14218*/     OPC_CheckType, MVT::v4i32,
/* 14220*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14222*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 14229*/    /*Scope*/ 21, /*->14251*/
/* 14230*/     OPC_CheckChild0Type, MVT::v4i32,
/* 14232*/     OPC_MoveSibling1,
/* 14233*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 14236*/     OPC_RecordChild0, // #1 = $rhs
/* 14237*/     OPC_CheckChild0Type, MVT::v4i32,
/* 14239*/     OPC_MoveParent,
/* 14240*/     OPC_CheckType, MVT::v2i64,
/* 14242*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14244*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 14251*/    0, /*End of Scope*/
/* 14252*/   0, // EndSwitchOpcode
/* 14253*/  /*Scope*/ 37, /*->14291*/
/* 14254*/   OPC_RecordChild0, // #0 = $lhs
/* 14255*/   OPC_RecordChild1, // #1 = $rhs
/* 14256*/   OPC_SwitchType /*3 cases */, 9, MVT::v8i16,// ->14268
/* 14259*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14261*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (MUL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 14268*/   /*SwitchType*/ 9, MVT::v4i32,// ->14279
/* 14270*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14272*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (MUL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 14279*/   /*SwitchType*/ 9, MVT::v2i64,// ->14290
/* 14281*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14283*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (MUL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 14290*/   0, // EndSwitchType
/* 14291*/  0, /*End of Scope*/
/* 14292*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::SDIV),// ->14317
/* 14295*/  OPC_RecordChild0, // #0 = $lhs
/* 14296*/  OPC_RecordChild1, // #1 = $rhs
/* 14297*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->14307
/* 14300*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_S_I32),
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (sdiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (DIV_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14307*/  /*SwitchType*/ 7, MVT::i64,// ->14316
/* 14309*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_S_I64),
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (sdiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (DIV_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14316*/  0, // EndSwitchType
/* 14317*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::UDIV),// ->14342
/* 14320*/  OPC_RecordChild0, // #0 = $lhs
/* 14321*/  OPC_RecordChild1, // #1 = $rhs
/* 14322*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->14332
/* 14325*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_U_I32),
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (udiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (DIV_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14332*/  /*SwitchType*/ 7, MVT::i64,// ->14341
/* 14334*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_U_I64),
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (udiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (DIV_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14341*/  0, // EndSwitchType
/* 14342*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::SREM),// ->14367
/* 14345*/  OPC_RecordChild0, // #0 = $lhs
/* 14346*/  OPC_RecordChild1, // #1 = $rhs
/* 14347*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->14357
/* 14350*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_S_I32),
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (srem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (REM_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14357*/  /*SwitchType*/ 7, MVT::i64,// ->14366
/* 14359*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_S_I64),
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (srem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (REM_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14366*/  0, // EndSwitchType
/* 14367*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::UREM),// ->14392
/* 14370*/  OPC_RecordChild0, // #0 = $lhs
/* 14371*/  OPC_RecordChild1, // #1 = $rhs
/* 14372*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->14382
/* 14375*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_U_I32),
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (urem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (REM_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14382*/  /*SwitchType*/ 7, MVT::i64,// ->14391
/* 14384*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_U_I64),
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (urem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (REM_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14391*/  0, // EndSwitchType
/* 14392*/ /*SwitchOpcode*/ 56|128,6/*824*/, TARGET_VAL(ISD::OR),// ->15220
/* 14396*/  OPC_Scope, 22, /*->14420*/ // 3 children in Scope
/* 14398*/   OPC_RecordChild0, // #0 = $lhs
/* 14399*/   OPC_RecordChild1, // #1 = $rhs
/* 14400*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->14410
/* 14403*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (OR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14410*/   /*SwitchType*/ 7, MVT::i64,// ->14419
/* 14412*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (OR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14419*/   0, // EndSwitchType
/* 14420*/  /*Scope*/ 116|128,5/*756*/, /*->15178*/
/* 14422*/   OPC_MoveChild0,
/* 14423*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14426*/   OPC_Scope, 4|128,1/*132*/, /*->14561*/ // 9 children in Scope
/* 14429*/    OPC_RecordChild0, // #0 = $c
/* 14430*/    OPC_RecordChild1, // #1 = $v1
/* 14431*/    OPC_MoveSibling1,
/* 14432*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14435*/    OPC_Scope, 54, /*->14491*/ // 4 children in Scope
/* 14437*/     OPC_MoveChild0,
/* 14438*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14441*/     OPC_CheckChild0Same, 0,
/* 14443*/     OPC_MoveChild1,
/* 14444*/     OPC_CheckImmAllOnesV,
/* 14445*/     OPC_MoveParent,
/* 14446*/     OPC_MoveParent,
/* 14447*/     OPC_RecordChild1, // #2 = $v2
/* 14448*/     OPC_MoveParent,
/* 14449*/     OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->14460
/* 14452*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14460*/     /*SwitchType*/ 8, MVT::v8i16,// ->14470
/* 14462*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14470*/     /*SwitchType*/ 8, MVT::v4i32,// ->14480
/* 14472*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14480*/     /*SwitchType*/ 8, MVT::v2i64,// ->14490
/* 14482*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14490*/     0, // EndSwitchType
/* 14491*/    /*Scope*/ 22, /*->14514*/
/* 14492*/     OPC_RecordChild0, // #2 = $v2
/* 14493*/     OPC_MoveChild1,
/* 14494*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14497*/     OPC_CheckChild0Same, 0,
/* 14499*/     OPC_MoveChild1,
/* 14500*/     OPC_CheckImmAllOnesV,
/* 14501*/     OPC_MoveParent,
/* 14502*/     OPC_MoveParent,
/* 14503*/     OPC_MoveParent,
/* 14504*/     OPC_CheckType, MVT::v16i8,
/* 14506*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14514*/    /*Scope*/ 22, /*->14537*/
/* 14515*/     OPC_MoveChild0,
/* 14516*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14519*/     OPC_CheckChild0Same, 1,
/* 14521*/     OPC_MoveChild1,
/* 14522*/     OPC_CheckImmAllOnesV,
/* 14523*/     OPC_MoveParent,
/* 14524*/     OPC_MoveParent,
/* 14525*/     OPC_RecordChild1, // #2 = $v2
/* 14526*/     OPC_MoveParent,
/* 14527*/     OPC_CheckType, MVT::v16i8,
/* 14529*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14537*/    /*Scope*/ 22, /*->14560*/
/* 14538*/     OPC_RecordChild0, // #2 = $v2
/* 14539*/     OPC_MoveChild1,
/* 14540*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14543*/     OPC_CheckChild0Same, 1,
/* 14545*/     OPC_MoveChild1,
/* 14546*/     OPC_CheckImmAllOnesV,
/* 14547*/     OPC_MoveParent,
/* 14548*/     OPC_MoveParent,
/* 14549*/     OPC_MoveParent,
/* 14550*/     OPC_CheckType, MVT::v16i8,
/* 14552*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14560*/    0, /*End of Scope*/
/* 14561*/   /*Scope*/ 46, /*->14608*/
/* 14562*/    OPC_MoveChild0,
/* 14563*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14566*/    OPC_RecordChild0, // #0 = $c
/* 14567*/    OPC_MoveChild1,
/* 14568*/    OPC_CheckImmAllOnesV,
/* 14569*/    OPC_MoveParent,
/* 14570*/    OPC_MoveParent,
/* 14571*/    OPC_RecordChild1, // #1 = $v2
/* 14572*/    OPC_MoveSibling1,
/* 14573*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14576*/    OPC_Scope, 14, /*->14592*/ // 2 children in Scope
/* 14578*/     OPC_CheckChild0Same, 0,
/* 14580*/     OPC_RecordChild1, // #2 = $v1
/* 14581*/     OPC_MoveParent,
/* 14582*/     OPC_CheckType, MVT::v16i8,
/* 14584*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14592*/    /*Scope*/ 14, /*->14607*/
/* 14593*/     OPC_RecordChild0, // #2 = $v1
/* 14594*/     OPC_CheckChild1Same, 0,
/* 14596*/     OPC_MoveParent,
/* 14597*/     OPC_CheckType, MVT::v16i8,
/* 14599*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14607*/    0, /*End of Scope*/
/* 14608*/   /*Scope*/ 126, /*->14735*/
/* 14609*/    OPC_RecordChild0, // #0 = $v2
/* 14610*/    OPC_Scope, 45, /*->14657*/ // 2 children in Scope
/* 14612*/     OPC_MoveChild1,
/* 14613*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14616*/     OPC_RecordChild0, // #1 = $c
/* 14617*/     OPC_MoveChild1,
/* 14618*/     OPC_CheckImmAllOnesV,
/* 14619*/     OPC_MoveParent,
/* 14620*/     OPC_MoveParent,
/* 14621*/     OPC_MoveSibling1,
/* 14622*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14625*/     OPC_Scope, 14, /*->14641*/ // 2 children in Scope
/* 14627*/      OPC_CheckChild0Same, 1,
/* 14629*/      OPC_RecordChild1, // #2 = $v1
/* 14630*/      OPC_MoveParent,
/* 14631*/      OPC_CheckType, MVT::v16i8,
/* 14633*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14641*/     /*Scope*/ 14, /*->14656*/
/* 14642*/      OPC_RecordChild0, // #2 = $v1
/* 14643*/      OPC_CheckChild1Same, 1,
/* 14645*/      OPC_MoveParent,
/* 14646*/      OPC_CheckType, MVT::v16i8,
/* 14648*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14656*/     0, /*End of Scope*/
/* 14657*/    /*Scope*/ 76, /*->14734*/
/* 14658*/     OPC_RecordChild1, // #1 = $v1
/* 14659*/     OPC_MoveSibling1,
/* 14660*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14663*/     OPC_Scope, 22, /*->14687*/ // 3 children in Scope
/* 14665*/      OPC_RecordChild0, // #2 = $v2
/* 14666*/      OPC_MoveChild1,
/* 14667*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14670*/      OPC_CheckChild0Same, 0,
/* 14672*/      OPC_MoveChild1,
/* 14673*/      OPC_CheckImmAllOnesV,
/* 14674*/      OPC_MoveParent,
/* 14675*/      OPC_MoveParent,
/* 14676*/      OPC_MoveParent,
/* 14677*/      OPC_CheckType, MVT::v8i16,
/* 14679*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14687*/     /*Scope*/ 22, /*->14710*/
/* 14688*/      OPC_MoveChild0,
/* 14689*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14692*/      OPC_CheckChild0Same, 1,
/* 14694*/      OPC_MoveChild1,
/* 14695*/      OPC_CheckImmAllOnesV,
/* 14696*/      OPC_MoveParent,
/* 14697*/      OPC_MoveParent,
/* 14698*/      OPC_RecordChild1, // #2 = $v2
/* 14699*/      OPC_MoveParent,
/* 14700*/      OPC_CheckType, MVT::v8i16,
/* 14702*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14710*/     /*Scope*/ 22, /*->14733*/
/* 14711*/      OPC_RecordChild0, // #2 = $v2
/* 14712*/      OPC_MoveChild1,
/* 14713*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14716*/      OPC_CheckChild0Same, 1,
/* 14718*/      OPC_MoveChild1,
/* 14719*/      OPC_CheckImmAllOnesV,
/* 14720*/      OPC_MoveParent,
/* 14721*/      OPC_MoveParent,
/* 14722*/      OPC_MoveParent,
/* 14723*/      OPC_CheckType, MVT::v8i16,
/* 14725*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14733*/     0, /*End of Scope*/
/* 14734*/    0, /*End of Scope*/
/* 14735*/   /*Scope*/ 46, /*->14782*/
/* 14736*/    OPC_MoveChild0,
/* 14737*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14740*/    OPC_RecordChild0, // #0 = $c
/* 14741*/    OPC_MoveChild1,
/* 14742*/    OPC_CheckImmAllOnesV,
/* 14743*/    OPC_MoveParent,
/* 14744*/    OPC_MoveParent,
/* 14745*/    OPC_RecordChild1, // #1 = $v2
/* 14746*/    OPC_MoveSibling1,
/* 14747*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14750*/    OPC_Scope, 14, /*->14766*/ // 2 children in Scope
/* 14752*/     OPC_CheckChild0Same, 0,
/* 14754*/     OPC_RecordChild1, // #2 = $v1
/* 14755*/     OPC_MoveParent,
/* 14756*/     OPC_CheckType, MVT::v8i16,
/* 14758*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14766*/    /*Scope*/ 14, /*->14781*/
/* 14767*/     OPC_RecordChild0, // #2 = $v1
/* 14768*/     OPC_CheckChild1Same, 0,
/* 14770*/     OPC_MoveParent,
/* 14771*/     OPC_CheckType, MVT::v8i16,
/* 14773*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14781*/    0, /*End of Scope*/
/* 14782*/   /*Scope*/ 126, /*->14909*/
/* 14783*/    OPC_RecordChild0, // #0 = $v2
/* 14784*/    OPC_Scope, 45, /*->14831*/ // 2 children in Scope
/* 14786*/     OPC_MoveChild1,
/* 14787*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14790*/     OPC_RecordChild0, // #1 = $c
/* 14791*/     OPC_MoveChild1,
/* 14792*/     OPC_CheckImmAllOnesV,
/* 14793*/     OPC_MoveParent,
/* 14794*/     OPC_MoveParent,
/* 14795*/     OPC_MoveSibling1,
/* 14796*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14799*/     OPC_Scope, 14, /*->14815*/ // 2 children in Scope
/* 14801*/      OPC_CheckChild0Same, 1,
/* 14803*/      OPC_RecordChild1, // #2 = $v1
/* 14804*/      OPC_MoveParent,
/* 14805*/      OPC_CheckType, MVT::v8i16,
/* 14807*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14815*/     /*Scope*/ 14, /*->14830*/
/* 14816*/      OPC_RecordChild0, // #2 = $v1
/* 14817*/      OPC_CheckChild1Same, 1,
/* 14819*/      OPC_MoveParent,
/* 14820*/      OPC_CheckType, MVT::v8i16,
/* 14822*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14830*/     0, /*End of Scope*/
/* 14831*/    /*Scope*/ 76, /*->14908*/
/* 14832*/     OPC_RecordChild1, // #1 = $v1
/* 14833*/     OPC_MoveSibling1,
/* 14834*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14837*/     OPC_Scope, 22, /*->14861*/ // 3 children in Scope
/* 14839*/      OPC_RecordChild0, // #2 = $v2
/* 14840*/      OPC_MoveChild1,
/* 14841*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14844*/      OPC_CheckChild0Same, 0,
/* 14846*/      OPC_MoveChild1,
/* 14847*/      OPC_CheckImmAllOnesV,
/* 14848*/      OPC_MoveParent,
/* 14849*/      OPC_MoveParent,
/* 14850*/      OPC_MoveParent,
/* 14851*/      OPC_CheckType, MVT::v4i32,
/* 14853*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14861*/     /*Scope*/ 22, /*->14884*/
/* 14862*/      OPC_MoveChild0,
/* 14863*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14866*/      OPC_CheckChild0Same, 1,
/* 14868*/      OPC_MoveChild1,
/* 14869*/      OPC_CheckImmAllOnesV,
/* 14870*/      OPC_MoveParent,
/* 14871*/      OPC_MoveParent,
/* 14872*/      OPC_RecordChild1, // #2 = $v2
/* 14873*/      OPC_MoveParent,
/* 14874*/      OPC_CheckType, MVT::v4i32,
/* 14876*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14884*/     /*Scope*/ 22, /*->14907*/
/* 14885*/      OPC_RecordChild0, // #2 = $v2
/* 14886*/      OPC_MoveChild1,
/* 14887*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14890*/      OPC_CheckChild0Same, 1,
/* 14892*/      OPC_MoveChild1,
/* 14893*/      OPC_CheckImmAllOnesV,
/* 14894*/      OPC_MoveParent,
/* 14895*/      OPC_MoveParent,
/* 14896*/      OPC_MoveParent,
/* 14897*/      OPC_CheckType, MVT::v4i32,
/* 14899*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14907*/     0, /*End of Scope*/
/* 14908*/    0, /*End of Scope*/
/* 14909*/   /*Scope*/ 46, /*->14956*/
/* 14910*/    OPC_MoveChild0,
/* 14911*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14914*/    OPC_RecordChild0, // #0 = $c
/* 14915*/    OPC_MoveChild1,
/* 14916*/    OPC_CheckImmAllOnesV,
/* 14917*/    OPC_MoveParent,
/* 14918*/    OPC_MoveParent,
/* 14919*/    OPC_RecordChild1, // #1 = $v2
/* 14920*/    OPC_MoveSibling1,
/* 14921*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14924*/    OPC_Scope, 14, /*->14940*/ // 2 children in Scope
/* 14926*/     OPC_CheckChild0Same, 0,
/* 14928*/     OPC_RecordChild1, // #2 = $v1
/* 14929*/     OPC_MoveParent,
/* 14930*/     OPC_CheckType, MVT::v4i32,
/* 14932*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14940*/    /*Scope*/ 14, /*->14955*/
/* 14941*/     OPC_RecordChild0, // #2 = $v1
/* 14942*/     OPC_CheckChild1Same, 0,
/* 14944*/     OPC_MoveParent,
/* 14945*/     OPC_CheckType, MVT::v4i32,
/* 14947*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14955*/    0, /*End of Scope*/
/* 14956*/   /*Scope*/ 126, /*->15083*/
/* 14957*/    OPC_RecordChild0, // #0 = $v2
/* 14958*/    OPC_Scope, 45, /*->15005*/ // 2 children in Scope
/* 14960*/     OPC_MoveChild1,
/* 14961*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14964*/     OPC_RecordChild0, // #1 = $c
/* 14965*/     OPC_MoveChild1,
/* 14966*/     OPC_CheckImmAllOnesV,
/* 14967*/     OPC_MoveParent,
/* 14968*/     OPC_MoveParent,
/* 14969*/     OPC_MoveSibling1,
/* 14970*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14973*/     OPC_Scope, 14, /*->14989*/ // 2 children in Scope
/* 14975*/      OPC_CheckChild0Same, 1,
/* 14977*/      OPC_RecordChild1, // #2 = $v1
/* 14978*/      OPC_MoveParent,
/* 14979*/      OPC_CheckType, MVT::v4i32,
/* 14981*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14989*/     /*Scope*/ 14, /*->15004*/
/* 14990*/      OPC_RecordChild0, // #2 = $v1
/* 14991*/      OPC_CheckChild1Same, 1,
/* 14993*/      OPC_MoveParent,
/* 14994*/      OPC_CheckType, MVT::v4i32,
/* 14996*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15004*/     0, /*End of Scope*/
/* 15005*/    /*Scope*/ 76, /*->15082*/
/* 15006*/     OPC_RecordChild1, // #1 = $v1
/* 15007*/     OPC_MoveSibling1,
/* 15008*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15011*/     OPC_Scope, 22, /*->15035*/ // 3 children in Scope
/* 15013*/      OPC_RecordChild0, // #2 = $v2
/* 15014*/      OPC_MoveChild1,
/* 15015*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15018*/      OPC_CheckChild0Same, 0,
/* 15020*/      OPC_MoveChild1,
/* 15021*/      OPC_CheckImmAllOnesV,
/* 15022*/      OPC_MoveParent,
/* 15023*/      OPC_MoveParent,
/* 15024*/      OPC_MoveParent,
/* 15025*/      OPC_CheckType, MVT::v2i64,
/* 15027*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 15035*/     /*Scope*/ 22, /*->15058*/
/* 15036*/      OPC_MoveChild0,
/* 15037*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15040*/      OPC_CheckChild0Same, 1,
/* 15042*/      OPC_MoveChild1,
/* 15043*/      OPC_CheckImmAllOnesV,
/* 15044*/      OPC_MoveParent,
/* 15045*/      OPC_MoveParent,
/* 15046*/      OPC_RecordChild1, // #2 = $v2
/* 15047*/      OPC_MoveParent,
/* 15048*/      OPC_CheckType, MVT::v2i64,
/* 15050*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 15058*/     /*Scope*/ 22, /*->15081*/
/* 15059*/      OPC_RecordChild0, // #2 = $v2
/* 15060*/      OPC_MoveChild1,
/* 15061*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15064*/      OPC_CheckChild0Same, 1,
/* 15066*/      OPC_MoveChild1,
/* 15067*/      OPC_CheckImmAllOnesV,
/* 15068*/      OPC_MoveParent,
/* 15069*/      OPC_MoveParent,
/* 15070*/      OPC_MoveParent,
/* 15071*/      OPC_CheckType, MVT::v2i64,
/* 15073*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 15081*/     0, /*End of Scope*/
/* 15082*/    0, /*End of Scope*/
/* 15083*/   /*Scope*/ 46, /*->15130*/
/* 15084*/    OPC_MoveChild0,
/* 15085*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15088*/    OPC_RecordChild0, // #0 = $c
/* 15089*/    OPC_MoveChild1,
/* 15090*/    OPC_CheckImmAllOnesV,
/* 15091*/    OPC_MoveParent,
/* 15092*/    OPC_MoveParent,
/* 15093*/    OPC_RecordChild1, // #1 = $v2
/* 15094*/    OPC_MoveSibling1,
/* 15095*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15098*/    OPC_Scope, 14, /*->15114*/ // 2 children in Scope
/* 15100*/     OPC_CheckChild0Same, 0,
/* 15102*/     OPC_RecordChild1, // #2 = $v1
/* 15103*/     OPC_MoveParent,
/* 15104*/     OPC_CheckType, MVT::v2i64,
/* 15106*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 15114*/    /*Scope*/ 14, /*->15129*/
/* 15115*/     OPC_RecordChild0, // #2 = $v1
/* 15116*/     OPC_CheckChild1Same, 0,
/* 15118*/     OPC_MoveParent,
/* 15119*/     OPC_CheckType, MVT::v2i64,
/* 15121*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 15129*/    0, /*End of Scope*/
/* 15130*/   /*Scope*/ 46, /*->15177*/
/* 15131*/    OPC_RecordChild0, // #0 = $v2
/* 15132*/    OPC_MoveChild1,
/* 15133*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15136*/    OPC_RecordChild0, // #1 = $c
/* 15137*/    OPC_MoveChild1,
/* 15138*/    OPC_CheckImmAllOnesV,
/* 15139*/    OPC_MoveParent,
/* 15140*/    OPC_MoveParent,
/* 15141*/    OPC_MoveSibling1,
/* 15142*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15145*/    OPC_Scope, 14, /*->15161*/ // 2 children in Scope
/* 15147*/     OPC_CheckChild0Same, 1,
/* 15149*/     OPC_RecordChild1, // #2 = $v1
/* 15150*/     OPC_MoveParent,
/* 15151*/     OPC_CheckType, MVT::v2i64,
/* 15153*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 15161*/    /*Scope*/ 14, /*->15176*/
/* 15162*/     OPC_RecordChild0, // #2 = $v1
/* 15163*/     OPC_CheckChild1Same, 1,
/* 15165*/     OPC_MoveParent,
/* 15166*/     OPC_CheckType, MVT::v2i64,
/* 15168*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 15176*/    0, /*End of Scope*/
/* 15177*/   0, /*End of Scope*/
/* 15178*/  /*Scope*/ 40, /*->15219*/
/* 15179*/   OPC_RecordChild0, // #0 = $lhs
/* 15180*/   OPC_RecordChild1, // #1 = $rhs
/* 15181*/   OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->15191
/* 15184*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 15191*/   /*SwitchType*/ 7, MVT::v8i16,// ->15200
/* 15193*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 15200*/   /*SwitchType*/ 7, MVT::v4i32,// ->15209
/* 15202*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 15209*/   /*SwitchType*/ 7, MVT::v2i64,// ->15218
/* 15211*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 15218*/   0, // EndSwitchType
/* 15219*/  0, /*End of Scope*/
/* 15220*/ /*SwitchOpcode*/ 121|128,11/*1529*/, TARGET_VAL(ISD::XOR),// ->16753
/* 15224*/  OPC_Scope, 22, /*->15248*/ // 17 children in Scope
/* 15226*/   OPC_RecordChild0, // #0 = $lhs
/* 15227*/   OPC_RecordChild1, // #1 = $rhs
/* 15228*/   OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->15238
/* 15231*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR_I32),
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (XOR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 15238*/   /*SwitchType*/ 7, MVT::i64,// ->15247
/* 15240*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR_I64),
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (XOR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 15247*/   0, // EndSwitchType
/* 15248*/  /*Scope*/ 121, /*->15370*/
/* 15249*/   OPC_MoveChild0,
/* 15250*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15253*/   OPC_MoveChild0,
/* 15254*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15257*/   OPC_RecordChild0, // #0 = $v1
/* 15258*/   OPC_Scope, 71, /*->15331*/ // 2 children in Scope
/* 15260*/    OPC_RecordChild1, // #1 = $v2
/* 15261*/    OPC_MoveSibling1,
/* 15262*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15265*/    OPC_RecordChild0, // #2 = $c
/* 15266*/    OPC_MoveChild1,
/* 15267*/    OPC_CheckImmAllOnesV,
/* 15268*/    OPC_MoveParent,
/* 15269*/    OPC_MoveParent,
/* 15270*/    OPC_MoveParent,
/* 15271*/    OPC_Scope, 44, /*->15317*/ // 2 children in Scope
/* 15273*/     OPC_CheckChild1Same, 1,
/* 15275*/     OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->15286
/* 15278*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15286*/     /*SwitchType*/ 8, MVT::v8i16,// ->15296
/* 15288*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15296*/     /*SwitchType*/ 8, MVT::v4i32,// ->15306
/* 15298*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15306*/     /*SwitchType*/ 8, MVT::v2i64,// ->15316
/* 15308*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15316*/     0, // EndSwitchType
/* 15317*/    /*Scope*/ 12, /*->15330*/
/* 15318*/     OPC_CheckChild1Same, 0,
/* 15320*/     OPC_CheckType, MVT::v16i8,
/* 15322*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15330*/    0, /*End of Scope*/
/* 15331*/   /*Scope*/ 37, /*->15369*/
/* 15332*/    OPC_MoveChild1,
/* 15333*/    OPC_CheckImmAllOnesV,
/* 15334*/    OPC_MoveParent,
/* 15335*/    OPC_MoveSibling1,
/* 15336*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15339*/    OPC_RecordChild0, // #1 = $v1
/* 15340*/    OPC_RecordChild1, // #2 = $v2
/* 15341*/    OPC_MoveParent,
/* 15342*/    OPC_MoveParent,
/* 15343*/    OPC_CheckType, MVT::v16i8,
/* 15345*/    OPC_Scope, 10, /*->15357*/ // 2 children in Scope
/* 15347*/     OPC_CheckChild1Same, 2,
/* 15349*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2)), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15357*/    /*Scope*/ 10, /*->15368*/
/* 15358*/     OPC_CheckChild1Same, 1,
/* 15360*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1)), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15368*/    0, /*End of Scope*/
/* 15369*/   0, /*End of Scope*/
/* 15370*/  /*Scope*/ 102, /*->15473*/
/* 15371*/   OPC_RecordChild0, // #0 = $v2
/* 15372*/   OPC_MoveChild1,
/* 15373*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15376*/   OPC_MoveChild0,
/* 15377*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15380*/   OPC_Scope, 23, /*->15405*/ // 3 children in Scope
/* 15382*/    OPC_RecordChild0, // #1 = $v1
/* 15383*/    OPC_CheckChild1Same, 0,
/* 15385*/    OPC_MoveSibling1,
/* 15386*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15389*/    OPC_RecordChild0, // #2 = $c
/* 15390*/    OPC_MoveChild1,
/* 15391*/    OPC_CheckImmAllOnesV,
/* 15392*/    OPC_MoveParent,
/* 15393*/    OPC_MoveParent,
/* 15394*/    OPC_MoveParent,
/* 15395*/    OPC_CheckType, MVT::v16i8,
/* 15397*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15405*/   /*Scope*/ 23, /*->15429*/
/* 15406*/    OPC_CheckChild0Same, 0,
/* 15408*/    OPC_RecordChild1, // #1 = $v1
/* 15409*/    OPC_MoveSibling1,
/* 15410*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15413*/    OPC_RecordChild0, // #2 = $c
/* 15414*/    OPC_MoveChild1,
/* 15415*/    OPC_CheckImmAllOnesV,
/* 15416*/    OPC_MoveParent,
/* 15417*/    OPC_MoveParent,
/* 15418*/    OPC_MoveParent,
/* 15419*/    OPC_CheckType, MVT::v16i8,
/* 15421*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15429*/   /*Scope*/ 42, /*->15472*/
/* 15430*/    OPC_RecordChild0, // #1 = $c
/* 15431*/    OPC_MoveChild1,
/* 15432*/    OPC_CheckImmAllOnesV,
/* 15433*/    OPC_MoveParent,
/* 15434*/    OPC_MoveSibling1,
/* 15435*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15438*/    OPC_Scope, 15, /*->15455*/ // 2 children in Scope
/* 15440*/     OPC_RecordChild0, // #2 = $v1
/* 15441*/     OPC_CheckChild1Same, 0,
/* 15443*/     OPC_MoveParent,
/* 15444*/     OPC_MoveParent,
/* 15445*/     OPC_CheckType, MVT::v16i8,
/* 15447*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15455*/    /*Scope*/ 15, /*->15471*/
/* 15456*/     OPC_CheckChild0Same, 0,
/* 15458*/     OPC_RecordChild1, // #2 = $v1
/* 15459*/     OPC_MoveParent,
/* 15460*/     OPC_MoveParent,
/* 15461*/     OPC_CheckType, MVT::v16i8,
/* 15463*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15471*/    0, /*End of Scope*/
/* 15472*/   0, /*End of Scope*/
/* 15473*/  /*Scope*/ 73, /*->15547*/
/* 15474*/   OPC_MoveChild0,
/* 15475*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15478*/   OPC_MoveChild0,
/* 15479*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15482*/   OPC_RecordChild0, // #0 = $v2
/* 15483*/   OPC_Scope, 23, /*->15508*/ // 2 children in Scope
/* 15485*/    OPC_RecordChild1, // #1 = $v1
/* 15486*/    OPC_MoveSibling1,
/* 15487*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15490*/    OPC_RecordChild0, // #2 = $c
/* 15491*/    OPC_MoveChild1,
/* 15492*/    OPC_CheckImmAllOnesV,
/* 15493*/    OPC_MoveParent,
/* 15494*/    OPC_MoveParent,
/* 15495*/    OPC_MoveParent,
/* 15496*/    OPC_CheckChild1Same, 0,
/* 15498*/    OPC_CheckType, MVT::v8i16,
/* 15500*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15508*/   /*Scope*/ 37, /*->15546*/
/* 15509*/    OPC_MoveChild1,
/* 15510*/    OPC_CheckImmAllOnesV,
/* 15511*/    OPC_MoveParent,
/* 15512*/    OPC_MoveSibling1,
/* 15513*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15516*/    OPC_RecordChild0, // #1 = $v1
/* 15517*/    OPC_RecordChild1, // #2 = $v2
/* 15518*/    OPC_MoveParent,
/* 15519*/    OPC_MoveParent,
/* 15520*/    OPC_CheckType, MVT::v8i16,
/* 15522*/    OPC_Scope, 10, /*->15534*/ // 2 children in Scope
/* 15524*/     OPC_CheckChild1Same, 2,
/* 15526*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2)), V128:{ *:[v8i16] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15534*/    /*Scope*/ 10, /*->15545*/
/* 15535*/     OPC_CheckChild1Same, 1,
/* 15537*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1)), V128:{ *:[v8i16] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15545*/    0, /*End of Scope*/
/* 15546*/   0, /*End of Scope*/
/* 15547*/  /*Scope*/ 102, /*->15650*/
/* 15548*/   OPC_RecordChild0, // #0 = $v2
/* 15549*/   OPC_MoveChild1,
/* 15550*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15553*/   OPC_MoveChild0,
/* 15554*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15557*/   OPC_Scope, 23, /*->15582*/ // 3 children in Scope
/* 15559*/    OPC_RecordChild0, // #1 = $v1
/* 15560*/    OPC_CheckChild1Same, 0,
/* 15562*/    OPC_MoveSibling1,
/* 15563*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15566*/    OPC_RecordChild0, // #2 = $c
/* 15567*/    OPC_MoveChild1,
/* 15568*/    OPC_CheckImmAllOnesV,
/* 15569*/    OPC_MoveParent,
/* 15570*/    OPC_MoveParent,
/* 15571*/    OPC_MoveParent,
/* 15572*/    OPC_CheckType, MVT::v8i16,
/* 15574*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15582*/   /*Scope*/ 23, /*->15606*/
/* 15583*/    OPC_CheckChild0Same, 0,
/* 15585*/    OPC_RecordChild1, // #1 = $v1
/* 15586*/    OPC_MoveSibling1,
/* 15587*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15590*/    OPC_RecordChild0, // #2 = $c
/* 15591*/    OPC_MoveChild1,
/* 15592*/    OPC_CheckImmAllOnesV,
/* 15593*/    OPC_MoveParent,
/* 15594*/    OPC_MoveParent,
/* 15595*/    OPC_MoveParent,
/* 15596*/    OPC_CheckType, MVT::v8i16,
/* 15598*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15606*/   /*Scope*/ 42, /*->15649*/
/* 15607*/    OPC_RecordChild0, // #1 = $c
/* 15608*/    OPC_MoveChild1,
/* 15609*/    OPC_CheckImmAllOnesV,
/* 15610*/    OPC_MoveParent,
/* 15611*/    OPC_MoveSibling1,
/* 15612*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15615*/    OPC_Scope, 15, /*->15632*/ // 2 children in Scope
/* 15617*/     OPC_RecordChild0, // #2 = $v1
/* 15618*/     OPC_CheckChild1Same, 0,
/* 15620*/     OPC_MoveParent,
/* 15621*/     OPC_MoveParent,
/* 15622*/     OPC_CheckType, MVT::v8i16,
/* 15624*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15632*/    /*Scope*/ 15, /*->15648*/
/* 15633*/     OPC_CheckChild0Same, 0,
/* 15635*/     OPC_RecordChild1, // #2 = $v1
/* 15636*/     OPC_MoveParent,
/* 15637*/     OPC_MoveParent,
/* 15638*/     OPC_CheckType, MVT::v8i16,
/* 15640*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15648*/    0, /*End of Scope*/
/* 15649*/   0, /*End of Scope*/
/* 15650*/  /*Scope*/ 73, /*->15724*/
/* 15651*/   OPC_MoveChild0,
/* 15652*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15655*/   OPC_MoveChild0,
/* 15656*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15659*/   OPC_RecordChild0, // #0 = $v2
/* 15660*/   OPC_Scope, 23, /*->15685*/ // 2 children in Scope
/* 15662*/    OPC_RecordChild1, // #1 = $v1
/* 15663*/    OPC_MoveSibling1,
/* 15664*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15667*/    OPC_RecordChild0, // #2 = $c
/* 15668*/    OPC_MoveChild1,
/* 15669*/    OPC_CheckImmAllOnesV,
/* 15670*/    OPC_MoveParent,
/* 15671*/    OPC_MoveParent,
/* 15672*/    OPC_MoveParent,
/* 15673*/    OPC_CheckChild1Same, 0,
/* 15675*/    OPC_CheckType, MVT::v4i32,
/* 15677*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15685*/   /*Scope*/ 37, /*->15723*/
/* 15686*/    OPC_MoveChild1,
/* 15687*/    OPC_CheckImmAllOnesV,
/* 15688*/    OPC_MoveParent,
/* 15689*/    OPC_MoveSibling1,
/* 15690*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15693*/    OPC_RecordChild0, // #1 = $v1
/* 15694*/    OPC_RecordChild1, // #2 = $v2
/* 15695*/    OPC_MoveParent,
/* 15696*/    OPC_MoveParent,
/* 15697*/    OPC_CheckType, MVT::v4i32,
/* 15699*/    OPC_Scope, 10, /*->15711*/ // 2 children in Scope
/* 15701*/     OPC_CheckChild1Same, 2,
/* 15703*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2)), V128:{ *:[v4i32] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15711*/    /*Scope*/ 10, /*->15722*/
/* 15712*/     OPC_CheckChild1Same, 1,
/* 15714*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1)), V128:{ *:[v4i32] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15722*/    0, /*End of Scope*/
/* 15723*/   0, /*End of Scope*/
/* 15724*/  /*Scope*/ 102, /*->15827*/
/* 15725*/   OPC_RecordChild0, // #0 = $v2
/* 15726*/   OPC_MoveChild1,
/* 15727*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15730*/   OPC_MoveChild0,
/* 15731*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15734*/   OPC_Scope, 23, /*->15759*/ // 3 children in Scope
/* 15736*/    OPC_RecordChild0, // #1 = $v1
/* 15737*/    OPC_CheckChild1Same, 0,
/* 15739*/    OPC_MoveSibling1,
/* 15740*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15743*/    OPC_RecordChild0, // #2 = $c
/* 15744*/    OPC_MoveChild1,
/* 15745*/    OPC_CheckImmAllOnesV,
/* 15746*/    OPC_MoveParent,
/* 15747*/    OPC_MoveParent,
/* 15748*/    OPC_MoveParent,
/* 15749*/    OPC_CheckType, MVT::v4i32,
/* 15751*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15759*/   /*Scope*/ 23, /*->15783*/
/* 15760*/    OPC_CheckChild0Same, 0,
/* 15762*/    OPC_RecordChild1, // #1 = $v1
/* 15763*/    OPC_MoveSibling1,
/* 15764*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15767*/    OPC_RecordChild0, // #2 = $c
/* 15768*/    OPC_MoveChild1,
/* 15769*/    OPC_CheckImmAllOnesV,
/* 15770*/    OPC_MoveParent,
/* 15771*/    OPC_MoveParent,
/* 15772*/    OPC_MoveParent,
/* 15773*/    OPC_CheckType, MVT::v4i32,
/* 15775*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15783*/   /*Scope*/ 42, /*->15826*/
/* 15784*/    OPC_RecordChild0, // #1 = $c
/* 15785*/    OPC_MoveChild1,
/* 15786*/    OPC_CheckImmAllOnesV,
/* 15787*/    OPC_MoveParent,
/* 15788*/    OPC_MoveSibling1,
/* 15789*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15792*/    OPC_Scope, 15, /*->15809*/ // 2 children in Scope
/* 15794*/     OPC_RecordChild0, // #2 = $v1
/* 15795*/     OPC_CheckChild1Same, 0,
/* 15797*/     OPC_MoveParent,
/* 15798*/     OPC_MoveParent,
/* 15799*/     OPC_CheckType, MVT::v4i32,
/* 15801*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15809*/    /*Scope*/ 15, /*->15825*/
/* 15810*/     OPC_CheckChild0Same, 0,
/* 15812*/     OPC_RecordChild1, // #2 = $v1
/* 15813*/     OPC_MoveParent,
/* 15814*/     OPC_MoveParent,
/* 15815*/     OPC_CheckType, MVT::v4i32,
/* 15817*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15825*/    0, /*End of Scope*/
/* 15826*/   0, /*End of Scope*/
/* 15827*/  /*Scope*/ 73, /*->15901*/
/* 15828*/   OPC_MoveChild0,
/* 15829*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15832*/   OPC_MoveChild0,
/* 15833*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15836*/   OPC_RecordChild0, // #0 = $v2
/* 15837*/   OPC_Scope, 23, /*->15862*/ // 2 children in Scope
/* 15839*/    OPC_RecordChild1, // #1 = $v1
/* 15840*/    OPC_MoveSibling1,
/* 15841*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15844*/    OPC_RecordChild0, // #2 = $c
/* 15845*/    OPC_MoveChild1,
/* 15846*/    OPC_CheckImmAllOnesV,
/* 15847*/    OPC_MoveParent,
/* 15848*/    OPC_MoveParent,
/* 15849*/    OPC_MoveParent,
/* 15850*/    OPC_CheckChild1Same, 0,
/* 15852*/    OPC_CheckType, MVT::v2i64,
/* 15854*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15862*/   /*Scope*/ 37, /*->15900*/
/* 15863*/    OPC_MoveChild1,
/* 15864*/    OPC_CheckImmAllOnesV,
/* 15865*/    OPC_MoveParent,
/* 15866*/    OPC_MoveSibling1,
/* 15867*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15870*/    OPC_RecordChild0, // #1 = $v1
/* 15871*/    OPC_RecordChild1, // #2 = $v2
/* 15872*/    OPC_MoveParent,
/* 15873*/    OPC_MoveParent,
/* 15874*/    OPC_CheckType, MVT::v2i64,
/* 15876*/    OPC_Scope, 10, /*->15888*/ // 2 children in Scope
/* 15878*/     OPC_CheckChild1Same, 2,
/* 15880*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2)), V128:{ *:[v2i64] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15888*/    /*Scope*/ 10, /*->15899*/
/* 15889*/     OPC_CheckChild1Same, 1,
/* 15891*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1)), V128:{ *:[v2i64] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15899*/    0, /*End of Scope*/
/* 15900*/   0, /*End of Scope*/
/* 15901*/  /*Scope*/ 102, /*->16004*/
/* 15902*/   OPC_RecordChild0, // #0 = $v2
/* 15903*/   OPC_MoveChild1,
/* 15904*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15907*/   OPC_MoveChild0,
/* 15908*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15911*/   OPC_Scope, 23, /*->15936*/ // 3 children in Scope
/* 15913*/    OPC_RecordChild0, // #1 = $v1
/* 15914*/    OPC_CheckChild1Same, 0,
/* 15916*/    OPC_MoveSibling1,
/* 15917*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15920*/    OPC_RecordChild0, // #2 = $c
/* 15921*/    OPC_MoveChild1,
/* 15922*/    OPC_CheckImmAllOnesV,
/* 15923*/    OPC_MoveParent,
/* 15924*/    OPC_MoveParent,
/* 15925*/    OPC_MoveParent,
/* 15926*/    OPC_CheckType, MVT::v2i64,
/* 15928*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15936*/   /*Scope*/ 23, /*->15960*/
/* 15937*/    OPC_CheckChild0Same, 0,
/* 15939*/    OPC_RecordChild1, // #1 = $v1
/* 15940*/    OPC_MoveSibling1,
/* 15941*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15944*/    OPC_RecordChild0, // #2 = $c
/* 15945*/    OPC_MoveChild1,
/* 15946*/    OPC_CheckImmAllOnesV,
/* 15947*/    OPC_MoveParent,
/* 15948*/    OPC_MoveParent,
/* 15949*/    OPC_MoveParent,
/* 15950*/    OPC_CheckType, MVT::v2i64,
/* 15952*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15960*/   /*Scope*/ 42, /*->16003*/
/* 15961*/    OPC_RecordChild0, // #1 = $c
/* 15962*/    OPC_MoveChild1,
/* 15963*/    OPC_CheckImmAllOnesV,
/* 15964*/    OPC_MoveParent,
/* 15965*/    OPC_MoveSibling1,
/* 15966*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15969*/    OPC_Scope, 15, /*->15986*/ // 2 children in Scope
/* 15971*/     OPC_RecordChild0, // #2 = $v1
/* 15972*/     OPC_CheckChild1Same, 0,
/* 15974*/     OPC_MoveParent,
/* 15975*/     OPC_MoveParent,
/* 15976*/     OPC_CheckType, MVT::v2i64,
/* 15978*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15986*/    /*Scope*/ 15, /*->16002*/
/* 15987*/     OPC_CheckChild0Same, 0,
/* 15989*/     OPC_RecordChild1, // #2 = $v1
/* 15990*/     OPC_MoveParent,
/* 15991*/     OPC_MoveParent,
/* 15992*/     OPC_CheckType, MVT::v2i64,
/* 15994*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 16002*/    0, /*End of Scope*/
/* 16003*/   0, /*End of Scope*/
/* 16004*/  /*Scope*/ 112, /*->16117*/
/* 16005*/   OPC_MoveChild0,
/* 16006*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16009*/   OPC_Scope, 69, /*->16080*/ // 2 children in Scope
/* 16011*/    OPC_MoveChild0,
/* 16012*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16015*/    OPC_RecordChild0, // #0 = $v1
/* 16016*/    OPC_RecordChild1, // #1 = $v2
/* 16017*/    OPC_MoveParent,
/* 16018*/    OPC_RecordChild1, // #2 = $c
/* 16019*/    OPC_MoveParent,
/* 16020*/    OPC_Scope, 44, /*->16066*/ // 2 children in Scope
/* 16022*/     OPC_CheckChild1Same, 1,
/* 16024*/     OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->16035
/* 16027*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 16035*/     /*SwitchType*/ 8, MVT::v8i16,// ->16045
/* 16037*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16045*/     /*SwitchType*/ 8, MVT::v4i32,// ->16055
/* 16047*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16055*/     /*SwitchType*/ 8, MVT::v2i64,// ->16065
/* 16057*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16065*/     0, // EndSwitchType
/* 16066*/    /*Scope*/ 12, /*->16079*/
/* 16067*/     OPC_CheckChild1Same, 0,
/* 16069*/     OPC_CheckType, MVT::v16i8,
/* 16071*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 16079*/    0, /*End of Scope*/
/* 16080*/   /*Scope*/ 35, /*->16116*/
/* 16081*/    OPC_RecordChild0, // #0 = $c
/* 16082*/    OPC_MoveChild1,
/* 16083*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16086*/    OPC_RecordChild0, // #1 = $v1
/* 16087*/    OPC_RecordChild1, // #2 = $v2
/* 16088*/    OPC_MoveParent,
/* 16089*/    OPC_MoveParent,
/* 16090*/    OPC_CheckType, MVT::v16i8,
/* 16092*/    OPC_Scope, 10, /*->16104*/ // 2 children in Scope
/* 16094*/     OPC_CheckChild1Same, 2,
/* 16096*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2)), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 16104*/    /*Scope*/ 10, /*->16115*/
/* 16105*/     OPC_CheckChild1Same, 1,
/* 16107*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1)), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 16115*/    0, /*End of Scope*/
/* 16116*/   0, /*End of Scope*/
/* 16117*/  /*Scope*/ 88, /*->16206*/
/* 16118*/   OPC_RecordChild0, // #0 = $v2
/* 16119*/   OPC_MoveChild1,
/* 16120*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16123*/   OPC_Scope, 40, /*->16165*/ // 2 children in Scope
/* 16125*/    OPC_MoveChild0,
/* 16126*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16129*/    OPC_Scope, 16, /*->16147*/ // 2 children in Scope
/* 16131*/     OPC_RecordChild0, // #1 = $v1
/* 16132*/     OPC_CheckChild1Same, 0,
/* 16134*/     OPC_MoveParent,
/* 16135*/     OPC_RecordChild1, // #2 = $c
/* 16136*/     OPC_MoveParent,
/* 16137*/     OPC_CheckType, MVT::v16i8,
/* 16139*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), V128:{ *:[v16i8] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 16147*/    /*Scope*/ 16, /*->16164*/
/* 16148*/     OPC_CheckChild0Same, 0,
/* 16150*/     OPC_RecordChild1, // #1 = $v1
/* 16151*/     OPC_MoveParent,
/* 16152*/     OPC_RecordChild1, // #2 = $c
/* 16153*/     OPC_MoveParent,
/* 16154*/     OPC_CheckType, MVT::v16i8,
/* 16156*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), V128:{ *:[v16i8] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 16164*/    0, /*End of Scope*/
/* 16165*/   /*Scope*/ 39, /*->16205*/
/* 16166*/    OPC_RecordChild0, // #1 = $c
/* 16167*/    OPC_MoveChild1,
/* 16168*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16171*/    OPC_Scope, 15, /*->16188*/ // 2 children in Scope
/* 16173*/     OPC_RecordChild0, // #2 = $v1
/* 16174*/     OPC_CheckChild1Same, 0,
/* 16176*/     OPC_MoveParent,
/* 16177*/     OPC_MoveParent,
/* 16178*/     OPC_CheckType, MVT::v16i8,
/* 16180*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 16188*/    /*Scope*/ 15, /*->16204*/
/* 16189*/     OPC_CheckChild0Same, 0,
/* 16191*/     OPC_RecordChild1, // #2 = $v1
/* 16192*/     OPC_MoveParent,
/* 16193*/     OPC_MoveParent,
/* 16194*/     OPC_CheckType, MVT::v16i8,
/* 16196*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 16204*/    0, /*End of Scope*/
/* 16205*/   0, /*End of Scope*/
/* 16206*/  /*Scope*/ 64, /*->16271*/
/* 16207*/   OPC_MoveChild0,
/* 16208*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16211*/   OPC_Scope, 21, /*->16234*/ // 2 children in Scope
/* 16213*/    OPC_MoveChild0,
/* 16214*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16217*/    OPC_RecordChild0, // #0 = $v2
/* 16218*/    OPC_RecordChild1, // #1 = $v1
/* 16219*/    OPC_MoveParent,
/* 16220*/    OPC_RecordChild1, // #2 = $c
/* 16221*/    OPC_MoveParent,
/* 16222*/    OPC_CheckChild1Same, 0,
/* 16224*/    OPC_CheckType, MVT::v8i16,
/* 16226*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16234*/   /*Scope*/ 35, /*->16270*/
/* 16235*/    OPC_RecordChild0, // #0 = $c
/* 16236*/    OPC_MoveChild1,
/* 16237*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16240*/    OPC_RecordChild0, // #1 = $v1
/* 16241*/    OPC_RecordChild1, // #2 = $v2
/* 16242*/    OPC_MoveParent,
/* 16243*/    OPC_MoveParent,
/* 16244*/    OPC_CheckType, MVT::v8i16,
/* 16246*/    OPC_Scope, 10, /*->16258*/ // 2 children in Scope
/* 16248*/     OPC_CheckChild1Same, 2,
/* 16250*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2)), V128:{ *:[v8i16] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16258*/    /*Scope*/ 10, /*->16269*/
/* 16259*/     OPC_CheckChild1Same, 1,
/* 16261*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1)), V128:{ *:[v8i16] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16269*/    0, /*End of Scope*/
/* 16270*/   0, /*End of Scope*/
/* 16271*/  /*Scope*/ 88, /*->16360*/
/* 16272*/   OPC_RecordChild0, // #0 = $v2
/* 16273*/   OPC_MoveChild1,
/* 16274*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16277*/   OPC_Scope, 40, /*->16319*/ // 2 children in Scope
/* 16279*/    OPC_MoveChild0,
/* 16280*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16283*/    OPC_Scope, 16, /*->16301*/ // 2 children in Scope
/* 16285*/     OPC_RecordChild0, // #1 = $v1
/* 16286*/     OPC_CheckChild1Same, 0,
/* 16288*/     OPC_MoveParent,
/* 16289*/     OPC_RecordChild1, // #2 = $c
/* 16290*/     OPC_MoveParent,
/* 16291*/     OPC_CheckType, MVT::v8i16,
/* 16293*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), V128:{ *:[v8i16] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16301*/    /*Scope*/ 16, /*->16318*/
/* 16302*/     OPC_CheckChild0Same, 0,
/* 16304*/     OPC_RecordChild1, // #1 = $v1
/* 16305*/     OPC_MoveParent,
/* 16306*/     OPC_RecordChild1, // #2 = $c
/* 16307*/     OPC_MoveParent,
/* 16308*/     OPC_CheckType, MVT::v8i16,
/* 16310*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), V128:{ *:[v8i16] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16318*/    0, /*End of Scope*/
/* 16319*/   /*Scope*/ 39, /*->16359*/
/* 16320*/    OPC_RecordChild0, // #1 = $c
/* 16321*/    OPC_MoveChild1,
/* 16322*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16325*/    OPC_Scope, 15, /*->16342*/ // 2 children in Scope
/* 16327*/     OPC_RecordChild0, // #2 = $v1
/* 16328*/     OPC_CheckChild1Same, 0,
/* 16330*/     OPC_MoveParent,
/* 16331*/     OPC_MoveParent,
/* 16332*/     OPC_CheckType, MVT::v8i16,
/* 16334*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16342*/    /*Scope*/ 15, /*->16358*/
/* 16343*/     OPC_CheckChild0Same, 0,
/* 16345*/     OPC_RecordChild1, // #2 = $v1
/* 16346*/     OPC_MoveParent,
/* 16347*/     OPC_MoveParent,
/* 16348*/     OPC_CheckType, MVT::v8i16,
/* 16350*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16358*/    0, /*End of Scope*/
/* 16359*/   0, /*End of Scope*/
/* 16360*/  /*Scope*/ 64, /*->16425*/
/* 16361*/   OPC_MoveChild0,
/* 16362*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16365*/   OPC_Scope, 21, /*->16388*/ // 2 children in Scope
/* 16367*/    OPC_MoveChild0,
/* 16368*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16371*/    OPC_RecordChild0, // #0 = $v2
/* 16372*/    OPC_RecordChild1, // #1 = $v1
/* 16373*/    OPC_MoveParent,
/* 16374*/    OPC_RecordChild1, // #2 = $c
/* 16375*/    OPC_MoveParent,
/* 16376*/    OPC_CheckChild1Same, 0,
/* 16378*/    OPC_CheckType, MVT::v4i32,
/* 16380*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16388*/   /*Scope*/ 35, /*->16424*/
/* 16389*/    OPC_RecordChild0, // #0 = $c
/* 16390*/    OPC_MoveChild1,
/* 16391*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16394*/    OPC_RecordChild0, // #1 = $v1
/* 16395*/    OPC_RecordChild1, // #2 = $v2
/* 16396*/    OPC_MoveParent,
/* 16397*/    OPC_MoveParent,
/* 16398*/    OPC_CheckType, MVT::v4i32,
/* 16400*/    OPC_Scope, 10, /*->16412*/ // 2 children in Scope
/* 16402*/     OPC_CheckChild1Same, 2,
/* 16404*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2)), V128:{ *:[v4i32] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16412*/    /*Scope*/ 10, /*->16423*/
/* 16413*/     OPC_CheckChild1Same, 1,
/* 16415*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1)), V128:{ *:[v4i32] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16423*/    0, /*End of Scope*/
/* 16424*/   0, /*End of Scope*/
/* 16425*/  /*Scope*/ 88, /*->16514*/
/* 16426*/   OPC_RecordChild0, // #0 = $v2
/* 16427*/   OPC_MoveChild1,
/* 16428*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16431*/   OPC_Scope, 40, /*->16473*/ // 2 children in Scope
/* 16433*/    OPC_MoveChild0,
/* 16434*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16437*/    OPC_Scope, 16, /*->16455*/ // 2 children in Scope
/* 16439*/     OPC_RecordChild0, // #1 = $v1
/* 16440*/     OPC_CheckChild1Same, 0,
/* 16442*/     OPC_MoveParent,
/* 16443*/     OPC_RecordChild1, // #2 = $c
/* 16444*/     OPC_MoveParent,
/* 16445*/     OPC_CheckType, MVT::v4i32,
/* 16447*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), V128:{ *:[v4i32] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16455*/    /*Scope*/ 16, /*->16472*/
/* 16456*/     OPC_CheckChild0Same, 0,
/* 16458*/     OPC_RecordChild1, // #1 = $v1
/* 16459*/     OPC_MoveParent,
/* 16460*/     OPC_RecordChild1, // #2 = $c
/* 16461*/     OPC_MoveParent,
/* 16462*/     OPC_CheckType, MVT::v4i32,
/* 16464*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), V128:{ *:[v4i32] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16472*/    0, /*End of Scope*/
/* 16473*/   /*Scope*/ 39, /*->16513*/
/* 16474*/    OPC_RecordChild0, // #1 = $c
/* 16475*/    OPC_MoveChild1,
/* 16476*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16479*/    OPC_Scope, 15, /*->16496*/ // 2 children in Scope
/* 16481*/     OPC_RecordChild0, // #2 = $v1
/* 16482*/     OPC_CheckChild1Same, 0,
/* 16484*/     OPC_MoveParent,
/* 16485*/     OPC_MoveParent,
/* 16486*/     OPC_CheckType, MVT::v4i32,
/* 16488*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16496*/    /*Scope*/ 15, /*->16512*/
/* 16497*/     OPC_CheckChild0Same, 0,
/* 16499*/     OPC_RecordChild1, // #2 = $v1
/* 16500*/     OPC_MoveParent,
/* 16501*/     OPC_MoveParent,
/* 16502*/     OPC_CheckType, MVT::v4i32,
/* 16504*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16512*/    0, /*End of Scope*/
/* 16513*/   0, /*End of Scope*/
/* 16514*/  /*Scope*/ 64, /*->16579*/
/* 16515*/   OPC_MoveChild0,
/* 16516*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16519*/   OPC_Scope, 21, /*->16542*/ // 2 children in Scope
/* 16521*/    OPC_MoveChild0,
/* 16522*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16525*/    OPC_RecordChild0, // #0 = $v2
/* 16526*/    OPC_RecordChild1, // #1 = $v1
/* 16527*/    OPC_MoveParent,
/* 16528*/    OPC_RecordChild1, // #2 = $c
/* 16529*/    OPC_MoveParent,
/* 16530*/    OPC_CheckChild1Same, 0,
/* 16532*/    OPC_CheckType, MVT::v2i64,
/* 16534*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16542*/   /*Scope*/ 35, /*->16578*/
/* 16543*/    OPC_RecordChild0, // #0 = $c
/* 16544*/    OPC_MoveChild1,
/* 16545*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16548*/    OPC_RecordChild0, // #1 = $v1
/* 16549*/    OPC_RecordChild1, // #2 = $v2
/* 16550*/    OPC_MoveParent,
/* 16551*/    OPC_MoveParent,
/* 16552*/    OPC_CheckType, MVT::v2i64,
/* 16554*/    OPC_Scope, 10, /*->16566*/ // 2 children in Scope
/* 16556*/     OPC_CheckChild1Same, 2,
/* 16558*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2)), V128:{ *:[v2i64] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16566*/    /*Scope*/ 10, /*->16577*/
/* 16567*/     OPC_CheckChild1Same, 1,
/* 16569*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1)), V128:{ *:[v2i64] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16577*/    0, /*End of Scope*/
/* 16578*/   0, /*End of Scope*/
/* 16579*/  /*Scope*/ 43|128,1/*171*/, /*->16752*/
/* 16581*/   OPC_RecordChild0, // #0 = $v2
/* 16582*/   OPC_Scope, 127, /*->16711*/ // 2 children in Scope
/* 16584*/    OPC_MoveChild1,
/* 16585*/    OPC_Scope, 86, /*->16673*/ // 2 children in Scope
/* 16587*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16590*/     OPC_Scope, 40, /*->16632*/ // 2 children in Scope
/* 16592*/      OPC_MoveChild0,
/* 16593*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16596*/      OPC_Scope, 16, /*->16614*/ // 2 children in Scope
/* 16598*/       OPC_RecordChild0, // #1 = $v1
/* 16599*/       OPC_CheckChild1Same, 0,
/* 16601*/       OPC_MoveParent,
/* 16602*/       OPC_RecordChild1, // #2 = $c
/* 16603*/       OPC_MoveParent,
/* 16604*/       OPC_CheckType, MVT::v2i64,
/* 16606*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), V128:{ *:[v2i64] }:$c)) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16614*/      /*Scope*/ 16, /*->16631*/
/* 16615*/       OPC_CheckChild0Same, 0,
/* 16617*/       OPC_RecordChild1, // #1 = $v1
/* 16618*/       OPC_MoveParent,
/* 16619*/       OPC_RecordChild1, // #2 = $c
/* 16620*/       OPC_MoveParent,
/* 16621*/       OPC_CheckType, MVT::v2i64,
/* 16623*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), V128:{ *:[v2i64] }:$c)) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16631*/      0, /*End of Scope*/
/* 16632*/     /*Scope*/ 39, /*->16672*/
/* 16633*/      OPC_RecordChild0, // #1 = $c
/* 16634*/      OPC_MoveChild1,
/* 16635*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16638*/      OPC_Scope, 15, /*->16655*/ // 2 children in Scope
/* 16640*/       OPC_RecordChild0, // #2 = $v1
/* 16641*/       OPC_CheckChild1Same, 0,
/* 16643*/       OPC_MoveParent,
/* 16644*/       OPC_MoveParent,
/* 16645*/       OPC_CheckType, MVT::v2i64,
/* 16647*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2))) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16655*/      /*Scope*/ 15, /*->16671*/
/* 16656*/       OPC_CheckChild0Same, 0,
/* 16658*/       OPC_RecordChild1, // #2 = $v1
/* 16659*/       OPC_MoveParent,
/* 16660*/       OPC_MoveParent,
/* 16661*/       OPC_CheckType, MVT::v2i64,
/* 16663*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1))) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16671*/      0, /*End of Scope*/
/* 16672*/     0, /*End of Scope*/
/* 16673*/    /*Scope*/ 36, /*->16710*/
/* 16674*/     OPC_CheckImmAllOnesV,
/* 16675*/     OPC_MoveParent,
/* 16676*/     OPC_SwitchType /*4 cases */, 6, MVT::v16i8,// ->16685
/* 16679*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    MVT::v16i8, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v, immAllOnesV:{ *:[v16i8] }) - Complexity = 7
                // Dst: (NOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v)
/* 16685*/     /*SwitchType*/ 6, MVT::v8i16,// ->16693
/* 16687*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    MVT::v8i16, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v, immAllOnesV:{ *:[v8i16] }) - Complexity = 7
                // Dst: (NOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v)
/* 16693*/     /*SwitchType*/ 6, MVT::v4i32,// ->16701
/* 16695*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    MVT::v4i32, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v, immAllOnesV:{ *:[v4i32] }) - Complexity = 7
                // Dst: (NOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v)
/* 16701*/     /*SwitchType*/ 6, MVT::v2i64,// ->16709
/* 16703*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    MVT::v2i64, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v, immAllOnesV:{ *:[v2i64] }) - Complexity = 7
                // Dst: (NOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v)
/* 16709*/     0, // EndSwitchType
/* 16710*/    0, /*End of Scope*/
/* 16711*/   /*Scope*/ 39, /*->16751*/
/* 16712*/    OPC_RecordChild1, // #1 = $rhs
/* 16713*/    OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->16723
/* 16716*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 16723*/    /*SwitchType*/ 7, MVT::v8i16,// ->16732
/* 16725*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 16732*/    /*SwitchType*/ 7, MVT::v4i32,// ->16741
/* 16734*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 16741*/    /*SwitchType*/ 7, MVT::v2i64,// ->16750
/* 16743*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 16750*/    0, // EndSwitchType
/* 16751*/   0, /*End of Scope*/
/* 16752*/  0, /*End of Scope*/
/* 16753*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CTLZ),// ->16777
/* 16756*/  OPC_RecordChild0, // #0 = $src
/* 16757*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->16767
/* 16760*/   OPC_CheckChild0TypeI32,
/* 16761*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CLZ_I32),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (ctlz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (CLZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16767*/  /*SwitchType*/ 7, MVT::i64,// ->16776
/* 16769*/   OPC_CheckChild0TypeI64,
/* 16770*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CLZ_I64),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (ctlz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (CLZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16776*/  0, // EndSwitchType
/* 16777*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CTTZ),// ->16801
/* 16780*/  OPC_RecordChild0, // #0 = $src
/* 16781*/  OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->16791
/* 16784*/   OPC_CheckChild0TypeI32,
/* 16785*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CTZ_I32),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (cttz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (CTZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16791*/  /*SwitchType*/ 7, MVT::i64,// ->16800
/* 16793*/   OPC_CheckChild0TypeI64,
/* 16794*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CTZ_I64),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (cttz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (CTZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16800*/  0, // EndSwitchType
/* 16801*/ /*SwitchOpcode*/ 33, TARGET_VAL(ISD::CTPOP),// ->16837
/* 16804*/  OPC_RecordChild0, // #0 = $src
/* 16805*/  OPC_SwitchType /*3 cases */, 7, MVT::i32,// ->16815
/* 16808*/   OPC_CheckChild0TypeI32,
/* 16809*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I32),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (POPCNT_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16815*/  /*SwitchType*/ 7, MVT::i64,// ->16824
/* 16817*/   OPC_CheckChild0TypeI64,
/* 16818*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I64),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (POPCNT_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16824*/  /*SwitchType*/ 10, MVT::v16i8,// ->16836
/* 16826*/   OPC_CheckChild0Type, MVT::v16i8,
/* 16828*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 16830*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I8x16),
                 MVT::v16i8, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$v) - Complexity = 3
             // Dst: (POPCNT_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 16836*/  0, // EndSwitchType
/* 16837*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::TRUNCATE),// ->16847
/* 16840*/  OPC_RecordChild0, // #0 = $src
/* 16841*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                MVT::i32, 1/*#Ops*/, 0, 
            // Src: (trunc:{ *:[i32] } I64:{ *:[i64] }:$src) - Complexity = 3
            // Dst: (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/* 16847*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::SIGN_EXTEND),// ->16857
/* 16850*/  OPC_RecordChild0, // #0 = $src
/* 16851*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_S_I32),
                MVT::i64, 1/*#Ops*/, 0, 
            // Src: (sext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
            // Dst: (I64_EXTEND_S_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/* 16857*/ /*SwitchOpcode*/ 112, TARGET_VAL(ISD::FP_TO_SINT),// ->16972
/* 16860*/  OPC_RecordChild0, // #0 = $src
/* 16861*/  OPC_Scope, 48, /*->16911*/ // 3 children in Scope
/* 16863*/   OPC_CheckChild0Type, MVT::f32,
/* 16865*/   OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->16888
/* 16868*/    OPC_Scope, 8, /*->16878*/ // 2 children in Scope
/* 16870*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasNontrappingFPToInt())
/* 16872*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16878*/    /*Scope*/ 8, /*->16887*/
/* 16879*/     OPC_CheckPatternPredicate, 15, // (!Subtarget->hasNontrappingFPToInt())
/* 16881*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16887*/    0, /*End of Scope*/
/* 16888*/   /*SwitchType*/ 20, MVT::i64,// ->16910
/* 16890*/    OPC_Scope, 8, /*->16900*/ // 2 children in Scope
/* 16892*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasNontrappingFPToInt())
/* 16894*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16900*/    /*Scope*/ 8, /*->16909*/
/* 16901*/     OPC_CheckPatternPredicate, 15, // (!Subtarget->hasNontrappingFPToInt())
/* 16903*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16909*/    0, /*End of Scope*/
/* 16910*/   0, // EndSwitchType
/* 16911*/  /*Scope*/ 48, /*->16960*/
/* 16912*/   OPC_CheckChild0Type, MVT::f64,
/* 16914*/   OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->16937
/* 16917*/    OPC_Scope, 8, /*->16927*/ // 2 children in Scope
/* 16919*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasNontrappingFPToInt())
/* 16921*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16927*/    /*Scope*/ 8, /*->16936*/
/* 16928*/     OPC_CheckPatternPredicate, 15, // (!Subtarget->hasNontrappingFPToInt())
/* 16930*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16936*/    0, /*End of Scope*/
/* 16937*/   /*SwitchType*/ 20, MVT::i64,// ->16959
/* 16939*/    OPC_Scope, 8, /*->16949*/ // 2 children in Scope
/* 16941*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasNontrappingFPToInt())
/* 16943*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16949*/    /*Scope*/ 8, /*->16958*/
/* 16950*/     OPC_CheckPatternPredicate, 15, // (!Subtarget->hasNontrappingFPToInt())
/* 16952*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16958*/    0, /*End of Scope*/
/* 16959*/   0, // EndSwitchType
/* 16960*/  /*Scope*/ 10, /*->16971*/
/* 16961*/   OPC_CheckType, MVT::v4i32,
/* 16963*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 16965*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
             // Dst: (fp_to_sint_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 16971*/  0, /*End of Scope*/
/* 16972*/ /*SwitchOpcode*/ 112, TARGET_VAL(ISD::FP_TO_UINT),// ->17087
/* 16975*/  OPC_RecordChild0, // #0 = $src
/* 16976*/  OPC_Scope, 48, /*->17026*/ // 3 children in Scope
/* 16978*/   OPC_CheckChild0Type, MVT::f32,
/* 16980*/   OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->17003
/* 16983*/    OPC_Scope, 8, /*->16993*/ // 2 children in Scope
/* 16985*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasNontrappingFPToInt())
/* 16987*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16993*/    /*Scope*/ 8, /*->17002*/
/* 16994*/     OPC_CheckPatternPredicate, 15, // (!Subtarget->hasNontrappingFPToInt())
/* 16996*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F32),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 17002*/    0, /*End of Scope*/
/* 17003*/   /*SwitchType*/ 20, MVT::i64,// ->17025
/* 17005*/    OPC_Scope, 8, /*->17015*/ // 2 children in Scope
/* 17007*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasNontrappingFPToInt())
/* 17009*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 17015*/    /*Scope*/ 8, /*->17024*/
/* 17016*/     OPC_CheckPatternPredicate, 15, // (!Subtarget->hasNontrappingFPToInt())
/* 17018*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F32),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 17024*/    0, /*End of Scope*/
/* 17025*/   0, // EndSwitchType
/* 17026*/  /*Scope*/ 48, /*->17075*/
/* 17027*/   OPC_CheckChild0Type, MVT::f64,
/* 17029*/   OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->17052
/* 17032*/    OPC_Scope, 8, /*->17042*/ // 2 children in Scope
/* 17034*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasNontrappingFPToInt())
/* 17036*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 17042*/    /*Scope*/ 8, /*->17051*/
/* 17043*/     OPC_CheckPatternPredicate, 15, // (!Subtarget->hasNontrappingFPToInt())
/* 17045*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F64),
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 17051*/    0, /*End of Scope*/
/* 17052*/   /*SwitchType*/ 20, MVT::i64,// ->17074
/* 17054*/    OPC_Scope, 8, /*->17064*/ // 2 children in Scope
/* 17056*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasNontrappingFPToInt())
/* 17058*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 17064*/    /*Scope*/ 8, /*->17073*/
/* 17065*/     OPC_CheckPatternPredicate, 15, // (!Subtarget->hasNontrappingFPToInt())
/* 17067*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F64),
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 17073*/    0, /*End of Scope*/
/* 17074*/   0, // EndSwitchType
/* 17075*/  /*Scope*/ 10, /*->17086*/
/* 17076*/   OPC_CheckType, MVT::v4i32,
/* 17078*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 17080*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
             // Dst: (fp_to_uint_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 17086*/  0, /*End of Scope*/
/* 17087*/ /*SwitchOpcode*/ 72, TARGET_VAL(ISD::FP_TO_SINT_SAT),// ->17162
/* 17090*/  OPC_RecordChild0, // #0 = $src
/* 17091*/  OPC_Scope, 27, /*->17120*/ // 3 children in Scope
/* 17093*/   OPC_CheckChild0Type, MVT::f32,
/* 17095*/   OPC_MoveChild1,
/* 17096*/   OPC_Scope, 10, /*->17108*/ // 2 children in Scope
/* 17098*/    OPC_CheckValueType, MVT::i32,
/* 17100*/    OPC_MoveParent,
/* 17101*/    OPC_CheckTypeI32,
/* 17102*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i32] } F32:{ *:[f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 17108*/   /*Scope*/ 10, /*->17119*/
/* 17109*/    OPC_CheckValueType, MVT::i64,
/* 17111*/    OPC_MoveParent,
/* 17112*/    OPC_CheckTypeI64,
/* 17113*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i64] } F32:{ *:[f32] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 17119*/   0, /*End of Scope*/
/* 17120*/  /*Scope*/ 27, /*->17148*/
/* 17121*/   OPC_CheckChild0Type, MVT::f64,
/* 17123*/   OPC_MoveChild1,
/* 17124*/   OPC_Scope, 10, /*->17136*/ // 2 children in Scope
/* 17126*/    OPC_CheckValueType, MVT::i32,
/* 17128*/    OPC_MoveParent,
/* 17129*/    OPC_CheckTypeI32,
/* 17130*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i32] } F64:{ *:[f64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 17136*/   /*Scope*/ 10, /*->17147*/
/* 17137*/    OPC_CheckValueType, MVT::i64,
/* 17139*/    OPC_MoveParent,
/* 17140*/    OPC_CheckTypeI64,
/* 17141*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i64] } F64:{ *:[f64] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 17147*/   0, /*End of Scope*/
/* 17148*/  /*Scope*/ 12, /*->17161*/
/* 17149*/   OPC_MoveChild1,
/* 17150*/   OPC_CheckValueType, MVT::i32,
/* 17152*/   OPC_MoveParent,
/* 17153*/   OPC_CheckType, MVT::v4i32,
/* 17155*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint_sat:{ *:[v4i32] } V128:{ *:[v4f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
             // Dst: (fp_to_sint_I32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$src)
/* 17161*/  0, /*End of Scope*/
/* 17162*/ /*SwitchOpcode*/ 72, TARGET_VAL(ISD::FP_TO_UINT_SAT),// ->17237
/* 17165*/  OPC_RecordChild0, // #0 = $src
/* 17166*/  OPC_Scope, 27, /*->17195*/ // 3 children in Scope
/* 17168*/   OPC_CheckChild0Type, MVT::f32,
/* 17170*/   OPC_MoveChild1,
/* 17171*/   OPC_Scope, 10, /*->17183*/ // 2 children in Scope
/* 17173*/    OPC_CheckValueType, MVT::i32,
/* 17175*/    OPC_MoveParent,
/* 17176*/    OPC_CheckTypeI32,
/* 17177*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i32] } F32:{ *:[f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 17183*/   /*Scope*/ 10, /*->17194*/
/* 17184*/    OPC_CheckValueType, MVT::i64,
/* 17186*/    OPC_MoveParent,
/* 17187*/    OPC_CheckTypeI64,
/* 17188*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i64] } F32:{ *:[f32] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 17194*/   0, /*End of Scope*/
/* 17195*/  /*Scope*/ 27, /*->17223*/
/* 17196*/   OPC_CheckChild0Type, MVT::f64,
/* 17198*/   OPC_MoveChild1,
/* 17199*/   OPC_Scope, 10, /*->17211*/ // 2 children in Scope
/* 17201*/    OPC_CheckValueType, MVT::i32,
/* 17203*/    OPC_MoveParent,
/* 17204*/    OPC_CheckTypeI32,
/* 17205*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64),
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i32] } F64:{ *:[f64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 17211*/   /*Scope*/ 10, /*->17222*/
/* 17212*/    OPC_CheckValueType, MVT::i64,
/* 17214*/    OPC_MoveParent,
/* 17215*/    OPC_CheckTypeI64,
/* 17216*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64),
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i64] } F64:{ *:[f64] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 17222*/   0, /*End of Scope*/
/* 17223*/  /*Scope*/ 12, /*->17236*/
/* 17224*/   OPC_MoveChild1,
/* 17225*/   OPC_CheckValueType, MVT::i32,
/* 17227*/   OPC_MoveParent,
/* 17228*/   OPC_CheckType, MVT::v4i32,
/* 17230*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint_sat:{ *:[v4i32] } V128:{ *:[v4f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
             // Dst: (fp_to_uint_I32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$src)
/* 17236*/  0, /*End of Scope*/
/* 17237*/ /*SwitchOpcode*/ 95|128,1/*223*/, TARGET_VAL(ISD::BITCAST),// ->17464
/* 17241*/  OPC_RecordChild0, // #0 = $src
/* 17242*/  OPC_Scope, 9, /*->17253*/ // 10 children in Scope
/* 17244*/   OPC_CheckChild0Type, MVT::f32,
/* 17246*/   OPC_CheckTypeI32,
/* 17247*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_REINTERPRET_F32),
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (I32_REINTERPRET_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 17253*/  /*Scope*/ 9, /*->17263*/
/* 17254*/   OPC_CheckChild0Type, MVT::f64,
/* 17256*/   OPC_CheckTypeI64,
/* 17257*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_REINTERPRET_F64),
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (I64_REINTERPRET_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 17263*/  /*Scope*/ 9, /*->17273*/
/* 17264*/   OPC_CheckChild0TypeI32,
/* 17265*/   OPC_CheckType, MVT::f32,
/* 17267*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_REINTERPRET_I32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (F32_REINTERPRET_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 17273*/  /*Scope*/ 9, /*->17283*/
/* 17274*/   OPC_CheckChild0TypeI64,
/* 17275*/   OPC_CheckType, MVT::f64,
/* 17277*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_REINTERPRET_I64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (F64_REINTERPRET_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 17283*/  /*Scope*/ 29, /*->17313*/
/* 17284*/   OPC_CheckChild0Type, MVT::v8i16,
/* 17286*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->17292
/* 17289*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17292*/   /*SwitchType*/ 3, MVT::v4i32,// ->17297
/* 17294*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17297*/   /*SwitchType*/ 3, MVT::v2i64,// ->17302
/* 17299*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17302*/   /*SwitchType*/ 3, MVT::v4f32,// ->17307
/* 17304*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17307*/   /*SwitchType*/ 3, MVT::v2f64,// ->17312
/* 17309*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17312*/   0, // EndSwitchType
/* 17313*/  /*Scope*/ 29, /*->17343*/
/* 17314*/   OPC_CheckChild0Type, MVT::v4i32,
/* 17316*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->17322
/* 17319*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17322*/   /*SwitchType*/ 3, MVT::v8i16,// ->17327
/* 17324*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17327*/   /*SwitchType*/ 3, MVT::v2i64,// ->17332
/* 17329*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17332*/   /*SwitchType*/ 3, MVT::v4f32,// ->17337
/* 17334*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17337*/   /*SwitchType*/ 3, MVT::v2f64,// ->17342
/* 17339*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17342*/   0, // EndSwitchType
/* 17343*/  /*Scope*/ 29, /*->17373*/
/* 17344*/   OPC_CheckChild0Type, MVT::v2i64,
/* 17346*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->17352
/* 17349*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17352*/   /*SwitchType*/ 3, MVT::v8i16,// ->17357
/* 17354*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17357*/   /*SwitchType*/ 3, MVT::v4i32,// ->17362
/* 17359*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17362*/   /*SwitchType*/ 3, MVT::v4f32,// ->17367
/* 17364*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17367*/   /*SwitchType*/ 3, MVT::v2f64,// ->17372
/* 17369*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17372*/   0, // EndSwitchType
/* 17373*/  /*Scope*/ 29, /*->17403*/
/* 17374*/   OPC_CheckChild0Type, MVT::v4f32,
/* 17376*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->17382
/* 17379*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17382*/   /*SwitchType*/ 3, MVT::v8i16,// ->17387
/* 17384*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17387*/   /*SwitchType*/ 3, MVT::v4i32,// ->17392
/* 17389*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17392*/   /*SwitchType*/ 3, MVT::v2i64,// ->17397
/* 17394*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17397*/   /*SwitchType*/ 3, MVT::v2f64,// ->17402
/* 17399*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17402*/   0, // EndSwitchType
/* 17403*/  /*Scope*/ 29, /*->17433*/
/* 17404*/   OPC_CheckChild0Type, MVT::v2f64,
/* 17406*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->17412
/* 17409*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17412*/   /*SwitchType*/ 3, MVT::v8i16,// ->17417
/* 17414*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17417*/   /*SwitchType*/ 3, MVT::v4i32,// ->17422
/* 17419*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17422*/   /*SwitchType*/ 3, MVT::v2i64,// ->17427
/* 17424*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17427*/   /*SwitchType*/ 3, MVT::v4f32,// ->17432
/* 17429*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17432*/   0, // EndSwitchType
/* 17433*/  /*Scope*/ 29, /*->17463*/
/* 17434*/   OPC_CheckChild0Type, MVT::v16i8,
/* 17436*/   OPC_SwitchType /*5 cases */, 3, MVT::v8i16,// ->17442
/* 17439*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17442*/   /*SwitchType*/ 3, MVT::v4i32,// ->17447
/* 17444*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17447*/   /*SwitchType*/ 3, MVT::v2i64,// ->17452
/* 17449*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17452*/   /*SwitchType*/ 3, MVT::v4f32,// ->17457
/* 17454*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17457*/   /*SwitchType*/ 3, MVT::v2f64,// ->17462
/* 17459*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17462*/   0, // EndSwitchType
/* 17463*/  0, /*End of Scope*/
/* 17464*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::ConstantFP),// ->17488
/* 17467*/  OPC_RecordNode, // #0 = $imm
/* 17468*/  OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->17478
/* 17471*/   OPC_EmitConvertToTarget0,
/* 17472*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_F32),
                 MVT::f32, 1/*#Ops*/, 1, 
             // Src: (fpimm:{ *:[f32] }):$imm - Complexity = 3
             // Dst: (CONST_F32:{ *:[f32] } (fpimm:{ *:[f32] }):$imm)
/* 17478*/  /*SwitchType*/ 7, MVT::f64,// ->17487
/* 17480*/   OPC_EmitConvertToTarget0,
/* 17481*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_F64),
                 MVT::f64, 1/*#Ops*/, 1, 
             // Src: (fpimm:{ *:[f64] }):$imm - Complexity = 3
             // Dst: (CONST_F64:{ *:[f64] } (fpimm:{ *:[f64] }):$imm)
/* 17487*/  0, // EndSwitchType
/* 17488*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::SINT_TO_FP),// ->17545
/* 17491*/  OPC_RecordChild0, // #0 = $src
/* 17492*/  OPC_Scope, 19, /*->17513*/ // 3 children in Scope
/* 17494*/   OPC_CheckChild0TypeI32,
/* 17495*/   OPC_SwitchType /*2 cases */, 6, MVT::f32,// ->17504
/* 17498*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_S_I32),
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_S_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 17504*/   /*SwitchType*/ 6, MVT::f64,// ->17512
/* 17506*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_S_I32),
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_S_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 17512*/   0, // EndSwitchType
/* 17513*/  /*Scope*/ 19, /*->17533*/
/* 17514*/   OPC_CheckChild0TypeI64,
/* 17515*/   OPC_SwitchType /*2 cases */, 6, MVT::f32,// ->17524
/* 17518*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_S_I64),
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_S_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 17524*/   /*SwitchType*/ 6, MVT::f64,// ->17532
/* 17526*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_S_I64),
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_S_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 17532*/   0, // EndSwitchType
/* 17533*/  /*Scope*/ 10, /*->17544*/
/* 17534*/   OPC_CheckType, MVT::v4f32,
/* 17536*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 17538*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::sint_to_fp_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (sint_to_fp_F32x4:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 17544*/  0, /*End of Scope*/
/* 17545*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::UINT_TO_FP),// ->17602
/* 17548*/  OPC_RecordChild0, // #0 = $src
/* 17549*/  OPC_Scope, 19, /*->17570*/ // 3 children in Scope
/* 17551*/   OPC_CheckChild0TypeI32,
/* 17552*/   OPC_SwitchType /*2 cases */, 6, MVT::f32,// ->17561
/* 17555*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_U_I32),
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_U_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 17561*/   /*SwitchType*/ 6, MVT::f64,// ->17569
/* 17563*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_U_I32),
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_U_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 17569*/   0, // EndSwitchType
/* 17570*/  /*Scope*/ 19, /*->17590*/
/* 17571*/   OPC_CheckChild0TypeI64,
/* 17572*/   OPC_SwitchType /*2 cases */, 6, MVT::f32,// ->17581
/* 17575*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_U_I64),
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_U_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 17581*/   /*SwitchType*/ 6, MVT::f64,// ->17589
/* 17583*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_U_I64),
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_U_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 17589*/   0, // EndSwitchType
/* 17590*/  /*Scope*/ 10, /*->17601*/
/* 17591*/   OPC_CheckType, MVT::v4f32,
/* 17593*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 17595*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::uint_to_fp_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (uint_to_fp_F32x4:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 17601*/  0, /*End of Scope*/
/* 17602*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::FP_EXTEND),// ->17612
/* 17605*/  OPC_RecordChild0, // #0 = $src
/* 17606*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_PROMOTE_F32),
                MVT::f64, 1/*#Ops*/, 0, 
            // Src: (fpextend:{ *:[f64] } F32:{ *:[f32] }:$src) - Complexity = 3
            // Dst: (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$src)
/* 17612*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::FP_ROUND),// ->17622
/* 17615*/  OPC_RecordChild0, // #0 = $src
/* 17616*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_DEMOTE_F64),
                MVT::f32, 1/*#Ops*/, 0, 
            // Src: (fpround:{ *:[f32] } F64:{ *:[f64] }:$src) - Complexity = 3
            // Dst: (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$src)
/* 17622*/ /*SwitchOpcode*/ 44, TARGET_VAL(ISD::FADD),// ->17669
/* 17625*/  OPC_RecordChild0, // #0 = $lhs
/* 17626*/  OPC_RecordChild1, // #1 = $rhs
/* 17627*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->17637
/* 17630*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (ADD_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17637*/  /*SwitchType*/ 7, MVT::f64,// ->17646
/* 17639*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (ADD_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17646*/  /*SwitchType*/ 9, MVT::v4f32,// ->17657
/* 17648*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 17650*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (ADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17657*/  /*SwitchType*/ 9, MVT::v2f64,// ->17668
/* 17659*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 17661*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (ADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17668*/  0, // EndSwitchType
/* 17669*/ /*SwitchOpcode*/ 44, TARGET_VAL(ISD::FSUB),// ->17716
/* 17672*/  OPC_RecordChild0, // #0 = $lhs
/* 17673*/  OPC_RecordChild1, // #1 = $rhs
/* 17674*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->17684
/* 17677*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (SUB_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17684*/  /*SwitchType*/ 7, MVT::f64,// ->17693
/* 17686*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (SUB_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17693*/  /*SwitchType*/ 9, MVT::v4f32,// ->17704
/* 17695*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 17697*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (SUB_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17704*/  /*SwitchType*/ 9, MVT::v2f64,// ->17715
/* 17706*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 17708*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (SUB_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17715*/  0, // EndSwitchType
/* 17716*/ /*SwitchOpcode*/ 44, TARGET_VAL(ISD::FMUL),// ->17763
/* 17719*/  OPC_RecordChild0, // #0 = $lhs
/* 17720*/  OPC_RecordChild1, // #1 = $rhs
/* 17721*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->17731
/* 17724*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MUL_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17731*/  /*SwitchType*/ 7, MVT::f64,// ->17740
/* 17733*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MUL_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17740*/  /*SwitchType*/ 9, MVT::v4f32,// ->17751
/* 17742*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 17744*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MUL_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17751*/  /*SwitchType*/ 9, MVT::v2f64,// ->17762
/* 17753*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 17755*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MUL_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17762*/  0, // EndSwitchType
/* 17763*/ /*SwitchOpcode*/ 44, TARGET_VAL(ISD::FDIV),// ->17810
/* 17766*/  OPC_RecordChild0, // #0 = $lhs
/* 17767*/  OPC_RecordChild1, // #1 = $rhs
/* 17768*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->17778
/* 17771*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (DIV_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17778*/  /*SwitchType*/ 7, MVT::f64,// ->17787
/* 17780*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (DIV_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17787*/  /*SwitchType*/ 9, MVT::v4f32,// ->17798
/* 17789*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 17791*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (DIV_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17798*/  /*SwitchType*/ 9, MVT::v2f64,// ->17809
/* 17800*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 17802*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (DIV_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17809*/  0, // EndSwitchType
/* 17810*/ /*SwitchOpcode*/ 39, TARGET_VAL(ISD::FSQRT),// ->17852
/* 17813*/  OPC_RecordChild0, // #0 = $src
/* 17814*/  OPC_SwitchType /*4 cases */, 6, MVT::f32,// ->17823
/* 17817*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (SQRT_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17823*/  /*SwitchType*/ 6, MVT::f64,// ->17831
/* 17825*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (SQRT_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17831*/  /*SwitchType*/ 8, MVT::v4f32,// ->17841
/* 17833*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 17835*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (SQRT_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17841*/  /*SwitchType*/ 8, MVT::v2f64,// ->17851
/* 17843*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 17845*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (SQRT_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17851*/  0, // EndSwitchType
/* 17852*/ /*SwitchOpcode*/ 39, TARGET_VAL(ISD::FABS),// ->17894
/* 17855*/  OPC_RecordChild0, // #0 = $src
/* 17856*/  OPC_SwitchType /*4 cases */, 6, MVT::f32,// ->17865
/* 17859*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (ABS_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17865*/  /*SwitchType*/ 6, MVT::f64,// ->17873
/* 17867*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (ABS_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17873*/  /*SwitchType*/ 8, MVT::v4f32,// ->17883
/* 17875*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 17877*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (ABS_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17883*/  /*SwitchType*/ 8, MVT::v2f64,// ->17893
/* 17885*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 17887*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (ABS_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17893*/  0, // EndSwitchType
/* 17894*/ /*SwitchOpcode*/ 39, TARGET_VAL(ISD::FNEG),// ->17936
/* 17897*/  OPC_RecordChild0, // #0 = $src
/* 17898*/  OPC_SwitchType /*4 cases */, 6, MVT::f32,// ->17907
/* 17901*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEG_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17907*/  /*SwitchType*/ 6, MVT::f64,// ->17915
/* 17909*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEG_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17915*/  /*SwitchType*/ 8, MVT::v4f32,// ->17925
/* 17917*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 17919*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (NEG_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17925*/  /*SwitchType*/ 8, MVT::v2f64,// ->17935
/* 17927*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 17929*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (NEG_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17935*/  0, // EndSwitchType
/* 17936*/ /*SwitchOpcode*/ 62, TARGET_VAL(ISD::FCOPYSIGN),// ->18001
/* 17939*/  OPC_RecordChild0, // #0 = $lhs
/* 17940*/  OPC_RecordChild1, // #1 = $rhs
/* 17941*/  OPC_Scope, 28, /*->17971*/ // 2 children in Scope
/* 17943*/   OPC_CheckChild1Type, MVT::f32,
/* 17945*/   OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->17955
/* 17948*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F32),
                  MVT::f32, 2/*#Ops*/, 0, 1, 
              // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17955*/   /*SwitchType*/ 13, MVT::f64,// ->17970
/* 17957*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::F64_PROMOTE_F32),
                  MVT::f64, 1/*#Ops*/, 1,  // Results = #2
/* 17963*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F64),
                  MVT::f64, 2/*#Ops*/, 0, 2, 
              // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$rhs))
/* 17970*/   0, // EndSwitchType
/* 17971*/  /*Scope*/ 28, /*->18000*/
/* 17972*/   OPC_CheckChild1Type, MVT::f64,
/* 17974*/   OPC_SwitchType /*2 cases */, 7, MVT::f64,// ->17984
/* 17977*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F64),
                  MVT::f64, 2/*#Ops*/, 0, 1, 
              // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17984*/   /*SwitchType*/ 13, MVT::f32,// ->17999
/* 17986*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::F32_DEMOTE_F64),
                  MVT::f32, 1/*#Ops*/, 1,  // Results = #2
/* 17992*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F32),
                  MVT::f32, 2/*#Ops*/, 0, 2, 
              // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$rhs))
/* 17999*/   0, // EndSwitchType
/* 18000*/  0, /*End of Scope*/
/* 18001*/ /*SwitchOpcode*/ 44, TARGET_VAL(ISD::FMINIMUM),// ->18048
/* 18004*/  OPC_RecordChild0, // #0 = $lhs
/* 18005*/  OPC_RecordChild1, // #1 = $rhs
/* 18006*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->18016
/* 18009*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MIN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 18016*/  /*SwitchType*/ 7, MVT::f64,// ->18025
/* 18018*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MIN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 18025*/  /*SwitchType*/ 9, MVT::v4f32,// ->18036
/* 18027*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18029*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 18036*/  /*SwitchType*/ 9, MVT::v2f64,// ->18047
/* 18038*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18040*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 18047*/  0, // EndSwitchType
/* 18048*/ /*SwitchOpcode*/ 44, TARGET_VAL(ISD::FMAXIMUM),// ->18095
/* 18051*/  OPC_RecordChild0, // #0 = $lhs
/* 18052*/  OPC_RecordChild1, // #1 = $rhs
/* 18053*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->18063
/* 18056*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F32),
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MAX_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 18063*/  /*SwitchType*/ 7, MVT::f64,// ->18072
/* 18065*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F64),
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MAX_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 18072*/  /*SwitchType*/ 9, MVT::v4f32,// ->18083
/* 18074*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18076*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F32x4),
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 18083*/  /*SwitchType*/ 9, MVT::v2f64,// ->18094
/* 18085*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18087*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F64x2),
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 18094*/  0, // EndSwitchType
/* 18095*/ /*SwitchOpcode*/ 39, TARGET_VAL(ISD::FCEIL),// ->18137
/* 18098*/  OPC_RecordChild0, // #0 = $src
/* 18099*/  OPC_SwitchType /*4 cases */, 6, MVT::f32,// ->18108
/* 18102*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (CEIL_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 18108*/  /*SwitchType*/ 6, MVT::f64,// ->18116
/* 18110*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (CEIL_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 18116*/  /*SwitchType*/ 8, MVT::v4f32,// ->18126
/* 18118*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18120*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (CEIL_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 18126*/  /*SwitchType*/ 8, MVT::v2f64,// ->18136
/* 18128*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18130*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (CEIL_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 18136*/  0, // EndSwitchType
/* 18137*/ /*SwitchOpcode*/ 39, TARGET_VAL(ISD::FFLOOR),// ->18179
/* 18140*/  OPC_RecordChild0, // #0 = $src
/* 18141*/  OPC_SwitchType /*4 cases */, 6, MVT::f32,// ->18150
/* 18144*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (FLOOR_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 18150*/  /*SwitchType*/ 6, MVT::f64,// ->18158
/* 18152*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (FLOOR_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 18158*/  /*SwitchType*/ 8, MVT::v4f32,// ->18168
/* 18160*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18162*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (FLOOR_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 18168*/  /*SwitchType*/ 8, MVT::v2f64,// ->18178
/* 18170*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18172*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (FLOOR_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 18178*/  0, // EndSwitchType
/* 18179*/ /*SwitchOpcode*/ 39, TARGET_VAL(ISD::FTRUNC),// ->18221
/* 18182*/  OPC_RecordChild0, // #0 = $src
/* 18183*/  OPC_SwitchType /*4 cases */, 6, MVT::f32,// ->18192
/* 18186*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (TRUNC_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 18192*/  /*SwitchType*/ 6, MVT::f64,// ->18200
/* 18194*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (TRUNC_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 18200*/  /*SwitchType*/ 8, MVT::v4f32,// ->18210
/* 18202*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18204*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (TRUNC_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 18210*/  /*SwitchType*/ 8, MVT::v2f64,// ->18220
/* 18212*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18214*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (TRUNC_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 18220*/  0, // EndSwitchType
/* 18221*/ /*SwitchOpcode*/ 39, TARGET_VAL(ISD::FNEARBYINT),// ->18263
/* 18224*/  OPC_RecordChild0, // #0 = $src
/* 18225*/  OPC_SwitchType /*4 cases */, 6, MVT::f32,// ->18234
/* 18228*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 18234*/  /*SwitchType*/ 6, MVT::f64,// ->18242
/* 18236*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 18242*/  /*SwitchType*/ 8, MVT::v4f32,// ->18252
/* 18244*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18246*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 18252*/  /*SwitchType*/ 8, MVT::v2f64,// ->18262
/* 18254*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18256*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 18262*/  0, // EndSwitchType
/* 18263*/ /*SwitchOpcode*/ 35, TARGET_VAL(ISD::FRINT),// ->18301
/* 18266*/  OPC_RecordChild0, // #0 = $src
/* 18267*/  OPC_SwitchType /*4 cases */, 6, MVT::f32,// ->18276
/* 18270*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[f32] } f32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } f32:{ *:[f32] }:$src)
/* 18276*/  /*SwitchType*/ 6, MVT::f64,// ->18284
/* 18278*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[f64] } f64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } f64:{ *:[f64] }:$src)
/* 18284*/  /*SwitchType*/ 6, MVT::v4f32,// ->18292
/* 18286*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$src)
/* 18292*/  /*SwitchType*/ 6, MVT::v2f64,// ->18300
/* 18294*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$src)
/* 18300*/  0, // EndSwitchType
/* 18301*/ /*SwitchOpcode*/ 35, TARGET_VAL(ISD::FROUNDEVEN),// ->18339
/* 18304*/  OPC_RecordChild0, // #0 = $src
/* 18305*/  OPC_SwitchType /*4 cases */, 6, MVT::f32,// ->18314
/* 18308*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[f32] } f32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } f32:{ *:[f32] }:$src)
/* 18314*/  /*SwitchType*/ 6, MVT::f64,// ->18322
/* 18316*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[f64] } f64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } f64:{ *:[f64] }:$src)
/* 18322*/  /*SwitchType*/ 6, MVT::v4f32,// ->18330
/* 18324*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$src)
/* 18330*/  /*SwitchType*/ 6, MVT::v2f64,// ->18338
/* 18332*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$src)
/* 18338*/  0, // EndSwitchType
/* 18339*/ /*SwitchOpcode*/ 26|128,3/*410*/, TARGET_VAL(ISD::BUILD_VECTOR),// ->18753
/* 18343*/  OPC_RecordChild0, // #0 = $i0
/* 18344*/  OPC_MoveChild0,
/* 18345*/  OPC_SwitchOpcode /*2 cases */, 77|128,2/*333*/, TARGET_VAL(ISD::Constant),// ->18683
/* 18350*/   OPC_SwitchType /*2 cases */, 50|128,2/*306*/, MVT::i32,// ->18660
/* 18354*/    OPC_Scope, 52|128,1/*180*/, /*->18537*/ // 3 children in Scope
/* 18357*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 18359*/     OPC_MoveSibling1,
/* 18360*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18363*/     OPC_RecordNode, // #1 = $i1
/* 18364*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 18366*/     OPC_CheckTypeI32,
/* 18367*/     OPC_MoveSibling2,
/* 18368*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18371*/     OPC_RecordNode, // #2 = $i2
/* 18372*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 18374*/     OPC_CheckTypeI32,
/* 18375*/     OPC_MoveSibling3,
/* 18376*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18379*/     OPC_RecordNode, // #3 = $i3
/* 18380*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 18382*/     OPC_CheckTypeI32,
/* 18383*/     OPC_MoveSibling4,
/* 18384*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18387*/     OPC_RecordNode, // #4 = $i4
/* 18388*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 18390*/     OPC_CheckTypeI32,
/* 18391*/     OPC_MoveSibling5,
/* 18392*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18395*/     OPC_RecordNode, // #5 = $i5
/* 18396*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 18398*/     OPC_CheckTypeI32,
/* 18399*/     OPC_MoveSibling6,
/* 18400*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18403*/     OPC_RecordNode, // #6 = $i6
/* 18404*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 18406*/     OPC_CheckTypeI32,
/* 18407*/     OPC_MoveSibling7,
/* 18408*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18411*/     OPC_RecordNode, // #7 = $i7
/* 18412*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 18414*/     OPC_CheckTypeI32,
/* 18415*/     OPC_MoveSibling, 8,
/* 18417*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18420*/     OPC_RecordNode, // #8 = $i8
/* 18421*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 18423*/     OPC_CheckTypeI32,
/* 18424*/     OPC_MoveSibling, 9,
/* 18426*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18429*/     OPC_RecordNode, // #9 = $i9
/* 18430*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 18432*/     OPC_CheckTypeI32,
/* 18433*/     OPC_MoveSibling, 10,
/* 18435*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18438*/     OPC_RecordNode, // #10 = $iA
/* 18439*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 18441*/     OPC_CheckTypeI32,
/* 18442*/     OPC_MoveSibling, 11,
/* 18444*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18447*/     OPC_RecordNode, // #11 = $iB
/* 18448*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 18450*/     OPC_CheckTypeI32,
/* 18451*/     OPC_MoveSibling, 12,
/* 18453*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18456*/     OPC_RecordNode, // #12 = $iC
/* 18457*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 18459*/     OPC_CheckTypeI32,
/* 18460*/     OPC_MoveSibling, 13,
/* 18462*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18465*/     OPC_RecordNode, // #13 = $iD
/* 18466*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 18468*/     OPC_CheckTypeI32,
/* 18469*/     OPC_MoveSibling, 14,
/* 18471*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18474*/     OPC_RecordNode, // #14 = $iE
/* 18475*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 18477*/     OPC_CheckTypeI32,
/* 18478*/     OPC_MoveSibling, 15,
/* 18480*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18483*/     OPC_RecordNode, // #15 = $iF
/* 18484*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 18486*/     OPC_CheckTypeI32,
/* 18487*/     OPC_MoveParent,
/* 18488*/     OPC_CheckType, MVT::v16i8,
/* 18490*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18492*/     OPC_EmitConvertToTarget0,
/* 18493*/     OPC_EmitConvertToTarget1,
/* 18494*/     OPC_EmitConvertToTarget2,
/* 18495*/     OPC_EmitConvertToTarget3,
/* 18496*/     OPC_EmitConvertToTarget4,
/* 18497*/     OPC_EmitConvertToTarget5,
/* 18498*/     OPC_EmitConvertToTarget6,
/* 18499*/     OPC_EmitConvertToTarget7,
/* 18500*/     OPC_EmitConvertToTarget, 8,
/* 18502*/     OPC_EmitConvertToTarget, 9,
/* 18504*/     OPC_EmitConvertToTarget, 10,
/* 18506*/     OPC_EmitConvertToTarget, 11,
/* 18508*/     OPC_EmitConvertToTarget, 12,
/* 18510*/     OPC_EmitConvertToTarget, 13,
/* 18512*/     OPC_EmitConvertToTarget, 14,
/* 18514*/     OPC_EmitConvertToTarget, 15,
/* 18516*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I8x16),
                   MVT::v16i8, 16/*#Ops*/, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 
               // Src: (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i7, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i8, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i9, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iA, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iB, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iC, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iD, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iE, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iF) - Complexity = 67
               // Dst: (CONST_V128_I8x16:{ *:[v16i8] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7, (imm:{ *:[i32] }):$i8, (imm:{ *:[i32] }):$i9, (imm:{ *:[i32] }):$iA, (imm:{ *:[i32] }):$iB, (imm:{ *:[i32] }):$iC, (imm:{ *:[i32] }):$iD, (imm:{ *:[i32] }):$iE, (imm:{ *:[i32] }):$iF)
/* 18537*/    /*Scope*/ 84, /*->18622*/
/* 18538*/     OPC_CheckPredicate, 24, // Predicate_ImmI16
/* 18540*/     OPC_MoveSibling1,
/* 18541*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18544*/     OPC_RecordNode, // #1 = $i1
/* 18545*/     OPC_CheckPredicate, 24, // Predicate_ImmI16
/* 18547*/     OPC_CheckTypeI32,
/* 18548*/     OPC_MoveSibling2,
/* 18549*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18552*/     OPC_RecordNode, // #2 = $i2
/* 18553*/     OPC_CheckPredicate, 24, // Predicate_ImmI16
/* 18555*/     OPC_CheckTypeI32,
/* 18556*/     OPC_MoveSibling3,
/* 18557*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18560*/     OPC_RecordNode, // #3 = $i3
/* 18561*/     OPC_CheckPredicate, 24, // Predicate_ImmI16
/* 18563*/     OPC_CheckTypeI32,
/* 18564*/     OPC_MoveSibling4,
/* 18565*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18568*/     OPC_RecordNode, // #4 = $i4
/* 18569*/     OPC_CheckPredicate, 24, // Predicate_ImmI16
/* 18571*/     OPC_CheckTypeI32,
/* 18572*/     OPC_MoveSibling5,
/* 18573*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18576*/     OPC_RecordNode, // #5 = $i5
/* 18577*/     OPC_CheckPredicate, 24, // Predicate_ImmI16
/* 18579*/     OPC_CheckTypeI32,
/* 18580*/     OPC_MoveSibling6,
/* 18581*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18584*/     OPC_RecordNode, // #6 = $i6
/* 18585*/     OPC_CheckPredicate, 24, // Predicate_ImmI16
/* 18587*/     OPC_CheckTypeI32,
/* 18588*/     OPC_MoveSibling7,
/* 18589*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18592*/     OPC_RecordNode, // #7 = $i7
/* 18593*/     OPC_CheckPredicate, 24, // Predicate_ImmI16
/* 18595*/     OPC_CheckTypeI32,
/* 18596*/     OPC_MoveParent,
/* 18597*/     OPC_CheckType, MVT::v8i16,
/* 18599*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18601*/     OPC_EmitConvertToTarget0,
/* 18602*/     OPC_EmitConvertToTarget1,
/* 18603*/     OPC_EmitConvertToTarget2,
/* 18604*/     OPC_EmitConvertToTarget3,
/* 18605*/     OPC_EmitConvertToTarget4,
/* 18606*/     OPC_EmitConvertToTarget5,
/* 18607*/     OPC_EmitConvertToTarget6,
/* 18608*/     OPC_EmitConvertToTarget7,
/* 18609*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I16x8),
                   MVT::v8i16, 8/*#Ops*/, 8, 9, 10, 11, 12, 13, 14, 15, 
               // Src: (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i7) - Complexity = 35
               // Dst: (CONST_V128_I16x8:{ *:[v8i16] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7)
/* 18622*/    /*Scope*/ 36, /*->18659*/
/* 18623*/     OPC_MoveSibling1,
/* 18624*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18627*/     OPC_RecordNode, // #1 = $i1
/* 18628*/     OPC_CheckTypeI32,
/* 18629*/     OPC_MoveSibling2,
/* 18630*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18633*/     OPC_RecordNode, // #2 = $i2
/* 18634*/     OPC_CheckTypeI32,
/* 18635*/     OPC_MoveSibling3,
/* 18636*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18639*/     OPC_RecordNode, // #3 = $i3
/* 18640*/     OPC_CheckTypeI32,
/* 18641*/     OPC_MoveParent,
/* 18642*/     OPC_CheckType, MVT::v4i32,
/* 18644*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18646*/     OPC_EmitConvertToTarget0,
/* 18647*/     OPC_EmitConvertToTarget1,
/* 18648*/     OPC_EmitConvertToTarget2,
/* 18649*/     OPC_EmitConvertToTarget3,
/* 18650*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I32x4),
                   MVT::v4i32, 4/*#Ops*/, 4, 5, 6, 7, 
               // Src: (build_vector:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3) - Complexity = 15
               // Dst: (CONST_V128_I32x4:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3)
/* 18659*/    0, /*End of Scope*/
/* 18660*/   /*SwitchType*/ 20, MVT::i64,// ->18682
/* 18662*/    OPC_MoveSibling1,
/* 18663*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18666*/    OPC_RecordNode, // #1 = $i1
/* 18667*/    OPC_CheckTypeI64,
/* 18668*/    OPC_MoveParent,
/* 18669*/    OPC_CheckType, MVT::v2i64,
/* 18671*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18673*/    OPC_EmitConvertToTarget0,
/* 18674*/    OPC_EmitConvertToTarget1,
/* 18675*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 2, 3, 
              // Src: (build_vector:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1) - Complexity = 9
              // Dst: (CONST_V128_I64x2:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1)
/* 18682*/   0, // EndSwitchType
/* 18683*/  /*SwitchOpcode*/ 66, TARGET_VAL(ISD::ConstantFP),// ->18752
/* 18686*/   OPC_SwitchType /*2 cases */, 39, MVT::f32,// ->18728
/* 18689*/    OPC_MoveSibling1,
/* 18690*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18693*/    OPC_RecordNode, // #1 = $i1
/* 18694*/    OPC_CheckType, MVT::f32,
/* 18696*/    OPC_MoveSibling2,
/* 18697*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18700*/    OPC_RecordNode, // #2 = $i2
/* 18701*/    OPC_CheckType, MVT::f32,
/* 18703*/    OPC_MoveSibling3,
/* 18704*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18707*/    OPC_RecordNode, // #3 = $i3
/* 18708*/    OPC_CheckType, MVT::f32,
/* 18710*/    OPC_MoveParent,
/* 18711*/    OPC_CheckType, MVT::v4f32,
/* 18713*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18715*/    OPC_EmitConvertToTarget0,
/* 18716*/    OPC_EmitConvertToTarget1,
/* 18717*/    OPC_EmitConvertToTarget2,
/* 18718*/    OPC_EmitConvertToTarget3,
/* 18719*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F32x4),
                  MVT::v4f32, 4/*#Ops*/, 4, 5, 6, 7, 
              // Src: (build_vector:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3) - Complexity = 15
              // Dst: (CONST_V128_F32x4:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3)
/* 18728*/   /*SwitchType*/ 21, MVT::f64,// ->18751
/* 18730*/    OPC_MoveSibling1,
/* 18731*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18734*/    OPC_RecordNode, // #1 = $i1
/* 18735*/    OPC_CheckType, MVT::f64,
/* 18737*/    OPC_MoveParent,
/* 18738*/    OPC_CheckType, MVT::v2f64,
/* 18740*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18742*/    OPC_EmitConvertToTarget0,
/* 18743*/    OPC_EmitConvertToTarget1,
/* 18744*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F64x2),
                  MVT::v2f64, 2/*#Ops*/, 2, 3, 
              // Src: (build_vector:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1) - Complexity = 9
              // Dst: (CONST_V128_F64x2:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1)
/* 18751*/   0, // EndSwitchType
/* 18752*/  0, // EndSwitchOpcode
/* 18753*/ /*SwitchOpcode*/ 97|128,16/*2145*/, TARGET_VAL(WebAssemblyISD::SHUFFLE),// ->20902
/* 18757*/  OPC_RecordChild0, // #0 = $x
/* 18758*/  OPC_Scope, 99|128,2/*355*/, /*->19116*/ // 6 children in Scope
/* 18761*/   OPC_CheckChild0Type, MVT::v16i8,
/* 18763*/   OPC_RecordChild1, // #1 = $y
/* 18764*/   OPC_CheckChild1Type, MVT::v16i8,
/* 18766*/   OPC_RecordChild2, // #2 = $m0
/* 18767*/   OPC_MoveChild2,
/* 18768*/   OPC_SwitchOpcode /*2 cases */, 57|128,1/*185*/, TARGET_VAL(ISD::Constant),// ->18958
/* 18773*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 18775*/    OPC_CheckTypeI32,
/* 18776*/    OPC_MoveSibling3,
/* 18777*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18780*/    OPC_RecordNode, // #3 = $m1
/* 18781*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 18783*/    OPC_CheckTypeI32,
/* 18784*/    OPC_MoveSibling4,
/* 18785*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18788*/    OPC_RecordNode, // #4 = $m2
/* 18789*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 18791*/    OPC_CheckTypeI32,
/* 18792*/    OPC_MoveSibling5,
/* 18793*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18796*/    OPC_RecordNode, // #5 = $m3
/* 18797*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 18799*/    OPC_CheckTypeI32,
/* 18800*/    OPC_MoveSibling6,
/* 18801*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18804*/    OPC_RecordNode, // #6 = $m4
/* 18805*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 18807*/    OPC_CheckTypeI32,
/* 18808*/    OPC_MoveSibling7,
/* 18809*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18812*/    OPC_RecordNode, // #7 = $m5
/* 18813*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 18815*/    OPC_CheckTypeI32,
/* 18816*/    OPC_MoveSibling, 8,
/* 18818*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18821*/    OPC_RecordNode, // #8 = $m6
/* 18822*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 18824*/    OPC_CheckTypeI32,
/* 18825*/    OPC_MoveSibling, 9,
/* 18827*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18830*/    OPC_RecordNode, // #9 = $m7
/* 18831*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 18833*/    OPC_CheckTypeI32,
/* 18834*/    OPC_MoveSibling, 10,
/* 18836*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18839*/    OPC_RecordNode, // #10 = $m8
/* 18840*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 18842*/    OPC_CheckTypeI32,
/* 18843*/    OPC_MoveSibling, 11,
/* 18845*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18848*/    OPC_RecordNode, // #11 = $m9
/* 18849*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 18851*/    OPC_CheckTypeI32,
/* 18852*/    OPC_MoveSibling, 12,
/* 18854*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18857*/    OPC_RecordNode, // #12 = $mA
/* 18858*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 18860*/    OPC_CheckTypeI32,
/* 18861*/    OPC_MoveSibling, 13,
/* 18863*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18866*/    OPC_RecordNode, // #13 = $mB
/* 18867*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 18869*/    OPC_CheckTypeI32,
/* 18870*/    OPC_MoveSibling, 14,
/* 18872*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18875*/    OPC_RecordNode, // #14 = $mC
/* 18876*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 18878*/    OPC_CheckTypeI32,
/* 18879*/    OPC_MoveSibling, 15,
/* 18881*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18884*/    OPC_RecordNode, // #15 = $mD
/* 18885*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 18887*/    OPC_CheckTypeI32,
/* 18888*/    OPC_MoveSibling, 16,
/* 18890*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18893*/    OPC_RecordNode, // #16 = $mE
/* 18894*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 18896*/    OPC_CheckTypeI32,
/* 18897*/    OPC_MoveSibling, 17,
/* 18899*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18902*/    OPC_RecordNode, // #17 = $mF
/* 18903*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 18905*/    OPC_CheckTypeI32,
/* 18906*/    OPC_MoveParent,
/* 18907*/    OPC_CheckType, MVT::v16i8,
/* 18909*/    OPC_EmitConvertToTarget2,
/* 18910*/    OPC_EmitConvertToTarget3,
/* 18911*/    OPC_EmitConvertToTarget4,
/* 18912*/    OPC_EmitConvertToTarget5,
/* 18913*/    OPC_EmitConvertToTarget6,
/* 18914*/    OPC_EmitConvertToTarget7,
/* 18915*/    OPC_EmitConvertToTarget, 8,
/* 18917*/    OPC_EmitConvertToTarget, 9,
/* 18919*/    OPC_EmitConvertToTarget, 10,
/* 18921*/    OPC_EmitConvertToTarget, 11,
/* 18923*/    OPC_EmitConvertToTarget, 12,
/* 18925*/    OPC_EmitConvertToTarget, 13,
/* 18927*/    OPC_EmitConvertToTarget, 14,
/* 18929*/    OPC_EmitConvertToTarget, 15,
/* 18931*/    OPC_EmitConvertToTarget, 16,
/* 18933*/    OPC_EmitConvertToTarget, 17,
/* 18935*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v16i8, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v16i8] } V128:{ *:[v16i8] }:$x, V128:{ *:[v16i8] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$x, ?:{ *:[v16i8] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 18958*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19115
/* 18962*/    OPC_CheckTypeI32,
/* 18963*/    OPC_MoveSibling3,
/* 18964*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18967*/    OPC_RecordNode, // #3 = $m1
/* 18968*/    OPC_CheckTypeI32,
/* 18969*/    OPC_MoveSibling4,
/* 18970*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18973*/    OPC_RecordNode, // #4 = $m2
/* 18974*/    OPC_CheckTypeI32,
/* 18975*/    OPC_MoveSibling5,
/* 18976*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18979*/    OPC_RecordNode, // #5 = $m3
/* 18980*/    OPC_CheckTypeI32,
/* 18981*/    OPC_MoveSibling6,
/* 18982*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18985*/    OPC_RecordNode, // #6 = $m4
/* 18986*/    OPC_CheckTypeI32,
/* 18987*/    OPC_MoveSibling7,
/* 18988*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18991*/    OPC_RecordNode, // #7 = $m5
/* 18992*/    OPC_CheckTypeI32,
/* 18993*/    OPC_MoveSibling, 8,
/* 18995*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18998*/    OPC_RecordNode, // #8 = $m6
/* 18999*/    OPC_CheckTypeI32,
/* 19000*/    OPC_MoveSibling, 9,
/* 19002*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19005*/    OPC_RecordNode, // #9 = $m7
/* 19006*/    OPC_CheckTypeI32,
/* 19007*/    OPC_MoveSibling, 10,
/* 19009*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19012*/    OPC_RecordNode, // #10 = $m8
/* 19013*/    OPC_CheckTypeI32,
/* 19014*/    OPC_MoveSibling, 11,
/* 19016*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19019*/    OPC_RecordNode, // #11 = $m9
/* 19020*/    OPC_CheckTypeI32,
/* 19021*/    OPC_MoveSibling, 12,
/* 19023*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19026*/    OPC_RecordNode, // #12 = $mA
/* 19027*/    OPC_CheckTypeI32,
/* 19028*/    OPC_MoveSibling, 13,
/* 19030*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19033*/    OPC_RecordNode, // #13 = $mB
/* 19034*/    OPC_CheckTypeI32,
/* 19035*/    OPC_MoveSibling, 14,
/* 19037*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19040*/    OPC_RecordNode, // #14 = $mC
/* 19041*/    OPC_CheckTypeI32,
/* 19042*/    OPC_MoveSibling, 15,
/* 19044*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19047*/    OPC_RecordNode, // #15 = $mD
/* 19048*/    OPC_CheckTypeI32,
/* 19049*/    OPC_MoveSibling, 16,
/* 19051*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19054*/    OPC_RecordNode, // #16 = $mE
/* 19055*/    OPC_CheckTypeI32,
/* 19056*/    OPC_MoveSibling, 17,
/* 19058*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19061*/    OPC_RecordNode, // #17 = $mF
/* 19062*/    OPC_CheckTypeI32,
/* 19063*/    OPC_MoveParent,
/* 19064*/    OPC_CheckType, MVT::v16i8,
/* 19066*/    OPC_EmitConvertToTarget2,
/* 19067*/    OPC_EmitConvertToTarget3,
/* 19068*/    OPC_EmitConvertToTarget4,
/* 19069*/    OPC_EmitConvertToTarget5,
/* 19070*/    OPC_EmitConvertToTarget6,
/* 19071*/    OPC_EmitConvertToTarget7,
/* 19072*/    OPC_EmitConvertToTarget, 8,
/* 19074*/    OPC_EmitConvertToTarget, 9,
/* 19076*/    OPC_EmitConvertToTarget, 10,
/* 19078*/    OPC_EmitConvertToTarget, 11,
/* 19080*/    OPC_EmitConvertToTarget, 12,
/* 19082*/    OPC_EmitConvertToTarget, 13,
/* 19084*/    OPC_EmitConvertToTarget, 14,
/* 19086*/    OPC_EmitConvertToTarget, 15,
/* 19088*/    OPC_EmitConvertToTarget, 16,
/* 19090*/    OPC_EmitConvertToTarget, 17,
/* 19092*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v16i8, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v16i8] } V128:{ *:[v16i8] }:$x, V128:{ *:[v16i8] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$x, ?:{ *:[v16i8] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19115*/   0, // EndSwitchOpcode
/* 19116*/  /*Scope*/ 99|128,2/*355*/, /*->19473*/
/* 19118*/   OPC_CheckChild0Type, MVT::v8i16,
/* 19120*/   OPC_RecordChild1, // #1 = $y
/* 19121*/   OPC_CheckChild1Type, MVT::v8i16,
/* 19123*/   OPC_RecordChild2, // #2 = $m0
/* 19124*/   OPC_MoveChild2,
/* 19125*/   OPC_SwitchOpcode /*2 cases */, 57|128,1/*185*/, TARGET_VAL(ISD::Constant),// ->19315
/* 19130*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19132*/    OPC_CheckTypeI32,
/* 19133*/    OPC_MoveSibling3,
/* 19134*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19137*/    OPC_RecordNode, // #3 = $m1
/* 19138*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19140*/    OPC_CheckTypeI32,
/* 19141*/    OPC_MoveSibling4,
/* 19142*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19145*/    OPC_RecordNode, // #4 = $m2
/* 19146*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19148*/    OPC_CheckTypeI32,
/* 19149*/    OPC_MoveSibling5,
/* 19150*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19153*/    OPC_RecordNode, // #5 = $m3
/* 19154*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19156*/    OPC_CheckTypeI32,
/* 19157*/    OPC_MoveSibling6,
/* 19158*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19161*/    OPC_RecordNode, // #6 = $m4
/* 19162*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19164*/    OPC_CheckTypeI32,
/* 19165*/    OPC_MoveSibling7,
/* 19166*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19169*/    OPC_RecordNode, // #7 = $m5
/* 19170*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19172*/    OPC_CheckTypeI32,
/* 19173*/    OPC_MoveSibling, 8,
/* 19175*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19178*/    OPC_RecordNode, // #8 = $m6
/* 19179*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19181*/    OPC_CheckTypeI32,
/* 19182*/    OPC_MoveSibling, 9,
/* 19184*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19187*/    OPC_RecordNode, // #9 = $m7
/* 19188*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19190*/    OPC_CheckTypeI32,
/* 19191*/    OPC_MoveSibling, 10,
/* 19193*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19196*/    OPC_RecordNode, // #10 = $m8
/* 19197*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19199*/    OPC_CheckTypeI32,
/* 19200*/    OPC_MoveSibling, 11,
/* 19202*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19205*/    OPC_RecordNode, // #11 = $m9
/* 19206*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19208*/    OPC_CheckTypeI32,
/* 19209*/    OPC_MoveSibling, 12,
/* 19211*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19214*/    OPC_RecordNode, // #12 = $mA
/* 19215*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19217*/    OPC_CheckTypeI32,
/* 19218*/    OPC_MoveSibling, 13,
/* 19220*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19223*/    OPC_RecordNode, // #13 = $mB
/* 19224*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19226*/    OPC_CheckTypeI32,
/* 19227*/    OPC_MoveSibling, 14,
/* 19229*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19232*/    OPC_RecordNode, // #14 = $mC
/* 19233*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19235*/    OPC_CheckTypeI32,
/* 19236*/    OPC_MoveSibling, 15,
/* 19238*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19241*/    OPC_RecordNode, // #15 = $mD
/* 19242*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19244*/    OPC_CheckTypeI32,
/* 19245*/    OPC_MoveSibling, 16,
/* 19247*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19250*/    OPC_RecordNode, // #16 = $mE
/* 19251*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19253*/    OPC_CheckTypeI32,
/* 19254*/    OPC_MoveSibling, 17,
/* 19256*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19259*/    OPC_RecordNode, // #17 = $mF
/* 19260*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19262*/    OPC_CheckTypeI32,
/* 19263*/    OPC_MoveParent,
/* 19264*/    OPC_CheckType, MVT::v8i16,
/* 19266*/    OPC_EmitConvertToTarget2,
/* 19267*/    OPC_EmitConvertToTarget3,
/* 19268*/    OPC_EmitConvertToTarget4,
/* 19269*/    OPC_EmitConvertToTarget5,
/* 19270*/    OPC_EmitConvertToTarget6,
/* 19271*/    OPC_EmitConvertToTarget7,
/* 19272*/    OPC_EmitConvertToTarget, 8,
/* 19274*/    OPC_EmitConvertToTarget, 9,
/* 19276*/    OPC_EmitConvertToTarget, 10,
/* 19278*/    OPC_EmitConvertToTarget, 11,
/* 19280*/    OPC_EmitConvertToTarget, 12,
/* 19282*/    OPC_EmitConvertToTarget, 13,
/* 19284*/    OPC_EmitConvertToTarget, 14,
/* 19286*/    OPC_EmitConvertToTarget, 15,
/* 19288*/    OPC_EmitConvertToTarget, 16,
/* 19290*/    OPC_EmitConvertToTarget, 17,
/* 19292*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v8i16, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v8i16] } V128:{ *:[v8i16] }:$x, V128:{ *:[v8i16] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v8i16] } ?:{ *:[v8i16] }:$x, ?:{ *:[v8i16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19315*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19472
/* 19319*/    OPC_CheckTypeI32,
/* 19320*/    OPC_MoveSibling3,
/* 19321*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19324*/    OPC_RecordNode, // #3 = $m1
/* 19325*/    OPC_CheckTypeI32,
/* 19326*/    OPC_MoveSibling4,
/* 19327*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19330*/    OPC_RecordNode, // #4 = $m2
/* 19331*/    OPC_CheckTypeI32,
/* 19332*/    OPC_MoveSibling5,
/* 19333*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19336*/    OPC_RecordNode, // #5 = $m3
/* 19337*/    OPC_CheckTypeI32,
/* 19338*/    OPC_MoveSibling6,
/* 19339*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19342*/    OPC_RecordNode, // #6 = $m4
/* 19343*/    OPC_CheckTypeI32,
/* 19344*/    OPC_MoveSibling7,
/* 19345*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19348*/    OPC_RecordNode, // #7 = $m5
/* 19349*/    OPC_CheckTypeI32,
/* 19350*/    OPC_MoveSibling, 8,
/* 19352*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19355*/    OPC_RecordNode, // #8 = $m6
/* 19356*/    OPC_CheckTypeI32,
/* 19357*/    OPC_MoveSibling, 9,
/* 19359*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19362*/    OPC_RecordNode, // #9 = $m7
/* 19363*/    OPC_CheckTypeI32,
/* 19364*/    OPC_MoveSibling, 10,
/* 19366*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19369*/    OPC_RecordNode, // #10 = $m8
/* 19370*/    OPC_CheckTypeI32,
/* 19371*/    OPC_MoveSibling, 11,
/* 19373*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19376*/    OPC_RecordNode, // #11 = $m9
/* 19377*/    OPC_CheckTypeI32,
/* 19378*/    OPC_MoveSibling, 12,
/* 19380*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19383*/    OPC_RecordNode, // #12 = $mA
/* 19384*/    OPC_CheckTypeI32,
/* 19385*/    OPC_MoveSibling, 13,
/* 19387*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19390*/    OPC_RecordNode, // #13 = $mB
/* 19391*/    OPC_CheckTypeI32,
/* 19392*/    OPC_MoveSibling, 14,
/* 19394*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19397*/    OPC_RecordNode, // #14 = $mC
/* 19398*/    OPC_CheckTypeI32,
/* 19399*/    OPC_MoveSibling, 15,
/* 19401*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19404*/    OPC_RecordNode, // #15 = $mD
/* 19405*/    OPC_CheckTypeI32,
/* 19406*/    OPC_MoveSibling, 16,
/* 19408*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19411*/    OPC_RecordNode, // #16 = $mE
/* 19412*/    OPC_CheckTypeI32,
/* 19413*/    OPC_MoveSibling, 17,
/* 19415*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19418*/    OPC_RecordNode, // #17 = $mF
/* 19419*/    OPC_CheckTypeI32,
/* 19420*/    OPC_MoveParent,
/* 19421*/    OPC_CheckType, MVT::v8i16,
/* 19423*/    OPC_EmitConvertToTarget2,
/* 19424*/    OPC_EmitConvertToTarget3,
/* 19425*/    OPC_EmitConvertToTarget4,
/* 19426*/    OPC_EmitConvertToTarget5,
/* 19427*/    OPC_EmitConvertToTarget6,
/* 19428*/    OPC_EmitConvertToTarget7,
/* 19429*/    OPC_EmitConvertToTarget, 8,
/* 19431*/    OPC_EmitConvertToTarget, 9,
/* 19433*/    OPC_EmitConvertToTarget, 10,
/* 19435*/    OPC_EmitConvertToTarget, 11,
/* 19437*/    OPC_EmitConvertToTarget, 12,
/* 19439*/    OPC_EmitConvertToTarget, 13,
/* 19441*/    OPC_EmitConvertToTarget, 14,
/* 19443*/    OPC_EmitConvertToTarget, 15,
/* 19445*/    OPC_EmitConvertToTarget, 16,
/* 19447*/    OPC_EmitConvertToTarget, 17,
/* 19449*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v8i16, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v8i16] } V128:{ *:[v8i16] }:$x, V128:{ *:[v8i16] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v8i16] } ?:{ *:[v8i16] }:$x, ?:{ *:[v8i16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19472*/   0, // EndSwitchOpcode
/* 19473*/  /*Scope*/ 99|128,2/*355*/, /*->19830*/
/* 19475*/   OPC_CheckChild0Type, MVT::v4i32,
/* 19477*/   OPC_RecordChild1, // #1 = $y
/* 19478*/   OPC_CheckChild1Type, MVT::v4i32,
/* 19480*/   OPC_RecordChild2, // #2 = $m0
/* 19481*/   OPC_MoveChild2,
/* 19482*/   OPC_SwitchOpcode /*2 cases */, 57|128,1/*185*/, TARGET_VAL(ISD::Constant),// ->19672
/* 19487*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19489*/    OPC_CheckTypeI32,
/* 19490*/    OPC_MoveSibling3,
/* 19491*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19494*/    OPC_RecordNode, // #3 = $m1
/* 19495*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19497*/    OPC_CheckTypeI32,
/* 19498*/    OPC_MoveSibling4,
/* 19499*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19502*/    OPC_RecordNode, // #4 = $m2
/* 19503*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19505*/    OPC_CheckTypeI32,
/* 19506*/    OPC_MoveSibling5,
/* 19507*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19510*/    OPC_RecordNode, // #5 = $m3
/* 19511*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19513*/    OPC_CheckTypeI32,
/* 19514*/    OPC_MoveSibling6,
/* 19515*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19518*/    OPC_RecordNode, // #6 = $m4
/* 19519*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19521*/    OPC_CheckTypeI32,
/* 19522*/    OPC_MoveSibling7,
/* 19523*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19526*/    OPC_RecordNode, // #7 = $m5
/* 19527*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19529*/    OPC_CheckTypeI32,
/* 19530*/    OPC_MoveSibling, 8,
/* 19532*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19535*/    OPC_RecordNode, // #8 = $m6
/* 19536*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19538*/    OPC_CheckTypeI32,
/* 19539*/    OPC_MoveSibling, 9,
/* 19541*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19544*/    OPC_RecordNode, // #9 = $m7
/* 19545*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19547*/    OPC_CheckTypeI32,
/* 19548*/    OPC_MoveSibling, 10,
/* 19550*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19553*/    OPC_RecordNode, // #10 = $m8
/* 19554*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19556*/    OPC_CheckTypeI32,
/* 19557*/    OPC_MoveSibling, 11,
/* 19559*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19562*/    OPC_RecordNode, // #11 = $m9
/* 19563*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19565*/    OPC_CheckTypeI32,
/* 19566*/    OPC_MoveSibling, 12,
/* 19568*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19571*/    OPC_RecordNode, // #12 = $mA
/* 19572*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19574*/    OPC_CheckTypeI32,
/* 19575*/    OPC_MoveSibling, 13,
/* 19577*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19580*/    OPC_RecordNode, // #13 = $mB
/* 19581*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19583*/    OPC_CheckTypeI32,
/* 19584*/    OPC_MoveSibling, 14,
/* 19586*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19589*/    OPC_RecordNode, // #14 = $mC
/* 19590*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19592*/    OPC_CheckTypeI32,
/* 19593*/    OPC_MoveSibling, 15,
/* 19595*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19598*/    OPC_RecordNode, // #15 = $mD
/* 19599*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19601*/    OPC_CheckTypeI32,
/* 19602*/    OPC_MoveSibling, 16,
/* 19604*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19607*/    OPC_RecordNode, // #16 = $mE
/* 19608*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19610*/    OPC_CheckTypeI32,
/* 19611*/    OPC_MoveSibling, 17,
/* 19613*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19616*/    OPC_RecordNode, // #17 = $mF
/* 19617*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19619*/    OPC_CheckTypeI32,
/* 19620*/    OPC_MoveParent,
/* 19621*/    OPC_CheckType, MVT::v4i32,
/* 19623*/    OPC_EmitConvertToTarget2,
/* 19624*/    OPC_EmitConvertToTarget3,
/* 19625*/    OPC_EmitConvertToTarget4,
/* 19626*/    OPC_EmitConvertToTarget5,
/* 19627*/    OPC_EmitConvertToTarget6,
/* 19628*/    OPC_EmitConvertToTarget7,
/* 19629*/    OPC_EmitConvertToTarget, 8,
/* 19631*/    OPC_EmitConvertToTarget, 9,
/* 19633*/    OPC_EmitConvertToTarget, 10,
/* 19635*/    OPC_EmitConvertToTarget, 11,
/* 19637*/    OPC_EmitConvertToTarget, 12,
/* 19639*/    OPC_EmitConvertToTarget, 13,
/* 19641*/    OPC_EmitConvertToTarget, 14,
/* 19643*/    OPC_EmitConvertToTarget, 15,
/* 19645*/    OPC_EmitConvertToTarget, 16,
/* 19647*/    OPC_EmitConvertToTarget, 17,
/* 19649*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v4i32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4i32] } V128:{ *:[v4i32] }:$x, V128:{ *:[v4i32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v4i32] } ?:{ *:[v4i32] }:$x, ?:{ *:[v4i32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19672*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19829
/* 19676*/    OPC_CheckTypeI32,
/* 19677*/    OPC_MoveSibling3,
/* 19678*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19681*/    OPC_RecordNode, // #3 = $m1
/* 19682*/    OPC_CheckTypeI32,
/* 19683*/    OPC_MoveSibling4,
/* 19684*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19687*/    OPC_RecordNode, // #4 = $m2
/* 19688*/    OPC_CheckTypeI32,
/* 19689*/    OPC_MoveSibling5,
/* 19690*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19693*/    OPC_RecordNode, // #5 = $m3
/* 19694*/    OPC_CheckTypeI32,
/* 19695*/    OPC_MoveSibling6,
/* 19696*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19699*/    OPC_RecordNode, // #6 = $m4
/* 19700*/    OPC_CheckTypeI32,
/* 19701*/    OPC_MoveSibling7,
/* 19702*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19705*/    OPC_RecordNode, // #7 = $m5
/* 19706*/    OPC_CheckTypeI32,
/* 19707*/    OPC_MoveSibling, 8,
/* 19709*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19712*/    OPC_RecordNode, // #8 = $m6
/* 19713*/    OPC_CheckTypeI32,
/* 19714*/    OPC_MoveSibling, 9,
/* 19716*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19719*/    OPC_RecordNode, // #9 = $m7
/* 19720*/    OPC_CheckTypeI32,
/* 19721*/    OPC_MoveSibling, 10,
/* 19723*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19726*/    OPC_RecordNode, // #10 = $m8
/* 19727*/    OPC_CheckTypeI32,
/* 19728*/    OPC_MoveSibling, 11,
/* 19730*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19733*/    OPC_RecordNode, // #11 = $m9
/* 19734*/    OPC_CheckTypeI32,
/* 19735*/    OPC_MoveSibling, 12,
/* 19737*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19740*/    OPC_RecordNode, // #12 = $mA
/* 19741*/    OPC_CheckTypeI32,
/* 19742*/    OPC_MoveSibling, 13,
/* 19744*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19747*/    OPC_RecordNode, // #13 = $mB
/* 19748*/    OPC_CheckTypeI32,
/* 19749*/    OPC_MoveSibling, 14,
/* 19751*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19754*/    OPC_RecordNode, // #14 = $mC
/* 19755*/    OPC_CheckTypeI32,
/* 19756*/    OPC_MoveSibling, 15,
/* 19758*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19761*/    OPC_RecordNode, // #15 = $mD
/* 19762*/    OPC_CheckTypeI32,
/* 19763*/    OPC_MoveSibling, 16,
/* 19765*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19768*/    OPC_RecordNode, // #16 = $mE
/* 19769*/    OPC_CheckTypeI32,
/* 19770*/    OPC_MoveSibling, 17,
/* 19772*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19775*/    OPC_RecordNode, // #17 = $mF
/* 19776*/    OPC_CheckTypeI32,
/* 19777*/    OPC_MoveParent,
/* 19778*/    OPC_CheckType, MVT::v4i32,
/* 19780*/    OPC_EmitConvertToTarget2,
/* 19781*/    OPC_EmitConvertToTarget3,
/* 19782*/    OPC_EmitConvertToTarget4,
/* 19783*/    OPC_EmitConvertToTarget5,
/* 19784*/    OPC_EmitConvertToTarget6,
/* 19785*/    OPC_EmitConvertToTarget7,
/* 19786*/    OPC_EmitConvertToTarget, 8,
/* 19788*/    OPC_EmitConvertToTarget, 9,
/* 19790*/    OPC_EmitConvertToTarget, 10,
/* 19792*/    OPC_EmitConvertToTarget, 11,
/* 19794*/    OPC_EmitConvertToTarget, 12,
/* 19796*/    OPC_EmitConvertToTarget, 13,
/* 19798*/    OPC_EmitConvertToTarget, 14,
/* 19800*/    OPC_EmitConvertToTarget, 15,
/* 19802*/    OPC_EmitConvertToTarget, 16,
/* 19804*/    OPC_EmitConvertToTarget, 17,
/* 19806*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v4i32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4i32] } V128:{ *:[v4i32] }:$x, V128:{ *:[v4i32] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v4i32] } ?:{ *:[v4i32] }:$x, ?:{ *:[v4i32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19829*/   0, // EndSwitchOpcode
/* 19830*/  /*Scope*/ 99|128,2/*355*/, /*->20187*/
/* 19832*/   OPC_CheckChild0Type, MVT::v2i64,
/* 19834*/   OPC_RecordChild1, // #1 = $y
/* 19835*/   OPC_CheckChild1Type, MVT::v2i64,
/* 19837*/   OPC_RecordChild2, // #2 = $m0
/* 19838*/   OPC_MoveChild2,
/* 19839*/   OPC_SwitchOpcode /*2 cases */, 57|128,1/*185*/, TARGET_VAL(ISD::Constant),// ->20029
/* 19844*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19846*/    OPC_CheckTypeI32,
/* 19847*/    OPC_MoveSibling3,
/* 19848*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19851*/    OPC_RecordNode, // #3 = $m1
/* 19852*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19854*/    OPC_CheckTypeI32,
/* 19855*/    OPC_MoveSibling4,
/* 19856*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19859*/    OPC_RecordNode, // #4 = $m2
/* 19860*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19862*/    OPC_CheckTypeI32,
/* 19863*/    OPC_MoveSibling5,
/* 19864*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19867*/    OPC_RecordNode, // #5 = $m3
/* 19868*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19870*/    OPC_CheckTypeI32,
/* 19871*/    OPC_MoveSibling6,
/* 19872*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19875*/    OPC_RecordNode, // #6 = $m4
/* 19876*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19878*/    OPC_CheckTypeI32,
/* 19879*/    OPC_MoveSibling7,
/* 19880*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19883*/    OPC_RecordNode, // #7 = $m5
/* 19884*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19886*/    OPC_CheckTypeI32,
/* 19887*/    OPC_MoveSibling, 8,
/* 19889*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19892*/    OPC_RecordNode, // #8 = $m6
/* 19893*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19895*/    OPC_CheckTypeI32,
/* 19896*/    OPC_MoveSibling, 9,
/* 19898*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19901*/    OPC_RecordNode, // #9 = $m7
/* 19902*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19904*/    OPC_CheckTypeI32,
/* 19905*/    OPC_MoveSibling, 10,
/* 19907*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19910*/    OPC_RecordNode, // #10 = $m8
/* 19911*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19913*/    OPC_CheckTypeI32,
/* 19914*/    OPC_MoveSibling, 11,
/* 19916*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19919*/    OPC_RecordNode, // #11 = $m9
/* 19920*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19922*/    OPC_CheckTypeI32,
/* 19923*/    OPC_MoveSibling, 12,
/* 19925*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19928*/    OPC_RecordNode, // #12 = $mA
/* 19929*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19931*/    OPC_CheckTypeI32,
/* 19932*/    OPC_MoveSibling, 13,
/* 19934*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19937*/    OPC_RecordNode, // #13 = $mB
/* 19938*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19940*/    OPC_CheckTypeI32,
/* 19941*/    OPC_MoveSibling, 14,
/* 19943*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19946*/    OPC_RecordNode, // #14 = $mC
/* 19947*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19949*/    OPC_CheckTypeI32,
/* 19950*/    OPC_MoveSibling, 15,
/* 19952*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19955*/    OPC_RecordNode, // #15 = $mD
/* 19956*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19958*/    OPC_CheckTypeI32,
/* 19959*/    OPC_MoveSibling, 16,
/* 19961*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19964*/    OPC_RecordNode, // #16 = $mE
/* 19965*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19967*/    OPC_CheckTypeI32,
/* 19968*/    OPC_MoveSibling, 17,
/* 19970*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19973*/    OPC_RecordNode, // #17 = $mF
/* 19974*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 19976*/    OPC_CheckTypeI32,
/* 19977*/    OPC_MoveParent,
/* 19978*/    OPC_CheckType, MVT::v2i64,
/* 19980*/    OPC_EmitConvertToTarget2,
/* 19981*/    OPC_EmitConvertToTarget3,
/* 19982*/    OPC_EmitConvertToTarget4,
/* 19983*/    OPC_EmitConvertToTarget5,
/* 19984*/    OPC_EmitConvertToTarget6,
/* 19985*/    OPC_EmitConvertToTarget7,
/* 19986*/    OPC_EmitConvertToTarget, 8,
/* 19988*/    OPC_EmitConvertToTarget, 9,
/* 19990*/    OPC_EmitConvertToTarget, 10,
/* 19992*/    OPC_EmitConvertToTarget, 11,
/* 19994*/    OPC_EmitConvertToTarget, 12,
/* 19996*/    OPC_EmitConvertToTarget, 13,
/* 19998*/    OPC_EmitConvertToTarget, 14,
/* 20000*/    OPC_EmitConvertToTarget, 15,
/* 20002*/    OPC_EmitConvertToTarget, 16,
/* 20004*/    OPC_EmitConvertToTarget, 17,
/* 20006*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v2i64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2i64] } V128:{ *:[v2i64] }:$x, V128:{ *:[v2i64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v2i64] } ?:{ *:[v2i64] }:$x, ?:{ *:[v2i64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20029*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->20186
/* 20033*/    OPC_CheckTypeI32,
/* 20034*/    OPC_MoveSibling3,
/* 20035*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20038*/    OPC_RecordNode, // #3 = $m1
/* 20039*/    OPC_CheckTypeI32,
/* 20040*/    OPC_MoveSibling4,
/* 20041*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20044*/    OPC_RecordNode, // #4 = $m2
/* 20045*/    OPC_CheckTypeI32,
/* 20046*/    OPC_MoveSibling5,
/* 20047*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20050*/    OPC_RecordNode, // #5 = $m3
/* 20051*/    OPC_CheckTypeI32,
/* 20052*/    OPC_MoveSibling6,
/* 20053*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20056*/    OPC_RecordNode, // #6 = $m4
/* 20057*/    OPC_CheckTypeI32,
/* 20058*/    OPC_MoveSibling7,
/* 20059*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20062*/    OPC_RecordNode, // #7 = $m5
/* 20063*/    OPC_CheckTypeI32,
/* 20064*/    OPC_MoveSibling, 8,
/* 20066*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20069*/    OPC_RecordNode, // #8 = $m6
/* 20070*/    OPC_CheckTypeI32,
/* 20071*/    OPC_MoveSibling, 9,
/* 20073*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20076*/    OPC_RecordNode, // #9 = $m7
/* 20077*/    OPC_CheckTypeI32,
/* 20078*/    OPC_MoveSibling, 10,
/* 20080*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20083*/    OPC_RecordNode, // #10 = $m8
/* 20084*/    OPC_CheckTypeI32,
/* 20085*/    OPC_MoveSibling, 11,
/* 20087*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20090*/    OPC_RecordNode, // #11 = $m9
/* 20091*/    OPC_CheckTypeI32,
/* 20092*/    OPC_MoveSibling, 12,
/* 20094*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20097*/    OPC_RecordNode, // #12 = $mA
/* 20098*/    OPC_CheckTypeI32,
/* 20099*/    OPC_MoveSibling, 13,
/* 20101*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20104*/    OPC_RecordNode, // #13 = $mB
/* 20105*/    OPC_CheckTypeI32,
/* 20106*/    OPC_MoveSibling, 14,
/* 20108*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20111*/    OPC_RecordNode, // #14 = $mC
/* 20112*/    OPC_CheckTypeI32,
/* 20113*/    OPC_MoveSibling, 15,
/* 20115*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20118*/    OPC_RecordNode, // #15 = $mD
/* 20119*/    OPC_CheckTypeI32,
/* 20120*/    OPC_MoveSibling, 16,
/* 20122*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20125*/    OPC_RecordNode, // #16 = $mE
/* 20126*/    OPC_CheckTypeI32,
/* 20127*/    OPC_MoveSibling, 17,
/* 20129*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20132*/    OPC_RecordNode, // #17 = $mF
/* 20133*/    OPC_CheckTypeI32,
/* 20134*/    OPC_MoveParent,
/* 20135*/    OPC_CheckType, MVT::v2i64,
/* 20137*/    OPC_EmitConvertToTarget2,
/* 20138*/    OPC_EmitConvertToTarget3,
/* 20139*/    OPC_EmitConvertToTarget4,
/* 20140*/    OPC_EmitConvertToTarget5,
/* 20141*/    OPC_EmitConvertToTarget6,
/* 20142*/    OPC_EmitConvertToTarget7,
/* 20143*/    OPC_EmitConvertToTarget, 8,
/* 20145*/    OPC_EmitConvertToTarget, 9,
/* 20147*/    OPC_EmitConvertToTarget, 10,
/* 20149*/    OPC_EmitConvertToTarget, 11,
/* 20151*/    OPC_EmitConvertToTarget, 12,
/* 20153*/    OPC_EmitConvertToTarget, 13,
/* 20155*/    OPC_EmitConvertToTarget, 14,
/* 20157*/    OPC_EmitConvertToTarget, 15,
/* 20159*/    OPC_EmitConvertToTarget, 16,
/* 20161*/    OPC_EmitConvertToTarget, 17,
/* 20163*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v2i64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2i64] } V128:{ *:[v2i64] }:$x, V128:{ *:[v2i64] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v2i64] } ?:{ *:[v2i64] }:$x, ?:{ *:[v2i64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20186*/   0, // EndSwitchOpcode
/* 20187*/  /*Scope*/ 99|128,2/*355*/, /*->20544*/
/* 20189*/   OPC_CheckChild0Type, MVT::v4f32,
/* 20191*/   OPC_RecordChild1, // #1 = $y
/* 20192*/   OPC_CheckChild1Type, MVT::v4f32,
/* 20194*/   OPC_RecordChild2, // #2 = $m0
/* 20195*/   OPC_MoveChild2,
/* 20196*/   OPC_SwitchOpcode /*2 cases */, 57|128,1/*185*/, TARGET_VAL(ISD::Constant),// ->20386
/* 20201*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20203*/    OPC_CheckTypeI32,
/* 20204*/    OPC_MoveSibling3,
/* 20205*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20208*/    OPC_RecordNode, // #3 = $m1
/* 20209*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20211*/    OPC_CheckTypeI32,
/* 20212*/    OPC_MoveSibling4,
/* 20213*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20216*/    OPC_RecordNode, // #4 = $m2
/* 20217*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20219*/    OPC_CheckTypeI32,
/* 20220*/    OPC_MoveSibling5,
/* 20221*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20224*/    OPC_RecordNode, // #5 = $m3
/* 20225*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20227*/    OPC_CheckTypeI32,
/* 20228*/    OPC_MoveSibling6,
/* 20229*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20232*/    OPC_RecordNode, // #6 = $m4
/* 20233*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20235*/    OPC_CheckTypeI32,
/* 20236*/    OPC_MoveSibling7,
/* 20237*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20240*/    OPC_RecordNode, // #7 = $m5
/* 20241*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20243*/    OPC_CheckTypeI32,
/* 20244*/    OPC_MoveSibling, 8,
/* 20246*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20249*/    OPC_RecordNode, // #8 = $m6
/* 20250*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20252*/    OPC_CheckTypeI32,
/* 20253*/    OPC_MoveSibling, 9,
/* 20255*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20258*/    OPC_RecordNode, // #9 = $m7
/* 20259*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20261*/    OPC_CheckTypeI32,
/* 20262*/    OPC_MoveSibling, 10,
/* 20264*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20267*/    OPC_RecordNode, // #10 = $m8
/* 20268*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20270*/    OPC_CheckTypeI32,
/* 20271*/    OPC_MoveSibling, 11,
/* 20273*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20276*/    OPC_RecordNode, // #11 = $m9
/* 20277*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20279*/    OPC_CheckTypeI32,
/* 20280*/    OPC_MoveSibling, 12,
/* 20282*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20285*/    OPC_RecordNode, // #12 = $mA
/* 20286*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20288*/    OPC_CheckTypeI32,
/* 20289*/    OPC_MoveSibling, 13,
/* 20291*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20294*/    OPC_RecordNode, // #13 = $mB
/* 20295*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20297*/    OPC_CheckTypeI32,
/* 20298*/    OPC_MoveSibling, 14,
/* 20300*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20303*/    OPC_RecordNode, // #14 = $mC
/* 20304*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20306*/    OPC_CheckTypeI32,
/* 20307*/    OPC_MoveSibling, 15,
/* 20309*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20312*/    OPC_RecordNode, // #15 = $mD
/* 20313*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20315*/    OPC_CheckTypeI32,
/* 20316*/    OPC_MoveSibling, 16,
/* 20318*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20321*/    OPC_RecordNode, // #16 = $mE
/* 20322*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20324*/    OPC_CheckTypeI32,
/* 20325*/    OPC_MoveSibling, 17,
/* 20327*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20330*/    OPC_RecordNode, // #17 = $mF
/* 20331*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20333*/    OPC_CheckTypeI32,
/* 20334*/    OPC_MoveParent,
/* 20335*/    OPC_CheckType, MVT::v4f32,
/* 20337*/    OPC_EmitConvertToTarget2,
/* 20338*/    OPC_EmitConvertToTarget3,
/* 20339*/    OPC_EmitConvertToTarget4,
/* 20340*/    OPC_EmitConvertToTarget5,
/* 20341*/    OPC_EmitConvertToTarget6,
/* 20342*/    OPC_EmitConvertToTarget7,
/* 20343*/    OPC_EmitConvertToTarget, 8,
/* 20345*/    OPC_EmitConvertToTarget, 9,
/* 20347*/    OPC_EmitConvertToTarget, 10,
/* 20349*/    OPC_EmitConvertToTarget, 11,
/* 20351*/    OPC_EmitConvertToTarget, 12,
/* 20353*/    OPC_EmitConvertToTarget, 13,
/* 20355*/    OPC_EmitConvertToTarget, 14,
/* 20357*/    OPC_EmitConvertToTarget, 15,
/* 20359*/    OPC_EmitConvertToTarget, 16,
/* 20361*/    OPC_EmitConvertToTarget, 17,
/* 20363*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v4f32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4f32] } V128:{ *:[v4f32] }:$x, V128:{ *:[v4f32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v4f32] } ?:{ *:[v4f32] }:$x, ?:{ *:[v4f32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20386*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->20543
/* 20390*/    OPC_CheckTypeI32,
/* 20391*/    OPC_MoveSibling3,
/* 20392*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20395*/    OPC_RecordNode, // #3 = $m1
/* 20396*/    OPC_CheckTypeI32,
/* 20397*/    OPC_MoveSibling4,
/* 20398*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20401*/    OPC_RecordNode, // #4 = $m2
/* 20402*/    OPC_CheckTypeI32,
/* 20403*/    OPC_MoveSibling5,
/* 20404*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20407*/    OPC_RecordNode, // #5 = $m3
/* 20408*/    OPC_CheckTypeI32,
/* 20409*/    OPC_MoveSibling6,
/* 20410*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20413*/    OPC_RecordNode, // #6 = $m4
/* 20414*/    OPC_CheckTypeI32,
/* 20415*/    OPC_MoveSibling7,
/* 20416*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20419*/    OPC_RecordNode, // #7 = $m5
/* 20420*/    OPC_CheckTypeI32,
/* 20421*/    OPC_MoveSibling, 8,
/* 20423*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20426*/    OPC_RecordNode, // #8 = $m6
/* 20427*/    OPC_CheckTypeI32,
/* 20428*/    OPC_MoveSibling, 9,
/* 20430*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20433*/    OPC_RecordNode, // #9 = $m7
/* 20434*/    OPC_CheckTypeI32,
/* 20435*/    OPC_MoveSibling, 10,
/* 20437*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20440*/    OPC_RecordNode, // #10 = $m8
/* 20441*/    OPC_CheckTypeI32,
/* 20442*/    OPC_MoveSibling, 11,
/* 20444*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20447*/    OPC_RecordNode, // #11 = $m9
/* 20448*/    OPC_CheckTypeI32,
/* 20449*/    OPC_MoveSibling, 12,
/* 20451*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20454*/    OPC_RecordNode, // #12 = $mA
/* 20455*/    OPC_CheckTypeI32,
/* 20456*/    OPC_MoveSibling, 13,
/* 20458*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20461*/    OPC_RecordNode, // #13 = $mB
/* 20462*/    OPC_CheckTypeI32,
/* 20463*/    OPC_MoveSibling, 14,
/* 20465*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20468*/    OPC_RecordNode, // #14 = $mC
/* 20469*/    OPC_CheckTypeI32,
/* 20470*/    OPC_MoveSibling, 15,
/* 20472*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20475*/    OPC_RecordNode, // #15 = $mD
/* 20476*/    OPC_CheckTypeI32,
/* 20477*/    OPC_MoveSibling, 16,
/* 20479*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20482*/    OPC_RecordNode, // #16 = $mE
/* 20483*/    OPC_CheckTypeI32,
/* 20484*/    OPC_MoveSibling, 17,
/* 20486*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20489*/    OPC_RecordNode, // #17 = $mF
/* 20490*/    OPC_CheckTypeI32,
/* 20491*/    OPC_MoveParent,
/* 20492*/    OPC_CheckType, MVT::v4f32,
/* 20494*/    OPC_EmitConvertToTarget2,
/* 20495*/    OPC_EmitConvertToTarget3,
/* 20496*/    OPC_EmitConvertToTarget4,
/* 20497*/    OPC_EmitConvertToTarget5,
/* 20498*/    OPC_EmitConvertToTarget6,
/* 20499*/    OPC_EmitConvertToTarget7,
/* 20500*/    OPC_EmitConvertToTarget, 8,
/* 20502*/    OPC_EmitConvertToTarget, 9,
/* 20504*/    OPC_EmitConvertToTarget, 10,
/* 20506*/    OPC_EmitConvertToTarget, 11,
/* 20508*/    OPC_EmitConvertToTarget, 12,
/* 20510*/    OPC_EmitConvertToTarget, 13,
/* 20512*/    OPC_EmitConvertToTarget, 14,
/* 20514*/    OPC_EmitConvertToTarget, 15,
/* 20516*/    OPC_EmitConvertToTarget, 16,
/* 20518*/    OPC_EmitConvertToTarget, 17,
/* 20520*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v4f32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4f32] } V128:{ *:[v4f32] }:$x, V128:{ *:[v4f32] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v4f32] } ?:{ *:[v4f32] }:$x, ?:{ *:[v4f32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20543*/   0, // EndSwitchOpcode
/* 20544*/  /*Scope*/ 99|128,2/*355*/, /*->20901*/
/* 20546*/   OPC_CheckChild0Type, MVT::v2f64,
/* 20548*/   OPC_RecordChild1, // #1 = $y
/* 20549*/   OPC_CheckChild1Type, MVT::v2f64,
/* 20551*/   OPC_RecordChild2, // #2 = $m0
/* 20552*/   OPC_MoveChild2,
/* 20553*/   OPC_SwitchOpcode /*2 cases */, 57|128,1/*185*/, TARGET_VAL(ISD::Constant),// ->20743
/* 20558*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20560*/    OPC_CheckTypeI32,
/* 20561*/    OPC_MoveSibling3,
/* 20562*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20565*/    OPC_RecordNode, // #3 = $m1
/* 20566*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20568*/    OPC_CheckTypeI32,
/* 20569*/    OPC_MoveSibling4,
/* 20570*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20573*/    OPC_RecordNode, // #4 = $m2
/* 20574*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20576*/    OPC_CheckTypeI32,
/* 20577*/    OPC_MoveSibling5,
/* 20578*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20581*/    OPC_RecordNode, // #5 = $m3
/* 20582*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20584*/    OPC_CheckTypeI32,
/* 20585*/    OPC_MoveSibling6,
/* 20586*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20589*/    OPC_RecordNode, // #6 = $m4
/* 20590*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20592*/    OPC_CheckTypeI32,
/* 20593*/    OPC_MoveSibling7,
/* 20594*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20597*/    OPC_RecordNode, // #7 = $m5
/* 20598*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20600*/    OPC_CheckTypeI32,
/* 20601*/    OPC_MoveSibling, 8,
/* 20603*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20606*/    OPC_RecordNode, // #8 = $m6
/* 20607*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20609*/    OPC_CheckTypeI32,
/* 20610*/    OPC_MoveSibling, 9,
/* 20612*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20615*/    OPC_RecordNode, // #9 = $m7
/* 20616*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20618*/    OPC_CheckTypeI32,
/* 20619*/    OPC_MoveSibling, 10,
/* 20621*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20624*/    OPC_RecordNode, // #10 = $m8
/* 20625*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20627*/    OPC_CheckTypeI32,
/* 20628*/    OPC_MoveSibling, 11,
/* 20630*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20633*/    OPC_RecordNode, // #11 = $m9
/* 20634*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20636*/    OPC_CheckTypeI32,
/* 20637*/    OPC_MoveSibling, 12,
/* 20639*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20642*/    OPC_RecordNode, // #12 = $mA
/* 20643*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20645*/    OPC_CheckTypeI32,
/* 20646*/    OPC_MoveSibling, 13,
/* 20648*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20651*/    OPC_RecordNode, // #13 = $mB
/* 20652*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20654*/    OPC_CheckTypeI32,
/* 20655*/    OPC_MoveSibling, 14,
/* 20657*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20660*/    OPC_RecordNode, // #14 = $mC
/* 20661*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20663*/    OPC_CheckTypeI32,
/* 20664*/    OPC_MoveSibling, 15,
/* 20666*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20669*/    OPC_RecordNode, // #15 = $mD
/* 20670*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20672*/    OPC_CheckTypeI32,
/* 20673*/    OPC_MoveSibling, 16,
/* 20675*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20678*/    OPC_RecordNode, // #16 = $mE
/* 20679*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20681*/    OPC_CheckTypeI32,
/* 20682*/    OPC_MoveSibling, 17,
/* 20684*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20687*/    OPC_RecordNode, // #17 = $mF
/* 20688*/    OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20690*/    OPC_CheckTypeI32,
/* 20691*/    OPC_MoveParent,
/* 20692*/    OPC_CheckType, MVT::v2f64,
/* 20694*/    OPC_EmitConvertToTarget2,
/* 20695*/    OPC_EmitConvertToTarget3,
/* 20696*/    OPC_EmitConvertToTarget4,
/* 20697*/    OPC_EmitConvertToTarget5,
/* 20698*/    OPC_EmitConvertToTarget6,
/* 20699*/    OPC_EmitConvertToTarget7,
/* 20700*/    OPC_EmitConvertToTarget, 8,
/* 20702*/    OPC_EmitConvertToTarget, 9,
/* 20704*/    OPC_EmitConvertToTarget, 10,
/* 20706*/    OPC_EmitConvertToTarget, 11,
/* 20708*/    OPC_EmitConvertToTarget, 12,
/* 20710*/    OPC_EmitConvertToTarget, 13,
/* 20712*/    OPC_EmitConvertToTarget, 14,
/* 20714*/    OPC_EmitConvertToTarget, 15,
/* 20716*/    OPC_EmitConvertToTarget, 16,
/* 20718*/    OPC_EmitConvertToTarget, 17,
/* 20720*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v2f64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2f64] } V128:{ *:[v2f64] }:$x, V128:{ *:[v2f64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v2f64] } ?:{ *:[v2f64] }:$x, ?:{ *:[v2f64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20743*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->20900
/* 20747*/    OPC_CheckTypeI32,
/* 20748*/    OPC_MoveSibling3,
/* 20749*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20752*/    OPC_RecordNode, // #3 = $m1
/* 20753*/    OPC_CheckTypeI32,
/* 20754*/    OPC_MoveSibling4,
/* 20755*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20758*/    OPC_RecordNode, // #4 = $m2
/* 20759*/    OPC_CheckTypeI32,
/* 20760*/    OPC_MoveSibling5,
/* 20761*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20764*/    OPC_RecordNode, // #5 = $m3
/* 20765*/    OPC_CheckTypeI32,
/* 20766*/    OPC_MoveSibling6,
/* 20767*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20770*/    OPC_RecordNode, // #6 = $m4
/* 20771*/    OPC_CheckTypeI32,
/* 20772*/    OPC_MoveSibling7,
/* 20773*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20776*/    OPC_RecordNode, // #7 = $m5
/* 20777*/    OPC_CheckTypeI32,
/* 20778*/    OPC_MoveSibling, 8,
/* 20780*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20783*/    OPC_RecordNode, // #8 = $m6
/* 20784*/    OPC_CheckTypeI32,
/* 20785*/    OPC_MoveSibling, 9,
/* 20787*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20790*/    OPC_RecordNode, // #9 = $m7
/* 20791*/    OPC_CheckTypeI32,
/* 20792*/    OPC_MoveSibling, 10,
/* 20794*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20797*/    OPC_RecordNode, // #10 = $m8
/* 20798*/    OPC_CheckTypeI32,
/* 20799*/    OPC_MoveSibling, 11,
/* 20801*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20804*/    OPC_RecordNode, // #11 = $m9
/* 20805*/    OPC_CheckTypeI32,
/* 20806*/    OPC_MoveSibling, 12,
/* 20808*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20811*/    OPC_RecordNode, // #12 = $mA
/* 20812*/    OPC_CheckTypeI32,
/* 20813*/    OPC_MoveSibling, 13,
/* 20815*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20818*/    OPC_RecordNode, // #13 = $mB
/* 20819*/    OPC_CheckTypeI32,
/* 20820*/    OPC_MoveSibling, 14,
/* 20822*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20825*/    OPC_RecordNode, // #14 = $mC
/* 20826*/    OPC_CheckTypeI32,
/* 20827*/    OPC_MoveSibling, 15,
/* 20829*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20832*/    OPC_RecordNode, // #15 = $mD
/* 20833*/    OPC_CheckTypeI32,
/* 20834*/    OPC_MoveSibling, 16,
/* 20836*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20839*/    OPC_RecordNode, // #16 = $mE
/* 20840*/    OPC_CheckTypeI32,
/* 20841*/    OPC_MoveSibling, 17,
/* 20843*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20846*/    OPC_RecordNode, // #17 = $mF
/* 20847*/    OPC_CheckTypeI32,
/* 20848*/    OPC_MoveParent,
/* 20849*/    OPC_CheckType, MVT::v2f64,
/* 20851*/    OPC_EmitConvertToTarget2,
/* 20852*/    OPC_EmitConvertToTarget3,
/* 20853*/    OPC_EmitConvertToTarget4,
/* 20854*/    OPC_EmitConvertToTarget5,
/* 20855*/    OPC_EmitConvertToTarget6,
/* 20856*/    OPC_EmitConvertToTarget7,
/* 20857*/    OPC_EmitConvertToTarget, 8,
/* 20859*/    OPC_EmitConvertToTarget, 9,
/* 20861*/    OPC_EmitConvertToTarget, 10,
/* 20863*/    OPC_EmitConvertToTarget, 11,
/* 20865*/    OPC_EmitConvertToTarget, 12,
/* 20867*/    OPC_EmitConvertToTarget, 13,
/* 20869*/    OPC_EmitConvertToTarget, 14,
/* 20871*/    OPC_EmitConvertToTarget, 15,
/* 20873*/    OPC_EmitConvertToTarget, 16,
/* 20875*/    OPC_EmitConvertToTarget, 17,
/* 20877*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  MVT::v2f64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2f64] } V128:{ *:[v2f64] }:$x, V128:{ *:[v2f64] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v2f64] } ?:{ *:[v2f64] }:$x, ?:{ *:[v2f64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20900*/   0, // EndSwitchOpcode
/* 20901*/  0, /*End of Scope*/
/* 20902*/ /*SwitchOpcode*/ 73|128,5/*713*/, TARGET_VAL(ISD::INSERT_VECTOR_ELT),// ->21619
/* 20906*/  OPC_Scope, 18|128,1/*146*/, /*->21055*/ // 2 children in Scope
/* 20909*/   OPC_MoveChild0,
/* 20910*/   OPC_CheckOpcode, TARGET_VAL(ISD::SPLAT_VECTOR),
/* 20913*/   OPC_CheckChild0Integer, 0, 
/* 20915*/   OPC_Scope, 68, /*->20985*/ // 2 children in Scope
/* 20917*/    OPC_CheckChild0TypeI32,
/* 20918*/    OPC_MoveSibling1,
/* 20919*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 20922*/    OPC_RecordMemRef,
/* 20923*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 20924*/    OPC_CheckFoldableChainNode,
/* 20925*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 20926*/    OPC_CheckTypeI32,
/* 20927*/    OPC_Scope, 27, /*->20956*/ // 2 children in Scope
/* 20929*/     OPC_CheckChild1TypeI32,
/* 20930*/     OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 20932*/     OPC_CheckPredicate, 15, // Predicate_load
/* 20934*/     OPC_MoveParent,
/* 20935*/     OPC_CheckChild2Integer, 0, 
/* 20937*/     OPC_CheckType, MVT::v4i32,
/* 20939*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 20941*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 20944*/     OPC_EmitMergeInputChains1_0,
/* 20945*/     OPC_EmitInteger32, 0, 
/* 20947*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v4i32] } (splat_vector:{ *:[v4i32] } 0:{ *:[i32] }), (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 20956*/    /*Scope*/ 27, /*->20984*/
/* 20957*/     OPC_CheckChild1TypeI64,
/* 20958*/     OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 20960*/     OPC_CheckPredicate, 15, // Predicate_load
/* 20962*/     OPC_MoveParent,
/* 20963*/     OPC_CheckChild2Integer, 0, 
/* 20965*/     OPC_CheckType, MVT::v4i32,
/* 20967*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 20969*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 20972*/     OPC_EmitMergeInputChains1_0,
/* 20973*/     OPC_EmitInteger32, 0, 
/* 20975*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v4i32] } (splat_vector:{ *:[v4i32] } 0:{ *:[i32] }), (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 20984*/    0, /*End of Scope*/
/* 20985*/   /*Scope*/ 68, /*->21054*/
/* 20986*/    OPC_CheckChild0TypeI64,
/* 20987*/    OPC_MoveSibling1,
/* 20988*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 20991*/    OPC_RecordMemRef,
/* 20992*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 20993*/    OPC_CheckFoldableChainNode,
/* 20994*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 20995*/    OPC_CheckTypeI64,
/* 20996*/    OPC_Scope, 27, /*->21025*/ // 2 children in Scope
/* 20998*/     OPC_CheckChild1TypeI32,
/* 20999*/     OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 21001*/     OPC_CheckPredicate, 15, // Predicate_load
/* 21003*/     OPC_MoveParent,
/* 21004*/     OPC_CheckChild2Integer, 0, 
/* 21006*/     OPC_CheckType, MVT::v2i64,
/* 21008*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 21010*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21013*/     OPC_EmitMergeInputChains1_0,
/* 21014*/     OPC_EmitInteger32, 0, 
/* 21016*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v2i64] } (splat_vector:{ *:[v2i64] } 0:{ *:[i64] }), (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21025*/    /*Scope*/ 27, /*->21053*/
/* 21026*/     OPC_CheckChild1TypeI64,
/* 21027*/     OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 21029*/     OPC_CheckPredicate, 15, // Predicate_load
/* 21031*/     OPC_MoveParent,
/* 21032*/     OPC_CheckChild2Integer, 0, 
/* 21034*/     OPC_CheckType, MVT::v2i64,
/* 21036*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 21038*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21041*/     OPC_EmitMergeInputChains1_0,
/* 21042*/     OPC_EmitInteger32, 0, 
/* 21044*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v2i64] } (splat_vector:{ *:[v2i64] } 0:{ *:[i64] }), (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21053*/    0, /*End of Scope*/
/* 21054*/   0, /*End of Scope*/
/* 21055*/  /*Scope*/ 49|128,4/*561*/, /*->21618*/
/* 21057*/   OPC_RecordChild0, // #0 = $vec
/* 21058*/   OPC_Scope, 50|128,2/*306*/, /*->21367*/ // 2 children in Scope
/* 21061*/    OPC_MoveChild1,
/* 21062*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 21065*/    OPC_RecordMemRef,
/* 21066*/    OPC_RecordNode, // #1 = 'ld' chained node
/* 21067*/    OPC_CheckFoldableChainNode,
/* 21068*/    OPC_RecordChild1, // #2 = $addr
/* 21069*/    OPC_Scope, 18|128,1/*146*/, /*->21218*/ // 2 children in Scope
/* 21072*/     OPC_CheckChild1TypeI32,
/* 21073*/     OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 21075*/     OPC_Scope, 71, /*->21148*/ // 2 children in Scope
/* 21077*/      OPC_CheckPredicate, 18, // Predicate_extload
/* 21079*/      OPC_CheckTypeI32,
/* 21080*/      OPC_Scope, 32, /*->21114*/ // 2 children in Scope
/* 21082*/       OPC_CheckPredicate, 0, // Predicate_extloadi8
/* 21084*/       OPC_MoveSibling2,
/* 21085*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21088*/       OPC_RecordNode, // #3 = $idx
/* 21089*/       OPC_CheckPredicate, 3, // Predicate_LaneIdx16
/* 21091*/       OPC_CheckTypeI32,
/* 21092*/       OPC_MoveParent,
/* 21093*/       OPC_CheckType, MVT::v16i8,
/* 21095*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 21097*/       OPC_EmitMergeInputChains1_1,
/* 21098*/       OPC_EmitInteger32, 0, 
/* 21100*/       OPC_EmitInteger32, 0, 
/* 21102*/       OPC_EmitConvertToTarget3,
/* 21103*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I8x16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v16i8, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I8x16_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 21114*/      /*Scope*/ 32, /*->21147*/
/* 21115*/       OPC_CheckPredicate, 1, // Predicate_extloadi16
/* 21117*/       OPC_MoveSibling2,
/* 21118*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21121*/       OPC_RecordNode, // #3 = $idx
/* 21122*/       OPC_CheckPredicate, 7, // Predicate_LaneIdx8
/* 21124*/       OPC_CheckTypeI32,
/* 21125*/       OPC_MoveParent,
/* 21126*/       OPC_CheckType, MVT::v8i16,
/* 21128*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 21130*/       OPC_EmitMergeInputChains1_1,
/* 21131*/       OPC_EmitInteger32, 0, 
/* 21133*/       OPC_EmitInteger32, 0, 
/* 21135*/       OPC_EmitConvertToTarget3,
/* 21136*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v8i16, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 21147*/      0, /*End of Scope*/
/* 21148*/     /*Scope*/ 68, /*->21217*/
/* 21149*/      OPC_CheckPredicate, 15, // Predicate_load
/* 21151*/      OPC_SwitchType /*2 cases */, 30, MVT::i32,// ->21184
/* 21154*/       OPC_MoveSibling2,
/* 21155*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21158*/       OPC_RecordNode, // #3 = $idx
/* 21159*/       OPC_CheckPredicate, 9, // Predicate_LaneIdx4
/* 21161*/       OPC_CheckTypeI32,
/* 21162*/       OPC_MoveParent,
/* 21163*/       OPC_CheckType, MVT::v4i32,
/* 21165*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 21167*/       OPC_EmitMergeInputChains1_1,
/* 21168*/       OPC_EmitInteger32, 0, 
/* 21170*/       OPC_EmitInteger32, 0, 
/* 21172*/       OPC_EmitConvertToTarget3,
/* 21173*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 21184*/      /*SwitchType*/ 30, MVT::i64,// ->21216
/* 21186*/       OPC_MoveSibling2,
/* 21187*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21190*/       OPC_RecordNode, // #3 = $idx
/* 21191*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx2
/* 21193*/       OPC_CheckTypeI32,
/* 21194*/       OPC_MoveParent,
/* 21195*/       OPC_CheckType, MVT::v2i64,
/* 21197*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 21199*/       OPC_EmitMergeInputChains1_1,
/* 21200*/       OPC_EmitInteger32, 0, 
/* 21202*/       OPC_EmitInteger32, 0, 
/* 21204*/       OPC_EmitConvertToTarget3,
/* 21205*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 21216*/      0, // EndSwitchType
/* 21217*/     0, /*End of Scope*/
/* 21218*/    /*Scope*/ 18|128,1/*146*/, /*->21366*/
/* 21220*/     OPC_CheckChild1TypeI64,
/* 21221*/     OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 21223*/     OPC_Scope, 71, /*->21296*/ // 2 children in Scope
/* 21225*/      OPC_CheckPredicate, 18, // Predicate_extload
/* 21227*/      OPC_CheckTypeI32,
/* 21228*/      OPC_Scope, 32, /*->21262*/ // 2 children in Scope
/* 21230*/       OPC_CheckPredicate, 0, // Predicate_extloadi8
/* 21232*/       OPC_MoveSibling2,
/* 21233*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21236*/       OPC_RecordNode, // #3 = $idx
/* 21237*/       OPC_CheckPredicate, 3, // Predicate_LaneIdx16
/* 21239*/       OPC_CheckTypeI32,
/* 21240*/       OPC_MoveParent,
/* 21241*/       OPC_CheckType, MVT::v16i8,
/* 21243*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 21245*/       OPC_EmitMergeInputChains1_1,
/* 21246*/       OPC_EmitInteger32, 0, 
/* 21248*/       OPC_EmitInteger64, 0, 
/* 21250*/       OPC_EmitConvertToTarget3,
/* 21251*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I8x16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v16i8, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I8x16_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 21262*/      /*Scope*/ 32, /*->21295*/
/* 21263*/       OPC_CheckPredicate, 1, // Predicate_extloadi16
/* 21265*/       OPC_MoveSibling2,
/* 21266*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21269*/       OPC_RecordNode, // #3 = $idx
/* 21270*/       OPC_CheckPredicate, 7, // Predicate_LaneIdx8
/* 21272*/       OPC_CheckTypeI32,
/* 21273*/       OPC_MoveParent,
/* 21274*/       OPC_CheckType, MVT::v8i16,
/* 21276*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 21278*/       OPC_EmitMergeInputChains1_1,
/* 21279*/       OPC_EmitInteger32, 0, 
/* 21281*/       OPC_EmitInteger64, 0, 
/* 21283*/       OPC_EmitConvertToTarget3,
/* 21284*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v8i16, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 21295*/      0, /*End of Scope*/
/* 21296*/     /*Scope*/ 68, /*->21365*/
/* 21297*/      OPC_CheckPredicate, 15, // Predicate_load
/* 21299*/      OPC_SwitchType /*2 cases */, 30, MVT::i32,// ->21332
/* 21302*/       OPC_MoveSibling2,
/* 21303*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21306*/       OPC_RecordNode, // #3 = $idx
/* 21307*/       OPC_CheckPredicate, 9, // Predicate_LaneIdx4
/* 21309*/       OPC_CheckTypeI32,
/* 21310*/       OPC_MoveParent,
/* 21311*/       OPC_CheckType, MVT::v4i32,
/* 21313*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 21315*/       OPC_EmitMergeInputChains1_1,
/* 21316*/       OPC_EmitInteger32, 0, 
/* 21318*/       OPC_EmitInteger64, 0, 
/* 21320*/       OPC_EmitConvertToTarget3,
/* 21321*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 21332*/      /*SwitchType*/ 30, MVT::i64,// ->21364
/* 21334*/       OPC_MoveSibling2,
/* 21335*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21338*/       OPC_RecordNode, // #3 = $idx
/* 21339*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx2
/* 21341*/       OPC_CheckTypeI32,
/* 21342*/       OPC_MoveParent,
/* 21343*/       OPC_CheckType, MVT::v2i64,
/* 21345*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 21347*/       OPC_EmitMergeInputChains1_1,
/* 21348*/       OPC_EmitInteger32, 0, 
/* 21350*/       OPC_EmitInteger64, 0, 
/* 21352*/       OPC_EmitConvertToTarget3,
/* 21353*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 21364*/      0, // EndSwitchType
/* 21365*/     0, /*End of Scope*/
/* 21366*/    0, /*End of Scope*/
/* 21367*/   /*Scope*/ 120|128,1/*248*/, /*->21617*/
/* 21369*/    OPC_RecordChild1, // #1 = $x
/* 21370*/    OPC_Scope, 107, /*->21479*/ // 4 children in Scope
/* 21372*/     OPC_CheckChild1TypeI32,
/* 21373*/     OPC_Scope, 59, /*->21434*/ // 2 children in Scope
/* 21375*/      OPC_RecordChild2, // #2 = $idx
/* 21376*/      OPC_MoveChild2,
/* 21377*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21380*/      OPC_CheckTypeI32,
/* 21381*/      OPC_Scope, 16, /*->21399*/ // 3 children in Scope
/* 21383*/       OPC_CheckPredicate, 3, // Predicate_LaneIdx16
/* 21385*/       OPC_MoveParent,
/* 21386*/       OPC_CheckType, MVT::v16i8,
/* 21388*/       OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 21390*/       OPC_EmitConvertToTarget2,
/* 21391*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16),
                     MVT::v16i8, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 21399*/      /*Scope*/ 16, /*->21416*/
/* 21400*/       OPC_CheckPredicate, 7, // Predicate_LaneIdx8
/* 21402*/       OPC_MoveParent,
/* 21403*/       OPC_CheckType, MVT::v8i16,
/* 21405*/       OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 21407*/       OPC_EmitConvertToTarget2,
/* 21408*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8),
                     MVT::v8i16, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 21416*/      /*Scope*/ 16, /*->21433*/
/* 21417*/       OPC_CheckPredicate, 9, // Predicate_LaneIdx4
/* 21419*/       OPC_MoveParent,
/* 21420*/       OPC_CheckType, MVT::v4i32,
/* 21422*/       OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 21424*/       OPC_EmitConvertToTarget2,
/* 21425*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4),
                     MVT::v4i32, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 21433*/      0, /*End of Scope*/
/* 21434*/     /*Scope*/ 43, /*->21478*/
/* 21435*/      OPC_MoveChild2,
/* 21436*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21439*/      OPC_MoveParent,
/* 21440*/      OPC_SwitchType /*3 cases */, 10, MVT::v16i8,// ->21453
/* 21443*/       OPC_EmitInteger32, 0, 
/* 21445*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16),
                     MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 21453*/      /*SwitchType*/ 10, MVT::v8i16,// ->21465
/* 21455*/       OPC_EmitInteger32, 0, 
/* 21457*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8),
                     MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 21465*/      /*SwitchType*/ 10, MVT::v4i32,// ->21477
/* 21467*/       OPC_EmitInteger32, 0, 
/* 21469*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4),
                     MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 21477*/      0, // EndSwitchType
/* 21478*/     0, /*End of Scope*/
/* 21479*/    /*Scope*/ 44, /*->21524*/
/* 21480*/     OPC_CheckChild1TypeI64,
/* 21481*/     OPC_Scope, 22, /*->21505*/ // 2 children in Scope
/* 21483*/      OPC_RecordChild2, // #2 = $idx
/* 21484*/      OPC_MoveChild2,
/* 21485*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21488*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx2
/* 21490*/      OPC_CheckTypeI32,
/* 21491*/      OPC_MoveParent,
/* 21492*/      OPC_CheckType, MVT::v2i64,
/* 21494*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 21496*/      OPC_EmitConvertToTarget2,
/* 21497*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2),
                    MVT::v2i64, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$x)
/* 21505*/     /*Scope*/ 17, /*->21523*/
/* 21506*/      OPC_MoveChild2,
/* 21507*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21510*/      OPC_MoveParent,
/* 21511*/      OPC_CheckType, MVT::v2i64,
/* 21513*/      OPC_EmitInteger32, 0, 
/* 21515*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2),
                    MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_I64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$vec, 0:{ *:[i32] }, ?:{ *:[i64] }:$x)
/* 21523*/     0, /*End of Scope*/
/* 21524*/    /*Scope*/ 45, /*->21570*/
/* 21525*/     OPC_CheckChild1Type, MVT::f32,
/* 21527*/     OPC_Scope, 22, /*->21551*/ // 2 children in Scope
/* 21529*/      OPC_RecordChild2, // #2 = $idx
/* 21530*/      OPC_MoveChild2,
/* 21531*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21534*/      OPC_CheckPredicate, 9, // Predicate_LaneIdx4
/* 21536*/      OPC_CheckTypeI32,
/* 21537*/      OPC_MoveParent,
/* 21538*/      OPC_CheckType, MVT::v4f32,
/* 21540*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 21542*/      OPC_EmitConvertToTarget2,
/* 21543*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4),
                    MVT::v4f32, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx, F32:{ *:[f32] }:$x)
/* 21551*/     /*Scope*/ 17, /*->21569*/
/* 21552*/      OPC_MoveChild2,
/* 21553*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21556*/      OPC_MoveParent,
/* 21557*/      OPC_CheckType, MVT::v4f32,
/* 21559*/      OPC_EmitInteger32, 0, 
/* 21561*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4),
                    MVT::v4f32, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_F32x4:{ *:[v4f32] } ?:{ *:[v4f32] }:$vec, 0:{ *:[i32] }, ?:{ *:[f32] }:$x)
/* 21569*/     0, /*End of Scope*/
/* 21570*/    /*Scope*/ 45, /*->21616*/
/* 21571*/     OPC_CheckChild1Type, MVT::f64,
/* 21573*/     OPC_Scope, 22, /*->21597*/ // 2 children in Scope
/* 21575*/      OPC_RecordChild2, // #2 = $idx
/* 21576*/      OPC_MoveChild2,
/* 21577*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21580*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx2
/* 21582*/      OPC_CheckTypeI32,
/* 21583*/      OPC_MoveParent,
/* 21584*/      OPC_CheckType, MVT::v2f64,
/* 21586*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 21588*/      OPC_EmitConvertToTarget2,
/* 21589*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2),
                    MVT::v2f64, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx, F64:{ *:[f64] }:$x)
/* 21597*/     /*Scope*/ 17, /*->21615*/
/* 21598*/      OPC_MoveChild2,
/* 21599*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21602*/      OPC_MoveParent,
/* 21603*/      OPC_CheckType, MVT::v2f64,
/* 21605*/      OPC_EmitInteger32, 0, 
/* 21607*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2),
                    MVT::v2f64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_F64x2:{ *:[v2f64] } ?:{ *:[v2f64] }:$vec, 0:{ *:[i32] }, ?:{ *:[f64] }:$x)
/* 21615*/     0, /*End of Scope*/
/* 21616*/    0, /*End of Scope*/
/* 21617*/   0, /*End of Scope*/
/* 21618*/  0, /*End of Scope*/
/* 21619*/ /*SwitchOpcode*/ 100|128,1/*228*/, TARGET_VAL(WebAssemblyISD::VEC_SHR_U),// ->21851
/* 21623*/  OPC_Scope, 87, /*->21712*/ // 2 children in Scope
/* 21625*/   OPC_MoveChild0,
/* 21626*/   OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 21629*/   OPC_MoveChild0,
/* 21630*/   OPC_SwitchOpcode /*2 cases */, 37, TARGET_VAL(ISD::ADD),// ->21671
/* 21634*/    OPC_RecordChild0, // #0 = $lhs
/* 21635*/    OPC_RecordChild1, // #1 = $rhs
/* 21636*/    OPC_CheckPredicate, 26, // Predicate_add_nuw
/* 21638*/    OPC_MoveSibling1,
/* 21639*/    OPC_CheckOpcode, TARGET_VAL(ISD::SPLAT_VECTOR),
/* 21642*/    OPC_CheckChild0Integer, 2, 
/* 21644*/    OPC_CheckChild0TypeI32,
/* 21645*/    OPC_MoveParent,
/* 21646*/    OPC_CheckPredicate, 26, // Predicate_add_nuw
/* 21648*/    OPC_MoveParent,
/* 21649*/    OPC_CheckChild1Integer, 2, 
/* 21651*/    OPC_SwitchType /*2 cases */, 7, MVT::v16i8,// ->21661
/* 21654*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } (add:{ *:[v16i8] } (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)<<P:Predicate_add_nuw>>, (splat_vector:{ *:[v16i8] } 1:{ *:[i32] }))<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 21661*/    /*SwitchType*/ 7, MVT::v8i16,// ->21670
/* 21663*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } (add:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)<<P:Predicate_add_nuw>>, (splat_vector:{ *:[v8i16] } 1:{ *:[i32] }))<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 21670*/    0, // EndSwitchType
/* 21671*/   /*SwitchOpcode*/ 37, TARGET_VAL(ISD::SPLAT_VECTOR),// ->21711
/* 21674*/    OPC_CheckChild0Integer, 2, 
/* 21676*/    OPC_CheckChild0TypeI32,
/* 21677*/    OPC_MoveSibling1,
/* 21678*/    OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 21681*/    OPC_RecordChild0, // #0 = $lhs
/* 21682*/    OPC_RecordChild1, // #1 = $rhs
/* 21683*/    OPC_CheckPredicate, 26, // Predicate_add_nuw
/* 21685*/    OPC_MoveParent,
/* 21686*/    OPC_CheckPredicate, 26, // Predicate_add_nuw
/* 21688*/    OPC_MoveParent,
/* 21689*/    OPC_CheckChild1Integer, 2, 
/* 21691*/    OPC_SwitchType /*2 cases */, 7, MVT::v16i8,// ->21701
/* 21694*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } (add:{ *:[v16i8] } (splat_vector:{ *:[v16i8] } 1:{ *:[i32] }), (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)<<P:Predicate_add_nuw>>)<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 21701*/    /*SwitchType*/ 7, MVT::v8i16,// ->21710
/* 21703*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } (add:{ *:[v8i16] } (splat_vector:{ *:[v8i16] } 1:{ *:[i32] }), (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)<<P:Predicate_add_nuw>>)<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 21710*/    0, // EndSwitchType
/* 21711*/   0, // EndSwitchOpcode
/* 21712*/  /*Scope*/ 8|128,1/*136*/, /*->21850*/
/* 21714*/   OPC_RecordChild0, // #0 = $lhs
/* 21715*/   OPC_Scope, 84, /*->21801*/ // 2 children in Scope
/* 21717*/    OPC_MoveChild1,
/* 21718*/    OPC_Scope, 24, /*->21744*/ // 5 children in Scope
/* 21720*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21723*/     OPC_MoveChild0,
/* 21724*/     OPC_CheckAndImm, 63, 
/* 21726*/     OPC_RecordChild0, // #1 = $rhs
/* 21727*/     OPC_MoveParent,
/* 21728*/     OPC_MoveParent,
/* 21729*/     OPC_CheckType, MVT::v2i64,
/* 21731*/     OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                   MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 21737*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 2, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 21744*/    /*Scope*/ 13, /*->21758*/
/* 21745*/     OPC_CheckAndImm, 7, 
/* 21747*/     OPC_RecordChild0, // #1 = $rhs
/* 21748*/     OPC_MoveParent,
/* 21749*/     OPC_CheckType, MVT::v16i8,
/* 21751*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 21758*/    /*Scope*/ 13, /*->21772*/
/* 21759*/     OPC_CheckAndImm, 15, 
/* 21761*/     OPC_RecordChild0, // #1 = $rhs
/* 21762*/     OPC_MoveParent,
/* 21763*/     OPC_CheckType, MVT::v8i16,
/* 21765*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 21772*/    /*Scope*/ 13, /*->21786*/
/* 21773*/     OPC_CheckAndImm, 31, 
/* 21775*/     OPC_RecordChild0, // #1 = $rhs
/* 21776*/     OPC_MoveParent,
/* 21777*/     OPC_CheckType, MVT::v4i32,
/* 21779*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 21786*/    /*Scope*/ 13, /*->21800*/
/* 21787*/     OPC_CheckAndImm, 63, 
/* 21789*/     OPC_RecordChild0, // #1 = $rhs
/* 21790*/     OPC_MoveParent,
/* 21791*/     OPC_CheckType, MVT::v2i64,
/* 21793*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 21800*/    0, /*End of Scope*/
/* 21801*/   /*Scope*/ 47, /*->21849*/
/* 21802*/    OPC_RecordChild1, // #1 = $x
/* 21803*/    OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->21815
/* 21806*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 21808*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I8x16),
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 21815*/    /*SwitchType*/ 9, MVT::v8i16,// ->21826
/* 21817*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 21819*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I16x8),
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 21826*/    /*SwitchType*/ 9, MVT::v4i32,// ->21837
/* 21828*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 21830*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 21837*/    /*SwitchType*/ 9, MVT::v2i64,// ->21848
/* 21839*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 21841*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 21848*/    0, // EndSwitchType
/* 21849*/   0, /*End of Scope*/
/* 21850*/  0, /*End of Scope*/
/* 21851*/ /*SwitchOpcode*/ 52|128,4/*564*/, TARGET_VAL(ISD::SPLAT_VECTOR),// ->22419
/* 21855*/  OPC_Scope, 95|128,1/*223*/, /*->22081*/ // 4 children in Scope
/* 21858*/   OPC_MoveChild0,
/* 21859*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 21862*/   OPC_RecordMemRef,
/* 21863*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 21864*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 21865*/   OPC_Scope, 106, /*->21973*/ // 2 children in Scope
/* 21867*/    OPC_CheckChild1TypeI32,
/* 21868*/    OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 21870*/    OPC_Scope, 51, /*->21923*/ // 2 children in Scope
/* 21872*/     OPC_CheckPredicate, 18, // Predicate_extload
/* 21874*/     OPC_CheckTypeI32,
/* 21875*/     OPC_Scope, 22, /*->21899*/ // 2 children in Scope
/* 21877*/      OPC_CheckPredicate, 0, // Predicate_extloadi8
/* 21879*/      OPC_MoveParent,
/* 21880*/      OPC_CheckType, MVT::v16i8,
/* 21882*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 21884*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21887*/      OPC_EmitMergeInputChains1_0,
/* 21888*/      OPC_EmitInteger32, 0, 
/* 21890*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v16i8] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>) - Complexity = 16
                // Dst: (LOAD8_SPLAT_A32:{ *:[v16i8] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21899*/     /*Scope*/ 22, /*->21922*/
/* 21900*/      OPC_CheckPredicate, 1, // Predicate_extloadi16
/* 21902*/      OPC_MoveParent,
/* 21903*/      OPC_CheckType, MVT::v8i16,
/* 21905*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 21907*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21910*/      OPC_EmitMergeInputChains1_0,
/* 21911*/      OPC_EmitInteger32, 0, 
/* 21913*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v8i16] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>) - Complexity = 16
                // Dst: (LOAD16_SPLAT_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21922*/     0, /*End of Scope*/
/* 21923*/    /*Scope*/ 48, /*->21972*/
/* 21924*/     OPC_CheckPredicate, 15, // Predicate_load
/* 21926*/     OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->21949
/* 21929*/      OPC_MoveParent,
/* 21930*/      OPC_CheckType, MVT::v4i32,
/* 21932*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 21934*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21937*/      OPC_EmitMergeInputChains1_0,
/* 21938*/      OPC_EmitInteger32, 0, 
/* 21940*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD32_SPLAT_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21949*/     /*SwitchType*/ 20, MVT::i64,// ->21971
/* 21951*/      OPC_MoveParent,
/* 21952*/      OPC_CheckType, MVT::v2i64,
/* 21954*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 21956*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21959*/      OPC_EmitMergeInputChains1_0,
/* 21960*/      OPC_EmitInteger32, 0, 
/* 21962*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD64_SPLAT_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21971*/     0, // EndSwitchType
/* 21972*/    0, /*End of Scope*/
/* 21973*/   /*Scope*/ 106, /*->22080*/
/* 21974*/    OPC_CheckChild1TypeI64,
/* 21975*/    OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 21977*/    OPC_Scope, 51, /*->22030*/ // 2 children in Scope
/* 21979*/     OPC_CheckPredicate, 18, // Predicate_extload
/* 21981*/     OPC_CheckTypeI32,
/* 21982*/     OPC_Scope, 22, /*->22006*/ // 2 children in Scope
/* 21984*/      OPC_CheckPredicate, 0, // Predicate_extloadi8
/* 21986*/      OPC_MoveParent,
/* 21987*/      OPC_CheckType, MVT::v16i8,
/* 21989*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 21991*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21994*/      OPC_EmitMergeInputChains1_0,
/* 21995*/      OPC_EmitInteger32, 0, 
/* 21997*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v16i8] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>) - Complexity = 16
                // Dst: (LOAD8_SPLAT_A64:{ *:[v16i8] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22006*/     /*Scope*/ 22, /*->22029*/
/* 22007*/      OPC_CheckPredicate, 1, // Predicate_extloadi16
/* 22009*/      OPC_MoveParent,
/* 22010*/      OPC_CheckType, MVT::v8i16,
/* 22012*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 22014*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22017*/      OPC_EmitMergeInputChains1_0,
/* 22018*/      OPC_EmitInteger32, 0, 
/* 22020*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v8i16] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>) - Complexity = 16
                // Dst: (LOAD16_SPLAT_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22029*/     0, /*End of Scope*/
/* 22030*/    /*Scope*/ 48, /*->22079*/
/* 22031*/     OPC_CheckPredicate, 15, // Predicate_load
/* 22033*/     OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->22056
/* 22036*/      OPC_MoveParent,
/* 22037*/      OPC_CheckType, MVT::v4i32,
/* 22039*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 22041*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22044*/      OPC_EmitMergeInputChains1_0,
/* 22045*/      OPC_EmitInteger32, 0, 
/* 22047*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD32_SPLAT_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22056*/     /*SwitchType*/ 20, MVT::i64,// ->22078
/* 22058*/      OPC_MoveParent,
/* 22059*/      OPC_CheckType, MVT::v2i64,
/* 22061*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 22063*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22066*/      OPC_EmitMergeInputChains1_0,
/* 22067*/      OPC_EmitInteger32, 0, 
/* 22069*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD64_SPLAT_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22078*/     0, // EndSwitchType
/* 22079*/    0, /*End of Scope*/
/* 22080*/   0, /*End of Scope*/
/* 22081*/  /*Scope*/ 24|128,1/*152*/, /*->22235*/
/* 22083*/   OPC_RecordChild0, // #0 = $x
/* 22084*/   OPC_Scope, 102, /*->22188*/ // 3 children in Scope
/* 22086*/    OPC_MoveChild0,
/* 22087*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22090*/    OPC_SwitchType /*2 cases */, 80, MVT::i32,// ->22173
/* 22093*/     OPC_MoveParent,
/* 22094*/     OPC_SwitchType /*3 cases */, 37, MVT::v16i8,// ->22134
/* 22097*/      OPC_EmitConvertToTarget0,
/* 22098*/      OPC_EmitConvertToTarget0,
/* 22099*/      OPC_EmitConvertToTarget0,
/* 22100*/      OPC_EmitConvertToTarget0,
/* 22101*/      OPC_EmitConvertToTarget0,
/* 22102*/      OPC_EmitConvertToTarget0,
/* 22103*/      OPC_EmitConvertToTarget0,
/* 22104*/      OPC_EmitConvertToTarget0,
/* 22105*/      OPC_EmitConvertToTarget0,
/* 22106*/      OPC_EmitConvertToTarget0,
/* 22107*/      OPC_EmitConvertToTarget0,
/* 22108*/      OPC_EmitConvertToTarget0,
/* 22109*/      OPC_EmitConvertToTarget0,
/* 22110*/      OPC_EmitConvertToTarget0,
/* 22111*/      OPC_EmitConvertToTarget0,
/* 22112*/      OPC_EmitConvertToTarget0,
/* 22113*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I8x16),
                    MVT::v16i8, 16/*#Ops*/, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 
                // Src: (splat_vector:{ *:[v16i8] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I8x16:{ *:[v16i8] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 22134*/     /*SwitchType*/ 21, MVT::v8i16,// ->22157
/* 22136*/      OPC_EmitConvertToTarget0,
/* 22137*/      OPC_EmitConvertToTarget0,
/* 22138*/      OPC_EmitConvertToTarget0,
/* 22139*/      OPC_EmitConvertToTarget0,
/* 22140*/      OPC_EmitConvertToTarget0,
/* 22141*/      OPC_EmitConvertToTarget0,
/* 22142*/      OPC_EmitConvertToTarget0,
/* 22143*/      OPC_EmitConvertToTarget0,
/* 22144*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I16x8),
                    MVT::v8i16, 8/*#Ops*/, 1, 2, 3, 4, 5, 6, 7, 8, 
                // Src: (splat_vector:{ *:[v8i16] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I16x8:{ *:[v8i16] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 22157*/     /*SwitchType*/ 13, MVT::v4i32,// ->22172
/* 22159*/      OPC_EmitConvertToTarget0,
/* 22160*/      OPC_EmitConvertToTarget0,
/* 22161*/      OPC_EmitConvertToTarget0,
/* 22162*/      OPC_EmitConvertToTarget0,
/* 22163*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I32x4),
                    MVT::v4i32, 4/*#Ops*/, 1, 2, 3, 4, 
                // Src: (splat_vector:{ *:[v4i32] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I32x4:{ *:[v4i32] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 22172*/     0, // EndSwitchType
/* 22173*/    /*SwitchType*/ 12, MVT::i64,// ->22187
/* 22175*/     OPC_MoveParent,
/* 22176*/     OPC_CheckType, MVT::v2i64,
/* 22178*/     OPC_EmitConvertToTarget0,
/* 22179*/     OPC_EmitConvertToTarget0,
/* 22180*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I64x2),
                   MVT::v2i64, 2/*#Ops*/, 1, 2, 
               // Src: (splat_vector:{ *:[v2i64] } (imm:{ *:[i64] }):$x) - Complexity = 6
               // Dst: (CONST_V128_I64x2:{ *:[v2i64] } (imm:{ *:[i64] }):$x, (imm:{ *:[i64] }):$x)
/* 22187*/    0, // EndSwitchType
/* 22188*/   /*Scope*/ 33, /*->22222*/
/* 22189*/    OPC_CheckChild0TypeI32,
/* 22190*/    OPC_SwitchType /*3 cases */, 8, MVT::v16i8,// ->22201
/* 22193*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22195*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I8x16),
                   MVT::v16i8, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I8x16:{ *:[v16i8] } I32:{ *:[i32] }:$x)
/* 22201*/    /*SwitchType*/ 8, MVT::v8i16,// ->22211
/* 22203*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22205*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I16x8),
                   MVT::v8i16, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I16x8:{ *:[v8i16] } I32:{ *:[i32] }:$x)
/* 22211*/    /*SwitchType*/ 8, MVT::v4i32,// ->22221
/* 22213*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22215*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I32x4),
                   MVT::v4i32, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I32x4:{ *:[v4i32] } I32:{ *:[i32] }:$x)
/* 22221*/    0, // EndSwitchType
/* 22222*/   /*Scope*/ 11, /*->22234*/
/* 22223*/    OPC_CheckChild0TypeI64,
/* 22224*/    OPC_CheckType, MVT::v2i64,
/* 22226*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22228*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I64x2),
                  MVT::v2i64, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x) - Complexity = 3
              // Dst: (SPLAT_I64x2:{ *:[v2i64] } I64:{ *:[i64] }:$x)
/* 22234*/   0, /*End of Scope*/
/* 22235*/  /*Scope*/ 113, /*->22349*/
/* 22236*/   OPC_MoveChild0,
/* 22237*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 22240*/   OPC_RecordMemRef,
/* 22241*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 22242*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 22243*/   OPC_Scope, 51, /*->22296*/ // 2 children in Scope
/* 22245*/    OPC_CheckChild1TypeI32,
/* 22246*/    OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 22248*/    OPC_CheckPredicate, 15, // Predicate_load
/* 22250*/    OPC_SwitchType /*2 cases */, 20, MVT::f32,// ->22273
/* 22253*/     OPC_MoveParent,
/* 22254*/     OPC_CheckType, MVT::v4f32,
/* 22256*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 22258*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22261*/     OPC_EmitMergeInputChains1_0,
/* 22262*/     OPC_EmitInteger32, 0, 
/* 22264*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD32_SPLAT_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22273*/    /*SwitchType*/ 20, MVT::f64,// ->22295
/* 22275*/     OPC_MoveParent,
/* 22276*/     OPC_CheckType, MVT::v2f64,
/* 22278*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 22280*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22283*/     OPC_EmitMergeInputChains1_0,
/* 22284*/     OPC_EmitInteger32, 0, 
/* 22286*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD64_SPLAT_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22295*/    0, // EndSwitchType
/* 22296*/   /*Scope*/ 51, /*->22348*/
/* 22297*/    OPC_CheckChild1TypeI64,
/* 22298*/    OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 22300*/    OPC_CheckPredicate, 15, // Predicate_load
/* 22302*/    OPC_SwitchType /*2 cases */, 20, MVT::f32,// ->22325
/* 22305*/     OPC_MoveParent,
/* 22306*/     OPC_CheckType, MVT::v4f32,
/* 22308*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 22310*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22313*/     OPC_EmitMergeInputChains1_0,
/* 22314*/     OPC_EmitInteger32, 0, 
/* 22316*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD32_SPLAT_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22325*/    /*SwitchType*/ 20, MVT::f64,// ->22347
/* 22327*/     OPC_MoveParent,
/* 22328*/     OPC_CheckType, MVT::v2f64,
/* 22330*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 22332*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22335*/     OPC_EmitMergeInputChains1_0,
/* 22336*/     OPC_EmitInteger32, 0, 
/* 22338*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD64_SPLAT_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22347*/    0, // EndSwitchType
/* 22348*/   0, /*End of Scope*/
/* 22349*/  /*Scope*/ 68, /*->22418*/
/* 22350*/   OPC_RecordChild0, // #0 = $x
/* 22351*/   OPC_Scope, 38, /*->22391*/ // 3 children in Scope
/* 22353*/    OPC_MoveChild0,
/* 22354*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 22357*/    OPC_SwitchType /*2 cases */, 16, MVT::f32,// ->22376
/* 22360*/     OPC_MoveParent,
/* 22361*/     OPC_CheckType, MVT::v4f32,
/* 22363*/     OPC_EmitConvertToTarget0,
/* 22364*/     OPC_EmitConvertToTarget0,
/* 22365*/     OPC_EmitConvertToTarget0,
/* 22366*/     OPC_EmitConvertToTarget0,
/* 22367*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F32x4),
                   MVT::v4f32, 4/*#Ops*/, 1, 2, 3, 4, 
               // Src: (splat_vector:{ *:[v4f32] } (fpimm:{ *:[f32] }):$x) - Complexity = 6
               // Dst: (CONST_V128_F32x4:{ *:[v4f32] } (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x)
/* 22376*/    /*SwitchType*/ 12, MVT::f64,// ->22390
/* 22378*/     OPC_MoveParent,
/* 22379*/     OPC_CheckType, MVT::v2f64,
/* 22381*/     OPC_EmitConvertToTarget0,
/* 22382*/     OPC_EmitConvertToTarget0,
/* 22383*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F64x2),
                   MVT::v2f64, 2/*#Ops*/, 1, 2, 
               // Src: (splat_vector:{ *:[v2f64] } (fpimm:{ *:[f64] }):$x) - Complexity = 6
               // Dst: (CONST_V128_F64x2:{ *:[v2f64] } (fpimm:{ *:[f64] }):$x, (fpimm:{ *:[f64] }):$x)
/* 22390*/    0, // EndSwitchType
/* 22391*/   /*Scope*/ 12, /*->22404*/
/* 22392*/    OPC_CheckChild0Type, MVT::f32,
/* 22394*/    OPC_CheckType, MVT::v4f32,
/* 22396*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22398*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F32x4),
                  MVT::v4f32, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x) - Complexity = 3
              // Dst: (SPLAT_F32x4:{ *:[v4f32] } F32:{ *:[f32] }:$x)
/* 22404*/   /*Scope*/ 12, /*->22417*/
/* 22405*/    OPC_CheckChild0Type, MVT::f64,
/* 22407*/    OPC_CheckType, MVT::v2f64,
/* 22409*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22411*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F64x2),
                  MVT::v2f64, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x) - Complexity = 3
              // Dst: (SPLAT_F64x2:{ *:[v2f64] } F64:{ *:[f64] }:$x)
/* 22417*/   0, /*End of Scope*/
/* 22418*/  0, /*End of Scope*/
/* 22419*/ /*SwitchOpcode*/ 52|128,1/*180*/, TARGET_VAL(ISD::SCALAR_TO_VECTOR),// ->22603
/* 22423*/  OPC_Scope, 113, /*->22538*/ // 2 children in Scope
/* 22425*/   OPC_MoveChild0,
/* 22426*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 22429*/   OPC_RecordMemRef,
/* 22430*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 22431*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 22432*/   OPC_Scope, 51, /*->22485*/ // 2 children in Scope
/* 22434*/    OPC_CheckChild1TypeI32,
/* 22435*/    OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 22437*/    OPC_CheckPredicate, 15, // Predicate_load
/* 22439*/    OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->22462
/* 22442*/     OPC_MoveParent,
/* 22443*/     OPC_CheckType, MVT::v4i32,
/* 22445*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 22447*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22450*/     OPC_EmitMergeInputChains1_0,
/* 22451*/     OPC_EmitInteger32, 0, 
/* 22453*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22462*/    /*SwitchType*/ 20, MVT::i64,// ->22484
/* 22464*/     OPC_MoveParent,
/* 22465*/     OPC_CheckType, MVT::v2i64,
/* 22467*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 22469*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22472*/     OPC_EmitMergeInputChains1_0,
/* 22473*/     OPC_EmitInteger32, 0, 
/* 22475*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22484*/    0, // EndSwitchType
/* 22485*/   /*Scope*/ 51, /*->22537*/
/* 22486*/    OPC_CheckChild1TypeI64,
/* 22487*/    OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 22489*/    OPC_CheckPredicate, 15, // Predicate_load
/* 22491*/    OPC_SwitchType /*2 cases */, 20, MVT::i32,// ->22514
/* 22494*/     OPC_MoveParent,
/* 22495*/     OPC_CheckType, MVT::v4i32,
/* 22497*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 22499*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22502*/     OPC_EmitMergeInputChains1_0,
/* 22503*/     OPC_EmitInteger32, 0, 
/* 22505*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22514*/    /*SwitchType*/ 20, MVT::i64,// ->22536
/* 22516*/     OPC_MoveParent,
/* 22517*/     OPC_CheckType, MVT::v2i64,
/* 22519*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 22521*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22524*/     OPC_EmitMergeInputChains1_0,
/* 22525*/     OPC_EmitInteger32, 0, 
/* 22527*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22536*/    0, // EndSwitchType
/* 22537*/   0, /*End of Scope*/
/* 22538*/  /*Scope*/ 63, /*->22602*/
/* 22539*/   OPC_RecordChild0, // #0 = $x
/* 22540*/   OPC_Scope, 27, /*->22569*/ // 4 children in Scope
/* 22542*/    OPC_CheckChild0TypeI32,
/* 22543*/    OPC_SwitchType /*3 cases */, 6, MVT::v16i8,// ->22552
/* 22546*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I8x16),
                   MVT::v16i8, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I8x16:{ *:[v16i8] } ?:{ *:[i32] }:$x)
/* 22552*/    /*SwitchType*/ 6, MVT::v8i16,// ->22560
/* 22554*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I16x8),
                   MVT::v8i16, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I16x8:{ *:[v8i16] } ?:{ *:[i32] }:$x)
/* 22560*/    /*SwitchType*/ 6, MVT::v4i32,// ->22568
/* 22562*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I32x4),
                   MVT::v4i32, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I32x4:{ *:[v4i32] } ?:{ *:[i32] }:$x)
/* 22568*/    0, // EndSwitchType
/* 22569*/   /*Scope*/ 9, /*->22579*/
/* 22570*/    OPC_CheckChild0TypeI64,
/* 22571*/    OPC_CheckType, MVT::v2i64,
/* 22573*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I64x2),
                  MVT::v2i64, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x) - Complexity = 3
              // Dst: (SPLAT_I64x2:{ *:[v2i64] } ?:{ *:[i64] }:$x)
/* 22579*/   /*Scope*/ 10, /*->22590*/
/* 22580*/    OPC_CheckChild0Type, MVT::f32,
/* 22582*/    OPC_CheckType, MVT::v4f32,
/* 22584*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F32x4),
                  MVT::v4f32, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x) - Complexity = 3
              // Dst: (SPLAT_F32x4:{ *:[v4f32] } ?:{ *:[f32] }:$x)
/* 22590*/   /*Scope*/ 10, /*->22601*/
/* 22591*/    OPC_CheckChild0Type, MVT::f64,
/* 22593*/    OPC_CheckType, MVT::v2f64,
/* 22595*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F64x2),
                  MVT::v2f64, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x) - Complexity = 3
              // Dst: (SPLAT_F64x2:{ *:[v2f64] } ?:{ *:[f64] }:$x)
/* 22601*/   0, /*End of Scope*/
/* 22602*/  0, /*End of Scope*/
/* 22603*/ /*SwitchOpcode*/ 8|128,1/*136*/, TARGET_VAL(WebAssemblyISD::VEC_SHL),// ->22743
/* 22607*/  OPC_RecordChild0, // #0 = $lhs
/* 22608*/  OPC_Scope, 84, /*->22694*/ // 2 children in Scope
/* 22610*/   OPC_MoveChild1,
/* 22611*/   OPC_Scope, 24, /*->22637*/ // 5 children in Scope
/* 22613*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22616*/    OPC_MoveChild0,
/* 22617*/    OPC_CheckAndImm, 63, 
/* 22619*/    OPC_RecordChild0, // #1 = $rhs
/* 22620*/    OPC_MoveParent,
/* 22621*/    OPC_MoveParent,
/* 22622*/    OPC_CheckType, MVT::v2i64,
/* 22624*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                  MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 22630*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 2, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 22637*/   /*Scope*/ 13, /*->22651*/
/* 22638*/    OPC_CheckAndImm, 7, 
/* 22640*/    OPC_RecordChild0, // #1 = $rhs
/* 22641*/    OPC_MoveParent,
/* 22642*/    OPC_CheckType, MVT::v16i8,
/* 22644*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22651*/   /*Scope*/ 13, /*->22665*/
/* 22652*/    OPC_CheckAndImm, 15, 
/* 22654*/    OPC_RecordChild0, // #1 = $rhs
/* 22655*/    OPC_MoveParent,
/* 22656*/    OPC_CheckType, MVT::v8i16,
/* 22658*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22665*/   /*Scope*/ 13, /*->22679*/
/* 22666*/    OPC_CheckAndImm, 31, 
/* 22668*/    OPC_RecordChild0, // #1 = $rhs
/* 22669*/    OPC_MoveParent,
/* 22670*/    OPC_CheckType, MVT::v4i32,
/* 22672*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22679*/   /*Scope*/ 13, /*->22693*/
/* 22680*/    OPC_CheckAndImm, 63, 
/* 22682*/    OPC_RecordChild0, // #1 = $rhs
/* 22683*/    OPC_MoveParent,
/* 22684*/    OPC_CheckType, MVT::v2i64,
/* 22686*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22693*/   0, /*End of Scope*/
/* 22694*/  /*Scope*/ 47, /*->22742*/
/* 22695*/   OPC_RecordChild1, // #1 = $x
/* 22696*/   OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->22708
/* 22699*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22701*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 22708*/   /*SwitchType*/ 9, MVT::v8i16,// ->22719
/* 22710*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22712*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 22719*/   /*SwitchType*/ 9, MVT::v4i32,// ->22730
/* 22721*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22723*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 22730*/   /*SwitchType*/ 9, MVT::v2i64,// ->22741
/* 22732*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22734*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 22741*/   0, // EndSwitchType
/* 22742*/  0, /*End of Scope*/
/* 22743*/ /*SwitchOpcode*/ 8|128,1/*136*/, TARGET_VAL(WebAssemblyISD::VEC_SHR_S),// ->22883
/* 22747*/  OPC_RecordChild0, // #0 = $lhs
/* 22748*/  OPC_Scope, 84, /*->22834*/ // 2 children in Scope
/* 22750*/   OPC_MoveChild1,
/* 22751*/   OPC_Scope, 24, /*->22777*/ // 5 children in Scope
/* 22753*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22756*/    OPC_MoveChild0,
/* 22757*/    OPC_CheckAndImm, 63, 
/* 22759*/    OPC_RecordChild0, // #1 = $rhs
/* 22760*/    OPC_MoveParent,
/* 22761*/    OPC_MoveParent,
/* 22762*/    OPC_CheckType, MVT::v2i64,
/* 22764*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                  MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 22770*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 2, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 22777*/   /*Scope*/ 13, /*->22791*/
/* 22778*/    OPC_CheckAndImm, 7, 
/* 22780*/    OPC_RecordChild0, // #1 = $rhs
/* 22781*/    OPC_MoveParent,
/* 22782*/    OPC_CheckType, MVT::v16i8,
/* 22784*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22791*/   /*Scope*/ 13, /*->22805*/
/* 22792*/    OPC_CheckAndImm, 15, 
/* 22794*/    OPC_RecordChild0, // #1 = $rhs
/* 22795*/    OPC_MoveParent,
/* 22796*/    OPC_CheckType, MVT::v8i16,
/* 22798*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22805*/   /*Scope*/ 13, /*->22819*/
/* 22806*/    OPC_CheckAndImm, 31, 
/* 22808*/    OPC_RecordChild0, // #1 = $rhs
/* 22809*/    OPC_MoveParent,
/* 22810*/    OPC_CheckType, MVT::v4i32,
/* 22812*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22819*/   /*Scope*/ 13, /*->22833*/
/* 22820*/    OPC_CheckAndImm, 63, 
/* 22822*/    OPC_RecordChild0, // #1 = $rhs
/* 22823*/    OPC_MoveParent,
/* 22824*/    OPC_CheckType, MVT::v2i64,
/* 22826*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22833*/   0, /*End of Scope*/
/* 22834*/  /*Scope*/ 47, /*->22882*/
/* 22835*/   OPC_RecordChild1, // #1 = $x
/* 22836*/   OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->22848
/* 22839*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22841*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I8x16),
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 22848*/   /*SwitchType*/ 9, MVT::v8i16,// ->22859
/* 22850*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22852*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I16x8),
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 22859*/   /*SwitchType*/ 9, MVT::v4i32,// ->22870
/* 22861*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22863*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32x4),
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 22870*/   /*SwitchType*/ 9, MVT::v2i64,// ->22881
/* 22872*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22874*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 22881*/   0, // EndSwitchType
/* 22882*/  0, /*End of Scope*/
/* 22883*/ /*SwitchOpcode*/ 99|128,3/*483*/, TARGET_VAL(ISD::VSELECT),// ->23370
/* 22887*/  OPC_Scope, 97, /*->22986*/ // 4 children in Scope
/* 22889*/   OPC_MoveChild0,
/* 22890*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 22893*/   OPC_MoveChild0,
/* 22894*/   OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 22897*/   OPC_RecordChild0, // #0 = $rhs
/* 22898*/   OPC_SwitchType /*2 cases */, 41, MVT::v4f32,// ->22942
/* 22901*/    OPC_CheckChild0Type, MVT::v4i32,
/* 22903*/    OPC_MoveSibling1,
/* 22904*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 22907*/    OPC_RecordChild0, // #1 = $lhs
/* 22908*/    OPC_CheckChild0Type, MVT::v4i32,
/* 22910*/    OPC_MoveParent,
/* 22911*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 22913*/    OPC_MoveParent,
/* 22914*/    OPC_CheckType, MVT::v4i32,
/* 22916*/    OPC_Scope, 11, /*->22929*/ // 2 children in Scope
/* 22918*/     OPC_CheckChild1Same, 0,
/* 22920*/     OPC_CheckChild2Same, 1,
/* 22922*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                   MVT::v4i32, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v4i32] } (setcc:{ *:[v4i32] } (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$rhs), (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v4i32] }:$rhs, V128:{ *:[v4i32] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 22929*/    /*Scope*/ 11, /*->22941*/
/* 22930*/     OPC_CheckChild1Same, 1,
/* 22932*/     OPC_CheckChild2Same, 0,
/* 22934*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v4i32] } (setcc:{ *:[v4i32] } (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$lhs), (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v4i32] }:$rhs, V128:{ *:[v4i32] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 22941*/    0, /*End of Scope*/
/* 22942*/   /*SwitchType*/ 41, MVT::v2f64,// ->22985
/* 22944*/    OPC_CheckChild0Type, MVT::v2i64,
/* 22946*/    OPC_MoveSibling1,
/* 22947*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 22950*/    OPC_RecordChild0, // #1 = $lhs
/* 22951*/    OPC_CheckChild0Type, MVT::v2i64,
/* 22953*/    OPC_MoveParent,
/* 22954*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 22956*/    OPC_MoveParent,
/* 22957*/    OPC_CheckType, MVT::v2i64,
/* 22959*/    OPC_Scope, 11, /*->22972*/ // 2 children in Scope
/* 22961*/     OPC_CheckChild1Same, 0,
/* 22963*/     OPC_CheckChild2Same, 1,
/* 22965*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                   MVT::v2i64, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v2i64] } (setcc:{ *:[v2i64] } (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$rhs), (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v2i64] }:$rhs, V128:{ *:[v2i64] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 22972*/    /*Scope*/ 11, /*->22984*/
/* 22973*/     OPC_CheckChild1Same, 1,
/* 22975*/     OPC_CheckChild2Same, 0,
/* 22977*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v2i64] } (setcc:{ *:[v2i64] } (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$lhs), (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v2i64] }:$rhs, V128:{ *:[v2i64] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 22984*/    0, /*End of Scope*/
/* 22985*/   0, // EndSwitchType
/* 22986*/  /*Scope*/ 45, /*->23032*/
/* 22987*/   OPC_RecordChild0, // #0 = $c
/* 22988*/   OPC_RecordChild1, // #1 = $v1
/* 22989*/   OPC_RecordChild2, // #2 = $v2
/* 22990*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->23001
/* 22993*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 23001*/   /*SwitchType*/ 8, MVT::v8i16,// ->23011
/* 23003*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 23011*/   /*SwitchType*/ 8, MVT::v4i32,// ->23021
/* 23013*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 23021*/   /*SwitchType*/ 8, MVT::v2i64,// ->23031
/* 23023*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 23031*/   0, // EndSwitchType
/* 23032*/  /*Scope*/ 53|128,2/*309*/, /*->23343*/
/* 23034*/   OPC_MoveChild0,
/* 23035*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 23038*/   OPC_RecordChild0, // #0 = $rhs
/* 23039*/   OPC_Scope, 21|128,1/*149*/, /*->23191*/ // 2 children in Scope
/* 23042*/    OPC_CheckChild0Type, MVT::v4f32,
/* 23044*/    OPC_RecordChild1, // #1 = $lhs
/* 23045*/    OPC_Scope, 35, /*->23082*/ // 4 children in Scope
/* 23047*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23049*/     OPC_MoveParent,
/* 23050*/     OPC_CheckType, MVT::v4f32,
/* 23052*/     OPC_Scope, 13, /*->23067*/ // 2 children in Scope
/* 23054*/      OPC_CheckChild1Same, 0,
/* 23056*/      OPC_CheckChild2Same, 1,
/* 23058*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23060*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23067*/     /*Scope*/ 13, /*->23081*/
/* 23068*/      OPC_CheckChild1Same, 1,
/* 23070*/      OPC_CheckChild2Same, 0,
/* 23072*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23074*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23081*/     0, /*End of Scope*/
/* 23082*/    /*Scope*/ 35, /*->23118*/
/* 23083*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 23085*/     OPC_MoveParent,
/* 23086*/     OPC_CheckType, MVT::v4f32,
/* 23088*/     OPC_Scope, 13, /*->23103*/ // 2 children in Scope
/* 23090*/      OPC_CheckChild1Same, 0,
/* 23092*/      OPC_CheckChild2Same, 1,
/* 23094*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23096*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23103*/     /*Scope*/ 13, /*->23117*/
/* 23104*/      OPC_CheckChild1Same, 1,
/* 23106*/      OPC_CheckChild2Same, 0,
/* 23108*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23110*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23117*/     0, /*End of Scope*/
/* 23118*/    /*Scope*/ 35, /*->23154*/
/* 23119*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 23121*/     OPC_MoveParent,
/* 23122*/     OPC_CheckType, MVT::v4f32,
/* 23124*/     OPC_Scope, 13, /*->23139*/ // 2 children in Scope
/* 23126*/      OPC_CheckChild1Same, 1,
/* 23128*/      OPC_CheckChild2Same, 0,
/* 23130*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23132*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23139*/     /*Scope*/ 13, /*->23153*/
/* 23140*/      OPC_CheckChild1Same, 0,
/* 23142*/      OPC_CheckChild2Same, 1,
/* 23144*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23146*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23153*/     0, /*End of Scope*/
/* 23154*/    /*Scope*/ 35, /*->23190*/
/* 23155*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 23157*/     OPC_MoveParent,
/* 23158*/     OPC_CheckType, MVT::v4f32,
/* 23160*/     OPC_Scope, 13, /*->23175*/ // 2 children in Scope
/* 23162*/      OPC_CheckChild1Same, 1,
/* 23164*/      OPC_CheckChild2Same, 0,
/* 23166*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23168*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23175*/     /*Scope*/ 13, /*->23189*/
/* 23176*/      OPC_CheckChild1Same, 0,
/* 23178*/      OPC_CheckChild2Same, 1,
/* 23180*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23182*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    MVT::v4f32, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23189*/     0, /*End of Scope*/
/* 23190*/    0, /*End of Scope*/
/* 23191*/   /*Scope*/ 21|128,1/*149*/, /*->23342*/
/* 23193*/    OPC_CheckChild0Type, MVT::v2f64,
/* 23195*/    OPC_RecordChild1, // #1 = $lhs
/* 23196*/    OPC_Scope, 35, /*->23233*/ // 4 children in Scope
/* 23198*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23200*/     OPC_MoveParent,
/* 23201*/     OPC_CheckType, MVT::v2f64,
/* 23203*/     OPC_Scope, 13, /*->23218*/ // 2 children in Scope
/* 23205*/      OPC_CheckChild1Same, 0,
/* 23207*/      OPC_CheckChild2Same, 1,
/* 23209*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23211*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23218*/     /*Scope*/ 13, /*->23232*/
/* 23219*/      OPC_CheckChild1Same, 1,
/* 23221*/      OPC_CheckChild2Same, 0,
/* 23223*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23225*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23232*/     0, /*End of Scope*/
/* 23233*/    /*Scope*/ 35, /*->23269*/
/* 23234*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 23236*/     OPC_MoveParent,
/* 23237*/     OPC_CheckType, MVT::v2f64,
/* 23239*/     OPC_Scope, 13, /*->23254*/ // 2 children in Scope
/* 23241*/      OPC_CheckChild1Same, 0,
/* 23243*/      OPC_CheckChild2Same, 1,
/* 23245*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23247*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23254*/     /*Scope*/ 13, /*->23268*/
/* 23255*/      OPC_CheckChild1Same, 1,
/* 23257*/      OPC_CheckChild2Same, 0,
/* 23259*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23261*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23268*/     0, /*End of Scope*/
/* 23269*/    /*Scope*/ 35, /*->23305*/
/* 23270*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 23272*/     OPC_MoveParent,
/* 23273*/     OPC_CheckType, MVT::v2f64,
/* 23275*/     OPC_Scope, 13, /*->23290*/ // 2 children in Scope
/* 23277*/      OPC_CheckChild1Same, 1,
/* 23279*/      OPC_CheckChild2Same, 0,
/* 23281*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23283*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23290*/     /*Scope*/ 13, /*->23304*/
/* 23291*/      OPC_CheckChild1Same, 0,
/* 23293*/      OPC_CheckChild2Same, 1,
/* 23295*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23297*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23304*/     0, /*End of Scope*/
/* 23305*/    /*Scope*/ 35, /*->23341*/
/* 23306*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 23308*/     OPC_MoveParent,
/* 23309*/     OPC_CheckType, MVT::v2f64,
/* 23311*/     OPC_Scope, 13, /*->23326*/ // 2 children in Scope
/* 23313*/      OPC_CheckChild1Same, 1,
/* 23315*/      OPC_CheckChild2Same, 0,
/* 23317*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23319*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23326*/     /*Scope*/ 13, /*->23340*/
/* 23327*/      OPC_CheckChild1Same, 0,
/* 23329*/      OPC_CheckChild2Same, 1,
/* 23331*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23333*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    MVT::v2f64, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23340*/     0, /*End of Scope*/
/* 23341*/    0, /*End of Scope*/
/* 23342*/   0, /*End of Scope*/
/* 23343*/  /*Scope*/ 25, /*->23369*/
/* 23344*/   OPC_RecordChild0, // #0 = $c
/* 23345*/   OPC_RecordChild1, // #1 = $v1
/* 23346*/   OPC_RecordChild2, // #2 = $v2
/* 23347*/   OPC_SwitchType /*2 cases */, 8, MVT::v4f32,// ->23358
/* 23350*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v4f32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v4f32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v4f32] } ?:{ *:[v4f32] }:$v1, ?:{ *:[v4f32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 23358*/   /*SwitchType*/ 8, MVT::v2f64,// ->23368
/* 23360*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  MVT::v2f64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v2f64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v2f64] } ?:{ *:[v2f64] }:$v1, ?:{ *:[v2f64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 23368*/   0, // EndSwitchType
/* 23369*/  0, /*End of Scope*/
/* 23370*/ /*SwitchOpcode*/ 17, TARGET_VAL(WebAssemblyISD::SWIZZLE),// ->23390
/* 23373*/  OPC_RecordChild0, // #0 = $src
/* 23374*/  OPC_CheckChild0Type, MVT::v16i8,
/* 23376*/  OPC_RecordChild1, // #1 = $mask
/* 23377*/  OPC_CheckChild1Type, MVT::v16i8,
/* 23379*/  OPC_CheckType, MVT::v16i8,
/* 23381*/  OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23383*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SWIZZLE),
                MVT::v16i8, 2/*#Ops*/, 0, 1, 
            // Src: (wasm_swizzle:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 3
            // Dst: (SWIZZLE:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask)
/* 23390*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::ABS),// ->23436
/* 23393*/  OPC_RecordChild0, // #0 = $v
/* 23394*/  OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->23405
/* 23397*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23399*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I8x16),
                 MVT::v16i8, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$v) - Complexity = 3
             // Dst: (ABS_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 23405*/  /*SwitchType*/ 8, MVT::v8i16,// ->23415
/* 23407*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23409*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$v) - Complexity = 3
             // Dst: (ABS_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$v)
/* 23415*/  /*SwitchType*/ 8, MVT::v4i32,// ->23425
/* 23417*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23419*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
             // Dst: (ABS_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$v)
/* 23425*/  /*SwitchType*/ 8, MVT::v2i64,// ->23435
/* 23427*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23429*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I64x2),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
             // Dst: (ABS_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$v)
/* 23435*/  0, // EndSwitchType
/* 23436*/ /*SwitchOpcode*/ 26, TARGET_VAL(ISD::SADDSAT),// ->23465
/* 23439*/  OPC_RecordChild0, // #0 = $lhs
/* 23440*/  OPC_RecordChild1, // #1 = $rhs
/* 23441*/  OPC_SwitchType /*2 cases */, 9, MVT::v16i8,// ->23453
/* 23444*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23446*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_S_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 23453*/  /*SwitchType*/ 9, MVT::v8i16,// ->23464
/* 23455*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23457*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_S_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 23464*/  0, // EndSwitchType
/* 23465*/ /*SwitchOpcode*/ 26, TARGET_VAL(ISD::UADDSAT),// ->23494
/* 23468*/  OPC_RecordChild0, // #0 = $lhs
/* 23469*/  OPC_RecordChild1, // #1 = $rhs
/* 23470*/  OPC_SwitchType /*2 cases */, 9, MVT::v16i8,// ->23482
/* 23473*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23475*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_U_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 23482*/  /*SwitchType*/ 9, MVT::v8i16,// ->23493
/* 23484*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23486*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_U_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 23493*/  0, // EndSwitchType
/* 23494*/ /*SwitchOpcode*/ 37, TARGET_VAL(ISD::SMIN),// ->23534
/* 23497*/  OPC_RecordChild0, // #0 = $lhs
/* 23498*/  OPC_RecordChild1, // #1 = $rhs
/* 23499*/  OPC_SwitchType /*3 cases */, 9, MVT::v16i8,// ->23511
/* 23502*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23504*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 23511*/  /*SwitchType*/ 9, MVT::v8i16,// ->23522
/* 23513*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23515*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 23522*/  /*SwitchType*/ 9, MVT::v4i32,// ->23533
/* 23524*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23526*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I32x4),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 23533*/  0, // EndSwitchType
/* 23534*/ /*SwitchOpcode*/ 37, TARGET_VAL(ISD::UMIN),// ->23574
/* 23537*/  OPC_RecordChild0, // #0 = $lhs
/* 23538*/  OPC_RecordChild1, // #1 = $rhs
/* 23539*/  OPC_SwitchType /*3 cases */, 9, MVT::v16i8,// ->23551
/* 23542*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23544*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 23551*/  /*SwitchType*/ 9, MVT::v8i16,// ->23562
/* 23553*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23555*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 23562*/  /*SwitchType*/ 9, MVT::v4i32,// ->23573
/* 23564*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23566*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I32x4),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 23573*/  0, // EndSwitchType
/* 23574*/ /*SwitchOpcode*/ 37, TARGET_VAL(ISD::SMAX),// ->23614
/* 23577*/  OPC_RecordChild0, // #0 = $lhs
/* 23578*/  OPC_RecordChild1, // #1 = $rhs
/* 23579*/  OPC_SwitchType /*3 cases */, 9, MVT::v16i8,// ->23591
/* 23582*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23584*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 23591*/  /*SwitchType*/ 9, MVT::v8i16,// ->23602
/* 23593*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23595*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 23602*/  /*SwitchType*/ 9, MVT::v4i32,// ->23613
/* 23604*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23606*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I32x4),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 23613*/  0, // EndSwitchType
/* 23614*/ /*SwitchOpcode*/ 37, TARGET_VAL(ISD::UMAX),// ->23654
/* 23617*/  OPC_RecordChild0, // #0 = $lhs
/* 23618*/  OPC_RecordChild1, // #1 = $rhs
/* 23619*/  OPC_SwitchType /*3 cases */, 9, MVT::v16i8,// ->23631
/* 23622*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23624*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 23631*/  /*SwitchType*/ 9, MVT::v8i16,// ->23642
/* 23633*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23635*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 23642*/  /*SwitchType*/ 9, MVT::v4i32,// ->23653
/* 23644*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23646*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I32x4),
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 23653*/  0, // EndSwitchType
/* 23654*/ /*SwitchOpcode*/ 13, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_S),// ->23670
/* 23657*/  OPC_RecordChild0, // #0 = $vec
/* 23658*/  OPC_CheckChild0Type, MVT::v2f64,
/* 23660*/  OPC_CheckType, MVT::v4i32,
/* 23662*/  OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23664*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::trunc_sat_zero_s_I32x4),
                MVT::v4i32, 1/*#Ops*/, 0, 
            // Src: (trunc_sat_zero_s:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (trunc_sat_zero_s_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 23670*/ /*SwitchOpcode*/ 13, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_U),// ->23686
/* 23673*/  OPC_RecordChild0, // #0 = $vec
/* 23674*/  OPC_CheckChild0Type, MVT::v2f64,
/* 23676*/  OPC_CheckType, MVT::v4i32,
/* 23678*/  OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23680*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::trunc_sat_zero_u_I32x4),
                MVT::v4i32, 1/*#Ops*/, 0, 
            // Src: (trunc_sat_zero_u:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (trunc_sat_zero_u_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 23686*/ /*SwitchOpcode*/ 39, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),// ->23728
/* 23689*/  OPC_RecordChild0, // #0 = $vec
/* 23690*/  OPC_SwitchType /*3 cases */, 10, MVT::v8i16,// ->23703
/* 23693*/   OPC_CheckChild0Type, MVT::v16i8,
/* 23695*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23697*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 23703*/  /*SwitchType*/ 10, MVT::v4i32,// ->23715
/* 23705*/   OPC_CheckChild0Type, MVT::v8i16,
/* 23707*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23709*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 23715*/  /*SwitchType*/ 10, MVT::v2i64,// ->23727
/* 23717*/   OPC_CheckChild0Type, MVT::v4i32,
/* 23719*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23721*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I64x2),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 23727*/  0, // EndSwitchType
/* 23728*/ /*SwitchOpcode*/ 39, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),// ->23770
/* 23731*/  OPC_RecordChild0, // #0 = $vec
/* 23732*/  OPC_SwitchType /*3 cases */, 10, MVT::v8i16,// ->23745
/* 23735*/   OPC_CheckChild0Type, MVT::v16i8,
/* 23737*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23739*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 23745*/  /*SwitchType*/ 10, MVT::v4i32,// ->23757
/* 23747*/   OPC_CheckChild0Type, MVT::v8i16,
/* 23749*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23751*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 23757*/  /*SwitchType*/ 10, MVT::v2i64,// ->23769
/* 23759*/   OPC_CheckChild0Type, MVT::v4i32,
/* 23761*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23763*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I64x2),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 23769*/  0, // EndSwitchType
/* 23770*/ /*SwitchOpcode*/ 39, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),// ->23812
/* 23773*/  OPC_RecordChild0, // #0 = $vec
/* 23774*/  OPC_SwitchType /*3 cases */, 10, MVT::v8i16,// ->23787
/* 23777*/   OPC_CheckChild0Type, MVT::v16i8,
/* 23779*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23781*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 23787*/  /*SwitchType*/ 10, MVT::v4i32,// ->23799
/* 23789*/   OPC_CheckChild0Type, MVT::v8i16,
/* 23791*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23793*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 23799*/  /*SwitchType*/ 10, MVT::v2i64,// ->23811
/* 23801*/   OPC_CheckChild0Type, MVT::v4i32,
/* 23803*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23805*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I64x2),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 23811*/  0, // EndSwitchType
/* 23812*/ /*SwitchOpcode*/ 39, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),// ->23854
/* 23815*/  OPC_RecordChild0, // #0 = $vec
/* 23816*/  OPC_SwitchType /*3 cases */, 10, MVT::v8i16,// ->23829
/* 23819*/   OPC_CheckChild0Type, MVT::v16i8,
/* 23821*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23823*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I16x8),
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 23829*/  /*SwitchType*/ 10, MVT::v4i32,// ->23841
/* 23831*/   OPC_CheckChild0Type, MVT::v8i16,
/* 23833*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23835*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I32x4),
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 23841*/  /*SwitchType*/ 10, MVT::v2i64,// ->23853
/* 23843*/   OPC_CheckChild0Type, MVT::v4i32,
/* 23845*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23847*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I64x2),
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 23853*/  0, // EndSwitchType
/* 23854*/ /*SwitchOpcode*/ 31, TARGET_VAL(WebAssemblyISD::NARROW_U),// ->23888
/* 23857*/  OPC_RecordChild0, // #0 = $left
/* 23858*/  OPC_SwitchType /*2 cases */, 12, MVT::v16i8,// ->23873
/* 23861*/   OPC_CheckChild0Type, MVT::v8i16,
/* 23863*/   OPC_RecordChild1, // #1 = $right
/* 23864*/   OPC_CheckChild1Type, MVT::v8i16,
/* 23866*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I8x16),
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (wasm_narrow_u:{ *:[v16i8] } V128:{ *:[v8i16] }:$left, V128:{ *:[v8i16] }:$right) - Complexity = 3
             // Dst: (NARROW_U_I8x16:{ *:[v16i8] } ?:{ *:[v8i16] }:$left, ?:{ *:[v8i16] }:$right)
/* 23873*/  /*SwitchType*/ 12, MVT::v8i16,// ->23887
/* 23875*/   OPC_CheckChild0Type, MVT::v4i32,
/* 23877*/   OPC_RecordChild1, // #1 = $right
/* 23878*/   OPC_CheckChild1Type, MVT::v4i32,
/* 23880*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I16x8),
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (wasm_narrow_u:{ *:[v8i16] } V128:{ *:[v4i32] }:$left, V128:{ *:[v4i32] }:$right) - Complexity = 3
             // Dst: (NARROW_U_I16x8:{ *:[v8i16] } ?:{ *:[v4i32] }:$left, ?:{ *:[v4i32] }:$right)
/* 23887*/  0, // EndSwitchType
/* 23888*/ /*SwitchOpcode*/ 13, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_S),// ->23904
/* 23891*/  OPC_RecordChild0, // #0 = $vec
/* 23892*/  OPC_CheckChild0Type, MVT::v4i32,
/* 23894*/  OPC_CheckType, MVT::v2f64,
/* 23896*/  OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23898*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::convert_low_s_F64x2),
                MVT::v2f64, 1/*#Ops*/, 0, 
            // Src: (convert_low_s:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
            // Dst: (convert_low_s_F64x2:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec)
/* 23904*/ /*SwitchOpcode*/ 13, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_U),// ->23920
/* 23907*/  OPC_RecordChild0, // #0 = $vec
/* 23908*/  OPC_CheckChild0Type, MVT::v4i32,
/* 23910*/  OPC_CheckType, MVT::v2f64,
/* 23912*/  OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23914*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::convert_low_u_F64x2),
                MVT::v2f64, 1/*#Ops*/, 0, 
            // Src: (convert_low_u:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
            // Dst: (convert_low_u_F64x2:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec)
/* 23920*/ /*SwitchOpcode*/ 13, TARGET_VAL(WebAssemblyISD::DEMOTE_ZERO),// ->23936
/* 23923*/  OPC_RecordChild0, // #0 = $vec
/* 23924*/  OPC_CheckChild0Type, MVT::v2f64,
/* 23926*/  OPC_CheckType, MVT::v4f32,
/* 23928*/  OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23930*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::demote_zero_F32x4),
                MVT::v4f32, 1/*#Ops*/, 0, 
            // Src: (demote_zero:{ *:[v4f32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (demote_zero_F32x4:{ *:[v4f32] } V128:{ *:[v2f64] }:$vec)
/* 23936*/ /*SwitchOpcode*/ 13, TARGET_VAL(WebAssemblyISD::PROMOTE_LOW),// ->23952
/* 23939*/  OPC_RecordChild0, // #0 = $vec
/* 23940*/  OPC_CheckChild0Type, MVT::v4f32,
/* 23942*/  OPC_CheckType, MVT::v2f64,
/* 23944*/  OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23946*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                MVT::v2f64, 1/*#Ops*/, 0, 
            // Src: (promote_low:{ *:[v2f64] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
            // Dst: (promote_low_F64x2:{ *:[v2f64] } V128:{ *:[v4f32] }:$vec)
/* 23952*/ 0, // EndSwitchOpcode
    0
  }; // Total Array size is 23954 bytes

  // Opcode Histogram:
  // #OPC_Scope                                = 331
  // #OPC_RecordNode                           = 282
  // #OPC_RecordChild                          = 710
  // #OPC_RecordMemRef                         = 39
  // #OPC_CaptureGlueInput                     = 1
  // #OPC_MoveChild                            = 281
  // #OPC_MoveSibling                          = 284
  // #OPC_MoveParent                           = 561
  // #OPC_CheckSame                            = 0
  // #OPC_CheckChildSame                       = 127
  // #OPC_CheckPatternPredicate                = 661
  // #OPC_CheckPredicate                       = 531
  // #OPC_CheckOpcode                          = 489
  // #OPC_SwitchOpcode                         = 15
  // #OPC_CheckType                            = 517
  // #OPC_SwitchType                           = 178
  // #OPC_CheckChildType                       = 433
  // #OPC_CheckInteger                         = 0
  // #OPC_CheckChildInteger                    = 97
  // #OPC_CheckCondCode                        = 0
  // #OPC_CheckChild2CondCode                  = 142
  // #OPC_CheckValueType                       = 15
  // #OPC_CheckComplexPat                      = 318
  // #OPC_CheckAndImm                          = 27
  // #OPC_CheckOrImm                           = 0
  // #OPC_CheckImmAllOnesV                     = 44
  // #OPC_CheckImmAllZerosV                    = 1
  // #OPC_CheckFoldableChainNode               = 5
  // #OPC_EmitInteger                          = 345
  // #OPC_EmitStringInteger                    = 0
  // #OPC_EmitRegister                         = 0
  // #OPC_EmitConvertToTarget                  = 310
  // #OPC_EmitMergeInputChains                 = 414
  // #OPC_EmitCopyToReg                        = 0
  // #OPC_EmitNode                             = 9
  // #OPC_EmitNodeXForm                        = 0
  // #OPC_CompleteMatch                        = 32
  // #OPC_MorphNodeTo                          = 1149

  #undef TARGET_VAL
  SelectCodeCommon(N, MatcherTable,sizeof(MatcherTable));
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckPatternPredicate(unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckPatternPredicate(unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: return (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 1: return (Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 2: return (!Subtarget->hasAddr64());
  case 3: return (Subtarget->hasAddr64());
  case 4: return (Subtarget->hasReferenceTypes());
  case 5: return (Subtarget->hasExceptionHandling());
  case 6: return (Subtarget->hasSIMD128());
  case 7: return (Subtarget->hasSignExt());
  case 8: return (Subtarget->hasBulkMemory());
  case 9: return (Subtarget->hasRelaxedSIMD());
  case 10: return (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  case 11: return (!Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 12: return (Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  case 13: return (Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 14: return (Subtarget->hasNontrappingFPToInt());
  case 15: return (!Subtarget->hasNontrappingFPToInt());
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckNodePredicate(SDNode *Node, unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckNodePredicate(SDNode *Node, unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: {
    // Predicate_atomic_cmp_swap_8
    // Predicate_atomic_load_add_8
    // Predicate_atomic_load_sub_8
    // Predicate_atomic_load_and_8
    // Predicate_atomic_load_or_8
    // Predicate_atomic_load_xor_8
    // Predicate_atomic_swap_8
    // Predicate_atomic_load_8
    // Predicate_atomic_store_8
    // Predicate_sextloadi8
    // Predicate_zextloadi8
    // Predicate_extloadi8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
return true;

  }
  case 1: {
    // Predicate_atomic_cmp_swap_16
    // Predicate_atomic_load_add_16
    // Predicate_atomic_load_sub_16
    // Predicate_atomic_load_and_16
    // Predicate_atomic_load_or_16
    // Predicate_atomic_load_xor_16
    // Predicate_atomic_swap_16
    // Predicate_atomic_load_16
    // Predicate_atomic_store_16
    // Predicate_sextloadi16
    // Predicate_zextloadi16
    // Predicate_extloadi16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
return true;

  }
  case 2: {
    // Predicate_atomic_cmp_swap_32
    // Predicate_atomic_load_add_32
    // Predicate_atomic_load_sub_32
    // Predicate_atomic_load_and_32
    // Predicate_atomic_load_or_32
    // Predicate_atomic_load_xor_32
    // Predicate_atomic_swap_32
    // Predicate_atomic_load_32
    // Predicate_atomic_store_32
    // Predicate_sextloadi32
    // Predicate_zextloadi32
    // Predicate_extloadi32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
return true;

  }
  case 3: {
    // Predicate_LaneIdx16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 16;
  }
  case 4: {
    // Predicate_unindexedstore
    SDNode *N = Node;
    (void)N;
if (cast<StoreSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 5: {
    // Predicate_truncstore
    SDNode *N = Node;
    (void)N;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 6: {
    // Predicate_truncstorei8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 7: {
    // Predicate_LaneIdx8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 8;
  }
  case 8: {
    // Predicate_truncstorei16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 9: {
    // Predicate_LaneIdx4
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 4;
  }
  case 10: {
    // Predicate_store
    SDNode *N = Node;
    (void)N;
 if (cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 11: {
    // Predicate_LaneIdx2
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 2;
  }
  case 12: {
    // Predicate_truncstorei32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 13: {
    // Predicate_atomic_store_64
    // Predicate_atomic_load_64
    // Predicate_atomic_load_add_64
    // Predicate_atomic_load_sub_64
    // Predicate_atomic_load_and_64
    // Predicate_atomic_load_or_64
    // Predicate_atomic_load_xor_64
    // Predicate_atomic_swap_64
    // Predicate_atomic_cmp_swap_64
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i64) return false;
return true;

  }
  case 14: {
    // Predicate_unindexedload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 15: {
    // Predicate_load
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::NON_EXTLOAD) return false;
return true;

  }
  case 16: {
    // Predicate_sextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::SEXTLOAD) return false;
return true;

  }
  case 17: {
    // Predicate_zextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::ZEXTLOAD) return false;
return true;

  }
  case 18: {
    // Predicate_extload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::EXTLOAD) return false;
return true;

  }
  case 19: {
    // Predicate_sextloadvi8
    // Predicate_zextloadvi8
    // Predicate_extloadvi8
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i8) return false;
return true;

  }
  case 20: {
    // Predicate_sextloadvi16
    // Predicate_zextloadvi16
    // Predicate_extloadvi16
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i16) return false;
return true;

  }
  case 21: {
    // Predicate_sextloadvi32
    // Predicate_zextloadvi32
    // Predicate_extloadvi32
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i32) return false;
return true;

  }
  case 22: {
    // Predicate_bool_node
    SDNode *N = Node;
    (void)N;

  return CurDAG->computeKnownBits(SDValue(N, 0)).countMinLeadingZeros() == 31;

  }
  case 23: {
    // Predicate_ImmI8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (8 - 1)) <= Imm && Imm < (1 << (8 - 1));
  }
  case 24: {
    // Predicate_ImmI16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (16 - 1)) <= Imm && Imm < (1 << (16 - 1));
  }
  case 25: {
    // Predicate_LaneIdx32
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 32;
  }
  case 26: {
    // Predicate_add_nuw
    SDNode *N = Node;
    (void)N;
return N->getFlags().hasNoUnsignedWrap();
  }
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckComplexPattern(SDNode *Root, SDNode *Parent,
      SDValue N, unsigned PatternNo,
      SmallVectorImpl<std::pair<SDValue, SDNode *>> &Result) override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckComplexPattern(SDNode *Root, SDNode *Parent,
      SDValue N, unsigned PatternNo,
      SmallVectorImpl<std::pair<SDValue, SDNode *>> &Result)
#if DAGISEL_INLINE
  override
#endif
{
  unsigned NextRes = Result.size();
  switch (PatternNo) {
  default: llvm_unreachable("Invalid pattern # in table?");
  case 0:
    Result.resize(NextRes+2);
  return SelectAddrOperands32(N, Result[NextRes+0].first, Result[NextRes+1].first);
  case 1:
    Result.resize(NextRes+2);
  return SelectAddrOperands64(N, Result[NextRes+0].first, Result[NextRes+1].first);
  }
}
#endif // GET_DAGISEL_BODY


#ifdef DAGISEL_INLINE
#undef DAGISEL_INLINE
#endif
#ifdef DAGISEL_CLASS_COLONCOLON
#undef DAGISEL_CLASS_COLONCOLON
#endif
#ifdef GET_DAGISEL_DECL
#undef GET_DAGISEL_DECL
#endif
#ifdef GET_DAGISEL_BODY
#undef GET_DAGISEL_BODY
#endif
